/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.application;

import javax.swing.JComponent;


/**
 * <code>VisiblePlugIn</code> interface extends <code>PlugIn</code> interface
 * with access to plug-ins GUI container.
 *
 * @author Igor Kriznar (<a
 *         href="mailto:igor.kriznar@cosylab.com">igor.kriznar&x40;cosylab.com</a>)
 * @version $Id: VisiblePlugIn.java,v 1.3 2008-04-22 12:31:02 jbobnar Exp $
 *
 * @since Jul 16, 2003.
 */
public interface VisiblePlugIn extends PlugIn
{
	/**
	 * Plugin must return non-null component with GUI presentation of plugin.
	 * @return non-null component with GUI presentation of plugin
	 */
	JComponent getGUIPanel();
}

/* __oOo__ */
