/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of Java-Common.
 *
 * Java-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Java-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Java-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.events;

import java.util.EventListener;

/**
 * This interface is used to notify the listeners of value change.
 * 
 * @author Ales Pucelj
 * @version @@VERSION@@
 */
public interface SetListener extends EventListener {

	/**
	 * Notifies that a set command has occured.
	 * 
	 * @param e SetEvent
	 */
	void setPerformed(SetEvent e);

}
