/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui;

import java.awt.Image;
import java.beans.IntrospectionException;

import com.cosylab.gui.adapters.ConverterCustomizerPropertyEditor;
import com.cosylab.gui.components.AbstractDisplayerPanelBeanInfo;
import com.cosylab.gui.components.util.ImageHelper;

/**
 * <code>BeanInfo</code> for <code>CheckBoxController</code>.
 * 
 * @author <a href="mailto:blaz.hostnik@cosylab.com">Blaz Hostnik, Cosylab</a>
 * @see ButtonController
 */
public class CheckBoxControllerBeanInfo extends AbstractDisplayerPanelBeanInfo {

	/**
	 * Constructs new CheckBoxControllerBeanInfo.
	 * 
	 * @throws IntrospectionException
	 */
	public CheckBoxControllerBeanInfo() throws IntrospectionException {
	    super();
	    setBeanDescriptor(CheckBoxControllerCustomizer.class);
		removePropertyDescriptor("dataState");
		removePropertyDescriptor("dataSource");
		overridePropertyDescriptor("converter", ConverterCustomizerPropertyEditor.class, "getConverter", "setConverter");
    }
	
	/*
	 * (non-Javadoc)
	 * @see java.beans.SimpleBeanInfo#getIcon(int)
	 */
	@Override
	public Image getIcon(int iconKind) {
		return ImageHelper.createImage("icons/general/Preferences16.gif");
	}
}
