/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui;

import com.cosylab.gui.components.AbstractDisplayerPanelCustomizer;
import com.cosylab.gui.components.customizer.AbstractCustomizerPanel;

/**
 * <code>IconDisplayerCustomizer</code> is a customizer for <code>IconDisplayer</code>
 * which allows customization of the basic displayer properties and includes
 * {@link IconCustomizer}.
 * 
 * @author Jaka Bobnar, Cosylab
 * @see IconDisplayer
 */
public class IconDisplayerCustomizer extends AbstractCustomizerPanel {
	private static final long serialVersionUID = 1L;
	
	public static final String KEEP_RATIO = "keepRatio";
	public static final String SCALE_ICONS = "scaleIcons";
	public static final String[] VISUAL_BASIC_PROPERTIES = { AbstractDisplayerPanelCustomizer.TITLE ,AbstractDisplayerPanelCustomizer.TITLE_VISIBLE, KEEP_RATIO, SCALE_ICONS};
	
	public IconDisplayerCustomizer() {
		super();
		addCustomizerTable(AbstractDisplayerPanelCustomizer.VISUAL_BASIC, VISUAL_BASIC_PROPERTIES);
		addCustomizer("Icon customization", new IconCustomizer());
		setSize(343, 440);
	}

}
