/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui;

import com.cosylab.gui.components.AbstractDisplayerPanelCustomizer;

/**
 * <code>LabelDisplayerCustomizer</code> is a customizer for 
 * <code>LabelDisplayer</code> which allows customization of its
 * most common properties.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: LabelDisplayerCustomizer.java,v 1.6 2008-04-22 12:31:02 jbobnar Exp $
 * @see LabelDisplayer
 */
public class LabelDisplayerCustomizer extends AbstractDisplayerPanelCustomizer {
	private static final long serialVersionUID = 1L;

	/** Edited number field property name. */
	public static final String ENHANCED = "enhanced";

	/** Edited number field property name. */
	public static final String COLUMNS = "columns";

	/** Edited number field property list. */
	public static final String[] VISUAL_BASIC_PROPERTIES = {
		TITLE, TITLE_VISIBLE, RESIZABLE, ENHANCED, 
		COLUMNS
	};
	
	/**
	 * Constructs new LabelDisplayerCustomizer.
	 *
	 */
	public LabelDisplayerCustomizer() {
		addCustomizerTable(VISUAL_BASIC, VISUAL_BASIC_PROPERTIES);
		setSize(287, 185);
	}
}
