/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui;

import java.beans.IntrospectionException;

import com.cosylab.gui.adapters.ConverterCustomizerPropertyEditor;
import com.cosylab.gui.components.LabelledWheelswitchBeanInfo;

/**
 * <code>BeanInfo</code> for <code>WheelswitchDisplayer</code>.
 * 
 * @author <a href="mailto:jernej.kamenik@cosylab.com">Jernej Kamenik</a>
 * @version $id$
 * @see WheelswitchDisplayer
 */
public class WheelswitchDisplayerBeanInfo extends LabelledWheelswitchBeanInfo {

	/**
	 * Constructs new WheelswitchDisplayerBeanInfo.
	 * 
	 * @throws IntrospectionException
	 */
	public WheelswitchDisplayerBeanInfo() throws IntrospectionException {
	    super();
	    setBeanDescriptor(WheelswitchDisplayerCustomizer.class);
		removePropertyDescriptor("dataState");
		removePropertyDescriptor("dataSource");
		overridePropertyDescriptor("converter", ConverterCustomizerPropertyEditor.class, "getConverter", "setConverter");
    }
	

}
