/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

/**
 * <code>AbstractNumericDisplayerPanelCustomizer</code> is a customizer for
 * AbstractNumericDisplayerPanel.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: AbstractNumericDisplayerPanelCustomizer.java,v 1.5 2008-04-22 12:28:40 jbobnar Exp $
 *
 */
public abstract class AbstractNumericDisplayerPanelCustomizer extends
		AbstractDisplayerPanelCustomizer {

	private static final long serialVersionUID = 1L;

	/** Title of the advance value display tab. */
	public static final String VALUE_DISPLAY_ADVANCED = "Value Display/Advanced";

	/** Title of the value display tab. */
	public static final String VALUE_DISPLAY = "Value Display";

	/** Tag for unitsVisible property. */
	public static final String UNITS_VISIBLE = "unitsVisible";

	/** Tag for unitsShownWithTitleVisible property. */
	public static final String UNITS_SHOWN_WITH_TITLE_VISIBLE = "unitsShownWithTitle";

	/** Tag for units property. */
	public static final String UNITS = "units";

	/** Tag for boundsVisible property. */
	public static final String BOUNDS_VISIBLE = "boundsVisible";

	/** Tag for format property. */
	public static final String FORMAT = "format";

	/** Names of value display properties. */
	public static String[] VALUE_DISPLAY_PROPERTIES = { BOUNDS_VISIBLE, UNITS,
			UNITS_VISIBLE, FORMAT };

	/** Supported aspects. */
	public static String[] ASPECTS = { VISUAL_BASIC, VISUAL_LAYOUT, VALUE_DISPLAY,
			VALUE_DISPLAY_ADVANCED };

	public AbstractNumericDisplayerPanelCustomizer() {

		addCustomizerTable(VALUE_DISPLAY, VALUE_DISPLAY_PROPERTIES);

	}

}
