package com.cosylab.gui.components;


/**
 * 
 * <code>DialKnobRotationType</code> defines the type of this knob, how it is turned around.
 * There are three policy:
 * <ul>
 *  <li>NORMAL - the knob can be turned from minimum to maximum value, which are located
 *  		at -3/8 and +3/8 of the full circle </li>
 *  <li>ENDLESS - knob can be turned endlessly, with a predefined endless factor which
 *  		defines the rate of change </li>
 *  <li>PERIODIC - knob can be turned endlessly but at each crossing of the maximum,
 *  		value changes to minimum and vice versa </li>
 *  </ul>  
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public enum DialKnobRotationType {
	NORMAL,ENDLESS,PERIODIC;
	
	public static DialKnobRotationType valueOf(int mode) {
		switch (mode) {
		case 0 : return NORMAL;
		case 1 : return ENDLESS;
		case 2 : return PERIODIC;
		default : return NORMAL;
		}
	}
}