/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

import java.awt.Image;
import java.beans.IntrospectionException;

import com.cosylab.gui.components.util.ImageHelper;

/**
 * @author <a href="mailto:jernej.kamenik@cosylab.com">Jernej Kamenik</a>
 * @version $id$
 *
 */
public class GaugerBeanInfo extends AbstractDisplayerPanelBeanInfo{

	public GaugerBeanInfo() throws IntrospectionException {
		super();
		setBeanDescriptor(GaugerCustomizer.class);
		loadPropertyDescriptors(GaugerCustomizer.GAUGER_PROPERTIES);
		loadPropertyDescriptors(AbstractDisplayerPanelCustomizer.VISUAL_BASIC_PROPERTIES);
		loadPropertyDescriptors("logarithmicScale");
		loadPropertyDescriptors("scaleMode");
	}

	/**
	 * @see java.beans.BeanInfo#getIcon(int)
	 */
	@Override
    public Image getIcon(int iconKind) {
		return ImageHelper.createImage("icons/components/Gauger16.gif");
	}

}
