/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

import java.beans.IntrospectionException;

import com.cosylab.gui.components.util.IconHelper;

/**
 * <code>BeanInfo</code> for <code>LabelledGauger</code>.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: LabelledGaugerBeanInfo.java,v 1.12 2008-04-22 12:28:40 jbobnar Exp $
 * @see LabelledGauger
 */
public class LabelledGaugerBeanInfo extends AbstractDisplayerPanelBeanInfo {
	
	
	/**
	 * Creates new instance of LabelledGaugerBeanInfo.
	 * @throws IntrospectionException 
	 */
	public LabelledGaugerBeanInfo() throws IntrospectionException {
		super();
		setBeanDescriptor(LabelledGaugerCustomizer.class);
		loadPropertyDescriptors(AbstractDisplayerPanelCustomizer.VISUAL_BASIC_PROPERTIES);
		loadPropertyDescriptors(LabelledGaugerCustomizer.VALUE_DISPLAY_PROPERTIES);
		loadPropertyDescriptors("logarithmicScale");
//		loadPropertyDescriptors("scaleMode");
		removePropertyDescriptor("state");
		setPropertyEditor("valuePolicy", ValuePolicyPropertyEditor.class);
	}
	
	/*
	 * (non-Javadoc)
	 * @see java.beans.SimpleBeanInfo#getIcon(int)
	 */
	@Override
    public java.awt.Image getIcon(int iconKind) {
    	return IconHelper.createImage("icons/components/Gauger16.gif");
    }
}
