/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components;

/**
 * Interface for listeners interested into monitoring progress of tasks.
 *
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a>
 * @version $Revision: 1.3 $
 */
public interface ProgressListener
{
	/**
	 * Notifies that task has changed progress.
	 *
	 * @param e event.
	 */
	public void progress(ProgressEvent e);

	/**
	 * Notifies that task has completed.
	 *
	 * @param e event.
	 */
	public void taskComplete(ProgressEvent e);

	/**
	 * Notifies that task has been interrupted.
	 *
	 * @param e event.
	 */
	public void taskInterruped(ProgressEvent e);

	/**
	 * Notifies that task has started.
	 *
	 * @param e event.
	 */
	public void taskStarted(ProgressEvent e);
}

/* __oOo__ */
