/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.introspection;

import java.awt.Component;
import java.lang.reflect.Member;

import javax.swing.DefaultListCellRenderer;

import com.cosylab.introspection.DataFormatter;

/**
 * Creation date: (12.1.2002 2:56:04)
 * 
 * @author <a href="mailto:miha.kadunc@cosylab.com">Miha Kadunc</a>
 * @version $id$
 */
public class MemberListCellRenderer extends DefaultListCellRenderer {

	private static final long serialVersionUID = 1L;
	private boolean fShowType=true;
	private boolean fShowParameters=false;
/**
 * MemberListCellRenderer constructor comment.
 * @param showType boolean
 * @param showParameters boolean
 */
public MemberListCellRenderer(boolean showType, boolean showParameters) {
	super();
	fShowType=showType;
	fShowParameters=showParameters;
}
/**
 * Creation date: (12.1.2002 2:56:47)
 * @param list javax.swing.JList
 * @param value Object
 * @param index int
 * @param isSelected boolean
 * @param cellHasFocus boolean
 * @return Component
 * @see javax.swing.ListCellRenderer#getListCellRendererComponent(JList, Object, int, boolean, boolean)
 */
@Override
public Component getListCellRendererComponent(
  javax.swing.JList list,
  Object value,
  int index,
  boolean isSelected,
  boolean cellHasFocus) {
	  
	return super.getListCellRendererComponent(list,toString((Member)value),index,isSelected,cellHasFocus);
}
/**
 * Creation date: (12.1.2002 2:56:47)
 * @param aMember Member
 * @return String
 */
public String toString(Member aMember) {
	return DataFormatter.toString(aMember,fShowType,fShowParameters);
}
}
