/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.introspection;

import java.lang.reflect.Member;

import javax.swing.DefaultListModel;
import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.JPanel;

import com.cosylab.introspection.ClassIntrospector;
import com.cosylab.introspection.MemberFilter;

/**
 * Creation date: (11.1.2002 23:50:39)
 * 
 * @author <a href="mailto:miha.kadunc@cosylab.com">Miha Kadunc</a>
 * @version $id$
 */
public class MethodSelectionPanel extends JPanel {

/**
     * 
     */
    private static final long serialVersionUID = 1L;
/**
 * 
 * @author  Miha Kadunc (miha.kadunc@cosylab.com)
 * @version @@VERSION@@
 */
class IvjEventHandler implements java.awt.event.ActionListener, java.beans.PropertyChangeListener, javax.swing.event.ListSelectionListener {
		/**
		 * @param e java.awt.event.ActionEvent
		 * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
		 */
		public void actionPerformed(java.awt.event.ActionEvent e) {
			if (e.getSource() == MethodSelectionPanel.this.getJComboBox1()) 
				connEtoC2(e);
		}
		/**
		 * @param evt java.beans.PropertyChangeEvent
		 * @see java.beans.PropertyChangeListener#propertyChange(PropertyChangeEvent)
		 */
		public void propertyChange(java.beans.PropertyChangeEvent evt) {
			if (evt.getSource() == MethodSelectionPanel.this && (evt.getPropertyName().equals("background"))) 
				connPtoP1SetTarget();
			if (evt.getSource() == MethodSelectionPanel.this.getJComboBox1() && (evt.getPropertyName().equals("background"))) 
				connPtoP1SetSource();
		}
		/**
		 * @param e javax.swing.event.ListSelectionEvent
		 * @see javax.swing.event.ListSelectionListener#valueChanged(ListSelectionEvent)
		 */
		public void valueChanged(javax.swing.event.ListSelectionEvent e) {
			if (e.getSource() == MethodSelectionPanel.this.getJList1()) 
				connEtoC1(e);
		}
	}
	private boolean ivjConnPtoP1Aligning = false;
	/**
	 */
	IvjEventHandler ivjEventHandler = new IvjEventHandler();
	private JComboBox ivjJComboBox1 = null;
	private JList ivjJList1 = null;
	private java.lang.Class fieldInspectedClass = null;
	private Member fieldSelectedMember = null;
	/**
	 */
	public final static short MODE_COMBO = 0;
	/**
	 */
	public final static short MODE_LIST = 1;
	private short fieldMode = (short) 0;
	private MemberFilter fieldMemberFilter = null;
/**
 * MethodSelectionPanel constructor comment.
 */
public MethodSelectionPanel() {
	super();
	initialize();
}
/**
 * MethodSelectionPanel constructor comment.
 * @param layout java.awt.LayoutManager
 */
public MethodSelectionPanel(java.awt.LayoutManager layout) {
	super(layout);
}
/**
 * MethodSelectionPanel constructor comment.
 * @param layout java.awt.LayoutManager
 * @param isDoubleBuffered boolean
 */
public MethodSelectionPanel(java.awt.LayoutManager layout, boolean isDoubleBuffered) {
	super(layout, isDoubleBuffered);
}
/**
 * MethodSelectionPanel constructor comment.
 * @param isDoubleBuffered boolean
 */
public MethodSelectionPanel(boolean isDoubleBuffered) {
	super(isDoubleBuffered);
}
/**
 * connEtoC1:  (JList1.listSelection.valueChanged(javax.swing.event.ListSelectionEvent) --> MethodSelectionPanel.setSelectedMember(Ljava.lang.reflect.Member;)V)
 * @param arg1 javax.swing.event.ListSelectionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC1(javax.swing.event.ListSelectionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.setSelectedMember((java.lang.reflect.Member)getJList1().getSelectedValue());
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connEtoC2:  (JComboBox1.action.actionPerformed(java.awt.event.ActionEvent) --> MethodSelectionPanel.setSelectedMember(Ljava.lang.reflect.Member;)V)
 * @param arg1 java.awt.event.ActionEvent
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connEtoC2(java.awt.event.ActionEvent arg1) {
	try {
		// user code begin {1}
		// user code end
		this.setSelectedMember((java.lang.reflect.Member)getJComboBox1().getSelectedItem());
		// user code begin {2}
		// user code end
	} catch (java.lang.Throwable ivjExc) {
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connPtoP1SetSource:  (MethodSelectionPanel.background <--> JComboBox1.background)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connPtoP1SetSource() {
	/* Set the source from the target */
	try {
		if (ivjConnPtoP1Aligning == false) {
			// user code begin {1}
			// user code end
			ivjConnPtoP1Aligning = true;
			this.setBackground(getJComboBox1().getBackground());
			// user code begin {2}
			// user code end
			ivjConnPtoP1Aligning = false;
		}
	} catch (java.lang.Throwable ivjExc) {
		ivjConnPtoP1Aligning = false;
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}
/**
 * connPtoP1SetTarget:  (MethodSelectionPanel.background <--> JComboBox1.background)
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void connPtoP1SetTarget() {
	/* Set the target from the source */
	try {
		if (ivjConnPtoP1Aligning == false) {
			// user code begin {1}
			// user code end
			ivjConnPtoP1Aligning = true;
			getJComboBox1().setBackground(this.getBackground());
			// user code begin {2}
			// user code end
			ivjConnPtoP1Aligning = false;
		}
	} catch (java.lang.Throwable ivjExc) {
		ivjConnPtoP1Aligning = false;
		// user code begin {3}
		// user code end
		handleException(ivjExc);
	}
}

/**
 * Gets the inspectedClass property (java.lang.Class) value.
 * @return The inspectedClass property value.
 * @see #setInspectedClass
 */
public java.lang.Class getInspectedClass() {
	return fieldInspectedClass;
}
/**
 * Return the JComboBox1 property value.
 * @return javax.swing.JComboBox
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JComboBox getJComboBox1() {
	if (ivjJComboBox1 == null) {
		try {
			ivjJComboBox1 = new javax.swing.JComboBox();
			ivjJComboBox1.setName("JComboBox1");
			ivjJComboBox1.setToolTipText("Select a method");
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJComboBox1;
}
/**
 * Return the JList1 property value.
 * @return javax.swing.JList
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private javax.swing.JList getJList1() {
	if (ivjJList1 == null) {
		try {
			ivjJList1 = new javax.swing.JList();
			ivjJList1.setName("JList1");
			ivjJList1.setVisible(false);
			// user code begin {1}
			// user code end
		} catch (java.lang.Throwable ivjExc) {
			// user code begin {2}
			// user code end
			handleException(ivjExc);
		}
	}
	return ivjJList1;
}
/**
 * Gets the memberFilter property (com.cosylab.gui.adapters.infobus.MemberFilter) value.
 * @return The memberFilter property value.
 * @see #setMemberFilter
 */
public MemberFilter getMemberFilter() {
	return fieldMemberFilter;
}
/**
 * Creation date: (13.1.2002 3:18:41)
 * @return short
 */
public short getMode() {
	return	fieldMode;
}
/**
 * Gets the selectedMethod property (java.lang.reflect.Method) value.
 * @return The selectedMethod property value.
 * @see #setSelectedMember
 */
public Member getSelectedMember() {
	return fieldSelectedMember;
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	 System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	 exception.printStackTrace(System.out);
}
/**
 * Initializes connections
 * @exception java.lang.Exception The exception description.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initConnections() throws java.lang.Exception {
	// user code begin {1}
	// user code end
	this.addPropertyChangeListener(ivjEventHandler);
	getJComboBox1().addPropertyChangeListener(ivjEventHandler);
	getJList1().addListSelectionListener(ivjEventHandler);
	getJComboBox1().addActionListener(ivjEventHandler);
	connPtoP1SetTarget();
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		// user code begin {1}
		// user code end
		setName("MethodSelectionPanel");
		setLayout(new java.awt.GridBagLayout());
		setSize(225, 23);

		java.awt.GridBagConstraints constraintsJComboBox1 = new java.awt.GridBagConstraints();
		constraintsJComboBox1.gridx = 0; constraintsJComboBox1.gridy = 0;
		constraintsJComboBox1.fill = java.awt.GridBagConstraints.HORIZONTAL;
		constraintsJComboBox1.weightx = 1.0;
		add(getJComboBox1(), constraintsJComboBox1);

		java.awt.GridBagConstraints constraintsJList1 = new java.awt.GridBagConstraints();
		constraintsJList1.gridx = 0; constraintsJList1.gridy = 1;
		constraintsJList1.fill = java.awt.GridBagConstraints.BOTH;
		constraintsJList1.weightx = 1.0;
		constraintsJList1.weighty = 1.0;
		constraintsJList1.insets = new java.awt.Insets(4, 4, 4, 4);
		add(getJList1(), constraintsJList1);
		initConnections();
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
	// user code begin {2}
	// user code end
}
/**
 * Creation date: (12.1.2002 0:59:43)
 * @return java.lang.reflect.Member[]
 */
private void initializeModels() {
	Member[] members=internalGetMembers();
	if (fieldMode==MODE_COMBO){
		getJComboBox1().setModel(new javax.swing.DefaultComboBoxModel(members));
		getJComboBox1().setRenderer(new MemberListCellRenderer(true,true));
	}
	else if (fieldMode==MODE_LIST) {
		DefaultListModel model=new javax.swing.DefaultListModel();
		for (int i = 0; i < members.length; i++){
		model.addElement(members[i]);
		}
//		model.copyInto(members);
		getJList1().setModel(model);
		getJList1().setCellRenderer(new MemberListCellRenderer(true,true));
	}
}
/**
 * Creation date: (12.1.2002 0:59:43)
 * @return java.lang.reflect.Member[]
 */
private Member[] internalGetMembers() {
  if (fieldInspectedClass == null)
    return new Member[0];

  Member[] members = ClassIntrospector.getMembers(fieldInspectedClass,fieldMemberFilter);
  return members;
}
/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	try {
		javax.swing.JFrame frame = new javax.swing.JFrame();
		MethodSelectionPanel aMethodSelectionPanel;
		aMethodSelectionPanel = new MethodSelectionPanel();
		frame.setContentPane(aMethodSelectionPanel);
		frame.setSize(aMethodSelectionPanel.getSize());
		frame.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override
            public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			}
		});
		frame.setVisible(true);
		java.awt.Insets insets = frame.getInsets();
		frame.setSize(frame.getWidth() + insets.left + insets.right, frame.getHeight() + insets.top + insets.bottom);
		frame.setVisible(true);
		aMethodSelectionPanel.setInspectedClass(Double.class);
	} catch (Throwable exception) {
		System.err.println("Exception occurred in main() of javax.swing.JPanel");
		exception.printStackTrace(System.out);
	}
}
/**
 * Sets the inspectedClass property (java.lang.Class) value.
 * @param inspectedClass The new value for the property.
 * @see #getInspectedClass
 */
public void setInspectedClass(java.lang.Class inspectedClass) {
	if (fieldInspectedClass != inspectedClass){
		fieldInspectedClass = inspectedClass;
		initializeModels();
	}
}
/**
 * Sets the memberFilter property (com.cosylab.gui.adapters.infobus.MemberFilter) value.
 * @param memberFilter The new value for the property.
 * @see #getMemberFilter
 */
public void setMemberFilter(MemberFilter memberFilter) {
	fieldMemberFilter = memberFilter;
}
/**
 * Creation date: (13.1.2002 3:18:41)
 * @param newMode short
 */
public void setMode(short newMode) {
	if (fieldMode != newMode) {
		fieldMode = newMode;
		getJComboBox1().setVisible(!getJComboBox1().isVisible());
		getJList1().setVisible(!getJList1().isVisible());
		initializeModels();
		return;
	}
}
/**
 * Sets the requiredType property (java.lang.Class) value.
 * @param requiredType The new value for the property.
 * @see #getRequiredType
 */
private void setSelectedMember(Member selectedMember) {
	if (selectedMember != fieldSelectedMember) {
		Member oldMember=fieldSelectedMember;
		fieldSelectedMember = selectedMember;
		firePropertyChange("selectedMember",oldMember,fieldSelectedMember);
	}
}
}
