/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.ledder;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Transparency;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;

import javax.swing.ImageIcon;


/**
 * @author Miha
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class CustomLedIcon extends ImageIcon {

	private static final long serialVersionUID = 1L;

		public CustomLedIcon(Color c) {
			this(c,16);
		}
		public CustomLedIcon(Color c, int size) {
			this(c,size,1);
		}
		
		public CustomLedIcon(Color c, int size, int border) {
			super();
            GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
            GraphicsDevice gs = ge.getDefaultScreenDevice();
            GraphicsConfiguration gc = gs.getDefaultConfiguration();            
            BufferedImage bufImg=gc.createCompatibleImage(size,size,Transparency.TRANSLUCENT);
            Graphics2D g2 = (Graphics2D)bufImg.getGraphics();
            g2.setPaint(new LedPaint(createDefaultParameters(c, size, border),size/2,size/2));
            g2.fill(new Rectangle2D.Double(0, 0, size, size));
            setImage(bufImg);
		}
		
		protected LedPaintParameters createDefaultParameters(Color color, int size, int border) {
            LedPaintParameters lpp = new LedPaintParameters();
            //lpp.centerX=size/2;
            //lpp.centerY=size/2;
            lpp.radius=size/2-border;
            lpp.highlightFactor = 0.85;
            lpp.highlightFocus = 3.0;
            lpp.shadowIntensity = 1.0;
            lpp.borderSize = 0.05*lpp.radius/6;
            lpp.lightX = -0.20;
            lpp.lightY = -0.50;
            lpp.antialiasing = 6;
            lpp.color=color;
			return lpp;
		}
}
