/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.numberfield;

/**
 * Visualize double number in hours:minutes:seconds format.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 */
public class HMSNumberDescriptor extends AngleNumberDescriptor
{

	/**
	 * @see NumberDescriptor
	 */
	public final static String NAME = "h:m:s Visualization";

	/**
	 * @see NumberDescriptor
	 */
	public final static String DESCRIPTION = "Displays double value in hour format: XX:XX:XX.";

	/**
	 * Creates new instance.
	 */
	public HMSNumberDescriptor()
	{
		super(':', ':', (char)0, true);
	}
}

/* __oOo__ */
