/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.table;

/**
 * Default implementation of the RowComparator.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @version $Id: DefaultRowComparator.java,v 1.5 2008-04-22 12:28:40 jbobnar Exp $
 *
 */
public class DefaultRowComparator implements RowComparator {

	int column = 0;
	boolean descending;


	public DefaultRowComparator(int col, boolean desc)
	{
		column = col;
		descending = desc;
	}

	/* (non-Javadoc)
	 * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
	 */
	public int compare(TableRow o1, TableRow o2)
	{
		if (descending) {
			return o2.compareTo(o1, column);
		}

		return o1.compareTo(o2, column);
	}
	
	/*
	 * (non-Javadoc)
	 * @see com.cosylab.gui.components.table.RowComparator#setColumn(int)
	 */
	public void setColumn(int column) {
		this.column = column;
	}

	/*
	 * (non-Javadoc)
	 * @see com.cosylab.gui.components.table.RowComparator#setDescending(boolean)
	 */
	public void setDescending(boolean descending) {
		this.descending = descending;
	}

	/*
	 * (non-Javadoc)
	 * @see com.cosylab.gui.components.table.RowComparator#getColumn()
	 */
	public int getColumn() {
		return column;
	}

	/*
	 * (non-Javadoc)
	 * @see com.cosylab.gui.components.table.RowComparator#getDescending()
	 */
	public boolean getDescending() {
		return descending;
	}

}
