/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.table.cells;

/**
 * DobubleCell holds double value.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $id$
 */
public class DoubleCell extends NumericCell
{
	/**
	 * Constructs a new DoubleCell.
	 *
	 */
	public DoubleCell()
	{
		super();
		//setting default value to avoid null pointer
		setDoubleValue(0.0);
	}

	/**
	 * Constructs a new DoubleCell.
	 *
	 * @param identifier
	 * @param dataSource
	 * @param value
	 * @param commands
	 */
	public DoubleCell(String identifier, Object dataSource, double value,
	    Command[] commands)
	{
		super(identifier, dataSource, new Double(value), commands);
	}

	/**
	 * Returns the cell's double value.
	 * @return
	 */
	public double getDoubleValue()
	{
		return ((Number)value).doubleValue();
	}

	/**
	 * Sets a double value to this cell.
	 * 
	 * @param value new value
	 */
	public void setDoubleValue(double value)
	{
		setValue(new Double(value));
	}
	
}

/* __oOo__ */
