/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.util;
import java.awt.Image;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.TransferHandler;


public class ImageClipboardHelper extends TransferHandler implements Transferable {

	private static final long serialVersionUID = 1L;
	private static final DataFlavor[] flavors = { DataFlavor.imageFlavor };
    private Image image;

    
    /**
     * we need to define action copy , because we are copying image to sys. clipboard
     */
    @Override
    public int getSourceActions(JComponent c) {
        return TransferHandler.COPY;
    }

   

    @Override
    public Transferable createTransferable(JComponent comp) {
        image = null;

        Icon icon = null;

        if (comp instanceof JLabel) {
            JLabel label = (JLabel) comp;
            icon = label.getIcon();
        } 
        if (icon instanceof ImageIcon) {
            image = ((ImageIcon) icon).getImage();

            return this;
        }

        return null;
    }

    
    // Transferable
    public Object getTransferData(DataFlavor flavor) {
        if (isDataFlavorSupported(flavor)) {
            return image;
        }

        return null;
    }

    public DataFlavor[] getTransferDataFlavors() {
        return flavors;
    }

    public boolean isDataFlavorSupported(DataFlavor flavor) {
        return flavor.equals(flavors[0]);
    }
}
