/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.util;

import java.awt.Container;
import java.awt.Window;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;


/**
 * 
 * 
 * @author <a href="mailto:miha.kadunc@cosylab.com">Miha Kadunc</a>
 * @version $id$
 */
public class RunnerHelper {

  public static void runFrame(Window frame, int width, int height) {
    try {
      frame.setSize(width, height);
      frame.addWindowListener(new WindowAdapter() {
        /**
         * @see java.awt.event.WindowAdapter#windowClosing(WindowEvent)
         */
        @Override
        public void windowClosing(WindowEvent e) {
          super.windowClosing(e);
          System.exit(0);
        }
      });
      ComponentPositioner.centerOnScreen(frame);
      frame.setVisible(true);
    } catch (Exception e) {
      System.out.println(">>> Exception in main");
      e.printStackTrace();
    }
  }

  public static void runComponent(Container c, int width, int height) {
    try {

      JFrame frame = new JFrame(c.getName());
      frame.setContentPane(c);
      int w = width + frame.getInsets().left + frame.getInsets().right;
      int h = height + frame.getInsets().bottom + frame.getInsets().top;
      runFrame(frame, w, h);
    } catch (Exception e) {
      System.out.println(">>> Exception in main");
      e.printStackTrace();
    }
  }

}
