/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.components.wheelswitch;

import com.cosylab.gui.components.SimpleButton;

/**
 * Descedant of <code>Digit</code> displaying static text.
 * Objects of this class also cannot be selected. 
 * 
 * @author <a href="mailto:jernej.kamenik@cosylab.com">Jernej Kamenik</a>
 * @version $id$
 */
public class StaticDigit extends Digit {

	private static final long serialVersionUID = 1L;

	/**
	 * Constructor for StaticDigit.
	 * 
	 * @param value to be displayed.
	 * @see Digit#Digit()
	 */			
	public StaticDigit(String value) {
		super();
		setActionMode(SimpleButton.NULL_ACTION_MODE);
		setText(value);
	}

	/**
	 * This method has been overriden to disable selection of static digits.
	 */
	@Override
	public void setSelected(boolean newSel){}

	/**
	 * This method has been overriden to disable selection of static digits.
	 */
	@Override
	public boolean isSelected() {return false;}
}
