/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.displayers;

import com.cosylab.util.CommonException;


/**
 * <code>NumberConsumer</code> is data consumer for receiveing updates of
 * <code>Number</code> dynamic values, which will block call until update is
 * completer and throws exception on fail.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $Id: NumberConsumer.java,v 1.3 2008-04-22 12:31:02 jbobnar Exp $
 *
 * @since Nov 24, 2003.
 */
public interface NumberConsumer extends DataConsumer
{
	/**
	 * Notifys this consumer about new dynamic value update.
	 *
	 * @param timestamp the time of dynamic value event
	 * @param value new value
	 */
	public void updateValue(long timestamp, Number value)
		throws CommonException;
}

/* __oOo__ */
