/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans.
 *
 * CosyBeans is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.displayers;

/**
 * <code>UpdateRequestListener</code> receives response for asynchronous update
 * request.
 *
 * @author <a href="mailto:igor.kriznar@cosylab.com">Igor Kriznar</a>
 * @version $Id: UpdateRequestListener.java,v 1.3 2008-04-22 12:31:02 jbobnar Exp $
 *
 * @since Dec 3, 2003.
 */
public interface UpdateRequestListener
{
	/**
	 * This event hook is called by <code>AsynchronousNumberConsumer</code>
	 * when receives response for update request.
	 *
	 * @param request the request which originated the respons
	 * @param successful <code>true</code> if update was succesful
	 * @param exception the exceptionthat was thrown upon uncussesful update
	 */
	public void replay(UpdateRequest request, boolean success,
	    Exception exception);
}

/* __oOo__ */
