/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.property.editors;

import com.cosylab.gui.components.numberfield.LongDocument;

/**
 * description
 * 
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a> 
 * @version $id$
 */
public class LongEditor extends NumberEditor {
    /**
     * 
     */
    private static final long serialVersionUID = -7039204380986050878L;
    /**
     * 
     */
	public LongEditor() {
		super(new LongDocument());
		setValue(new Long(0));
	}
    
    /* (non-Javadoc)
     * @see com.cosylab.gui.property.editors.NumberEditor#getPropertyValue()
     */
    @Override
    public Object getPropertyValue() {
        Number val=getValue();
        if (val==null) return null;
        return new Long(val.longValue());
    }
    /* (non-Javadoc)
     * @see com.cosylab.gui.property.editors.NumberEditor#setValue(java.lang.Number)
     */
    @Override
    public void setValue(Number newValue) {
        Number oldValue=getValue();
        setText(newValue==null?"":String.valueOf(newValue.longValue()));
        revalidate();
        if (oldValue==null && newValue==null) return;
        if ((newValue==null || oldValue==null) || !(newValue.longValue()==oldValue.longValue())) {
            firePropertyChange(PROPERTY_VALUE_NAME,oldValue,newValue);
        }
    }
}
