/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of CosyBeans-Common.
 *
 * CosyBeans-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * CosyBeans-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CosyBeans-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.gui.property.editors;

import javax.swing.JTextField;


/**
 * description
 * 
 * @author <a href="mailto:ales.pucelj@cosylab.com">Ales Pucelj</a> 
 * @version $id$
 */
public class StringEditor extends JTextField implements PropertyEditor {

	/**
     * 
     */
    private static final long serialVersionUID = 7785802740224428063L;
    private boolean nullAllowed = false;

    /**
	 * Constructor for StringEditor.
	 */
	public StringEditor() {
		super();
	}

	/**
	 * @see PropertyEditor#getValue()
	 */
	public Object getPropertyValue() {
        String ret=getText();
        if (ret==null && !nullAllowed) {
            ret="";
        }
        if (ret=="" && nullAllowed) {
            ret=null;
        }
		return ret; 
	}

	/**
	 * @see PropertyEditor#setValue(Object)
	 */
	public boolean setPropertyValue(Object value) {
		String old=getText();
		if (value == null) {
			setText("");
		} else {
		    setText(String.valueOf(value));
        }
		firePropertyChange(PROPERTY_VALUE_NAME,old,value);
		return true;
	}

	/**
	 * @see PropertyEditor#getDescription()
	 */
	public String getDescription() {
		return null;
	}

	/**
	 * @see PropertyEditor#setDescription(String)
	 */
	public void setDescription(String description) {
	}

	/**
	 * @see PropertyEditor#getEditor()
	 */
	public PropertyEditor getEditor() {
		return null;
	}

    public boolean isNullAllowed() {
        return nullAllowed;
    }

    public void setNullAllowed(boolean allow) {
        this.nullAllowed=allow;
    }

}
