/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of Java-Common.
 *
 * Java-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Java-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Java-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.util;

/**
 * Describes condition of single bit in <code>StatusBit</code> when bit is on 
 * (bit value is 1) or when bit is off (bit value is 0). Used in pattern proerties.
 * 
 * @author Igor Kriznar (igor.kriznarATcosylab.com)
 *
 */
public enum BitCondition {
	/**
     * Bit signals error condition.
     */
	ERROR, 
	/**
     * Bit signals warning condition.
     */
	WARNING, 
	/**
     * Bit signals normal condition.
     */
	OK, 
	/**
     * Bit signals that it is not used.
     */
	UNUSED;
}
/* __oOo__ */
