/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of Java-Common.
 *
 * Java-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Java-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Java-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.util;

import java.util.Iterator;
import java.util.NoSuchElementException;

/**
 * An iterator over an empty set.
 * 
 * @author Klemen Zagar, Cosylab
 */
public class NoElementsIterator<T> implements Iterator<T> {
	/* (non-Javadoc)
     * @see java.util.Iterator#hasNext()
     */
    public boolean hasNext() {
	    return false;
    }

	/* (non-Javadoc)
     * @see java.util.Iterator#next()
     */
    public T next() {
    	throw new NoSuchElementException();
    }

	/* (non-Javadoc)
     * @see java.util.Iterator#remove()
     */
    @Override
    public void remove() {
	    throw new IllegalStateException();
    }
}


/* __oOo__ */
