/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of Java-Common.
 *
 * Java-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Java-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Java-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.util;

/**
 * <code>ObjectFatory</code> is a factory used by <code>ObjectPool</code> when
 * pool is empty and needs to create new instance of
 * <code>PoolableObject</code>
 *
 * @author <a href="mailto:andrej.kosmrlj@cosylab.com">Andrej Kosmrlj</a>
 * @version $Id: ObjectFactory.java,v 1.3 2008-04-22 12:26:29 jbobnar Exp $
 *
 * @since VERSION
 */
public interface ObjectFactory
{
	/**
	 * New instance of <code>PoolableObject</code>
	 *
	 * @return
	 */
	public PoolableObject newInstance();
}

/* __oOo__ */
