/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of Java-Common.
 *
 * Java-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Java-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Java-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.util;

/**
 * @author Miha
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class StringBufferUtilities {

	private StringBufferUtilities() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	public static void replace(StringBuffer buf, String replaceWhat, String replaceTo) {
		int idxFind=buf.indexOf(replaceWhat,0);
		int findLen=replaceWhat.length();
		int repLen=replaceTo.length();
		while (idxFind>=0) {
			buf.replace(idxFind,idxFind+findLen,replaceTo);
			idxFind=idxFind+repLen;
			idxFind=buf.indexOf(replaceWhat, idxFind);
		}
	}

	public static void prepend(StringBuffer buf, String beforeWhat, String toPrepend) {
		prepend(buf,beforeWhat,toPrepend,beforeWhat.length());
	}

	public static void prepend(StringBuffer buf, String beforeWhat, String toPrepend, int offset) {
		int idxFind=buf.indexOf(beforeWhat,0);
		int prepLen=toPrepend.length();
		while (idxFind>=0) {
			buf.insert(idxFind,toPrepend);
			idxFind=idxFind+prepLen+offset;
			idxFind=buf.indexOf(beforeWhat, idxFind);
		}
	}
	
	public static void replace(StringBuffer buf, char replaceWhat, char replaceTo) {
		for (int i = buf.length()-1; i >= 0 ; i--) {
			if (buf.charAt(i)==replaceWhat) {
				buf.setCharAt(i,replaceTo);
			}
		}
	}

	public static void prepend(StringBuffer buf, char beforeWhat, char toPrepend) {
		for (int i = buf.length()-1; i >= 0 ; i--) {
			if (buf.charAt(i)==beforeWhat) {
				buf.insert(i,toPrepend);
			}
		}
	}
	
	public static void replace(StringBuffer buf, char replaceWhat, String replaceTo) {
		for (int i = buf.length()-1; i >= 0 ; i--) {
			if (buf.charAt(i)==replaceWhat) {
				buf.replace(i,i+1,replaceTo);
			}
		}
	}

	public static void prepend(StringBuffer buf, char beforeWhat, String toPrepend) {
		for (int i = buf.length()-1; i >= 0 ; i--) {
			if (buf.charAt(i)==beforeWhat) {
				buf.insert(i,toPrepend);
			}
		}
	}
	
	public static void replace(StringBuffer buf, String replaceWhat, char replaceTo) {
		int idxFind=buf.indexOf(replaceWhat,0);
		int findLen=replaceWhat.length();
		while (idxFind>=0) {
			buf.delete(idxFind+1,idxFind+findLen);
			buf.setCharAt(idxFind,replaceTo);
			idxFind=idxFind+1;
			idxFind=buf.indexOf(replaceWhat, idxFind);
		}
	}
	
	public static void prepend(StringBuffer buf, String beforeWhat, char toPrepend) {
		prepend(buf,beforeWhat,toPrepend,beforeWhat.length());
	}

	public static void prepend(StringBuffer buf, String beforeWhat, char toPrepend, int offset) {
		int idxFind=buf.indexOf(beforeWhat,0);
		while (idxFind>=0) {
			buf.insert(idxFind,toPrepend);
			idxFind=idxFind+1+offset;
			idxFind=buf.indexOf(beforeWhat, idxFind);
		}
	}
	
	public static int indexOf(StringBuffer buf, char toFind) {
		return indexOf(buf,toFind,0);
	}
	/**
	 * 
	 * @param buf
	 * @param toFind
	 * @param startIndex inclusive
	 * @return
	 */
	public static int indexOf(StringBuffer buf, char toFind, int startIndex) {
		int len=buf.length();
		for (int i = startIndex; i < len; i++) {
			if (buf.charAt(i)==toFind) {
				return i;
			}
		}
		return -1;
	}

	public static void deleteAll(StringBuffer buf, char toDelete) {
		for (int i = buf.length()-1; i >= 0 ; i--) {
			if (buf.charAt(i)==toDelete) {
				buf.deleteCharAt(i);
			}
		}
	}
	
	public static void deleteAll(StringBuffer buf, String toDelete) {
		int idxFind=buf.indexOf(toDelete,0);
		int findLen=toDelete.length();
		while (idxFind>=0) {
			buf.delete(idxFind,idxFind+findLen);
			idxFind=buf.indexOf(toDelete, idxFind);
		}
	}
	
	public static void main(String[] args) {
		StringBuffer buf=new StringBuffer("mihafoobar-krakra");
		System.out.print(buf);
		System.out.println(" "+indexOf(buf,'a'));
		replace(buf,'a','y');
		System.out.println(buf);
		replace(buf,'y',"_A_");
		System.out.println(buf);
		replace(buf,"_A_","[[_B_]]");
		System.out.println(buf);
		replace(buf,"B_",'a');
		System.out.println(buf);
		deleteAll(buf,'_');
		System.out.println(buf);
		deleteAll(buf,"[[");
		System.out.println(buf);
		prepend(buf,"a]]",'p');
		System.out.println(buf);
		deleteAll(buf,"]]");
		System.out.println(buf+" "+indexOf(buf,'a',4));
	}

}
