/*
 * Copyright (c) 2003-2008 by Cosylab d. d.
 *
 * This file is part of Java-Common.
 *
 * Java-Common is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Java-Common is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Java-Common.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.cosylab.util;

/**
 * Objects implementing this interface control a process which can be suspended
 * on request.
 *
 * @author <a href="mailto:miha.kadunc@cosylab.com">Miha Kadunc</a>
 * @version $id$
 */
public interface Suspendable
{
	/**
	 * Sets the <code>suspended</code> property of the object to provided
	 * boolean value.
	 */
	void setSuspended(boolean suspended);

	/**
	 * Returns the value of the <code>suspended</code> property of this object.
	 *
	 * @return DOCUMENT ME!
	 */
	boolean isSuspended();
}

/* __oOo__ */
