package de.desy.acop.chart;
import java.awt.*;
import java.text.*;

public class AcopConst
{
    protected static DecimalFormat textFormat = new DecimalFormat("#0.0000");
    protected static int  max_points = 524288;   //	8192*64
    protected static double zero_check = 1.0e-30;

    protected static int  N_TIME = 6;
    protected static int  timeMax[] = {100, 100, 100, 100, 20, 1000},
                        timeScale[] = {1, 60, 3600, 86400, 2592000, 31536000};
    protected static java.lang.String[] timeStr = {"Seconds", "Minutes", "Hours", "Days", "Months", "Years"};

    protected static int  MAX_DISPLAY = 100;    // maximum # of curves
    protected static int  MAX_TEXT = 100;    // maximum # of text strings
    protected static int  N_DEF_DISPLAY = 20;    // maximum # of curves for averaging
    protected static int  TEXT_MOVE = 3;    // x move bit 0; y move bit 1
    protected static int  lengthZoom = 20;
    protected static int  MAX_BACKGROUND_REGION = 16;
    protected static int  MAX_AXIS = 2;     // maximum # of Axis
    
    protected static int  NEW_PRINT_WINDOW = 4;
    protected static int  NEW_TEXT_WINDOW = 3;
    protected static int  NEW_ZOOM_WINDOW = 2;
    protected static int  NEW_MOVE_WINDOW = 1;

    protected static int  FFT_SPEKTRUM   = 0x1;	// spektrum + 0
    protected static int  FFT_PHASE      = 0x2;	// phase + 0
    protected static int  FFT_SP	       = 0x3;	// spektrum + phase
    protected static int  FFT_RI	       = 0x4;	// real part + imaginary part
    protected static int  FFT_REAL       = 0x5; // real part
    protected static int  FFT_IMAGINARY  = 0x6; // imaginary part
    protected static int  FFT_RI_INVERSE = 0x7; // inverse FFT for real and imaginary

    protected static int  PS_SOLID = 0,
                          PS_DASH = 1,
                          PS_DOT = 2,
                          PS_DASH_DOT = 3;

    protected static int  mode_polyline = 0,
                        mode_barline = 1,
                        mode_histogram = 2,
                        mode_dots = 3,
                        mode_histogram_rastoring = 4,
                        mode_rectangle = 5,
                        mode_circle = 6,
                        mode_textbox = 7;
                        
    protected static double log_check(double x)
    {
      if ( x < 1.0e-14 ) x = 1.0e-15;
      return x;
    }

	protected static BasicStroke createStroke(float penWidth, int penStyle)
	{ BasicStroke stroke;
		
	  if ( penStyle == PS_SOLID )
	  {
  		if ( penWidth <= 1 ) stroke = new BasicStroke((float)penWidth);
	  	else stroke = new BasicStroke((float)penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER);
	  }
	  else if ( penStyle == AcopConst.PS_DASH )
		  stroke = new BasicStroke((float)penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,(float)penWidth,new float[]{6.f,2.f},6f);
	  else if ( penStyle == AcopConst.PS_DOT )
		  stroke = new BasicStroke((float)penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,(float)penWidth,new float[]{2.f,2.f},2f);
	  else
		  stroke = new BasicStroke((float)penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER,(float)penWidth,new float[]{2.f,2.f,6.f,2.f},2f);

	  return stroke;
	}

}