/*
 * Copyright (c) 2006 Stiftung Deutsches Elektronen-Synchroton,
 * Member of the Helmholtz Association, (DESY), HAMBURG, GERMANY.
 *
 * THIS SOFTWARE IS PROVIDED UNDER THIS LICENSE ON AN "../AS IS" BASIS.
 * WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. SHOULD THE SOFTWARE PROVE DEFECTIVE
 * IN ANY RESPECT, THE USER ASSUMES THE COST OF ANY NECESSARY SERVICING, REPAIR OR
 * CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE.
 * NO USE OF ANY SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.
 * DESY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 * OR MODIFICATIONS.
 * THE FULL LICENSE SPECIFYING FOR THE SOFTWARE THE REDISTRIBUTION, MODIFICATION,
 * USAGE AND OTHER RIGHTS AND OBLIGATIONS IS INCLUDED WITH THE DISTRIBUTION OF THIS
 * PROJECT IN THE FILE LICENSE.HTML. IF THE LICENSE IS NOT INCLUDED YOU MAY FIND A COPY
 * AT HTTP://WWW.DESY.DE/LEGAL/LICENSE.HTM
 */

package de.desy.acop.chart;
import java.awt.Rectangle;

public class AcopFrame
{
	protected java.awt.Color frameForeColor;
	protected java.awt.Font frameFont;
  protected boolean leftTimeLabel;   // it is valid only for x
  protected boolean absTimeDisplay;
	protected int histogramPosition;
  protected Rectangle histRect;    // pixel width and height
	protected boolean drawFlag;
	
	protected int ZoomExtent;
  protected Rectangle zoomIcon;
	
	protected int xleft, xright, dxwidth, absxleft;

  public AcopFrame()
	{
      histRect = new Rectangle();
      zoomIcon = new Rectangle();
      ZoomExtent = 36;
		//{{INIT_CONTROLS
		//}}
	}
	
	//{{DECLARE_CONTROLS
  protected void getOxleftright(AcopHisto pHisto, AcopScale pScale)
  { int Rest, Wpixel, Offset;
      
    if ( pHisto.dismode == AcopConst.mode_histogram_rastoring )
    {
      dxwidth = Math.min( histRect.width, (int)(pScale.max-pScale.min) );
      if (dxwidth < 2) dxwidth = pHisto.npoints > 2 ? pHisto.npoints - 1 : 1;
      if ( histRect.width >= dxwidth )
      {
        Wpixel = histRect.width / dxwidth;        // space between two indices
    	  Offset = histRect.width % Wpixel;		    // fractions to get rid of
    	  Rest = ((histRect.width-Offset) % dxwidth);// rest to compensate histogram
    	  if ( histogramPosition == 0 )	    		// left adjusted
        {
      		xleft = 0;
	   	    xright = histRect.width - Rest - Offset;
        }
        else if ( histogramPosition == 2 )  // right adjusted
        {
      		xleft = Rest + Offset;
		      xright = histRect.width;
		    }
  		  else									// centered
	      {
          xleft = Rest/2;
          xright = histRect.width - (Rest - Rest/2) - Offset;
    	  }
    	}
    }
    else
    {
      xleft  = 0;
    	xright = histRect.width;
    }
    dxwidth = xright - xleft;
    absxleft = xleft + histRect.x;
  }
	//}}
}

