/*
 * Copyright (c) 2006 Stiftung Deutsches Elektronen-Synchroton,
 * Member of the Helmholtz Association, (DESY), HAMBURG, GERMANY.
 *
 * THIS SOFTWARE IS PROVIDED UNDER THIS LICENSE ON AN "../AS IS" BASIS.
 * WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. SHOULD THE SOFTWARE PROVE DEFECTIVE
 * IN ANY RESPECT, THE USER ASSUMES THE COST OF ANY NECESSARY SERVICING, REPAIR OR
 * CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE.
 * NO USE OF ANY SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.
 * DESY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 * OR MODIFICATIONS.
 * THE FULL LICENSE SPECIFYING FOR THE SOFTWARE THE REDISTRIBUTION, MODIFICATION,
 * USAGE AND OTHER RIGHTS AND OBLIGATIONS IS INCLUDED WITH THE DISTRIBUTION OF THIS
 * PROJECT IN THE FILE LICENSE.HTML. IF THE LICENSE IS NOT INCLUDED YOU MAY FIND A COPY
 * AT HTTP://WWW.DESY.DE/LEGAL/LICENSE.HTM
 */

package de.desy.acop.chart;
import java.awt.BasicStroke;

public class AcopLine
{
    private static int  dash = 6,
                        dot = 3,
                        empty = 3;
    protected static java.awt.Graphics a;
	protected static BasicStroke stroke = new BasicStroke(1.0f); 
    
    protected int LineMode;
    protected java.awt.Color LineColor;
    protected int LineWidth;

    public AcopLine()
    {
    }
//    public AcopLine(java.awt.Graphics ga, java.awt.Color c)
//  {
//      LineColor = c;
//      a = ga;
//    }

    protected void drawAcopLine(int x1, int y1, int x2, int y2)
    { int length,tmp;

      if ( x1 == x2 )
      {
        if (y2<y1)
        {
          tmp = y2;
          y2=y1;
          y1=tmp;
        }
      }
      else
      {
        if (x2<x1)
        {
          tmp = x2;
          x2=x1;
          x1=tmp;
        }
      }
      
        if ( LineMode == 0 )
        {
          if ( LineWidth < 2 ) a.drawLine(x1,y1,x2,y2);
          else
          {
            if ( y1 == y2 ) a.fillRect(x1,y1-LineWidth/2,x2-x1,LineWidth);
            else a.fillRect(x1-LineWidth/2,y1,LineWidth,y2-y1);
          }
        }
        else
        {
          if ( LineMode == 2 ) length = dot;  // dot-dot
          else length = dash;                  // dash-dash or dash-dot-dot
          
          if ( x1 == x2 )
          {
            for ( ; y1 < y2;  )
            {
              if ( y2-y1 >= length )
              {
                if ( LineWidth < 2 ) a.drawLine(x1,y1,x2,y1+length);
                else a.fillRect(x1-LineWidth/2,y1,LineWidth,length);
                
                y1 += length + empty;
                if ( LineMode == 3 )    // dash-dot-dot
                {
                  if ( y1 + (dot + empty) < y2 )
                  {
                    if ( LineWidth < 2 ) a.drawLine(x1,y1,x2,y1+dot);
                    else a.fillRect(x1-LineWidth/2,y1,LineWidth,dot);
                    y1 += (dot + empty);
                    if ( y1 + (dot + empty) < y2 )
                    {
                      if ( LineWidth < 2 ) a.drawLine(x1,y1,x2,y1+dot);
                      else a.fillRect(x1-LineWidth/2,y1,LineWidth,dot);
                      y1 += (dot + empty);
                    }
                  }
                }
              }
              else
              {
                if ( LineWidth < 2 ) a.drawLine(x1,y1,x2,y2);
                else a.fillRect(x1-LineWidth/2,y1,LineWidth,y2-y1);
                break;
              }
            }     
          }
          else
          {
            for ( ; x1 < x2;  )
            {
              if ( x2-x1 >= length )
              {
                if ( LineWidth < 2 ) a.drawLine(x1,y1,x1+length,y2);
                else a.fillRect(x1,y1-LineWidth/2,length,LineWidth);
                x1 += length+empty;
                if ( LineMode == 3 )    // dash-dot-dot
                {
                  if ( x1 + (dot + empty) < x2 )
                  {
                    if ( LineWidth < 2 ) a.drawLine(x1,y1,x1+dot,y2);
                    else a.fillRect(x1,y1-LineWidth/2,dot,LineWidth);
                    x1 += (dot + empty);
                    if ( x1 + (dot + empty) < x2 )
                    {
                      if ( LineWidth < 2 ) a.drawLine(x1,y1,x1+dot,y2);
                      else a.fillRect(x1,y1-LineWidth/2,dot,LineWidth);
                      x1 += (dot + empty);
                    }
                  }
                }
              }
              else
              {
                if ( LineWidth < 2 ) a.drawLine(x1,y1,x2,y2);
                else a.fillRect(x1,y1-LineWidth/2,x2-x1,LineWidth);
                break;
              }
            }     
          }
        }
      
    }
}
