/*
 * Copyright (c) 2006 Stiftung Deutsches Elektronen-Synchroton,
 * Member of the Helmholtz Association, (DESY), HAMBURG, GERMANY.
 *
 * THIS SOFTWARE IS PROVIDED UNDER THIS LICENSE ON AN "../AS IS" BASIS.
 * WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. SHOULD THE SOFTWARE PROVE DEFECTIVE
 * IN ANY RESPECT, THE USER ASSUMES THE COST OF ANY NECESSARY SERVICING, REPAIR OR
 * CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE.
 * NO USE OF ANY SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.
 * DESY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 * OR MODIFICATIONS.
 * THE FULL LICENSE SPECIFYING FOR THE SOFTWARE THE REDISTRIBUTION, MODIFICATION,
 * USAGE AND OTHER RIGHTS AND OBLIGATIONS IS INCLUDED WITH THE DISTRIBUTION OF THIS
 * PROJECT IN THE FILE LICENSE.HTML. IF THE LICENSE IS NOT INCLUDED YOU MAY FIND A COPY
 * AT HTTP://WWW.DESY.DE/LEGAL/LICENSE.HTM
 */

package de.desy.acop.chart.customizer;

import java.awt.GridBagLayout;
import java.beans.Customizer;

import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import de.desy.acop.chart.Acop;

/**
 * @author wu To change the template for this generated type comment go to
 *         Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AcopCustomizer extends JTabbedPane implements Customizer
{
  private static final long serialVersionUID = -7625213490859479986L;
//  private String accessRate, accessRateOld;
//  private AccessMode accessMode;
  // private int accessModeIndex, accessModeIndexOld;
  // private AccessMode[] accessModeString = AccessMode.values();
  protected Acop bean; // The bean being customized.
  private ColorCustomizerPanel colorCustomizer;
  private DisplayCustomizerPanel displayCustomizer;
  private FrameCustomizerPanel frameCustomizer;
  private GraphCustomizerPanel graphCustomizer;
  private AxisCustomizerPanel axisCustomizer;
  private SpecialCustomizerPanel specialCustomizer;
  private MarkersCustomizerPanel markersCustomizer;
  /**
   * This is the default constructor
   */
  public AcopCustomizer()
  {
    super();
    initialize();
  }
  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize()
  {
    setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
    
    JPanel p = new JPanel();
    p.setLayout(new GridBagLayout());
    
    displayCustomizer = new DisplayCustomizerPanel();
    addTab("Display", displayCustomizer);
    
    frameCustomizer = new FrameCustomizerPanel();
    addTab("Frame", frameCustomizer);

    graphCustomizer = new GraphCustomizerPanel();
    addTab("Graph", graphCustomizer);
    
    axisCustomizer = new AxisCustomizerPanel();
    addTab("Axis", axisCustomizer);

    specialCustomizer = new SpecialCustomizerPanel();
    addTab("Special", specialCustomizer);

    markersCustomizer = new MarkersCustomizerPanel();
    addTab("Markers", markersCustomizer);

    colorCustomizer = new ColorCustomizerPanel();
    addTab("Colors", colorCustomizer);
    
    this.setSize(478, 297);
  }
  public void setObject(Object o)
  {
    bean = (Acop) o; // Save the object we're customizing.
    displayCustomizer.setAcopBean(bean);
    frameCustomizer.setAcopBean(bean);
    graphCustomizer.setAcopBean(bean);
    axisCustomizer.setAcopBean(bean);
    specialCustomizer.setAcopBean(bean);
    markersCustomizer.setAcopBean(bean);
    colorCustomizer.setAcopBean(bean);
  }

} // @jve:decl-index=0:visual-constraint="7,1"
