/*
 * Copyright (c) 2006 Stiftung Deutsches Elektronen-Synchroton,
 * Member of the Helmholtz Association, (DESY), HAMBURG, GERMANY.
 *
 * THIS SOFTWARE IS PROVIDED UNDER THIS LICENSE ON AN "../AS IS" BASIS.
 * WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. SHOULD THE SOFTWARE PROVE DEFECTIVE
 * IN ANY RESPECT, THE USER ASSUMES THE COST OF ANY NECESSARY SERVICING, REPAIR OR
 * CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE.
 * NO USE OF ANY SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.
 * DESY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 * OR MODIFICATIONS.
 * THE FULL LICENSE SPECIFYING FOR THE SOFTWARE THE REDISTRIBUTION, MODIFICATION,
 * USAGE AND OTHER RIGHTS AND OBLIGATIONS IS INCLUDED WITH THE DISTRIBUTION OF THIS
 * PROJECT IN THE FILE LICENSE.HTML. IF THE LICENSE IS NOT INCLUDED YOU MAY FIND A COPY
 * AT HTTP://WWW.DESY.DE/LEGAL/LICENSE.HTM
 */

package de.desy.acop.chart.customizer;

import java.lang.reflect.Method;
import java.util.Vector;
import javax.swing.ComboBoxModel;
import javax.swing.JComboBox;
import de.desy.acop.chart.Acop;

public class AcopJComBox<T> extends JComboBox<T>
{
  private static final long serialVersionUID = 2197104263845671411L;
  private Acop acopBean;
  private String proper;
  private int index;
  public AcopJComBox(ComboBoxModel<T> aModel)
  {
    super(aModel);
  }
  public AcopJComBox(T[] items)
  {
    super(items);
  }
  public AcopJComBox(Vector<T> items)
  {
    super(items);
  }
  public AcopJComBox()
  {
    super();
  }
  public void setAcopBean(Acop Bean)
  {
    acopBean = Bean;
    try
    {
      Method m = acopBean.getClass().getMethod("get" + proper);
      index = (Integer) m.invoke(acopBean);
      this.setSelectedIndex(index);
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }
  public AcopJComBox(String property, T[] enumObject)
  {
    super();
    proper = property;
    for (int i = 0; i < enumObject.length; i++)
      this.addItem(enumObject[i]);
    addItemListener(new java.awt.event.ItemListener()
    {
      public void itemStateChanged(java.awt.event.ItemEvent e)
      {
        if (index != getSelectedIndex())
        {
          if (acopBean != null)
          {
            try
            {
              Method m = acopBean.getClass().getMethod("set" + proper, int.class);
              int soll = getSelectedIndex();
              m.invoke(acopBean, soll);
//              System.out.println("set JComBox property: " + proper + "   value: " + soll); 
              firePropertyChange(proper, index, soll);
              index = soll;
            }
            catch (Exception ex)
            {
              ex.printStackTrace();
            }
          }
        }
      }
    });
  }
}
