package de.desy.acop.displayers.chart;

import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;

import de.desy.acop.chart.AcopGraphStyleEnum;

/**
 * 
 * <code>StyleComboRenderer</code> is renderer to be used in combination
 * with the lists displaying {@link AcopGraphStyleEnum}. This renderer
 * only displays the second part of the enumeration (only the y axis style).
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public class StyleComboRenderer extends DefaultListCellRenderer {

	private static final long serialVersionUID = 1L;

	/*
	 * (non-Javadoc)
	 * @see javax.swing.DefaultListCellRenderer#getListCellRendererComponent(javax.swing.JList, java.lang.Object, int, boolean, boolean)
	 */
	@Override
	public Component getListCellRendererComponent(JList<?> list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
		if (value instanceof AcopGraphStyleEnum) {
			AcopGraphStyleEnum style = (AcopGraphStyleEnum)value;
			String name = style.name();
			String n = name.toLowerCase();
			if (n.startsWith("time")) {
				name = name.substring(4);
			} else if (n.startsWith("lin") || n.startsWith("log")) {
				name = name.substring(3);
			}
			value = name;
		}
		return super.getListCellRendererComponent(list,value,index,isSelected,cellHasFocus);
		
	}
}
