/**
 * File: EStatusRoot.java
 * Date: Aug 23, 2010
 */
package de.desy.acop.displayers.tarantula;

/**
 * Root status enumeration.
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: EStatusRoot.java 40186 2010-11-03 14:12:06Z walla $
 */
public enum EStatusRoot {

	/** Root node. */
	ROOT,
	
	/** Provokes on the root node that connections are refreshed. */
	ROOT_REFRESH_CONNECTIONS,
	/** Provokes on the root node that refreshing the connections are finished. */
	ROOT_REFRESH_FINISHED,
	
	/** Provokes on the root node that the user should press the refresh button to 
	 * start refreshing all connections. */
	ROOT_REFRESH_PRESS_BUTTON_TO_REFRESH,
	/** Provokes on the root node that the user should wait until the update starts. */
	ROOT_REFRESH_WAIT_FOR_REFRESH,
	
	/** Time has exceeded. */
	ROOT_TIME_EXCEEDED,
	
	/** Only failed connections are represented in the tree structure. */
	ROOT_ONLY_FAILED_CONNECTIONS,
	
	/** Non connection failed. */
	ROOT_NON_CONNECTION_FAILED;
}
/* end of file */