/**
 * File: TarantulaEvent.java
 * Date: Jul 29, 2010
 */
package de.desy.acop.displayers.tarantula;

import java.util.EventObject;

/**
 * Tarantula event. Is used by the {@link ITarantulaUpdateListener#refreshTarantula(TarantulaEvent)}
 * event.
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: TarantulaEvent.java 40186 2010-11-03 14:12:06Z walla $
 */
final class TarantulaEvent extends EventObject {

	// --- CLASS FIELDS --------------------------------------------------------
	
	private static final long serialVersionUID = -4693409957886923420L;

	// --- INSTANCE FIELDS -----------------------------------------------------
	
	private final TarantulaPanel.ERefresh state;
	
	// --- CONSTRUCTOR ---------------------------------------------------------

	/**
	 * Constructor.
	 * 
	 * @param source Source.
	 * @param state Tarantula refresh state.
	 */
	TarantulaEvent(final Object source, final TarantulaPanel.ERefresh state) {
		super(source);
		this.state = state;
	}
	
	// --- INSTANCE METHODS ----------------------------------------------------

	/**
	 * Returns the tarantula update state.
	 * @return Update state.
	 */
	public TarantulaPanel.ERefresh getUpdateState() { return this.state; }
	
	@Override public String toString() { return this.state.toString(); }
}
/* end of file */