/**
 * 
 */
package de.desy.acop.displayers.tarantula;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * Application version specification. Provides different annotation styled 
 * entries which give the developer information about the application.
 * 
 * @author <a href="marcus.walla(at)desy.de">Marcus Walla</a>
 * @version $Id: Version.java 40186 2010-11-03 14:12:06Z walla $
 */
@Retention(RetentionPolicy.RUNTIME)
public @interface Version {
	/** Returns the organization. */
	String organization() default "DESY Hamburg";
	/** Returns the developer names, normally with its first- and surname. */
	String[] developers();
	/** Returns the e-mail addresses of the developers. */
	String[] emails();
	/** Returns the application name. */
	String application();
	/** Returns the mailing list e-mail address. By default the 
	 * developer@mcs.desy.de e-mail address is returned. */
	String mailinglist() default "developer@mcs.desy.de";
	/** Returns the building. */
	String building();
	/** Returns the rooms. */
	String[] rooms();
	/** Returns the phone numbers. */
	String[] phones();
	/** Returns the group. */
	String group();
	/** Returns the major version number. By default the number 1 is returned. */
	int major() default 1;
	/** Returns the minor version number. By default the number 0 is returned. */
	int minor() default 0;
	/** Returns the build version number. By default the number 0 is returned. */
	int build() default 0;
	/** Returns the release date. */
	String releaseDate();
}
/* end of file */