/*
 * Copyright (c) 2006 Stiftung Deutsches Elektronen-Synchroton,
 * Member of the Helmholtz Association, (DESY), HAMBURG, GERMANY.
 *
 * THIS SOFTWARE IS PROVIDED UNDER THIS LICENSE ON AN "../AS IS" BASIS.
 * WITHOUT WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE. SHOULD THE SOFTWARE PROVE DEFECTIVE
 * IN ANY RESPECT, THE USER ASSUMES THE COST OF ANY NECESSARY SERVICING, REPAIR OR
 * CORRECTION. THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF THIS LICENSE.
 * NO USE OF ANY SOFTWARE IS AUTHORIZED HEREUNDER EXCEPT UNDER THIS DISCLAIMER.
 * DESY HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
 * OR MODIFICATIONS.
 * THE FULL LICENSE SPECIFYING FOR THE SOFTWARE THE REDISTRIBUTION, MODIFICATION,
 * USAGE AND OTHER RIGHTS AND OBLIGATIONS IS INCLUDED WITH THE DISTRIBUTION OF THIS
 * PROJECT IN THE FILE LICENSE.HTML. IF THE LICENSE IS NOT INCLUDED YOU MAY FIND A COPY
 * AT HTTP://WWW.DESY.DE/LEGAL/LICENSE.HTM
 */

package de.desy.acop.displayers.tools;

import java.awt.datatransfer.DataFlavor;
import java.beans.PropertyVetoException;

import javax.swing.JComponent;

import com.cosylab.gui.displayers.DisplayerParameters;
import com.cosylab.util.CommonException;

/**
 * <code>AcopMultipleDisplayerParametersTransferHandler</code> is a TransferHandler
 * that can handle MultipleAcopDisplayers.
 * 
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @see MultipleAcopDisplayer
 */
public class AcopMultipleDisplayerParametersTransferHandler extends AbstractMDPTransferHandler{
	
	private static final long serialVersionUID = 4277524441131938702L;

	public AcopMultipleDisplayerParametersTransferHandler(MultipleAcopDisplayer<?> comp, boolean reciveEnabled, boolean exportEnabled, DataFlavor[] f, boolean resetFlavors) {
		super((JComponent)comp, reciveEnabled, exportEnabled, f, resetFlavors);
	}
	
	@Override
	protected AcopDisplayerParameters[] exportMultipleDisplayerParameters() {
		return ((MultipleAcopDisplayer<?>)displayer).getDisplayerParameters();
	}
	
	@SuppressWarnings({"unchecked","rawtypes"})
	@Override
	public boolean setParametersToDisplayer(Object disp, DisplayerParameters parameters) throws PropertyVetoException {
		try {
			if (parameters instanceof AcopDisplayerParameters) {
				((MultipleAcopDisplayer)displayer).addDisplayerParameters((AcopDisplayerParameters) parameters);
				return true;
			}
		} catch (CommonException e) {
			e.printStackTrace();
		}
		return super.setParametersToDisplayer(disp, parameters);
	}
	
}
