package de.desy.acop.displayers.tools;

import de.desy.tine.dataUtils.TDataType;


/**
 * 
 * <code>DataUtilities</code> provides methods to transform data into a 
 * proper tine formats.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @deprecated use {@link TDataType#toTDataType(String, String)} instead
 */
@Deprecated
public class DataUtilities {
	
	@SuppressWarnings("unused")
	private static int getInteger(String s) {
		if (s.compareToIgnoreCase("true") == 0)
			return 1;
		if (s.compareToIgnoreCase("false") == 0)
			return 0;
		if (s.startsWith("0x") || s.startsWith("0X") || s.startsWith("&H") || s.startsWith("&h"))
			return Integer.parseInt(s.substring(2),16);
		return Integer.parseInt(s);
	}

	@SuppressWarnings("unused")
	private static short getShort(String s) {
		if (s.startsWith("0x") || s.startsWith("0X") || s.startsWith("&H") || s.startsWith("&h"))
			return Short.parseShort(s.substring(2),16);
		return Short.parseShort(s);
	}

	@SuppressWarnings("unused")
	private static long getLong(String s) {
		if (s.startsWith("0x") || s.startsWith("0X") || s.startsWith("&H") || s.startsWith("&h"))
			return Long.parseLong(s.substring(2),16);
		return Long.parseLong(s);
	}

	@SuppressWarnings("unused")
	private static byte getByte(String s) {
		if (s.startsWith("0x") || s.startsWith("0X") || s.startsWith("&H") || s.startsWith("&h"))
			return Byte.parseByte(s.substring(2),16);
		return Byte.parseByte(s);
	}
	
	/**
	 * Returns the {@link TDataType} that matches the given format
	 * and contains the given text as the data object.
	 * 
	 * @param format the format of the data
	 * @param text the data
	 * @return tine data object
	 * @deprecated use TDataType#toDataType()
	 */
	@Deprecated
	public static TDataType getInputData(String format, String text) {
	    return TDataType.toTDataType(text, format);
	    // p.d. move the code below into TDataType from tine.jar 
	    // this makes more sense as any new data types get added there
	    // and that's where the parsing rules should be ...
//		if (text.length() == 0)
//			return null;
//		short fmtcode = TFormat.getFormatCode(format);
//		String del = " ";
//		if (text.indexOf(',') != -1)
//			del = ",";
//		String[] vars = new String[text.length()]; // worst case
//		String[] v = text.split("\n");
//		int siz = 0, len = 0;
//		if (v.length > 1 && TFormat.isVariableLengthString(fmtcode)) {
//			for (int p = 0; p < v.length; p++)
//				vars[siz++] = v[p].trim();
//		} else {
//			for (int n = 0; n < v.length; n++) {
//				String[] sv = del == null ? v : v[n].trim().split(del);
//				for (int p = 0; p < sv.length; p++)
//					vars[siz++] = sv[p].trim();
//			}
//		}
//		int i = 0, retrycnt = 2;
//		while (retrycnt-- > 0) {
//			try {
//				switch (fmtcode) {
//				case TFormat.CF_DOUBLE: {
//					double[] vals = new double[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = new Double(vars[i]).doubleValue();
//					return new TDataType(vals);
//				}
//				case TFormat.CF_SHORT: {
//					short[] vals = new short[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = getShort(vars[i]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_BOOLEAN: {
//					boolean[] vals = new boolean[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = getInteger(vars[i]) == 0 ? false : true;
//					return new TDataType(vals);
//				}
//				case TFormat.CF_LONG: {
//					int[] vals = new int[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = getInteger(vars[i]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_DLONG: {
//					long[] vals = new long[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = getInteger(vars[i]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_FLOAT: {
//					float[] vals = new float[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = new Float(vars[i]).floatValue();
//					return new TDataType(vals);
//				}
//				case TFormat.CF_BYTE: {
//					byte[] vals = new byte[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = getByte(vars[i]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_TEXT: {
//					return new TDataType(text);
//				}
//				case TFormat.CF_XML: {
//					TDataType tdt = new TDataType(text);
//					tdt.dFormat = TFormat.CF_XML;
//					return tdt;
//				}
//				case TFormat.CF_NAME8: {
//					NAME8[] vals = new NAME8[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = new NAME8(vars[i]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME16: {
//					NAME16[] vals = new NAME16[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = new NAME16(vars[i]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME32: {
//					NAME32[] vals = new NAME32[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = new NAME32(vars[i]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME48: {
//					NAME48[] vals = new NAME48[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = new NAME48(vars[i]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME64: {
//					NAME64[] vals = new NAME64[siz];
//					for (i = 0; i < siz; i++)
//						vals[i] = new NAME64(vars[i]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME16I: {
//					len = siz / 2;
//					NAME16I[] vals = new NAME16I[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new NAME16I(vars[i * 2],getInteger(vars[i * 2 + 1]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME32I: {
//					len = siz / 2;
//					NAME32I[] vals = new NAME32I[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new NAME32I(vars[i * 2],getInteger(vars[i * 2 + 1]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME48I: {
//					len = siz / 2;
//					NAME48I[] vals = new NAME48I[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new NAME48I(vars[i * 2],getInteger(vars[i * 2 + 1]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME64I: {
//					len = siz / 2;
//					NAME64I[] vals = new NAME64I[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new NAME64I(vars[i * 2],getInteger(vars[i * 2 + 1]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_STRING: {
//					return new TDataType(vars,siz);
//				}
//                case TFormat.CF_KEYVALUE: {
//                  KEYVALUE[] vals = new KEYVALUE[siz];
//                  for (i = 0; i < siz; i++) vals[i] = new KEYVALUE(vars[i]);
//                  return new TDataType(vals,siz);
//              }
//				case TFormat.CF_UNAME: {
//					len = siz / 5;
//					UNAME[] vals = new UNAME[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new UNAME(getInteger(vars[i * 5]),new Float(vars[i * 5 + 1]).floatValue(),new Float(vars[i * 5 + 2])
//								.floatValue(),new Float(vars[i * 5 + 3]).floatValue(),vars[i * 5 + 4]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_USTRING: {
//					len = siz / 5;
//					USTRING[] vals = new USTRING[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new USTRING(getInteger(vars[i * 5]),new Float(vars[i * 5 + 1]).floatValue(),new Float(vars[i * 5 + 2])
//								.floatValue(),getInteger(vars[i * 5 + 3]),vars[i * 5 + 4]);
//					return new TDataType(vals);
//				}
//				case TFormat.CF_INTINT: {
//					len = siz / 2;
//					INTINT[] vals = new INTINT[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new INTINT(getInteger(vars[i * 2]),getInteger(vars[i * 2 + 1]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_FLTINT: {
//					len = siz / 2;
//					FLTINT[] vals = new FLTINT[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new FLTINT(new Float(vars[i * 2]).floatValue(),getInteger(vars[i * 2 + 1]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_FLTFLT: {
//					len = siz / 2;
//					FLTFLT[] vals = new FLTFLT[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new FLTFLT(new Float(vars[i * 2]).floatValue(),new Float(vars[i * 2 + 1]).floatValue());
//					return new TDataType(vals);
//				}
//				case TFormat.CF_DBLDBL: {
//					len = siz / 2;
//					DBLDBL[] vals = new DBLDBL[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new DBLDBL(new Double(vars[i * 2]).doubleValue(),new Double(vars[i * 2 + 1]).doubleValue());
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME16FI: {
//					len = siz / 3;
//					NAME16FI[] vals = new NAME16FI[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new NAME16FI(vars[i * 3],getInteger(vars[i * 3 + 2]),new Float(vars[i * 3 + 1]).floatValue());
//					return new TDataType(vals);
//				}
//				case TFormat.CF_NAME16II: {
//					len = siz / 3;
//					NAME16II[] vals = new NAME16II[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new NAME16II(vars[i * 3],getInteger(vars[i * 3 + 1]),getInteger(vars[i * 3 + 2]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_FLTFLTINT: {
//					len = siz / 3;
//					FLTFLTINT[] vals = new FLTFLTINT[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new FLTFLTINT(new Float(vars[i * 3]).floatValue(),new Float(vars[i * 3 + 1]).floatValue(),
//								getInteger(vars[i * 3 + 2]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_FLTINTINT: {
//					len = siz / 3;
//					FLTINTINT[] vals = new FLTINTINT[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new FLTINTINT(new Float(vars[i * 3]).floatValue(),getInteger(vars[i * 3 + 1]),getInteger(vars[i * 3 + 2]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_INTFLTFLTFLT: {
//					len = siz / 4;
//					INTFLTFLTFLT[] vals = new INTFLTFLTFLT[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new INTFLTFLTFLT(getInteger(vars[i * 4]),new Float(vars[i * 4 + 1]).floatValue(),new Float(
//								vars[i * 4 + 2]).floatValue(),new Float(vars[i * 4 + 3]).floatValue());
//					return new TDataType(vals);
//				}
//				case TFormat.CF_INTFLTINT: {
//					len = siz / 3;
//					INTFLTINT[] vals = new INTFLTINT[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new INTFLTINT(getInteger(vars[i * 3]),new Float(vars[i * 3 + 1]).floatValue(),getInteger(vars[i * 3 + 2]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_INTINTFLTFLT: {
//					len = siz / 4;
//					INTINTFLTFLT[] vals = new INTINTFLTFLT[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new INTINTFLTFLT(new Float(vars[i * 4 + 2]).floatValue(),new Float(vars[i * 4 + 3]).floatValue(),
//								getInteger(vars[i * 4]),getInteger(vars[i * 4 + 1]));
//					return new TDataType(vals);
//				}
//				case TFormat.CF_INTINTINTINT: {
//					len = siz / 4;
//					INTINTINTINT[] vals = new INTINTINTINT[len];
//					for (i = 0; i < len; i++)
//						vals[i] = new INTINTINTINT(getInteger(vars[i * 4]),getInteger(vars[i * 4 + 1]),getInteger(vars[i * 4 + 2]),
//								getInteger(vars[i * 4 + 3]));
//					return new TDataType(vals);
//				}
//  	            case TFormat.CF_WINDOW:
//		        {
//		            len = siz / 4;
//		            WINDOW[] vals = new WINDOW[len];
//		            for (i = 0; i < len; i++)
//		              vals[i] = new WINDOW(getInteger(vars[i * 4]), getInteger(vars[i * 4 + 1]), 
//		                  getInteger(vars[i * 4 + 2]), getInteger(vars[i * 4 + 3]));
//		            return new TDataType(vals);
//		        }
//				}
//				return null;
//			}
//			catch (NumberFormatException e) {
//				siz = i;
//			}
//		}
//		return null;
	}
}
