package de.desy.acop.transport.adapters;

import com.cosylab.gui.displayers.DataConsumer;
import com.cosylab.util.CommonException;

/**
 * 
 * <code>TineDualArrayConsumer</code> is a consumer which accepts two double arrays. This kind of consumer is normally
 * associated with FLTFLT (or similar) type channels.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public interface TineDualArrayConsumer extends DataConsumer {
    
    /**
     * Notifys this consumer about new dynamic value update.
     *
     * @param timestamp the time of dynamic value event
     * @param systemstamp the system timestamp of the event
     * @param userstamp the user timestamp of the event
     * @param firstValue the primary array of the new value
     * @param secondValue the secondary array of the new value
     */
    public void updateValue(long timestamp, long systemstamp, long userstamp, double[] firstValue, double[] secondValue)
        throws CommonException;
}