package de.desy.acop.transport.adapters;

import com.cosylab.gui.displayers.DataConsumer;
import com.cosylab.util.CommonException;


/**
 * 
 * <code>TineStringSeqConsumer</code> is a double sequence consumer,
 * which is designed specially for TINE to receive 3 different
 * timestamps.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public interface TineStringSeqConsumer extends DataConsumer {
	
	/**
	 * Notifys this consumer about new dynamic value update.
	 *
	 * @param timestamp the time of dynamic value event
	 * @param systemstamp the system timestamp of the event
	 * @param userstamp the user timestamp of the event
	 * @param value new value
	 */
	public void updateValue(long timestamp, long systemstamp, long userstamp, String[] value)
		throws CommonException;
}