package de.desy.acop.video.analysis;

/**
 *
 * <code>AnalysisType</code> defines the two possible analysis types which are available for selection in the
 * customizer.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public enum AnalysisType {
    //for backward compatibility the names are like they are
	GAUSSIAN,INTERFEROMETER_H,INTERFEROMETER_V,INTERFEROMETER_BOTH,INTERFEROMETER_BESSEL,
	INTERFEROMETER_BESSEL_V, INTERFEROMETER_BESSEL_H, GAUSSIAN2D;

    /*
     * (non-Javadoc)
     * @see java.lang.Enum#toString()
     */
    @Override
    public String toString() {
        if (this == GAUSSIAN) return "Gaussian";
        else if (this == GAUSSIAN2D) return "Gaussian 2-dimensional";
        else if (this == INTERFEROMETER_V) return "Interferometer (Vertical)";
        else if (this == INTERFEROMETER_H) return "Interferometer (Horizontal)";
        else if (this == INTERFEROMETER_BOTH) return "Interferometer (Both Sides)";
        else if (this == INTERFEROMETER_BESSEL) return "Interferometer Bessel (Both Sides)";
        else if (this == INTERFEROMETER_BESSEL_H) return "Interferometer Bessel (Horizontal)";
        else if (this == INTERFEROMETER_BESSEL_V) return "Interferometer Bessel (Vertical)";
        else return null;
    }
}
