/**
 *
 */
package de.desy.acop.video.analysis.decoders;

import java.awt.Color;

import de.desy.acop.video.analysis.ColorDecoder;

/**
 * </code>AvrerageColorDecoder</code> transforms the</code>TYPE_INT_ARGB</code>
 * integer color code into a normalized sum of red, green and blue components.
 *
 * @author Tilen Kusterle, Cosylab
 *
 */
public class AverageColorDecoder implements ColorDecoder {

	/* (non-Javadoc)
	 * @see de.desy.acop.video.analysis.ColorDecoder#transform(int)
	 */
	@Override
	@Deprecated
	public double transform(int code) {
		Color c = new Color(code, true);
		return (c.getRed()+c.getGreen()+c.getBlue())/765.0;
	}

	/*
	 * (non-Javadoc)
	 * @see de.desy.acop.video.analysis.ColorDecoder#transform(int[])
	 */
	@Override
	public double[] transform(int[] data) {
		int length = data.length;
		int code;
		double[] ret = new double[length];
		for (int i = 0; i < length; i++) {
			code = data[i];
			ret[i] = ((code >> 16) & 0xFF + (code >> 8) & 0xFF + (code >> 0) & 0xFF)/765.;
		}
		return ret;
	}

	@Override
	public double[] transformBGR(int[] data) {
	    return transformBGR(data);
	}

}
