package de.desy.acop.video.analysis.gaussian;

import de.desy.tine.types.IMAGE;

public class Gaussian2DImage extends AbstractGaussianImage {

    private static final String NAME = "G2DAISr4";

    /**
     * Constructs a new Gaussian2DImage, with default values (empty image and 0 value parameters and results).
     */
    public Gaussian2DImage() {
        super(NAME);
        initDone();
    }

    /**
     * Constructs a new Gaussian2DImage from the given Gaussian2DImage. This method creates a clone of the given image.
     *
     * @param image the image
     */
    public Gaussian2DImage(Gaussian2DImage image) {
        this(image.getImage(),image.getRoiX(),image.getRoiY(),image.getRoiW(),image.getRoiH(),image.getRoi2X(),
                image.getRoi2Y(),image.getRoi2W(),image.getRoi2H(),image.getThreshold(),image.getSideViewX(),
                image.getSideViewY(),image.getMeanX(),image.getStdX(),image.getMeanY(),image.getStdY(),
                image.getAmplitude2D(),image.getConst2D(),image.getAngle2D(),image.getThresholdPoints(),
                image.isCalculateThreshold(),image.isPerformFit(),image.isPerformSmoothing());
    }

    /**
     * Constructs a new Gaussian2DImage from parameters.
     */
    public Gaussian2DImage(IMAGE image, int roiX, int roiY, int roiW, int roiH, int roi2X, int roi2Y, int roi2W,
            int roi2H, double threshold, double[] sideViewX, double[] sideViewY, double meanX, double stdX,
            double meanY, double stdY, double amplitude, double constant, double angle, int thresholdPoints,
            boolean calculateThreshold, boolean performFit, boolean performSmoothing) {
        super(NAME,image,roiX,roiY,roiW,roiH,roi2X,roi2Y,roi2W,roi2H,threshold,sideViewX,sideViewY,meanX,stdX,meanY,
                stdY,amplitude,constant,angle,thresholdPoints,calculateThreshold,performFit,performSmoothing);
        initStructure();
        initDone();
    }
}
