package de.desy.acop.video.analysis.interferometer;

import de.desy.tine.types.IMAGE;

/**
 * <code>BesselIFMImage</code> is the analysis image structure which has been fitted with bessel functions.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public class BesselIFMImage extends DIFMImage {

    private static final String NAME = "BIFMISr4";

    /**
     * Construct new image.
     */
    public BesselIFMImage() {
        super(NAME);
        initDone();
    }

    /**
     * Copy the image.
     *
     * @param image the source
     */
    public BesselIFMImage(BesselIFMImage image) {
        this(image.getImage(),image.getRoiX(),image.getRoiY(),image.getRoiW(),image.getRoiH(),image.getRoi2X(),
                image.getRoi2Y(),image.getRoi2W(),image.getRoi2H(),image.getThreshold(),image.getSideViewX(),
                image.getSideViewY(),image.getConstantY(),image.getAmplitudeY(),image.getAsincY(),image.getPsincY(),
                image.getVisY(),image.getAcosY(),image.getPcosY(),image.getConstantX(),image.getAmplitudeX(),
                image.getAsincX(),image.getPsincX(),image.getVisX(),image.getAcosX(),image.getPcosX(),
                image.getThresholdPoints(),image.isCalculateThreshold(),image.isPerformFit(),
                image.isPerformSmoothing());
    }

    /**
     * @see DIFMImage
     */
    public BesselIFMImage(IMAGE image, int roiX, int roiY, int roiW, int roiH, int roi2X, int roi2Y, int roi2W,
            int roi2H, double threshold, double[] sideViewX, double[] sideViewY, double constantY, double amplitudeY,
            double asincY, double psincY, double visY, double acosY, double pcosY, double constantX, double amplitudeX,
            double asincX, double psincX, double visX, double acosX, double pcosX, int thresholdPoints,
            boolean calculateThreshold, boolean performFit, boolean performSmoothing) {
        super(NAME,image,roiX,roiY,roiW,roiH,roi2X,roi2Y,roi2W,roi2H,threshold,sideViewX,sideViewY,constantY,amplitudeY,
                asincY,psincY,visY,acosY,pcosY,constantX,amplitudeX,asincX,psincX,visX,acosX,pcosX,thresholdPoints,
                calculateThreshold,performFit,performSmoothing);
    }
}
