package de.desy.acop.video.displayer;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Formatter;
import java.util.logging.LogRecord;

/**
 * 
 * <code>LogFormatter</code> is the default formatter to be used with the image logger.
 * It formats the message with the timestamp at front.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public class LogFormatter extends Formatter {

	private DateFormat format = new SimpleDateFormat("dd.MM.yy HH:mm:ss.SSS z");
	
	/*
	 * (non-Javadoc)
	 * @see java.util.logging.Formatter#format(java.util.logging.LogRecord)
	 */
	@Override
	public String format(LogRecord record) {
		StringBuilder retVal = new StringBuilder();
		retVal.append('[');
		retVal.append(format.format(new Date(record.getMillis())));
		retVal.append("] ");
		retVal.append(record.getMessage());
		retVal.append("\n");
		return retVal.toString();
	}
}
