/**
 * 
 */
package de.desy.acop.video.displayer;

import de.desy.tine.types.IMAGE;

/**
 * </code>TineImageReceiver</code> provides the interface to receivers which can be used
 * with </code>TineHandler</code>.
 * 
 * @author Tilen Kusterle, Cosylab
 *
 */
public interface TineImageReceiver {

	/**
	 * Resets this receiver for receiving.
	 */
	public void resetForReceiving();
	
	/**
	 * Updates this receiver's </code>IMAGE</code>.
	 * @param newImage the new </code>IMAGE</code>
	 s*/
	public void updateValue(IMAGE newImage);
	
	/**
	 * Updates this receiver's </code>IMAGE</code> and the link information.
	 * 
	 * @param newImage the new image
	 * @param data the link information about the new image
	 */
	public void updateValue(IMAGE newImage, LinkData data);
}
