/*
 * Created on Jan 16, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.config;

import javax.xml.bind.annotation.XmlRootElement;

/**
 * An enumeration of initialization types.
 * The initialization type specifies which JDBC driver should be used. 
 * @author jwlg
 */
@XmlRootElement
public enum CfgInitType {
    /** The Stels CSV driver */
    StelsCSV,
    /** The Stels DBF driver */
    StelsDBF,
    /** The Stels XML driver */
    StelsXML,
    /** The open source CsvJDBC driver */
    CSV,
    /** Another JDBC driver */
    JDBC,
    /** An ODBC driver */
    ODBC,
    /** No JDBC used. Custom initialization. */
    CUSTOM;
}
