/*
 * Created on Mar 1, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.config;

/**
 * An enum for log file types.
 * The device server specification provides a simplified 
 * log4j configuration which supports two types
 * of file loggers. For more information, see
 * the log4j documentation. 
 * 
 */
public enum CfgLogFileType {
    
    /** Rolling file - change at maximum size, rotate backups */
    ROLLING,
    /** Daily rolling file - new file every day */
    DAILY_ROLLING;
    
    /**
     * Returns true if the type is ROLLING.
     */
    public boolean isRollingFile() {
        return (this.equals(ROLLING));
    }
    
    /**
     * Returns true if the type is DAILY_ROLLING.
     */
     public boolean isDailyRollingFile() {
        return (this.equals(DAILY_ROLLING));
    }
     
}
