/*
 * Created on Jan 16, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.config;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * MstApp configuration.
 * This section contains informations which are needed when
 * a device server is an MstApp.
 * @author jwlg
 */
@XmlRootElement
public class CfgMstApp {
    
    private boolean isEnabled = false;
    private boolean isDirectoryStructureAdopted = false;
    private boolean isMstBuildDeployUsed = false;
    
    /**
     * Returns true if the device server is an MstApp.
     */
    @XmlElement
    public boolean isEnabled() {
        return isEnabled;
    }

    /**
     * Makes the device server an MstApp.
     * @param isEnabled New value.
     */
    public void setEnabled(boolean isEnabled) {
        this.isEnabled = isEnabled;
    }

    /**
     * Returns true if the server uses the MstApp 
     * directory structure.
     */
    @XmlElement
    public boolean isDirectoryStructureAdopted() {
        return isDirectoryStructureAdopted;
    }

    /**
     * Makes the server use the MstApp directory structure.
     * The device server normally uses a standard directory 
     * structure which is suitable for device servers. MstApp 
     * has also an idea of a directory structure which is suitable
     * for MstApp. Both are hardly integrable. This option makes
     * the device server use MstApp's directory structure.
     * 
     * @param isDirectoryStructureUsed
     */
    public void setDirectoryStructureAdopted(boolean isDirectoryStructureUsed) {
        this.isDirectoryStructureAdopted = isDirectoryStructureUsed;
    }

    
    public boolean isMstBuildDeployUsed() {
        return isMstBuildDeployUsed;
    }

    
    public void setMstBuildDeployUsed(boolean isMstBuildDeployUsed) {
        this.isMstBuildDeployUsed = isMstBuildDeployUsed;
    }

    
}
