/*
 * Created on Jun 19, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.config;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
/**
 * Configuration of fields with user-defined data types.
 * Elements:
 * <ul>
 * <li>packageName: optional</li>
 * <li>className: mandatory (default package)</li>
 * </ul>
 */
public class CfgUserType {
    
    private String packageName = null;
    private String className = "";
    
    /**
     * Returns the class name.
     */
    @XmlElement
    public String getClassName() {
    
        return className;
    }

    /** 
     * Sets the class name.
     * @param className
     */
    public void setClassName(String className) {
    
        this.className = className;
    }
    
    /**
     * Returns the package name.
     * The package name is optional and may be null.
     */
    @XmlElement
    public String getPackageName() {
    
        return packageName;
    }
    
    /**
     * Sets the package name.
     * 
     * @param packageName New package name.
     * 
     */
    public void setPackageName(String packageName) {
    
        this.packageName = packageName;
    }
    
}
