/*
 * Created on Sep 21, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.exceptions;


/**
 * Thrown to indicate that a device is out of order.
 * This exception means that a method cannot be executed or cannot 
 * return a correct value because the device is in a defective state.
 * 
 * @author jwlg
 */
public class DeviceErrorException extends DeviceException {

    private static final long serialVersionUID = 381699200430513609L;

    /**
     * Default constructor.
     */
    public DeviceErrorException() {
        super(ErrorSpecs.DEVICE_ERROR_EXCEPTION);
    }

    /**
     * Constructor with a specific message.
     * @param message A message which overrides the default message.
     */
    public DeviceErrorException(String message) {
        super(ErrorSpecs.DEVICE_ERROR_EXCEPTION,message);
    }

}
