/*
 * Created on Sep 20, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.exceptions;


/**
 * An exception which can be thrown by a device method 
 * when an I/O-Exception has occurred.
 * This is a superclass. Its subclasses provide more detailed specification.
 * 
 * @see FileIOException
 * @see HardwareIOException
 * @see NetworkIOException
 * 
 * @author jwlg
 */
public class IOException extends PredefinedException {

    private static final long serialVersionUID = -8708529763619539202L;

    /**
     * Default constructor.
     */
    public IOException() {
        super(ErrorSpecs.IO_EXCEPTION);
    }
    
    /**
     * Constructor with a specific message.
     * @param message A message which overrides the default message.
     */
    public IOException(String message) {
        super(ErrorSpecs.IO_EXCEPTION, message);
    }
    
    IOException(ErrorSpecs errorSpecs, String message) {
        super(errorSpecs, message);
    }
    
    IOException(ErrorSpecs errorSpecs) {
        super(errorSpecs);
    }
    
}
