/*
 * Created on Sep 21, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.exceptions;


/**
 * An exception which is used when a runtime exception occurs in a devices.
 * 
 * This exception is not intended for direct use. It is used internally
 * by the device server.
 * 
 * @author jwlg
 */
public class JavaRuntimeException extends PredefinedException {

    private static final long serialVersionUID = -2320360218540047218L;

    /**
     * Default constructor.
     */
    public JavaRuntimeException() {
        super(ErrorSpecs.JAVA_RUNTIME_EXCEPTION);
    }
    
    public JavaRuntimeException(String message) {
        super(ErrorSpecs.JAVA_RUNTIME_EXCEPTION, message);
    }
    
    public JavaRuntimeException(RuntimeException re) {
        super(ErrorSpecs.JAVA_RUNTIME_EXCEPTION, re.getMessage());
    }
    
    public JavaRuntimeException(ErrorSpecs errorSpecs) {
        super(errorSpecs);
    }
    
    public JavaRuntimeException(ErrorSpecs errorSpecs, String message) {
        super(errorSpecs, message);
    }
    
}
