/*
 * Created on Aug 25, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.exceptions;



/**
 * Base class for device server exceptions with a fixed error number.
 * @author jwlg
 */
public abstract class PredefinedException extends DeviceServerException {
    
    /**
     * 
     */
    private static final long serialVersionUID = -7001416944503918728L;
    private final ErrorSpecs errorSpecs;

    
    /**
     * Default constructor.
     */
    PredefinedException(ErrorSpecs errorSpecs) {
        super(errorSpecs.getDefaultMessage());
        this.errorSpecs = errorSpecs;
    }

    
    PredefinedException(ErrorSpecs errorSpecs, String message) {
        super(message == null ? errorSpecs.getDefaultMessage() : message);
        this.errorSpecs = errorSpecs;
    }
    
    public ErrorSpecs getErrorSpecs() {
        return this.errorSpecs;
    }
    
    public int getErrorKey() {
        return getErrorSpecs().getKey();
    }
    
}
