/*
 * Created on Jul 5, 2006
 *
 */
package de.desy.mst.auxiliary.devl.deviceserverlib.initialization;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;


/**
 * A CSV Table driver which uses the csvjdbc driver.
 * @author jwlg
 */
public class CsvJdbcDriver implements IDatabaseDriver {

    Connection connection = null;

    public ResultSet getResult(HashMap<String,String> properties) throws ClassNotFoundException, SQLException  { 
        ResultSet resultSet = null;
        String directory = properties.get("directory");
        String sqlQuery = properties.get("sqlQuery");

        if ((sqlQuery == null) || sqlQuery.equals("")) {
            sqlQuery = properties.get("table");
        } 
        sqlQuery = SelectUtil.extendSelect(sqlQuery);

        String url = "jdbc:relique:csv:" + directory;
        Class.forName("org.relique.jdbc.csv.CsvDriver");
        connection = DriverManager.getConnection(url);
        Statement statement = connection.createStatement();
        resultSet = statement.executeQuery(sqlQuery);
        return resultSet;
    }

    public HashMap<String,String> getDefaultProperties() {
        HashMap<String,String> params = new HashMap<String,String>();
        params.put("directory", "");
        params.put("sqlQuery", "");
        return params;
    }

    public void close() {
        if (connection != null) {
            try {
                connection.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    protected void finalize() throws Throwable {
        super.finalize();
        close();
    }



}
