/*
 * Created on Jul 14, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.initialization;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;



/**
 * A table driver for the JDBC/ODBC bridge.
 * @author jwlg
 */
public class OdbcDriver implements IDatabaseDriver {

    Connection connection = null;

    /**
     * Performs a query and returns the result.
     * @param properties Set odf properties. Expected keys are "odbcDataSource" and "sqlQuery".
     */
    public ResultSet getResult(HashMap<String,String> properties) throws ClassNotFoundException, SQLException  { 
        ResultSet resultSet = null;
        String odbcDataSource = properties.get("odbcDataSource");
        String sqlQuery = SelectUtil.extendSelect(properties.get("sqlQuery"));
        String url = "jdbc:odbc:" + odbcDataSource;
        
        Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
        connection = DriverManager.getConnection(url);
        Statement statement = connection.createStatement();
        resultSet = statement.executeQuery(sqlQuery);
        return resultSet;
    }
    
    public HashMap<String,String> getDefaultProperties() {
        HashMap<String,String> params = new HashMap<String,String>();
        params.put("odbcDataSource", "");
        params.put("sqlQuery", "");
        return params;
    }
    
    public void close() {
        if (connection != null) {
            try {
                connection.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    protected void finalize() throws Throwable {
        super.finalize();
        close();
    }


}
