/*
 * Created on Feb 14, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.initialization;

/**
 * Utilities for SQL SELECT.
 * 
 * Provides a static method which makes a SELECT query from a 
 * table name.
 * 
 * @author jwlg
 */
public class SelectUtil {
    
    /**
     * Accepts an SQL query or a table className 
     * and returns an SQL query.
     * If the specified SQL query is only a table className 
     * (i.e. contains no spaces) then the result is
     * a "SELECT * FROM " plus the table className. 
     * Otherwise the input value is returned (trimmed).
     * @param sqlQuery An SQL Query or table className)
     */
    public static String extendSelect(String sqlQuery) {
        String result = sqlQuery.trim();
        if (result.indexOf(' ') < 0) {
            result = "SELECT * FROM " + result;
        }
        return result;
    }

}
