/*
 * Created on Sep 3, 2007
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.initialization.controller;

import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * A device range.
 * A device range specifies the first device and 
 * the last device in an ordered list of devices.
 * 
 * @author jwlg
 */
@XmlRootElement
public class DeviceRange {
    
    String firstDevice = null;
    String lastDevice = null;
    
    /**
     * Returns the first device in the range.
     */
    @XmlAttribute(name="firstDevice")
    public String getFirstDevice() {
        return firstDevice;
    }
    
    /**
     * Assigns the first device.
     * @param firstDevice
     */
    public void setFirstDevice(String firstDevice) {
        this.firstDevice = firstDevice;
    }

    /**
     * Returns the last device in the range.
     */
    @XmlAttribute(name="lastDevice")
    public String getLastDevice() {
        return lastDevice;
    }
    
    /**
     * Assigns the last device.
     * @param lastDevice
     */
    public void setLastDevice(String lastDevice) {
        this.lastDevice = lastDevice;
    }

}
