package de.desy.mst.auxiliary.devl.deviceserverlib.server;

import de.desy.mst.auxiliary.devl.deviceserverlib.initialization.controller.ControllerDefinition;



/**
 * A base class for device controllers.
 * 
 * @version 1.0
 * @created 30-Aug-2007 10:19:54
 */
public abstract class ABasicController<D extends IBasicDevice> extends ABasicDevice {

	private DeviceMap<D> deviceMap = new DeviceMap<D>();
    ControllerDefinition controllerDefinition = null;
	
    public ABasicController(DeviceMap<D> deviceMap, DeviceContext context) {
        super(context);
        setDeviceMap(deviceMap);
    }
    
    public ABasicController(DeviceContext context){
        super(context);
	}

    public ABasicController(DeviceMap<D> deviceMap) {
        super();
        setDeviceMap(deviceMap);
    }

    public ABasicController(){
        super();
    }
    
    protected final ControllerDefinition getControllerDefinition() {
        return controllerDefinition;
    }
    
    final void setControllerDefinition(ControllerDefinition controllerDefinition) {
    
        this.controllerDefinition = controllerDefinition;
    }

    final void setDeviceMap(DeviceMap<D> deviceMap) {
        this.deviceMap = deviceMap;
    }

    protected final DeviceMap<D> getDeviceMap() {
        return deviceMap;
    }
    
    protected final DeviceLockManager getLockManager() {
        return new DeviceLockManager(deviceMap);
    }
    
	/**
	 * @param device
	 */
	public final void addDevice(D device) {
        deviceMap.addDevice(device);
    }

	public final String[] getDeviceList(){
		return (String[]) deviceMap.getDeviceNames().toArray();
	}

}
