package de.desy.mst.auxiliary.devl.deviceserverlib.server;

/**
 * A base class for property handlers.
 * 
 * 
 * Property handlers are generated by the device server wizard.
 * The class APropertyHandler serves as a base class for all 
 * generated property handlers. It inherits functionality from 
 * ABasicPropertyHandler. In addition to ABasicPropertyHandler,
 * it contains configuration information.
 * 
 * @author jwlg
 */
public abstract class APropertyHandler<D extends IBasicDevice> extends ABasicPropertyHandler<D> {

    
    /**
     * Constructor.
     * @param propertyName Name of the property.
     * @param deviceGroup Name of the device group.
     */
	public APropertyHandler(String propertyName, DeviceGroup<D> deviceGroup) {
		super(propertyName, deviceGroup);
	}

    
    /**
     * Updates the buffer.
     * This method has to be implemented by derived classes.
     * It is used for properties which read data asynchronously.
     */
    public abstract void updateBuffer();
    
     
}
