/*
 * Created on Jul 3, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.server;

/**
 * The interface for device factories.
 * 
 * @author jwlg
 */
public interface IDeviceFactory<T extends IBasicDevice> {
    
    /**
     * Populates a device group with devices.
     * 
     * This method creates devices, assigns a device context
     * to them and adds them to a device group.
     * 
     * The device server normally uses a standard device factory,
     * but it is also possible to use a customized device factory.
     * It has to implement this interface.
     *  
     * @param deviceGroup The device group.
     * @param context The device context.
     */
    public void createDevices(DeviceGroup<T> deviceGroup);
    
}
