/*
 * Created on Jun 2, 2006
 *
 */
package de.desy.mst.auxiliary.devl.deviceserverlib.server;

import java.sql.ResultSet;



/**
 * An interface for a device factory method.
 * 
 * The device factory method is called by the StandardDeviceFactory.
 * It creates a device from the current record in a result set.
 * It has to be implemented by the user for each device type.
 * 
 * @author jwlg
 */
public interface IDeviceFactoryMethod<T extends IBasicDevice> {
    
    /**
     * Creates a device.
     */
    public T createDevice(ResultSet resultSet);
    
}
