/*
 * Created on Jul 12, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.server;


/**
 * Module factory for ordinary devicese.
 * 
 * Device factory part.
 * 
 * @author jwlg
 */
public interface IDeviceModuleFactory <T extends IBasicDevice> extends IBasicModuleFactory<T> {
    
    /**
     * Creates a factory method for devices.
     * This method has to be implemented by derived classes.
     * 
     */
    public IDeviceFactoryMethod<T> createFactoryMethod();

    /**
     * Creates a custom device factory.
     * @param parameters
     * @return
     */
    public ADeviceFactory<T> createDeviceFactory();


}
