/*
 * Created on Aug 29, 2007
 *
 */
package de.desy.mst.auxiliary.devl.deviceserverlib.tools.array;

/**
 * A wrapper class for all array utils.
 * 
 * Combines generic array utils and array utils for all data types.
 * 
 * @author jwlg
 */
public class ArrayUtils {

    /**
     * @see GenericArrayUtils#rotateRight
     */
    public static <T> void rotateRight(T[] array) {
        GenericArrayUtils.rotateRight(array);
    }

    /**
     * @see GenericArrayUtils#rotateLeft
     */
    public static <T> void rotateLeft(T[] array) {
        GenericArrayUtils.rotateLeft(array);
    }

    /**
     * @see GenericArrayUtils#copySlice
     */
    public static <T> int copySlice(T[] source, 
            int sourceOffset,
            int nElements, 
            T[] dest, 
            int destOffset) {
        return GenericArrayUtils.copySlice(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see GenericArrayUtils#copyRotate(Object[], int, Object[])
     */
    public static <T> int copyRotate(T[] source, int sourceOffset, int nElements, T[] dest, int destOffset) {
        return GenericArrayUtils.copyRotate(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see GenericArrayUtils#copyRotate(Object[], int, int, Object[], int)
     */
    public static <T> int copyRotate(T[] source, int sourceOffset,
            T[] dest) {
        return GenericArrayUtils.copyRotate(source, sourceOffset, source.length, dest, 0);
    }

    /**
     * @see GenericArrayUtils#copy
     */
    public static <T> int copy(T[] source, T[] dest) {
        return GenericArrayUtils.copy(source,dest);
    }

    /**
     * @see GenericArrayUtils#prepend
     */
    public static <T> void prepend(T[] array, T value) {
        GenericArrayUtils.prepend(array, value);
    }

    /**
     * @see GenericArrayUtils#append
     */
    public static <T> void append(T[] array, T value) {
        GenericArrayUtils.append(array, value);
    }

    
    /**
     * @see DoubleArrayUtils#rotateRight
     */
     public static  void rotateRight(double[] array) {
        DoubleArrayUtils.rotateRight(array);
    }

     /**
      * @see DoubleArrayUtils#rotateLeft
      */
    public static  void rotateLeft(double[] array) {
        DoubleArrayUtils.rotateLeft(array);
    }

    /**
     * @see DoubleArrayUtils#copySlice
     */
    public static  int copySlice(double[] source, 
            int sourceOffset,
            int nElements, 
            double[] dest, 
            int destOffset) {
        return DoubleArrayUtils.copySlice(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see DoubleArrayUtils#copyRotate(double[], int, double[])
     */
    public static  int copyRotate(double[] source, int sourceOffset, int nElements, double[] dest, int destOffset) {
        return DoubleArrayUtils.copyRotate(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see DoubleArrayUtils#copyRotate(double[], int, int, double[], int)
     */
    public static  int copyRotate(double[] source, int sourceOffset,
            double[] dest) {
        return DoubleArrayUtils.copyRotate(source, sourceOffset, source.length, dest, 0);
    }

    /**
     * @see DoubleArrayUtils#copy
     */
    public static  int copy(double[] source, double[] dest) {
        return DoubleArrayUtils.copy(source,dest);
    }

    /**
     * @see DoubleArrayUtils#prepend
     */
    public static  void prepend(double[] array, double value) {
        DoubleArrayUtils.prepend(array, value);
    }

    /**
     * @see DoubleArrayUtils#append
     */
    public static  void append(double[] array, double value) {
        DoubleArrayUtils.append(array, value);
    }


    /**
     * @see FloatArrayUtils#rotateRight
     */
    public static  void rotateRight(float[] array) {
        FloatArrayUtils.rotateRight(array);
    }

    /**
     * @see FloatArrayUtils#rotateLeft
     */
    public static  void rotateLeft(float[] array) {
        FloatArrayUtils.rotateLeft(array);
    }

    /**
     * @see FloatArrayUtils#copySlice
     */
    public static  int copySlice(float[] source, 
            int sourceOffset,
            int nElements, 
            float[] dest, 
            int destOffset) {
        return FloatArrayUtils.copySlice(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see FloatArrayUtils#copyRotate(float[], int, float[])
     */
    public static  int copyRotate(float[] source, int sourceOffset, int nElements, float[] dest, int destOffset) {
        return FloatArrayUtils.copyRotate(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see FloatArrayUtils#copyRotate(float[], int, int, float[], int)
     */
    public static  int copyRotate(float[] source, int sourceOffset,
            float[] dest) {
        return FloatArrayUtils.copyRotate(source, sourceOffset, source.length, dest, 0);
    }

    /**
     * @see FloatArrayUtils#copy
     */
    public static  int copy(float[] source, float[] dest) {
        return FloatArrayUtils.copy(source,dest);
    }

    /**
     * @see FloatArrayUtils#prepend
     */
    public static  void prepend(float[] array, float value) {
        FloatArrayUtils.prepend(array, value);
    }

    /**
     * @see FloatArrayUtils#append
     */
    public static  void append(float[] array, float value) {
        FloatArrayUtils.append(array, value);
    }


    /**
     * @see IntArrayUtils#rotateRight
     */
    public static  void rotateRight(int[] array) {
        IntArrayUtils.rotateRight(array);
    }

    /**
     * @see IntArrayUtils#rotateLeft
     */
    public static  void rotateLeft(int[] array) {
        IntArrayUtils.rotateLeft(array);
    }

    /**
     * @see IntArrayUtils#copySlice
     */
    public static  int copySlice(int[] source, 
            int sourceOffset,
            int nElements, 
            int[] dest, 
            int destOffset) {
        return IntArrayUtils.copySlice(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see IntArrayUtils#copyRotate(int[], int, int[])
     */
    public static  int copyRotate(int[] source, int sourceOffset, int nElements, int[] dest, int destOffset) {
        return IntArrayUtils.copyRotate(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see IntArrayUtils#copyRotate(int[], int, int, int[], int)
     */
    public static  int copyRotate(int[] source, int sourceOffset,
            int[] dest) {
        return IntArrayUtils.copyRotate(source, sourceOffset, source.length, dest, 0);
    }

    /**
     * @see IntArrayUtils#copy
     */
    public static  int copy(int[] source, int[] dest) {
        return IntArrayUtils.copy(source,dest);
    }

    /**
     * @see IntArrayUtils#prepend
     */
    public static  void prepend(int[] array, int value) {
        IntArrayUtils.prepend(array, value);
    }

    /**
     * @see IntArrayUtils#append
     */
    public static  void append(int[] array, int value) {
        IntArrayUtils.append(array, value);
    }


    /**
     * @see ShortArrayUtils#rotateRight
     */
    public static  void rotateRight(short[] array) {
        ShortArrayUtils.rotateRight(array);
    }

    /**
     * @see ShortArrayUtils#rotateLeft
     */
    public static  void rotateLeft(short[] array) {
        ShortArrayUtils.rotateLeft(array);
    }

    /**
     * @see ShortArrayUtils#copySlice
     */
    public static  int copySlice(short[] source, 
            int sourceOffset,
            int nElements, 
            short[] dest, 
            int destOffset) {
        return ShortArrayUtils.copySlice(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see ShortArrayUtils#copyRotate(short[], int, short[])
     */
    public static  int copyRotate(short[] source, int sourceOffset, int nElements, short[] dest, int destOffset) {
        return ShortArrayUtils.copyRotate(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see ShortArrayUtils#copyRotate(short[], int, int, short[], int)
     */
    public static  int copyRotate(short[] source, int sourceOffset,
            short[] dest) {
        return ShortArrayUtils.copyRotate(source, sourceOffset, source.length, dest, 0);
    }

    /**
     * @see ShortArrayUtils#copy
     */
    public static  int copy(short[] source, short[] dest) {
        return ShortArrayUtils.copy(source,dest);
    }

    /**
     * @see ShortArrayUtils#prepend
     */
    public static  void prepend(short[] array, short value) {
        ShortArrayUtils.prepend(array, value);
    }

    /**
     * @see ShortArrayUtils#append
     */
    public static  void append(short[] array, short value) {
        ShortArrayUtils.append(array, value);
    }


    
    
    /**
     * @see ByteArrayUtils#rotateRight
     */
    public static  void rotateRight(byte[] array) {
        ByteArrayUtils.rotateRight(array);
    }

    /**
     * @see ByteArrayUtils#rotateLeft
     */
    public static  void rotateLeft(byte[] array) {
        ByteArrayUtils.rotateLeft(array);
    }

    /**
     * @see ByteArrayUtils#copySlice
     */
    public static  int copySlice(byte[] source, 
            int sourceOffset,
            int nElements, 
            byte[] dest, 
            int destOffset) {
        return ByteArrayUtils.copySlice(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see ByteArrayUtils#copyRotate(byte[], int, int, byte[], int)
     */
    public static  int copyRotate(byte[] source, int sourceOffset, int nElements, byte[] dest, int destOffset) {
        return ByteArrayUtils.copyRotate(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see ByteArrayUtils#copyRotate(byte[], int, byte[])
     */
    public static  int copyRotate(byte[] source, int sourceOffset,
            byte[] dest) {
        return ByteArrayUtils.copyRotate(source, sourceOffset, source.length, dest, 0);
    }

    /**
     * @see ByteArrayUtils#copy
     */
    public static  int copy(byte[] source, byte[] dest) {
        return ByteArrayUtils.copy(source,dest);
    }

    /**
     * @see ByteArrayUtils#prepend
     */
    public static  void prepend(byte[] array, byte value) {
        ByteArrayUtils.prepend(array, value);
    }

    /**
     * @see ByteArrayUtils#append
     */
    public static  void append(byte[] array, byte value) {
        ByteArrayUtils.append(array, value);
    }


    
    /**
     * @see BooleanArrayUtils#rotateRight
     */
    public static  void rotateRight(boolean[] array) {
        BooleanArrayUtils.rotateRight(array);
    }

    /**
     * @see BooleanArrayUtils#rotateLeft
     */
    public static  void rotateLeft(boolean[] array) {
        BooleanArrayUtils.rotateLeft(array);
    }

    /**
     * @see BooleanArrayUtils#copySlice
     */
    public static  int copySlice(boolean[] source, 
            int sourceOffset,
            int nElements, 
            boolean[] dest, 
            int destOffset) {
        return BooleanArrayUtils.copySlice(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see BooleanArrayUtils#copyRotate(boolean[], int, boolean[])
     */
    public static  int copyRotate(boolean[] source, int sourceOffset, int nElements, boolean[] dest, int destOffset) {
        return BooleanArrayUtils.copyRotate(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see BooleanArrayUtils#copyRotate(boolean[], int, int, boolean[], int)
     */
   public static  int copyRotate(boolean[] source, int sourceOffset,
            boolean[] dest) {
        return BooleanArrayUtils.copyRotate(source, sourceOffset, source.length, dest, 0);
    }

   /**
    * @see BooleanArrayUtils#copy
    */
    public static  int copy(boolean[] source, boolean[] dest) {
        return BooleanArrayUtils.copy(source,dest);
    }

    /**
     * @see BooleanArrayUtils#prepend
     */
    public static  void prepend(boolean[] array, boolean value) {
        BooleanArrayUtils.prepend(array, value);
    }

    /**
     * @see BooleanArrayUtils#append
     */
    public static  void append(boolean[] array, boolean value) {
        BooleanArrayUtils.append(array, value);
    }


    
    /**
     * @see LongArrayUtils#rotateRight
     */
    public static  void rotateRight(long[] array) {
        LongArrayUtils.rotateRight(array);
    }

    /**
     * @see LongArrayUtils#rotateLeft
     */
    public static  void rotateLeft(long[] array) {
        LongArrayUtils.rotateLeft(array);
    }

    /**
     * @see LongArrayUtils#copySlice
     */
    public static  int copySlice(long[] source, 
            int sourceOffset,
            int nElements, 
            long[] dest, 
            int destOffset) {
        return LongArrayUtils.copySlice(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see LongArrayUtils#copyRotate(long[], int, long[])
     */
    public static  int copyRotate(long[] source, int sourceOffset, int nElements, long[] dest, int destOffset) {
        return LongArrayUtils.copyRotate(source, sourceOffset, nElements, dest, destOffset);
    }

    /**
     * @see LongArrayUtils#copyRotate(long[], int, int, long[], int)
     */
    public static  int copyRotate(long[] source, int sourceOffset,
            long[] dest) {
        return LongArrayUtils.copyRotate(source, sourceOffset, source.length, dest, 0);
    }

    /**
     * @see LongArrayUtils#copy
     */
    public static  int copy(long[] source, long[] dest) {
        return LongArrayUtils.copy(source,dest);
    }

    /**
     * @see LongArrayUtils#prepend
     */
    public static  void prepend(long[] array, long value) {
        LongArrayUtils.prepend(array, value);
    }

    /**
     * @see LongArrayUtils#append
     */
    public static  void append(long[] array, long value) {
        LongArrayUtils.append(array, value);
    }



}
