/*
 * Created on Jun 8, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.tools.selector;

/**
 * An And-Combination of selectors.
 * @author jwlg
 */
public class AndSelectorSet<T>  extends ASelectorSet<T> {

    
    /**
     * Returns true if the item is selected.
     * All selectors are applied. If all return true,
     * thre result is true. If one returns
     * false, the result is false. If no selector exists,
     * the result is true.
     */
    public boolean isSelected(T item) {
        boolean result = true;
        for (ISelector<T> selector : getSelectors() ) {
            if (!selector.isSelected(item)) {
                result = false;
                break;
            }
        }
        return result;
    }

    /**
     * Default Constructor.
     */
    public AndSelectorSet() {
        super();
    }

}
