/*
 * Created on Jun 7, 2006
 *
  */
package de.desy.mst.auxiliary.devl.deviceserverlib.tools.selector;

/**
 * An Or-Combination of selectors.
 * 
 * @author jwlg
 */
public class OrSelectorSet<T> extends ASelectorSet<T> {

    /**
     * Default Constructor.
     *
     */
    public OrSelectorSet() {
        super();
    }

    /**
     * Returns true if the item is selected.
     * All selectors are applied. If one returns
     * true, the result is true. If no selector exists,
     * the result is false.
     */
    public boolean isSelected(T item) {
        boolean result = false;
        for (ISelector<T> selector : getSelectors() ) {
            if (selector.isSelected(item)) {
                result = true;
                break;
            }
        }
        return result;
    }

}
