package de.desy.tine.accesslayer;

import de.desy.tine.dataUtils.TDataType;

/**
 * <code>ChannelCallback2</code> is an extension of the channel callback which provides more bullet proof mechanism to
 * catch all updates and states. For backward compatibility the extra methods are kept in a separate interface.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 * @deprecated use {@link ChannelListener}
 */
@Deprecated
public interface ChannelCallback2 extends ChannelCallback {

    /**
     * The channel value was updated and is given as a parameter.
     *
     * @param channel the channel which value was updated
     * @param rawValue the value of the channel at the time when the event was triggered
     * @deprecated use {@link ChannelListener#updateValue(ChannelReadEvent)} instead
     */
    @Deprecated
    public void updateValue(Channel channel, TDataType rawValue);

    /**
     * The channel status was updated. The status that triggered the call is given as a parameter.
     *
     * @param channel the channel which value was updated
     * @param value the value of the channel at the time when the event was triggered
     * @param status the status that triggered the callback
     * @deprecated use {@link ChannelListener#updateError(ChannelReadEvent)} instead
     */
    @Deprecated
    public void updateErrorStatus(Channel channel, TDataType value, int status);
}
