package de.desy.tine.accesslayer;

import de.desy.tine.dataUtils.TDataType;


/**
 *
 * <code>ChannelCallbackAdapter</code> is an adapter which provides empty implementation
 * of the {@link ChannelCallback}. Extend this class when you do not want to provide
 * implementation for all 5 methods from the {@link ChannelCallback}.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
@SuppressWarnings("deprecation")
public abstract class ChannelCallbackAdapter implements ChannelCallback2, ChannelListener {

    /*
     * (non-Javadoc)
     * @see de.desy.tine.accesslayer.ChannelCallback#writeCompleted(java.lang.String, java.lang.Object)
     */
    @Override
    public void writeCompleted(String address, Object value) {}

    /*
     * (non-Javadoc)
     * @see de.desy.tine.accesslayer.ChannelCallback#writeFailed(java.lang.String, java.lang.Object, int)
     */
    @Override
    public void writeFailed(String address, Object value, int linkStatus) {}

    /*
     * (non-Javadoc)
     * @see de.desy.tine.accesslayer.ChannelCallback#updateValue(de.desy.tine.accesslayer.Channel)
     */
    @Override
    public void updateValue(Channel channel) {}

    /*
     * (non-Javadoc)
     * @see de.desy.tine.accesslayer.ChannelCallback2#updateValue(de.desy.tine.accesslayer.Channel, de.desy.tine.dataUtils.TDataType)
     */
    @Override
    public void updateValue(Channel channel, TDataType rawValue) {}

    /*
     * (non-Javadoc)
     * @see de.desy.tine.accesslayer.ChannelCallback#updateErrorStatus(de.desy.tine.accesslayer.Channel)
     */
    @Override
    public void updateErrorStatus(Channel channel) {}

    /*
     * (non-Javadoc)
     * @see de.desy.tine.accesslayer.ChannelCallback2#updateErrorStatus(de.desy.tine.accesslayer.Channel, de.desy.tine.dataUtils.TDataType, int)
     */
    @Override
    public void updateErrorStatus(Channel channel, TDataType value, int status) {}

    /*
     * (non-Javadoc)
     * @see de.desy.tine.accesslayer.ChannelCallback#channelError(java.lang.String, java.lang.Throwable)
     */
    @Override
    public void channelError(String message, Throwable cause) {}

    /*
     * (non-Javadoc)
     * @see de.desy.tine.accesslayer.ChannelListener#updateValue(de.desy.tine.accesslayer.ChannelReadEvent)
     */
    @Override
    public void updateValue(ChannelReadEvent event) {}

    /*
     * (non-Javadoc)
     * @see de.desy.tine.accesslayer.ChannelListener#updateError(de.desy.tine.accesslayer.ChannelReadEvent)
     */
    @Override
    public void updateError(ChannelReadEvent event) {}
}
