package de.desy.tine.accesslayer;

import java.util.EventListener;

/**
 *
 * <code>ChannelListener</code> is an extension of the channel callback which provides an event driven callback pattern.
 * For backward compatibility the extra methods are kept in a separate interface.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public interface ChannelListener extends ChannelCallback, EventListener {

    /**
     * Called when a value has been updated.
     *
     * @param event the event describing the change
     */
    public void updateValue(ChannelReadEvent event);

    /**
     * Called when the channel receives an error value.
     *
     * @param event the event describing the change
     */
    public void updateError(ChannelReadEvent event);

}
