package de.desy.tine.accesslayer;

/**
 *
 * <code>ConnectionMode</code> defines the possible connection modes to the underlying links.
 * SINGLE connections will receive only one update, CHANGE connections will receive an update
 * every time the value changes, and POLL connections will receive updates periodically.
 * SYNC_SINGLE is a special type of connection which establishes a synchronous call and
 * should be used with greatest caution.
 *
 * @author <a href="mailto:jaka.bobnar@cosylab.com">Jaka Bobnar</a>
 *
 */
public enum ConnectionMode {
    SINGLE, CHANGE, POLL, SYNC_SINGLE
}
