package de.desy.tine.addrUtils;

import de.desy.tine.structUtils.TTaggedStructure;

public class GrpMbr extends TTaggedStructure
{
  public void clear()
  {
    serverString = null;
    devPrefixString = null;
    devPostfixString = null;
  }
  private char[] server = new char[32];
  private String serverString;
  private char[] devPrefix = new char[8];
  private String devPrefixString;
  private char[] devPostfix = new char[8];
  private String devPostfixString;
  private int[] index = new int[1];
  private void initStructure()
  {
    addField(server,"server");
    addField(devPrefix,"devPrefix");
    addField(devPostfix,"devPostfix");
    addField(index,"index");
    initDone();    
  }
  public GrpMbr()
  {
    super();
    initStructure();
  }
  public GrpMbr(GrpMbr reference)
  {
    super();
    initStructure();
    System.arraycopy(reference.server, 0, server, 0, 32);    
    System.arraycopy(reference.devPrefix, 0, devPrefix, 0, 8);    
    System.arraycopy(reference.devPostfix, 0, devPostfix, 0, 8);
    index[0] = reference.index[0];
  }
  public String getServer()
  {
    if (serverString == null) serverString = new String(server).trim();
    return serverString;
  }
  public String getDevPrefix()
  {
    if (devPrefixString == null) devPrefixString = new String(devPrefix).trim();
    return devPrefixString;
  }
  public String getDevPostfix()
  {
    if (devPostfixString == null) devPostfixString = new String(devPostfix).trim();
    return devPostfixString;
  }
  public int getIndex()
  {
    return index[0];
  }
  public void setServer(String server) 
  {
    pushChars(server,this.server);
    this.serverString = new String(server);
  }
  public void setDevPrefix(String devPrefix) 
  {
    pushChars(devPrefix,this.devPrefix);
    this.devPrefixString = new String(devPrefix);
  }
  public void setDevPostfix(String devPostfix) 
  {
    pushChars(devPostfix,this.devPostfix);
    this.devPostfixString = new String(devPostfix);
  }
  public void setAppend(int index) 
  {
    this.index[0] = index;
  } 
}
