package de.desy.tine.alarmUtils;

import de.desy.tine.definitions.TStrings;
import de.desy.tine.structUtils.TTaggedStructure;

public class ApcBlk extends TTaggedStructure
{
  private int[] sessionId = new int[1];
  private int[] event = new int[1];
  private char[] ext = new char[16]; // mostly unused;
  private char[] ctx = new char[TStrings.CONTEXT_NAME_SIZE];
  private char[] exp = new char[TStrings.EXPORT_NAME_SIZE];
  private char[] dev = new char[TStrings.DEVICE_NAME_SIZE];
  private char[] prp = new char[TStrings.PROPERTY_NAME_SIZE];
  private char[] tag = new char[TStrings.TAG_NAME_SIZE];
  private int[] siz = new int[1];
  private short[] fmt = new short[1];
  private short[] reserved = new short[1];
  private void initStructure()
  {
    addField(sessionId,"sessionId");
    addField(event,"event");
    addField(ext,"ext");
    addField(ctx,"context");
    addField(exp,"export");
    addField(dev,"device");
    addField(prp,"property");
    addField(tag,"tag");
    addField(siz,"size");
    addField(fmt,"format");
    addField(reserved,"reserved");
    initDone();    
  }
  ApcBlk()
  {
    super("APCBLKr4");
    initStructure();
  }
  ApcBlk(int session,int event,String context,String server,String device,String property,int size,short format,String tag)
  {
    super("APCBLKr4");
    this.event[0] = event;
    sessionId[0] = session;
    pushChars(context,ctx);
    pushChars(server,exp);
    pushChars(device,dev);
    pushChars(property,prp);
    siz[0] = size;
    fmt[0] = format;
    pushChars(tag,this.tag);
    initStructure();
  }
}
