package de.desy.tine.alarmUtils;

import de.desy.tine.definitions.TStrings;
import de.desy.tine.structUtils.TTaggedStructure;

public class CasAlarmSys extends TTaggedStructure
{ // CasAlSys
//  int number;
//  int column;
//  int row;
//  char tag[ALARM_TAG_SIZE];
//  char subsystem[SUBSYSTEM_NAME_SIZE];
  
	public void clear() {
		subsystemString = null;
		tagString = null;
	}

	private char[] subs = new char[TStrings.SUBSYSTEM_NAME_SIZE]; /* calling subsystem */
	private String subsystemString;
	private char[] tag = new char[TStrings.ALARM_TAG_SIZE]; /* calling alarm tag */
	private String tagString;
	private int[] number = new int[1];
	private int[] column = new int[1];
	private int[] row = new int[1];
	
	private void initStructure() {
		addField(number,"number");
		addField(column,"column");
		addField(row,"row");
		addField(tag,"tag");
		addField(subs,"subSystem");
		initDone();
	}

	public CasAlarmSys() {
		super("CasAlSys");
		initStructure();
	}

	public CasAlarmSys(CasAlarmSys reference) {
		super("CasAlSys");
		initStructure();
		row[0] = reference.row[0];
		column[0] = reference.column[0];
		number[0] = reference.number[0];
		setSubsystem(reference.getSubsystem());
		setTag(reference.getTag());
	}

	
	public int getRow() {
		return row[0];
	}
	
	public void setRow(int row) {
		this.row[0] = row;
	}
	
	public int getColumn() {
		return column[0];
	}
	
	public void setColumn(int column) {
		this.column[0] = column;
	}
	
	public int getNumber() {
		return number[0];
	}
	
	public void setNumber(int number) {
		this.number[0] = number;
	}

	public String getSubsystem() {
		if (subsystemString == null)
			subsystemString = new String(subs).trim();
		return subsystemString;
	}

	public void setSubsystem(String subsystem) {
		pushChars(subsystem,subs);
		subsystemString = new String(subs);
	}

	public String getTag() {
		if (tagString == null)
			tagString = new String(tag).trim();
		return tagString;
	}

	public void setTag(String tag) {
		pushChars(tag,this.tag);
		tagString = new String(tag);
	}
	
}
