package de.desy.tine.bitfieldUtils;

public class TField
{
  private int bitmask; 
  private int bitshift; 
  private String name; // 16 chars
  private int orderIndex;
  public TField(String field, int mask)
  {
    if (field == null) return; //TODO: throw exception
    name = field.length() > 16 ? field.substring(0, 16) : field;
    bitmask = mask;
  }
  public int getBitmask()
  {
    return bitmask;
  }
  public void setBitshift(int shift)
  {
    bitshift = shift;
  }
  public int getBitshift()
  {
    return bitshift;
  }
  public String getName()
  {
    return name;
  }
  public int getValue(int rawValue)
  {
    int bfValue = rawValue & bitmask;
    return bfValue >> bitshift;   
  }
  public int getValue(long rawValue)
  {
    int bfValue = (int)rawValue & bitmask;
    return bfValue >> bitshift;   
  }
  public int getOrderIndex() { return orderIndex; }
  public void setOrderIndex(int index) { orderIndex = index; }
}
