/*
 * Created on Jul 12, 2006
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.client;

import de.desy.tine.dataUtils.*;
import de.desy.tine.definitions.*;
import de.desy.tine.server.logger.*;

public class TWildcardMembersCallback implements TLinkCallback
{
  public void callback(TLink link)
  {
    int lstid = link.callbackId;
    TWildcardLink wc = link.twcl;
    int wccc;
    int i, k=0, len;
    int debug = TLinkFactory.debugLevel;
    if (wc == null || wc.status == null)
    {
      MsgLog.log("TWildcardMembersCallback", "called with no wildcard link",TErrorList.code_failure,null,0);
      return;
    }
    if (lstid < 0 || lstid >= wc.status.length)
    {
      MsgLog.log("TWildcardMembersCallback", "invalid member id "+lstid,TErrorList.code_failure,null,0);
      return;    	
    }
    if (wc.status[lstid] == TErrorList.not_ready) wc.numPending--;
    wc.status[lstid] = link.linkStatus;
    if (debug > 1) 
      DbgLog.log("TWildcardMembersCallback","grp cb : (" + lstid + ") : <" + link.linkStatus + "> pending : " + wc.numPending + " from " + wc.length);    
    if (link.linkStatus == TErrorList.link_blacklisted) link.close();
    if (link.linkStatus == TErrorList.illegal_property) link.close();
    if (link.linkStatus == TErrorList.illegal_format) link.close();

    if (wc.numPending > 0) return;

    if (debug > 1) DbgLog.log("TWildcardMembersCallback","wildcard group all in !!!!!!!!");
    TDataType pd = wc.parent.getOutputDataObject();
    TDataType md = null;
    int maxlen = pd.getArrayLength();
    try 
    {
	    for (i=0, k=0; i<wc.links.length && k<maxlen; i++)
	    { // each member link has a subset of the list to return ...
	    	md = wc.links[i].getOutputDataObject();
	    	len = md.getCompletionLength();
	    	pd.putData(k,md.getDataObject(),len,0,false);
	      pd.dTimestamp = md.dTimestamp;
	      pd.sysDataStamp = md.sysDataStamp;
	      pd.usrDataStamp = md.usrDataStamp;
	    	k += len;
	    }
  	} 
    catch (Exception x)
  	{ // if anything bizarre happens we still have to notify !
  		x.printStackTrace();
  		link.linkStatus = TErrorList.code_failure;
  	}
    wc.numActive = wc.links.length;
    wccc = link.linkStatus;
    wc.numPending = wc.numActive;
    for (i=0; i<wc.length; i++)
    {
      if (wc.status[i] == TErrorList.illegal_format) continue;
      if (wc.status[i] == TErrorList.illegal_property) continue;
      if (wc.status[i] == TErrorList.link_blacklisted) continue;
      if (wccc != 0 && wc.status[i] == 0) wccc = 0; /* at least one success */
      wc.status[i] = TErrorList.not_ready;
    }
    //wc.parent.dOutput.setArrayLength(k);
    wc.parent.linkStatus = wccc;
    wc.parent.linkStatusSource = link.linkStatusSource;
    wc.parent.getOutputDataObject().dCompletionLength = k;
    wc.parent.hasObtainedStatus = true;
    if (wc.tlcb != null) wc.tlcb.callback(wc.parent);
    else if (wc.tcb != null) wc.tcb.callback(wc.parent.linkId,wccc);
    else wc.parent.wakeUpCall();
    wc.canNotify = true;
    wc.checkActive();
    return;
  }
}
