package de.desy.tine.console;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import de.desy.tine.definitions.TAccess;

public class TCommandItem
{
  private String cmdString = null;
  private String cmdDesc = null;
  public String getCommandString() { return cmdString; }
  public String getCommandDescription() { return cmdDesc; }
  private Method cmdR = null;
  private Method cmdW = null;
  private int access = TAccess.CA_NULL;
  public static boolean getBoolean(String value)
  {
  	if (value == null) return false;
  	boolean bvalue = false;
  	if (value.compareToIgnoreCase("true") == 0 ||
  			value.compareToIgnoreCase("yes") == 0 ||
  			value.compareToIgnoreCase("on") == 0)
  	{
  		bvalue = true;
  	}
  	else
  	{
  		try
  		{
  			int v = Integer.parseInt(value);
  			bvalue = (v != 0);
  		}
  		catch (Exception ignore) 
  		{ 
  			bvalue = false; 
  		}
  	}
  	return bvalue;
  }
  public boolean canSet() { return TAccess.isWrite((byte)access); }
  public boolean canGet() { return TAccess.isRead((byte)access); }
  public TCommandItem(String command,String description,Method method)
  {
    cmdString = command;
    cmdDesc = description;
    cmdR = method;
    cmdW = method;
    access = TAccess.CA_READ;
  }
  public TCommandItem(String command,String description,Method method,int access)
  {
    cmdString = command;
    cmdDesc = description;
    cmdR = method;
    cmdW = method;
    this.access = access;
  }
  public TCommandItem(String command,String description,Method methodRead,Method methodWrite,int access)
  {
    cmdString = command;
    cmdDesc = description;
    cmdR = methodRead;
    cmdW = methodWrite;
    this.access = access;
  }
  public void invoke()
  {
    invoke(TAccess.CA_READ);
  }
  public void invoke(short access)
  {
    try
    {
      if (TAccess.isWrite((byte)access))
        cmdW.invoke((Object)null, (Object[])null);
      else
        cmdR.invoke((Object)null, (Object[])null);
    }
    catch (Exception e)
    {
      System.out.println("cannot invoke "+cmdString+" : "+e.getMessage());
    }
  }
  public void invoke(int value) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException
  {
    invoke(value,TAccess.CA_WRITE);
  }
  public void invoke(int value,short access) throws IllegalAccessException, IllegalArgumentException, InvocationTargetException
  {
//    try
    {
      if (TAccess.isWrite((byte)access))
        cmdW.invoke((Object)null, value);
      else
        cmdR.invoke((Object)null, value);
    }
//    catch (Exception e)
//    {
//      System.out.println("cannot invoke "+cmdString+" : "+e.getMessage());
//    }
  }
  public void invoke(String value)
  {
    invoke(value,TAccess.CA_WRITE);
  }
  public void invoke(String value,short access)
  {
    try
    {
      if (TAccess.isWrite((byte)access))
        cmdW.invoke((Object)null, value);
      else
        cmdR.invoke((Object)null, value);
    }
    catch (Exception e)
    {
      System.out.println("cannot invoke "+cmdString+" : "+e.getMessage());
    }
  }
}
