package de.desy.tine.csvUtils;

import java.lang.reflect.Field;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.server.logger.MsgLog;

public class FormatFieldHandler implements csvHandler
{
  private RowHandler rHndlr;
  private Field field;

  public FormatFieldHandler(RowHandler rowHndlr, String fieldName)
  {
    rHndlr = rowHndlr;
    field = null;
    try
    {
      field = rowHndlr.getClass().getField(fieldName);
      field.setAccessible(true);
    }
    catch (SecurityException e)
    {
      e.printStackTrace();
      MsgLog.log("FormatFieldHandler", "cannot set field " + fieldName, TErrorList.invalid_field, e, 0);
    }
    catch (NoSuchFieldException e)
    {
      e.printStackTrace();
      MsgLog.log("FormatFieldHandler", "field " + fieldName + " does not exist", TErrorList.invalid_field, e, 0);
    }
  }

  public int process(String strValue, int index)
  {
    try
    {
      short fmt = TFormat.getFormatCode(strValue);
      field.setShort(rHndlr, fmt);
      if (fmt == TFormat.CF_STRUCT)
      {
        Field tagfield = rHndlr.getClass().getField("dataText");
        tagfield.setAccessible(true);
        String tag = TFormat.getFormatTag(strValue);
        tagfield.set(rHndlr, tag);
      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
      MsgLog.log("FormatFieldHandler", "cannot set field value to " + strValue, TErrorList.invalid_field, e, 0);
    }
    return 0;
  }
}
