package de.desy.tine.csvUtils;

import java.lang.reflect.Field;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

public class ShortFieldHandler implements csvHandler
{
  private RowHandler rHndlr;
  private Field field;
  public ShortFieldHandler(RowHandler rowHndlr,String fieldName) 
  { 
    rHndlr = rowHndlr;
    field = null;
    try
    {
      field = rowHndlr.getClass().getField(fieldName);
      field.setAccessible(true);
    }
    catch (SecurityException e)
    {
      e.printStackTrace();
      MsgLog.log("IntFieldHandler","cannot set field " + fieldName,TErrorList.invalid_field,e,0);
    }
    catch (NoSuchFieldException e)
    {
      e.printStackTrace();
      MsgLog.log("IntFieldHandler","field " + fieldName + " does not exist",TErrorList.invalid_field,e,0);
    }
  }
  public int process(String strValue,int index)
  {
    try
    {
      field.setShort(rHndlr, (short)csv.getIntFromString(strValue));
    }
    catch (Exception e)
    {
      e.printStackTrace();
      MsgLog.log("IntFieldHandler","cannot set field value to " + strValue,TErrorList.invalid_field,e,0);
    }
    return 0;
  }
}
