package de.desy.tine.csvUtils;

import java.lang.reflect.Field;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;
import de.desy.tine.stringUtils.Str;

public class StringFieldHandler implements csvHandler
{
  private RowHandler rHndlr;
  private Field field;
  public StringFieldHandler(RowHandler rowHndlr,String fieldName) 
  { 
    rHndlr = rowHndlr;
    field = null;
    try
    {
      if (fieldName == null) fieldName = "";
      field = rowHndlr.getClass().getField(fieldName);
      field.setAccessible(true);
    }
    catch (SecurityException e)
    {
      e.printStackTrace();
      MsgLog.log("IntFieldHandler","cannot set field " + fieldName,TErrorList.invalid_field,e,0);
    }
    catch (NoSuchFieldException e)
    {
      e.printStackTrace();
      MsgLog.log("IntFieldHandler","field " + fieldName + " does not exist",TErrorList.invalid_field,e,0);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      MsgLog.log("IntFieldHandler","field input is invalid",TErrorList.invalid_field,e,0);
    }
  }
  public int process(String strValue,int index)
  {
    try
    {
      strValue = Str.trim(strValue);
      field.set(rHndlr, strValue);
    }
    catch (Exception e)
    {
      e.printStackTrace();
      MsgLog.log("IntFieldHandler","cannot set field value to " + strValue,TErrorList.invalid_field,e,0);
    }
    return 0;
  }
}
