package de.desy.tine.definitions;

public final class TEndianness
{
  public static final short BO_LITTLE_ENDIAN = 0x00;
  public static final short BO_BIG_ENDIAN = 0x01;
  public static String toString(short endianness)
  {
    switch (endianness)
    {
      default:
      case BO_BIG_ENDIAN: return "Big Endian";
      case BO_LITTLE_ENDIAN: return "Little Endian";
    }
  }
  public static short getEndiannessCode(String txt)
  {
    txt = txt.toUpperCase();
    if (txt == null) return BO_BIG_ENDIAN;
    if (txt.contains("BIG")) return BO_BIG_ENDIAN;
    if (txt.contains("LITTLE")) return BO_LITTLE_ENDIAN;
    return BO_BIG_ENDIAN;
  }

}
