package de.desy.tine.eventArchive;

//import java.sql.Date;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.types.FLTINT;
import de.desy.tine.types.NAME32I;
import java.util.Date;

/**
 * @version 	1.0
 * @author
 */
public class FrameEventTest
{  
//int stop = (int)(System.currentTimeMillis()/1000) - 3 * 30 * 24 * 3600;
//int start = stop - 24 * 3600 * 3; // 1178447610 < some time in May 2007 that has events
  public static void main (String[] args)
  {
    // NOTE: references to MSTIELRFPIA.CDI are stored in the event archiver as simply RFPIA
    //       references to property RECV.CLBR (for HF104XESLECKWAN - HF104XCAVRECHFU) are
    //                  stored as property GRPSTATUS ('group status')
    //                  RECV.CLBR for HF104ESUANODE is stored as ANODESTATUS
    // decide on a from-to time span (the last 24 hours is selected below
    int stop = (int)(System.currentTimeMillis()/1000);
    int start = stop - 24 * 3600; 
    System.out.println("looking for events for " + new Date((long)start*1000).toString());
    // DESYEVENTDATA is the event server, RFPIA is the targetted device server
    int el[] = TEventArchive.getArchivedDeviceEventList("DESY2","D2GRAB2",start,stop);
    if (el == null)
    {
      System.out.println("no events found");
      System.exit(0);
    }
    for (int i=0; i<el.length; i++) System.out.println("event " + i + " : " + el[i]);
    // or get the events as a human readable string ...
    String els[] = TEventArchive.getArchivedDeviceEventListAsString("LINAC2","D2GRAB2",start,stop);
    for (int i=0; i<els.length; i++) System.out.println("event " + i + " : " + els[i]);
    // get the data for a selected event ...
    int evn = el[el.length-1]; // most recent
    Date dt = new Date();
    dt.setTime((long)(evn)*1000);
    System.out.println("event : " + evn + " (" + dt.toString() + ")");
    int rc = 0;
    TDataType d;
    /*
    d = new TDataType(1,(short)TFormat.CF_NAME32I);
    for (int i=0; i<32; i++) 
    {
      //TEventArchive.getArchiveData("piarf","LINAC2","HARDWARE","RFPIA","GRPSTATUS","HF104XESLECKWAN",0,el[0],start,stop,d);
      rc = TEventArchive.getArchiveData("piarf104","LINAC2","HARDWARE","RFPIA","GRPSTATUS",devs[i],0,evn,start,stop,d);
      if (rc != 0) System.out.println("getArchiveData failed : " + TErrorList.getErrorString(rc));
      NAME32I[] n32 = (NAME32I[])d.getDataObject();
      System.out.println(devs[i] + " name = " + n32[0].getName() + " i = " + n32[0].ival);
    }
    */
    byte[] frame = new byte[150000];
    d = new TDataType(frame);
    for (int i=0; i<10; i++)
    {
      TEventArchive.getArchiveData("d2grab2","DESY2","DESY2","D2GRAB2","FRAME."+(i+1),"device_0",0,evn,start,stop,d);
      System.out.println("frame "+i+" b1 = " + frame[0]+ " : "+d.getCompletionLength()+" bytes returned");
    }
    
    System.exit(0);
  }
}
