package de.desy.tine.eventArchive;

import de.desy.tine.structUtils.TTaggedStructure;

public class TrgChn extends TTaggedStructure
{
  public void clear()
  {
    contextString = null;
    serverString = null;
    propertyString = null;
    deviceString = null;
  }
  private char[] context = new char[32];
  private String contextString;
  private char[] server = new char[32];
  private String serverString;
  private char[] property = new char[64];
  private String propertyString;
  private char[] device = new char[64];
  private String deviceString;
  private void initStructure()
  {
    addField(context,"context");
    addField(server,"server");
    addField(property,"property");
    addField(device,"device");
    initDone();    
  }
  public TrgChn()
  {
    super();
    initStructure();
  }
  public TrgChn(TrgChn reference)
  {
    super();
    initStructure();
    System.arraycopy(reference.context, 0, context, 0, 32);    
    System.arraycopy(reference.server, 0, server, 0, 32);    
    System.arraycopy(reference.property, 0, property, 0, 64);    
    System.arraycopy(reference.device, 0, device, 0, 64);
  }
  public String getContext()
  {
    if (contextString == null) contextString = new String(context).trim();
    return contextString;
  }
  public String getDevice()
  {
    if (deviceString == null) deviceString = new String(device).trim();
    return deviceString;
  }
  public String getProperty()
  {
    if (propertyString == null) propertyString = new String(property).trim();
    return propertyString;
  }
  public String getServer()
  {
    if (serverString == null) serverString = new String(server).trim();
    return serverString;
  }
  public void setContext(String context) 
  {
    Util.pushChars(context,this.context);
    this.contextString = new String(context);
  }
  public void setDevice(String device) 
  {
    Util.pushChars(device,this.device);
    this.deviceString = new String(device);
  }
  public void setServer(String server) 
  {
    Util.pushChars(server,this.server);
    this.serverString = new String(server);
  }
  public void setProperty(String property) 
  {
    Util.pushChars(property,this.property);
    this.propertyString = new String(property);
  }
}
