package de.desy.tine.eventArchive;

//import java.sql.Date;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.queryUtils.TQuery;
import de.desy.tine.types.FLTINT;
import de.desy.tine.types.IMAGE;
import de.desy.tine.types.NAME32I;
import java.util.Date;

/**
 * @version 	1.0
 * @author
 */
public class eventTest
{  
//int stop = (int)(System.currentTimeMillis()/1000) - 3 * 30 * 24 * 3600;
//int start = stop - 24 * 3600 * 3; // 1178447610 < some time in May 2007 that has events
  public static void main (String[] args)
  {
    String[] cmps = TEventArchiveDataBase.getTrcComponentNames("PETRA");
    String cfgName = cmps[0];
    
    String[] devices = TEventArchive.getDevicesAsString("temp_vac_intlk", "PETRA", "/PETRA/P3VacTempProxy", "Temperature.HIST", 1611843632);
    System.out.println("with valid event");
    for (String s : devices) System.out.println(s);
    System.out.println("with no event");
    devices = TEventArchive.getDevicesAsString("temp_vac_intlk", "PETRA", "/PETRA/P3VacTempProxy", "Temperature.HIST", -1);
    for (String s : devices) System.out.println(s);
    System.out.println("with no event and no target property");
    devices = TEventArchive.getDevicesAsString("temp_vac_intlk", "PETRA", "/PETRA/P3VacTempProxy", null, -1);
    for (String s : devices) System.out.println(s);
    System.out.println("with no event and no target property and no trigger");
    devices = TEventArchive.getDevicesAsString(null, "PETRA", "/PETRA/P3VacTempProxy", null, -1);
    for (String s : devices) System.out.println(s);
    System.out.println("finito!");
    //String[] properties = TEventArchive.getPropertiesAsString("FLASH","kly3_hv","/FLASH/KLY3","U_Kly",1379999586);
    
    //for (String p : properties) System.out.println(p);

 /*
 -> get HISTORY servers for selected context
   -> get Device Names from EVENTSTORE
 -> fill in grpsCombo: (no action)
  -> get Device Names from EVENTS
   -> arc server select: EVENTS/srv name 
    -> "StoredProperties" -> ArcProp combo select (no action)
    -> "StoredDevices" -> ArcDev combo select (no action)
    -> fill in TRC components: EVENTS/TRC.COMPONENTS.NAM -> trcViews(i).desc
      ->  EVENTS/configname TRC.CHANNELS.NAM  (struct: trgView)
    -> select hist config
      -> fillin TRC Channels:
      -> EVENTS/TRC.CHANNELS
  -> hstcfg list: getTrcCmpSettings -> TRC.COMPONENTS
    -> hstcfg item list: updateTrcChannelList -> EVENTS/confg name TRC.CHANNELS.NAM
    
   */ 
    try
    {
      // get trigger table : trigger names fill in the 'trigger items' combo box
      ARBQS[] trgs =  TEventArchiveDataBase.getTriggerTable("PETRA");
      System.out.println("1st trg: "+trgs[0].toString());
      // get servers for selected trigger to fill in archived servers combo box:
      String[] asrvs = TEventArchive.getDeviceServers("PETRA", trgs[0].getName());
      System.out.println("1st srv: "+asrvs[0]);
      // get properties for selected server (fill in stored properties combo)
      String[] aprps = TEventArchive.getPropertiesAsString("PETRA", trgs[0].getName(), asrvs[0], null);
      System.out.println("1st prp: "+aprps[0]);
           
      // get TRC components (upper left hand list box)
      TrgView[] tvc = TEventArchiveDataBase.getTrcConfigs("PETRA");//TRC.COMPONENTS.NAM
      //System.out.println("1st config: "+tvc[0].toString());
      System.out.println("1st list box entry: "+tvc[0].getDescription()); // use this as 'config name below'
      // get cross references (list of TrgViews[] items  (config name -> file name)
      TrgView[] tv = TEventArchiveDataBase.getTrcComponentViews("PETRA",tvc[0].getDescription());//TRC.CHANNELS.NAM
      System.out.println("1st Xref: "+tv[0].getDescription());

      //get specific config info for selected configuration (upper left listbox selections)
      TrgCmp[] tc = TEventArchiveDataBase.getTrcComponents("PETRA", tvc[0].getDescription());//TRC.COMPONENTS
      // list of TrgCmp[] items ... //'desc' populates lower left combo
      System.out.println("1st component: "+tc[0].getDescription());
      
      // get channel information to display in configuration settings list box 
      TrgChn[] tch = TEventArchiveDataBase.getTrcChannels("PETRA", tc[0].getDescription());//TRC.CHANNELS
      //System.out.println("1st channel: "+tch[0].toString());
      System.out.println("1st channel: /"+tch[0].getContext()+"/"+tch[0].getServer()+"/"+tch[0].getDevice()+"["+tch[0].getProperty()+"]");
      
      // WRITING info back:
      // write the configs back
      TEventArchiveDataBase.setTrcConfigs("TEST", tvc); // configs ...
      // write the components back
      TEventArchiveDataBase.setTrcComponentViews("TEST", tvc[0].getDescription(), tv);
      // write the channels back
      TEventArchiveDataBase.setTrcChannels("TEST", tv[0].getDescription(), tch);
      
      // get trigger database
      DASQS[] dasqs = TEventArchiveDataBase.getTriggerDataBase("TEST","asdf");
      System.out.println("Data TAG at start: '" + dasqs[1].getDataTag() + "'");
      dasqs[1].setDataTag("TraceHS");
      TEventArchiveDataBase.setTriggerDataBase("TEST","asdf",dasqs);
      dasqs = TEventArchiveDataBase.getTriggerDataBase("TEST","asdf");
      System.out.println("Data Tag after it was changed: '"+dasqs[1].getDataTag()+"'");
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
//    int cc = TEventArchive.sendTrigger("PETRA", "MPSEvent", "test");
//    
//    String actx[] = TEventArchive.getArchiveContexts("PETRA","SL_Control");
//    if (actx != null) for (String s : actx) System.out.println(s);
//    
//    String ctx[] = TEventArchive.getEventArchiveServerContexts();
//    for (String s : ctx) System.out.println(s);
//    String cmp[] = TEventArchive.getTransientRecorderConfigurationNames("DORIS");
//    for (String s : cmp) System.out.println(s);
//    TrgCmp[] tc = null;
//    try 
//    { // get the 'components' list for the selected configuration (often a list of 1)
//      tc = TEventArchive.getTransientRecorderComponents("DORIS", cmp[0]);
//      for (TrgCmp c : tc) System.out.println(c.toString());
//    }
//    catch (Exception e)
//    {
//      System.out.println("oops!");
//    }
//    try 
//    { // after selected a component, get the channels (no null pointer check here)
//      TrgChn[] tch = TEventArchive.getTransientRecorderChannels("DORIS", tc[0].getDescription());
//      for (TrgChn c : tch) System.out.println(c.toString());
//    }
//    catch (Exception e)
//    {
//      System.out.println("oops!");
//    }
    
    int stop = (int)(System.currentTimeMillis()/1000);
    int start = stop - 96 * 3600; // last 4 days
    //stop -= 48 * 3600;
    System.out.println("looking for events for " + new Date((long)start*1000).toString());
    int el[] = TEventArchive.getArchivedDeviceEventList("PETRA","bpm_intlk",start,stop);
    if (el == null)
    {
      System.out.println("no events found");
     // System.exit(0);
    }
    for (int i=0; i<el.length; i++) 
      System.out.println("event "+i+" : "+el[i]+" ("+new Date((long)el[i]*1000).toString()+")");
    // no need to browse for servers within the event -> it's all coming from "BPM"
    // select a server browse for properties (in a given archive context) ...
    String[] pps = TEventArchive.getPropertiesAsString("PETRA","bpm_intlk","BPM",null);
    System.out.println("properties stored with this event:");
    for (int i=0; i<pps.length; i++) System.out.println(pps[i]);
    System.out.println("devices stored with server BPM:");
    String[] devs = TEventArchive.getDevicesAsString("PETRA","BPM");
    for (int i=0; i<devs.length; i++) System.out.println(devs[i]);
    TDataType d16384 = new TDataType(16384,(short)TFormat.CF_INT32);
    int evn = el[el.length-1]; // choose the most recent event for this example ...
    int[] trgOffset = new int[227];
    int[] trigTime = new int[227];
    int[] readTime = new int[227];
    int[] mcTime = new int[227];
    int[] sysTime = new int[227];
    TDataType d227 = new TDataType(trgOffset);
    TEventArchive.getArchiveData("bpm_intlk","PETRA","PETRA","BPM","TRIGGEROFFSET",devs[0],0,evn,start,stop,d227);
    d227 = new TDataType(mcTime);
    TEventArchive.getArchiveData("bpm_intlk","PETRA","PETRA","BPM","PM_MC_TIME",devs[0],0,evn,start,stop,d227);
    d227 = new TDataType(readTime);
    TEventArchive.getArchiveData("bpm_intlk","PETRA","PETRA","BPM","PM_READTIME",devs[0],0,evn,start,stop,d227);
    d227 = new TDataType(trigTime);
    TEventArchive.getArchiveData("bpm_intlk","PETRA","PETRA","BPM","PM_TRIGTIME",devs[0],0,evn,start,stop,d227);
    d227 = new TDataType(sysTime);
    TEventArchive.getArchiveData("bpm_intlk","PETRA","PETRA","BPM","PM_SYS_TIME",devs[0],0,evn,start,stop,d227);
    for (int i=0; i<227; i++) 
    {
      System.out.println(devs[i]+" trigger offset: "+trgOffset[i]+
          " trigger time: "+trigTime[i]+" read time: "+readTime[i]+
          " mc time: "+mcTime[i]+" sys time: "+sysTime[i]);
      // e.g. property PM_DATA_X:
      if (TEventArchive.getArchiveData("bpm_intlk","PETRA","PETRA","BPM","PM_DATA_X",devs[i],0,evn,start,stop,d16384) == 0)
      {
        int[] orbx = (int[])d16384.getDataObject();
        System.out.println(devs[i]+" 1st 5 values: "+orbx[0]+" "+orbx[1]+" "+orbx[2]+" "+orbx[3]+" "+orbx[4]);
      }     
    }
    
//    // browse for servers
//    String[] ds = TEventArchive.getDeviceServersAsString("LINAC2");
//    for (int i=0; i<ds.length; i++) System.out.println(ds[i]);
//    // select a server browse for properties (in a given archive context) ...
//    String[] pps = TEventArchive.getPropertiesAsString("LINAC2","piarf","RFPIA",null);
//    for (int i=0; i<pps.length; i++) System.out.println(pps[i]);
//    // browse for device names for a given server
//    String[] devs = TEventArchive.getDevicesAsString("LINAC2","RFPIA");
//    for (int i=0; i<devs.length; i++) System.out.println(devs[i]);
//      // there are no event headers (as yet) for the PIARF event archives 
// //   DHS dhs = ArchiveQuery.getArchiveHeader("piarf","LINAC2","HARDWARE","RFPIA","GRPSTATUS","HF104XESLECKKWAN",0,el[0],start,stop);
// //   System.out.println( dhs.arraysize + " values of type " + dhs.datatype + " " + dhs.egu);
// //   System.out.println( "Archived comment: " + dhs.comment);
//
//    // get the data for a selected event ...
//    int evn = el[el.length-1]; // most recent
//    Date dt = new Date();
//    dt.setTime((long)(evn)*1000);
//    System.out.println("event : " + evn + " (" + dt.toString() + ")");
    int rc = 0;
    TDataType d;
    /*
    d = new TDataType(1,(short)TFormat.CF_NAME32I);
    for (int i=0; i<32; i++) 
    {
      //TEventArchive.getArchiveData("piarf","LINAC2","HARDWARE","RFPIA","GRPSTATUS","HF104XESLECKWAN",0,el[0],start,stop,d);
      rc = TEventArchive.getArchiveData("piarf104","LINAC2","HARDWARE","RFPIA","GRPSTATUS",devs[i],0,evn,start,stop,d);
      if (rc != 0) System.out.println("getArchiveData failed : " + TErrorList.getErrorString(rc));
      NAME32I[] n32 = (NAME32I[])d.getDataObject();
      System.out.println(devs[i] + " name = " + n32[0].getName() + " i = " + n32[0].ival);
    }
    */
//    FLTINT[] fi = new FLTINT[1];
//    d = new TDataType(fi);
//    TEventArchive.getArchiveData("piarf104","LINAC2","HARDWARE","RFPIA","ANODESTATUS","HF104ESUANODE",0,evn,start,stop,d);
//    System.out.println("flt = " + fi[0].fval + " int = " + fi[0].ival);
//
//    float[] f = new float[1];
//    d = new TDataType(f);
//    TEventArchive.getArchiveData("piarf104","LINAC2","HARDWARE","RFPIA","preEnergy","SWITCH",0,evn,start,stop,d);
//    System.out.println("flt = " + f[0]);

    
    el = TEventArchive.getArchivedEventList("PETRA","video_test_trig",start,stop);
    System.out.println("event number: "+el[0]);
    
    int[] nseq = new int[1];
    d = new TDataType(nseq);
    TEventArchive.getArchiveData("video_test_trig","PETRA","HASYLAB_TEST","P01_LM2","Frame.Sched.NSEQ","Output",0,el[0],start,stop,d);
    
    IMAGE img = new IMAGE(6291456);
    d = new TDataType(img);
    TEventArchive.getArchiveData("video_test_trig","PETRA","HASYLAB_TEST","P01_LM2","Frame.Sched.1","Output",0,el[0],start,stop,d);
    //System.out.println("flt = " + f[0]);
    
    /* */
    // e.g. how to trigger an event :
//    rc = TEventArchive.sendTrigger("LINAC2", "piarf", "event triggered as a test");
    System.out.println("trigger event : " + TErrorList.getErrorString(rc));
    // that's all folks ...
    System.exit(0);
  }
}
