package de.desy.tine.eventArchive;

import java.sql.Date;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.types.FLTINT;
import de.desy.tine.types.NAME32I;

/**
 * @version 	1.0
 * @author
 */
public class eventTestDoris
{  
//int stop = (int)(System.currentTimeMillis()/1000) - 3 * 30 * 24 * 3600;
//int start = stop - 24 * 3600 * 3; // 1178447610 < some time in May 2007 that has events
  public static void main (String[] args)
  {
    // NOTE: references to MSTIELRFPIA.CDI are stored in the event archiver as simply RFPIA
    //       references to property RECV.CLBR (for HF104XESLECKWAN - HF104XCAVRECHFU) are
    //                  stored as property GRPSTATUS ('group status')
    //                  RECV.CLBR for HF104ESUANODE is stored as ANODESTATUS
    // decide on a from-to time span (the last 24 hours is selected below
    int stop = (int)(System.currentTimeMillis()/1000);
    int start = stop - 24 * 3600; 
    Date d1 = new Date(107, 10, 1);
    Date d2 = new Date(107, 10, 29);
    start = (int)(d1.getTime()/1000);
    stop = (int)(d2.getTime()/1000);
    System.out.println("looking for events for " + new Date((long)start*1000).toString());
    // DESYEVENTDATA is the event server, RFPIA is the targetted device server
    int el[];
    int counter = 0;
    do
    {
      el = TEventArchive.getArchivedDeviceEventList("DORIS","DOTRCRF",start,stop);
      if (el == null) try
      {
        Thread.sleep(1000);
        el = TEventArchive.getArchivedDeviceEventList("DORIS","DOTRCRF",start,stop);
        if (el == null)
        {
          System.out.println("no events found");
          System.exit(0);
        }
      }
      catch (InterruptedException e)
      {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }
      counter++;
    } while (el != null && counter < 1000);
    if (el == null)
    {
      System.out.println("no events found");
      System.exit(0);
    }
    for (int i=0; i<el.length; i++) System.out.println("event " + i + " : " + el[i]);
    // or get the events as a human readable string ...
    String els[] = TEventArchive.getArchivedDeviceEventListAsString("DORIS","DOTRCRF",start,stop);
    for (int i=0; i<els.length; i++) System.out.println("event " + i + " : " + els[i]);
    // browse for servers
    String[] ds = TEventArchive.getDeviceServersAsString("DORIS");
    for (int i=0; i<ds.length; i++) System.out.println(ds[i]);
    // browse for archive contexts (trigger names)
    String[] ctxs = TEventArchive.getArchiveContexts("DORIS");
    for (int i=0; i<ctxs.length; i++) System.out.println(ctxs[i]);
    // select a server browse for properties (in a given archive context) ...
    String[] pps = TEventArchive.getPropertiesAsString("DORIS","dotrcrf","DOTRCRF",null);
    for (int i=0; i<pps.length; i++) System.out.println(pps[i]);
    // browse for device names for a given server
    String[] devs = TEventArchive.getDevicesAsString("DORIS","DOTRCRF");
    for (int i=0; i<devs.length; i++) System.out.println(devs[i]);
      // there are no event headers (as yet) for the PIARF event archives 
 //   DHS dhs = ArchiveQuery.getArchiveHeader("piarf","LINAC2","HARDWARE","RFPIA","GRPSTATUS","HF104XESLECKKWAN",0,el[0],start,stop);
 //   System.out.println( dhs.arraysize + " values of type " + dhs.datatype + " " + dhs.egu);
 //   System.out.println( "Archived comment: " + dhs.comment);

    // get the data for a selected event ...
    
    int evn = el[el.length-1]; // most recent 
    // get the header info for a specific event
    DHS hdr = TEventArchive.getArchiveHeader("DORIS", "DOTRCRF", "SAMPLE", "CHANNEL2", evn,start,stop);
    //System.out.println(" size : " + hdr.arraysize + " of type " + TFormat.toString(hdr.datatype));
    System.out.println("header : \n" + hdr.toString());
    // get the event comment separately :
    String cmt = TEventArchive.getArchiveComment("DORIS", "dotrcrf", evn);
    System.out.println("comment :" + cmt);
    
    TDataType d;
    int rc = 0;
    short[] fi = new short[hdr.arraysize];
    d = new TDataType(fi);
    TEventArchive.getArchiveData("dotrcrf","DORIS","DORIS","DOTRCRF","SAMPLE","CHANNEL8",0,evn,start,stop,d);
    System.out.println("short val = " + fi[0]);
    System.exit(0);
/* */
    // e.g. how to trigger an event :
    rc = TEventArchive.sendTrigger("LINAC2", "piarf", "event triggered as a test");
    System.out.println("trigger event : " + TErrorList.getErrorString(rc));
    // that's all folks ...
    System.exit(0);
  }
}
