package de.desy.tine.eventUtils;
import java.io.*;
import de.desy.tine.endianUtils.Swap;

public class ADRBX
{
  public int eventNumber;
  public int starttime;
  public int stoptime;
  public String deviceContext = new String(new StringBuffer(16));
  public String deviceServerName = new String(new StringBuffer(16));
  public String deviceProperty = new String(new StringBuffer(32));
  public String deviceName = new String(new StringBuffer(32));
  public short dataFormat;
  public short reserved;
  public int dataIndex;
  public int dataDimension;
  public static int sizeInBytes = (3*4 + 2*16 + 2*32+ 2*2 + 2*4);
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      ds.writeInt(Swap.Int(eventNumber));
      ds.writeInt(Swap.Int(starttime));
      ds.writeInt(Swap.Int(stoptime));
      byte[] bstr = new byte[32];
      byte[] tmp  = deviceContext.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      tmp  = deviceServerName.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      tmp  = deviceProperty.getBytes();
      for (int i=0; i<32; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,32);
      tmp  = deviceName.getBytes();
      for (int i=0; i<32; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,32);
      ds.writeShort(Swap.Short(dataFormat+512));
      ds.writeShort(Swap.Short(reserved));
      ds.writeInt(Swap.Int(dataIndex));
      ds.writeInt(Swap.Int(dataDimension));
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      eventNumber = Swap.Int(ds.readInt());
      starttime = Swap.Int(ds.readInt());
      stoptime  = Swap.Int(ds.readInt());
      byte[] bstr = new byte[32];
      ds.read(bstr,0,16);
      deviceContext = new String(bstr,0,16);
      ds.read(bstr,0,16);
      deviceServerName = new String(bstr,0,16);
      ds.read(bstr,0,32);
      deviceProperty = new String(bstr);
      ds.read(bstr,0,32);
      deviceName = new String(bstr);
      dataFormat = Swap.Short(ds.readShort()-512);
      reserved = Swap.Short(ds.readShort());
      dataIndex = Swap.Int(ds.readInt());
      dataDimension = Swap.Int(ds.readInt());
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
  }
  public void dump()
  {
    String dmpstr = "Event Number : " + eventNumber; System.out.println(dmpstr);
    dmpstr = "Start time : " + starttime; System.out.println(dmpstr);
    dmpstr = "Stop time : " + stoptime; System.out.println(dmpstr);
    dmpstr = "Device Context: " + deviceContext; System.out.println(dmpstr);
    dmpstr = "Device Server Name: " + deviceServerName; System.out.println(dmpstr);
    dmpstr = "Device Property: " + deviceProperty; System.out.println(dmpstr);
    dmpstr = "Device Name: " + deviceName; System.out.println(dmpstr);
    dmpstr = "Data Format: " + dataFormat; System.out.println(dmpstr);
    dmpstr = "Data Index: " + dataIndex; System.out.println(dmpstr);
    dmpstr = "Data Dimension: " + dataDimension; System.out.println(dmpstr);
  }
}
