package de.desy.tine.eventUtils;
import java.io.*;
import de.desy.tine.endianUtils.*;
public class AIB
{
  public short numProperties;
  public short numDevices;
  public int eventCode;
  public String comment = new String(new StringBuffer(64));
  public static int sizeInBytes = (2*4 + 4 + 64);
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public byte[] toByteArray()
  {
    try
    {
    	dBuffer.reset();
    	DataOutputStream ds = new DataOutputStream(dBuffer);
    	ds.writeShort(Swap.Short(numProperties));
    	ds.writeShort(Swap.Short(numDevices));
    	ds.writeInt(Swap.Int(eventCode));
    	byte[] bstr = new byte[64];
    	byte[] tmp  = comment.getBytes();
    	for (int i=0; i<64; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
    	ds.write(bstr,0,64);
    	ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }
  public void toStruct()
  {
    try
    {
    	ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
    	DataInputStream ds = new DataInputStream(dis);
    	numProperties = Swap.Short(ds.readShort());
    	numDevices = Swap.Short(ds.readShort());
    	eventCode = Swap.Int(ds.readInt());
    	byte[] bstr = new byte[64];
    	ds.read(bstr,0,64);
    	comment = new String(bstr);
    	ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
  }
}
