package de.desy.tine.eventUtils;

import de.desy.tine.definitions.TStrings;
import de.desy.tine.structUtils.TTaggedStructure;

public class ARBQS extends TTaggedStructure
{ // ARBQS
  public void clear()
  {
    trgStr = null;
    extStr = null;
    descStr = null;
  }
  private char[] trg = new char[TStrings.DEVICE_NAME_SIZE];
  private String trgStr = null;
  private char[] ext = new char[16];
  private String extStr = null;
  private char[] desc = new char[64];
  private String descStr = null;
  int[]  depthInMonths = new int[1];
  short[]  recordEvents = new short[1];
  short[] maxQueueSize = new short[1];
  
  private void initStructure()
  {
    addField(trg,"trg");
    addField(ext,"ext");
    addField(desc,"desc");
    addField(depthInMonths,"depthInMonths");
    addField(recordEvents,"recordEvents");
    addField(maxQueueSize,"maxQueueSize");
    initDone();    
  }
  public ARBQS()
  {
    super();
    initStructure();
  }
  public String getTrigger()
  {
    if (trgStr == null) trgStr = new String(trg).trim();
    return trgStr;
  }
  public void setTrigger(String newTrg)
  {
    pushChars(newTrg, trg);
    trgStr = new String(newTrg);
  }
  public String getExtension()
  {
    if (extStr == null) extStr = new String(ext).trim();
    return extStr;
  }
  public void setExtension(String newExt)
  {
    pushChars(newExt, ext);
    extStr = new String(newExt);
  }
  public String getDescription()
  {
    if (descStr == null) descStr = new String(desc).trim();
    return descStr;
  }
  public void setDescription(String newDescription)
  {
    pushChars(newDescription, desc);
    descStr = new String(newDescription);
  }
  public int getDepthInMonths() { return depthInMonths[0]; }
  public void setDepthInMonths(int value) { depthInMonths[0] = value; }
  public int getRecordEvents() { return recordEvents[0]; }
  public void setRecordEvents(int value) { recordEvents[0] = (short)value; }
  public int getMaxQueueSize() { return maxQueueSize[0]; }
  public void setMaxQueueSize(int value) { maxQueueSize[0] = (short)value; }
}
