package de.desy.tine.eventUtils;
import java.io.*;
import de.desy.tine.endianUtils.*;

public class PIB
{
  public float SamplingRate;
  public int numPreTriggerValues;
  public int TimeOffset;
  public int LowCount;
  public int HighCount;
  public String Units = new String(new StringBuffer(16));
  public double LowEGU;
  public double HighEGU;  
  public short numDevices;
  public short reserved;
  public static int sizeInBytes = (5*4 + 16 + 2*8 + 2*2);
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  byte[] hByteArray;
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      byte[] bstr = new byte[256];
      byte[] tmp;
      DataOutputStream ds = new DataOutputStream(dBuffer);
      ds.write(Swap.Float(SamplingRate),0,4);
      ds.writeInt(Swap.Int(numPreTriggerValues));
      ds.writeInt(Swap.Int(TimeOffset));
      ds.writeInt(Swap.Int(LowCount));
      ds.writeInt(Swap.Int(HighCount));
      tmp  = Units.getBytes();
      for (int i=0; i<16; i++) bstr[i] = i < tmp.length ? tmp[i] : 0;
      ds.write(bstr,0,16);
      ds.write(Swap.Double(LowEGU),0,8);
      ds.write(Swap.Double(HighEGU),0,8);
      ds.writeShort(Swap.Short(numDevices));
      ds.writeShort(Swap.Short(reserved));
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }
  public void toStruct()
  {
    try
    {
      byte[] bstr = new byte[256];
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      SamplingRate = Swap.Float(bstr);
      numPreTriggerValues = Swap.Int(ds.readInt());
      TimeOffset = Swap.Int(ds.readInt());
      LowCount = Swap.Int(ds.readInt());
      HighCount = Swap.Int(ds.readInt());
      ds.read(bstr,0,16);
      Units = new String(bstr);
      ds.read(bstr,0,8);
      LowEGU = Swap.Double(bstr);
      ds.read(bstr,0,8);
      HighEGU = Swap.Double(bstr);
      numDevices = Swap.Short(ds.readShort());
      reserved = Swap.Short(ds.readShort());
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      System.exit(1);
    }	 
  }
}
