package de.desy.tine.histUtils;

import de.desy.tine.structUtils.TTaggedStructure;

public class DclProc extends TTaggedStructure
{
  public void clear()
  {
    devnameString = null;
    fileString = null; // without the .csv; ususally the same name as devnameString ...
    machine[0] = 0;
    nstates[0] = 0;
  }
  private char[] devname = new char[64];
  private String devnameString;
  private char[] file = new char[64];
  private String fileString;
  private int[] machine = new int[1];
  private int[] nstates = new int[1];
  private void initStructure()
  {
    addField(devname,"name");
    addField(file,"file");
    addField(machine,"machine");
    addField(nstates,"nstates");
    initDone();    
  }
  public DclProc()
  {
    super();
    initStructure();
  }
  public DclProc(DclProc reference)
  {
    super();
    initStructure();
    System.arraycopy(reference.devname, 0, devname, 0, 64);    
    System.arraycopy(reference.file, 0, file, 0, 64);
    machine[0] = reference.machine[0];
    nstates[0] = reference.nstates[0];
  }
  public String getDeviceName()
  {
    if (devnameString == null) devnameString = new String(devname).trim();
    return devnameString;
  }
  public void setDeviceName(String name) {
      pushChars(name,this.devname);
      this.devnameString = new String(name);
  }
  public String getFile()
  {
    if (fileString == null) fileString = new String(file).trim();
    return fileString;
  }
  public void setFile(String file) {
      pushChars(file,this.file);
      this.fileString = new String(file);
  }
  public int getNumberStates()
  {
    return nstates[0];
  }
  public void setNumberStates(int number)
  {
    nstates[0] = number;
  }
  public int getMachine()
  {
    return machine[0];
  }
  public void setMachine(int value) 
  {
    machine[0] = value;
  }
  
}
