package de.desy.tine.histUtils;

import de.desy.tine.structUtils.TTaggedStructure;

public class DclState extends TTaggedStructure
{
  public void clear()
  {
    devnameString = null;
    tagString = null;
    machine[0] = 0;
    reserved[0] = 0;
  }
  private char[] devname = new char[64];
  private String devnameString;
  private char[] tag = new char[64];
  private String tagString;
  private int[] machine = new int[1];
  private int[] reserved = new int[1];
  private void initStructure()
  {
    addField(devname,"name");
    addField(tag,"tag");
    addField(machine,"machine");
    addField(reserved,"reserved");
    initDone();    
  }
  public DclState()
  {
    super();
    initStructure();
  }
  public DclState(DclState reference)
  {
    super();
    initStructure();
    System.arraycopy(reference.devname, 0, devname, 0, 64);    
    System.arraycopy(reference.tag, 0, tag, 0, 64);
    machine[0] = reference.machine[0];
    reserved[0] = reference.reserved[0];
  }
  public String getDeviceName()
  {
    if (devnameString == null) devnameString = new String(devname).trim();
    return devnameString;
  }
  public void setDeviceName(String name) {
      pushChars(name,this.devname);
      this.devnameString = new String(name);
  }
  public String getStateTag()
  {
    if (tagString == null) tagString = new String(tag).trim();
    return tagString;
  }
  public void setStateTag(String tag) {
      pushChars(tag,this.tag);
      this.tagString = new String(tag);
  }
  public int getMachine()
  {
    return machine[0];
  }
  public void setMachine(int value) 
  {
    machine[0] = value;
  }
  
}
