package de.desy.tine.histUtils;

import de.desy.tine.structUtils.TTaggedStructure;

public class HstView extends TTaggedStructure
{
  public void clear()
  {
    fileNameString = null;
    descString = null;
  }
  private char[] fileName = new char[64];
  private String fileNameString;
  private char[] desc = new char[64];
  private String descString;
  
  private void initStructure()
  {
    addField(fileName,"context");
    addField(desc,"server");
    initDone();    
  }
  public HstView()
  {
    super();
    initStructure();
  }
  public HstView(HstView reference)
  {
    super();
    initStructure();
    System.arraycopy(reference.fileName, 0, fileName, 0, 64);    
    System.arraycopy(reference.desc, 0, desc, 0, 64);    
  }
  public String getFileName()
  {
    if (fileNameString == null) fileNameString = new String(fileName).trim();
    return fileNameString;
  }
  public String getDescription()
  {
    if (descString == null) descString = new String(desc).trim();
    return descString;
  }
  public void setFileName(String context) {
    pushChars(context,this.fileName);
    this.fileNameString = new String(context);
  }
  public void setDescription(String description) {
    pushChars(description,this.desc);
    this.descString = new String(description);
  }
}
