package de.desy.tine.histUtils;

import de.desy.tine.structUtils.TTaggedStructure;

public class StateCor extends TTaggedStructure
{
  public void clear()
  {
  	startString = null;
  	stopString = null;
  	fromStateString = null;
  	toStateString = null;
  	usrString = null;
  	cmtString = null;
  }
  private double[] start = new double[1];
  private double[] stop = new double[1];
  private int[] counts = new int[1];
  private int[] reserved = new int[1];
  private char[] startStr = new char[64];
  private String startString;
  private char[] stopStr = new char[64];
  private String stopString;
  private char[] fromState = new char[64];
  private String fromStateString;
  private char[] toState = new char[64];
  private String toStateString;
  private char[] usr = new char[16];
  private String usrString;
  private char[] cmt = new char[256];
  private String cmtString;
  private void initStructure()
  {
    addField(start,"startUtc");
    addField(stop,"stopUtc");
    addField(counts,"counts");
    addField(reserved,"reserved");
    addField(startStr,"startStr");
    addField(stopStr,"stopStr");
    addField(fromState,"fromState");
    addField(toState,"toState");
    addField(usr,"user");
    addField(cmt,"comment");
    initDone();    
  }
  public StateCor()
  {
    super();
    initStructure();
  }
  public StateCor(StateCor reference)
  {
    super();
    initStructure();
    start[0] = reference.start[0];
    stop[0] = reference.stop[0];
    counts[0] = reference.counts[0];
    reserved[0] = reference.reserved[0];
    System.arraycopy(reference.startStr, 0, startStr, 0, 64);    
    System.arraycopy(reference.stopStr, 0, stopStr, 0, 64);    
    System.arraycopy(reference.fromState, 0, fromState, 0, 64);    
    System.arraycopy(reference.toState, 0, toState, 0, 64);    
    System.arraycopy(reference.usr, 0, usr, 0, 16);    
    System.arraycopy(reference.cmt, 0, cmt, 0, 256);    
  }
  public String getStartString()
  {
    if (startString == null) startString = new String(startStr).trim();
    return startString;
  }
  public String getStopString()
  {
    if (stopString == null) stopString = new String(stopStr).trim();
    return stopString;
  }
  public String getFromState()
  {
    if (fromStateString == null) fromStateString = new String(fromState).trim();
    return fromStateString;
  }
  public void setFromState(String from) 
  {
    pushChars(from,this.fromState);
    this.fromStateString = new String(from);
  }  
  public String getToState()
  {
    if (toStateString == null) toStateString = new String(toState).trim();
    return toStateString;
  }
  public void setToState(String to) 
  {
    pushChars(to,this.toState);
    this.toStateString = new String(to);
  }
  public String getUser()
  {
    if (usrString == null) usrString = new String(usr).trim();
    return usrString;
  }
  public void setUser(String user) 
  {
    pushChars(user,this.usr);
    this.usrString = new String(user);
  }
  public String getComment()
  {
    if (cmtString == null) cmtString = new String(cmt).trim();
    return cmtString;
  }
  public void setComment(String comment) 
  {
    pushChars(comment,this.cmt);
    this.cmtString = new String(comment);
  }
  public double getStartTime()
  {
  	return start[0];
  }
  public void setStartTime(double time)
  {
  	start[0] = time;
  	//TODO: also set the string variant according to dd.mm.yy hh:mm:ss TZV
  	//TODO: also set the counts (stop - start)
  }
  public void setStartTime(long time)
  {
  	start[0] = ((double)time)/1000.0;
  }
  public void setStopTime(double time)
  {
  	stop[0] = time;
  	//TODO: also set the string variant according to dd.mm.yy hh:mm:ss TZV
  	//TODO: also set the counts (stop - start)
  }
  public void setStopTime(long time)
  {
  	stop[0] = ((double)time)/1000.0;
  }
  public double getStopTime()
  {
  	return stop[0];
  }
  public double getCounts()
  {
  	return counts[0];
  }
}
