package de.desy.tine.histUtils;

import de.desy.tine.types.NAME32DBLDBL;

public class THistorySource
{
  HstSrc CentralArchive;
  HstSrc LocalHistory;
  private int numberOfPointsReturned = 0;
  private boolean extendedTimeRange = false;
  private int heartbeat = 0;
  public void copyFrom(THistorySource src)
  {
    CentralArchive = src.CentralArchive;
    LocalHistory = src.LocalHistory;
    numberOfPointsReturned = src.getNumberOfPointsReturned();
    extendedTimeRange = src.hasExtendedTimeRange();
    heartbeat = src.getHeartbeat();
    statusList = src.getStatusList();
    annotationTimes = src.getAnnotationTimes();
    annotationActive = src.getAnnotationActive();
  }
  public int getHeartbeat()
  {
    return heartbeat;
  }
  public void setHeartbeat(int value)
  {
    if (value < 0) value = 0; 
    heartbeat = value;
  }
  public boolean hasExtendedTimeRange()
  {
    return extendedTimeRange;
  }
  public void setExtendedTimeRange(boolean hasExtendedTimeRange)
  {
    extendedTimeRange = hasExtendedTimeRange;
  }
  private NAME32DBLDBL[] statusList = null;
  private double[] annotationTimes = null;
  private boolean[] annotationActive = null;
  public HstSrc getCentralArchive()
  {
    return CentralArchive;
  }
  public HstSrc getLocalHistory()
  {
    return LocalHistory;
  }
  public int getNumberOfPointsReturned()
  {
    return numberOfPointsReturned;
  }
  public void setNumberOfPointsReturned(int numberOfPointsReturned)
  {
    this.numberOfPointsReturned = numberOfPointsReturned;
  }
  public void setStatusList(NAME32DBLDBL[] lst)
  {
    statusList = lst;
  }
  public NAME32DBLDBL[] getStatusList()
  {
    return statusList;
  }
  public void setAnnotationTimes(double[] lst)
  {
    annotationTimes = lst;
  } 
  public double[] getAnnotationTimes()
  {
    return annotationTimes;
  }
  public void setAnnotationActive(boolean[] lst)
  {
    annotationActive = lst;
  } 
  public boolean[] getAnnotationActive()
  {
    return annotationActive;
  } 
}
