/*
 * Created on Oct 31, 2016
 */
package de.desy.tine.server;

import de.desy.tine.server.alarms.TAlarmDefinition;
import de.desy.tine.server.histories.THistoryRecord;
import de.desy.tine.structUtils.TTaggedStructure;

/**
 *
 * @author szczesny
 */
public class TFilterStruct extends TTaggedStructure 
{    
  private int[] filterIdx = new int[1];
  private char[] filterLink = new char[256];
  private String filterLinkString;
  
  public int getCodeIdx() { return filterIdx[0]; }
  public String getFilterLink() 
  { 
    if (filterLinkString == null) filterLinkString = new String(filterLink).trim();
    return filterLinkString; 
  } 
  
  private void initStructDescription()
  {
    addField(filterIdx,"FilterIdx");
    addField(filterLink,"FilterLink");
    initDone();
  }
  
  public TFilterStruct()
  {
    super("Filt");
    initStructDescription();
  }
  
  public TFilterStruct(int filterIndex, String filterLnk)
  {
    super("Filt");
    initStructDescription();
    setFilterIdx(filterIndex);
    pushString(filterLnk, filterLink);
  }
  
  private void pushString(String s,char[] c)
  {
    if (s != null) 
    {
      int len = s.length();
      if (len > c.length) len = c.length; 
      s.getChars(0, len, c, 0);
      for (int i=len; i<c.length; i++) c[i]=0;
    }    
  }
  
  public void setAlmFields(TAlarmDefinition reference)
  {
    filterIdx[0] = reference.getAlarmCode();
    if(reference.getFilter() == null) pushString("no assigned filter", filterLink);
    else pushString(reference.getFilter().toString(), filterLink);
  }
  
  public void setHstFields(THistoryRecord reference)
  {
    filterIdx[0] = reference.getRcdIdx();
    if(reference.getFilter() == null) pushString("no assigned filter", filterLink);
    else pushString(reference.getFilter().toString(), filterLink);
  }
  
  public void setFilterIdx(int fi)
  {
    filterIdx[0] = fi;
  }
  
  public void setFilterLnk(String fl)
  {
    pushString(fl, filterLink);
  }
}
