package de.desy.tine.server;

import de.desy.tine.structUtils.TTaggedStructure;

public class TServerSettings extends TTaggedStructure
{
  private int[] srvWorkArea = new int[1]; /* srvWorkAreaSize */
  private int[] cycDeadBand = new int[1]; /* gSystemCycleDeadband */
  private int[] minPollInterval = new int[1]; /* MinPollingRate */
  private int[] conTblCapacity = new int[1]; /* ContractListCapacity */
  private int[] conRenewalLen = new int[1]; /* gSubRenewalLength */
  private int[] clnTblCapacity = new int[1]; /* ClientListCapacity */
  private int[] ackOnChange = new int[1]; /* RequireAcknowledgments */
  private int[] srvBurstLimit = new int[1]; /* gBurstLimit */
  private int[] srvBurstCycDly = new int[1]; /* gCycleDelay */
  private int[] srvPacketMTU = new int[1]; /* gPacketMtu */
  private int[] tcpMaxMsgSize = new int[1]; /* gMaxTcpMsgSize */
  private int[] tcpTblCapacity = new int[1]; /* tcpConTblSize */
  private int[] srvSendBuffers = new int[1]; /* max_srvrcvbuf */
  private int[] srvRecvBuffers = new int[1]; /* max_srvsndbuf */
  private int[] srvLazySched = new int[1]; /* gSchedulePropertyLazy */
  private int[] srvBkgTskRentr = new int[1]; /* gAllowBkgTaskReentrancy */
  private int[] srvCycInSepThrd = new int[1]; /* gRunServerCycleInSeparateThread */
  private int[] tcpTraInSepThrd = new int[1]; /* gRunTransportInSeparateThread */
  private int[] clnWorkArea = new int[1]; /* clnWorkAreaSize */
  private int[] lnkTblCapacity = new int[1]; /* ConTblCapacity */
  private int[] clnBurstLimit = new int[1]; /* gClientBurstLimit */
  private int[] clnSendBuffers = new int[1]; /* max_clnrcvbuf */
  private int[] clnRecvBuffers = new int[1]; /* max_clnsndbuf */
  private int[] clnRecvQueue = new int[1]; /* gClnRecvQueueDepth */
  private int[] useLoopbackAddr = new int[1]; /* gUseLoopback */
  private int[] useWdogLinks = new int[1]; /* gAutoLinkWatchdogs */
  private int[] allowCommonLnks = new int[1]; /* allowCommonLinks */
  private int[] retryOnTimeout = new int[1]; /* gAlwaysRetry */
  private int[] srvSchedIntvl = new int[1]; /*gSchedulerInterval; */
  private int[] srvRetrdRemovl = new int[1]; /* gRetardSingleContractRemoval */
  private int[] srvAllowRemote = new int[1]; /* gAllowRemoteExit, etc. */
  private int[] reserved4 = new int[1]; 

  public TServerSettings()
  {
    super("SrvSetQy");
    
    addField(srvWorkArea,"srvWorkArea");
    addField(cycDeadBand,"cycDeadBand");
    addField(minPollInterval,"minPollInterval");
    addField(conTblCapacity,"conTblCapacity");
    addField(conRenewalLen,"conRenewalLen");
    addField(clnTblCapacity,"clnTblCapacity");
    addField(ackOnChange,"ackOnChange");
    addField(srvBurstLimit,"srvBurstLimit");
    addField(srvBurstCycDly,"srvBurstCycDly");
    addField(srvPacketMTU,"srvPacketMTU");
    addField(tcpMaxMsgSize,"tcpMaxMsgSize");
    addField(tcpTblCapacity,"tcpTblCapacity");
    addField(srvSendBuffers,"srvSendBuffers");
    addField(srvRecvBuffers,"srvRecvBuffers");
    addField(srvLazySched,"srvLazySched");
    addField(srvBkgTskRentr,"srvBkgTskRentr");
    addField(srvCycInSepThrd,"srvCycInSepThrd");
    addField(tcpTraInSepThrd,"tcpTraInSepThrd");
    addField(clnWorkArea,"clnWorkArea");
    addField(lnkTblCapacity,"lnkTblCapacity");
    addField(clnBurstLimit,"clnBurstLimit");
    addField(clnSendBuffers,"clnSendBuffers");
    addField(clnRecvBuffers,"clnRecvBuffers");
    addField(clnRecvQueue,"clnRecvQueue");
    addField(useLoopbackAddr,"useLoopbackAddr");
    addField(useWdogLinks,"useWdogLinks");
    addField(allowCommonLnks,"allowCommonLnks");
    addField(retryOnTimeout,"retryOnTimeout");
    addField(srvSchedIntvl,"srvSchedIntvl");
    addField(srvRetrdRemovl,"srvRetrdRemovl");
    addField(srvAllowRemote,"srvAllowRemote");
    addField(reserved4,"reserved4");

    initDone();
  }

  public int getSrvWorkArea()
  {
    return srvWorkArea[0];
  }

  public void setSrvWorkArea(int[] srvWorkArea)
  {
    this.srvWorkArea = srvWorkArea;
  }

  public int getCycDeadBand()
  {
    return cycDeadBand[0];
  }

  public void setCycDeadBand(int[] cycDeadBand)
  {
    this.cycDeadBand = cycDeadBand;
  }

  public int getMinPollInterval()
  {
    return minPollInterval[0];
  }

  public void setMinPollInterval(int minPollInterval)
  {
    this.minPollInterval[0] = minPollInterval;
  }

  public int getConTblCapacity()
  {
    return conTblCapacity[0];
  }

  public void setConTblCapacity(int conTblCapacity)
  {
    this.conTblCapacity[0] = conTblCapacity;
  }

  public int getConRenewalLength()
  {
    return conRenewalLen[0];
  }

  public void setConRenewalLength(int conRenewalLen)
  {
    this.conRenewalLen[0] = conRenewalLen;
  }

  public int getClnTblCapacity()
  {
    return clnTblCapacity[0];
  }

  public void setClnTblCapacity(int clnTblCapacity)
  {
    this.clnTblCapacity[0] = clnTblCapacity;
  }

  public int getAckOnChange()
  {
    return ackOnChange[0];
  }

  public void setAckOnChange(int ackOnChange)
  {
    this.ackOnChange[0] = ackOnChange;
  }

  public int getSrvBurstLimit()
  {
    return srvBurstLimit[0];
  }

  public void setSrvBurstLimit(int srvBurstLimit)
  {
    this.srvBurstLimit[0] = srvBurstLimit;
  }

  public int getSrvBurstCycleDelay()
  {
    return srvBurstCycDly[0];
  }

  public void setSrvBurstCycleDelay(int srvBurstCycDly)
  {
    this.srvBurstCycDly[0] = srvBurstCycDly;
  }

  public int getSrvPacketMTU()
  {
    return srvPacketMTU[0];
  }

  public void setSrvPacketMTU(int srvPacketMTU)
  {
    this.srvPacketMTU[0] = srvPacketMTU;
  }

  public int getTcpMaxMsgSize()
  {
    return tcpMaxMsgSize[0];
  }

  public void setTcpMaxMsgSize(int tcpMaxMsgSize)
  {
    this.tcpMaxMsgSize[0] = tcpMaxMsgSize;
  }

  public int getTcpTblCapacity()
  {
    return tcpTblCapacity[0];
  }

  public void setTcpTblCapacity(int tcpTblCapacity)
  {
    this.tcpTblCapacity[0] = tcpTblCapacity;
  }

  public int getSrvSendBuffers()
  {
    return srvSendBuffers[0];
  }

  public void setSrvSendBuffers(int srvSendBuffers)
  {
    this.srvSendBuffers[0] = srvSendBuffers;
  }

  public int getSrvRecvBuffers()
  {
    return srvRecvBuffers[0];
  }

  public void setSrvRecvBuffers(int srvRecvBuffers)
  {
    this.srvRecvBuffers[0] = srvRecvBuffers;
  }

  public int getSrvLazySched()
  {
    return srvLazySched[0];
  }

  public void setSrvLazySched(int srvLazySched)
  {
    this.srvLazySched[0] = srvLazySched;
  }

  public int getSrvBkgTskRentrancy()
  {
    return srvBkgTskRentr[0];
  }

  public void setSrvBkgTskRentrancy(int srvBkgTskRentr)
  {
    this.srvBkgTskRentr[0] = srvBkgTskRentr;
  }

  public int getSrvCycInSeparateThread()
  { 
    return srvCycInSepThrd[0];
  }

  public void setSrvCycInSeparateThread(int srvCycInSepThrd)
  {
    this.srvCycInSepThrd[0] = srvCycInSepThrd;
  }

  public int getTcpTraInSeparateThread()
  {
    return tcpTraInSepThrd[0];
  }

  public void setTcpTraInSeparateThread(int tcpTraInSepThrd)
  {
    this.tcpTraInSepThrd[0] = tcpTraInSepThrd;
  }

  public int getClnWorkArea()
  {
    return clnWorkArea[0];
  }

  public void setClnWorkArea(int clnWorkArea)
  {
    this.clnWorkArea[0] = clnWorkArea;
  }

  public int getLnkTblCapacity()
  {
    return lnkTblCapacity[0];
  }

  public void setLnkTblCapacity(int lnkTblCapacity)
  {
    this.lnkTblCapacity[0] = lnkTblCapacity;
  }

  public int getClnBurstLimit()
  {
    return clnBurstLimit[0];
  }

  public void setClnBurstLimit(int clnBurstLimit)
  {
    this.clnBurstLimit[0] = clnBurstLimit;
  }

  public int getClnSendBuffers()
  {
    return clnSendBuffers[0];
  }

  public void setClnSendBuffers(int clnSendBuffers)
  {
    this.clnSendBuffers[0] = clnSendBuffers;
  }

  public int getClnRecvBuffers()
  {
    return clnRecvBuffers[0];
  }

  public void setClnRecvBuffers(int clnRecvBuffers)
  {
    this.clnRecvBuffers[0] = clnRecvBuffers;
  }

  public int getClnRecvQueue()
  {
    return clnRecvQueue[0];
  }

  public void setClnRecvQueue(int clnRecvQueue)
  {
    this.clnRecvQueue[0] = clnRecvQueue;
  }

  public int getUseLoopbackAddr()
  {
    return useLoopbackAddr[0];
  }

  public void setUseLoopbackAddr(int useLoopbackAddr)
  {
    this.useLoopbackAddr[0] = useLoopbackAddr;
  }

  public int getUseWdogLinks()
  {
    return useWdogLinks[0];
  }

  public void setUseWdogLinks(int useWdogLinks)
  {
    this.useWdogLinks[0] = useWdogLinks;
  }

  public int getAllowCommonLnks()
  {
    return allowCommonLnks[0];
  }

  public void setAllowCommonLnks(int allowCommonLnks)
  {
    this.allowCommonLnks[0] = allowCommonLnks;
  }

  public int getRetryOnTimeout()
  {
    return retryOnTimeout[0];
  }

  public void setRetryOnTimeout(int retryOnTimeout)
  {
    this.retryOnTimeout[0] = retryOnTimeout;
  }

  public int getSrvSchedInterval()
  {
    return srvSchedIntvl[0];
  }

  public void setSrvSchedInterval(int srvSchedIntvl)
  {
    this.srvSchedIntvl[0] = srvSchedIntvl;
  }

  public int getSrvRetardRemoval()
  {
    return srvRetrdRemovl[0];
  }

  public void setSrvRetardRemoval(int srvRetrdRemovl)
  {
    this.srvRetrdRemovl[0] = srvRetrdRemovl;
  }

  public int getSrvAllowRemote()
  {
    return srvAllowRemote[0];
  }

  public void setSrvAllowRemote(int srvAllowRemote)
  {
    this.srvAllowRemote[0] = srvAllowRemote;
  }

  public int getReserved4()
  {
    return reserved4[0];
  }

  public void setReserved4(int reserved4)
  {
    this.reserved4[0] = reserved4;
  }
  
}
