/*
 * Created on Nov 9, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.server.connections;

import de.desy.tine.definitions.TFormat;
import de.desy.tine.definitions.TTransport;
import de.desy.tine.headers.*;
import de.desy.tine.server.equipment.TEquipmentModuleFactory;

/**
 * \internal
 * 
 * @author duval
 *
 */
public class TClientStatus
{
  public short id;          // contract ID as seen by consumer
  public short mode;        // SINGLE,REFRESH,POLL,CANCEL
  public int PollingRate;   // requested polling rate
  public long lasttime;     // time of most recent update
  public long starttime;    // start of initial subscription
  public short counter;     // counts remaining in subscription(s)
  public short Stale;       // 1 = send new data to consumer
  public short numblks;     // total number of message blocks
  public short blknum;      // block number of this message
  public short statusCode;  // interim completion
  public int mtu;           // maximal transport unit (carried as unsigned short)
  public int nextDataSize;  // next outgoing data size in bytes
  public int nextDataPtr;   // next outgoing data array pointer
  public int BytesRemaining;// number of bytes data remaining
  public int BytesTotal;    // total number of bytes data
  public int misses;        // data return after expiration
  public int reconnects;    // client unexpectedly re-establishes link
  public boolean isRetry;   // the contract is being resubmitted by the client
  public int transport;     // overlying transport mechanism
  public int protocol;      // tine protocol level
  public TClientStatus()
  {
    transport = TTransport.UDP;
  }
  public TClientStatus(int transport,int protocol)
  {
    this.transport = transport;
    this.protocol = protocol;
  }
  public void reset(TSubReqHdr sub)
  {
    int datasize = sub.getOutputDataSize();
    int fmtsize = TFormat.formatSizeOf(sub.contract.dataFormatOut);
    // reset certain fields according to the subscription ...
    PollingRate = sub.pollingInterval;
    id = sub.id;
    starttime = 1000 * (long)sub.starttime;
    blknum = 1;
    nextDataPtr = 0;
    BytesRemaining = datasize;
    BytesTotal = datasize;
    int hdrSize = TSubRspHdr.getHeaderSizeInBytes(protocol);
    int pmtu = TEquipmentModuleFactory.getServerPacketMTU();
    if (transport == TTransport.TCP && pmtu > TTransport.TCP_BUFFER_SIZE)
    { // don't allow larger MTUs for TCP !
      pmtu = TTransport.TCP_BUFFER_SIZE;
    }
    int datamtu = pmtu - hdrSize - 2;
    if (fmtsize > 0) datamtu -= datamtu%fmtsize;
    mtu = datamtu;
    nextDataSize = BytesRemaining;
    if (BytesRemaining > mtu) nextDataSize = mtu;
    numblks = (short)(datasize/mtu + (datasize%mtu > 0 ? 1 : 0));
    if (datasize == 0) numblks = 1;
  }
}
