package de.desy.tine.server.connections;

import java.net.InetAddress;
import de.desy.tine.definitions.*;
import de.desy.tine.server.logger.*;

public class TNetAcl
{
  @Override
  public boolean equals(Object obj)
  {
    if (obj instanceof TNetAcl)
    {
      TNetAcl a = (TNetAcl)obj;
      return (a.getStrAddress().compareToIgnoreCase(strAdr) == 0);
    }
    if (obj instanceof String)
    {
      String s = (String)obj;
      return (s.compareToIgnoreCase(strAdr) == 0);
    }
    return false;
  }
  private String strAdr = null;
  private byte[] rawAdr = null;
  private int mask = 0;
  public TNetAcl(String netAdr)
  {
    strAdr = netAdr;
    if (netAdr == null || netAdr.length() == 0) return;
    String adr;
    int idx;
    try
    {
      if ((idx=netAdr.indexOf('/')) >= 0)
      {
        adr = strAdr.substring(0, idx);
        mask = Integer.parseInt(strAdr.substring(idx+1));
      }
      else
      {
        mask = 32; // start off pessimistic 
        adr = strAdr;
        String[] ip4segs = netAdr.split("\\.");
        if (ip4segs.length == 4 && ip4segs[3].compareTo("255") == 0) mask = 24;
        if (ip4segs.length == 4 && ip4segs[3].compareTo("0") == 0) mask = 24;
      }
      rawAdr = InetAddress.getByName(adr).getAddress();
    }
    catch (Exception e)
    {
      MsgLog.log("TNetAcl", "could not instantiate",TErrorList.code_failure,e,0);
    }
  }
  public String getStrAddress()
  {
    return strAdr;
  }
  public byte[] getRawAddress()
  {
    return rawAdr;
  }
  public int getMask()
  {
    return mask;
  }
}
