package de.desy.tine.server.equipment;

import de.desy.tine.client.TLink;
import de.desy.tine.client.TLinkCallback;
import de.desy.tine.server.logger.MsgLog;

public class TCycleTriggerCallback implements TLinkCallback
{
  private int last_cc = -1;
  private int last_cycleNumber = -1;
  public void callback(TLink link)
  {
    int cc = link.getLinkStatus();
    if (cc != last_cc)
    {
      last_cc = cc;
      MsgLog.log("TCycleTriggerCallback","cycle trigger : " + link.getLastError(),cc,null,1);
    }
    if (cc != 0) return;
    int cycleNumber = TEquipmentModuleFactory.getCycleNumber();
    if (cycleNumber == last_cycleNumber) return;
    last_cycleNumber = cycleNumber;
    TCycleTrigger[] trgs = TEquipmentModuleFactory.getCycleTriggerList(); 
    for (int i=0; i<trgs.length; i++) trgs[i].update(cycleNumber, cc);
    TEquipmentModuleFactory.setSystemStamp(cycleNumber);
    // schedule properties 
  }    
}
