/*
 * Created on Nov 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.server.equipment;

/**
 * Servers wishing to register a background IO task should extend 
 * TEquipmentBackgroundTask
 * 
 * @author duval
 *
 */
public class TEquipmentBackgroundTask
{
  private long rateBkg = 1000;        // background polling rate msec
  private boolean isIdle = false;
  private TEquipmentModule eqm = null;
  public TEquipmentBackgroundTask() {}
  /**
   * Create a background task with the specified inteval and assign
   * it to the specified equipment module
   * 
   * @param eqm is the reference to an equipment module to be associated with the task
   * @param interval is the timer interval in milliseconds of the task 
   */
  public TEquipmentBackgroundTask(TEquipmentModule eqm,long interval)
  {
    this.setEquipmentModule(eqm);
    rateBkg = interval;
  }
  /** Returns the current idle state */
  public boolean isIdleState() { return isIdle; }
  /** Sets the idle state to the value given */
  public void setIdleState(boolean value) { isIdle = value; }
  /** Is the background dispatch routine */
  public void call() 
  { // the task
    return; 
  }
  /** Is the initialization dispatch routine */
  public void startup() 
  { // initialization prior to calls to task
    return;
  }
  /** Sets the background interval to the value given */
  public void setBackgroundTaskInterval(long msec)
  {
    if (msec > 0) rateBkg = msec;
  }
  /** Returns the background interval */
  public long getBackgroundTaskInterval() { return rateBkg; }
  public void setEquipmentModule(TEquipmentModule eqm)
  {
    this.eqm = eqm;
  }
  public TEquipmentModule getEquipmentModule()
  {
    return eqm;
  }
}
