package de.desy.tine.server.equipment;

import de.desy.tine.definitions.TStrings;
import de.desy.tine.structUtils.TTaggedStructure;

public class TWriteAccessInfo extends TTaggedStructure
{
  char[] user = new char[TStrings.USERNAME_SIZE];
  char[] addr = new char[TStrings.ADDR_SIZE];
  char[] prp = new char[TStrings.PROPERTY_NAME_SIZE];
  char[] dev = new char[TStrings.DEVICE_NAME_SIZE];
  double[] timestamp = new double[1];
  int port = 0;
  String eqm = null;
  public String getUser() { return charsToString(user); }
  public String getAddress() { return charsToString(addr); }
  public String getProperty() { return charsToString(prp); }
  public String getDevice() { return charsToString(dev); }
  public double getTime() { return timestamp[0]; }
  public String getEqm() { return eqm; } 
  private String charsToString(char[] c)
  {
    boolean done = false;
    for (int i=0; i<c.length; i++)
    {
      if (c[i] != 0 && !done) continue;
      done = true;
      c[i] = 0;
    }
    return new String(c).trim();
  }
  private void pushStringToChars(String s, char[] c)
  {
    int len = s == null ? 0 : s.length();
    if (len > c.length) len = c.length;
    if (len > 0) s.getChars(0, len, c, 0);
    for (int i=len; i<c.length; i++)
    {
      c[i] = 0;
    }
  }
  public TWriteAccessInfo()
  {
    super("WRACCTBL");
    addField(this.user,"user");
    addField(this.addr,"addr");
    addField(this.prp,"prp");
    addField(this.dev,"dev");
    addField(timestamp,"timestamp");
    initDone();
  }  
  public TWriteAccessInfo(String user,String addr,String eqm,String prp,String dev,double time)
  {
    this(user,addr,0,eqm,prp,dev,time);
  }  
  public TWriteAccessInfo(String user,String addr,int port,String eqm,String prp,String dev,double time)
  {
    super("WRACCTBL");
    addField(this.user,"user");
    addField(this.addr,"addr");
    addField(this.prp,"prp");
    addField(this.dev,"dev");
    addField(timestamp,"timestamp");
    pushStringToChars(user, this.user);
    pushStringToChars(addr, this.addr);
    pushStringToChars(prp, this.prp);
    pushStringToChars(dev, this.dev);
    timestamp[0] = time;
    initDone();
    this.port = port;
    this.eqm = new String(eqm);
  }  
}
