/*
 * Created on Sep 1, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.server.histories;

public class THistorySpecification
{
  private int  pRate;              /* polling rate in msec */
  private int  aRate;               /* archive rate in msec */
  private int  depthSht;             /* for short term storage */
  private int  depthLng;               /* for long term storage */
  private int  hbt;            /* archive heartbeat in sec */
  private float pTol;                 /* percent tolerance */
  private float aTol;                /* absolute tolerance */
  private String rhsSrv;             /* Remote Server Name */
  private static THistorySpecification defaultInstance = null;
  public static THistorySpecification getDefaultInstance()
  {
    if (defaultInstance == null)
    {
      defaultInstance = new THistorySpecification(1000,1000,600,1,1800,(float)0.1,0,"");
    }
    return defaultInstance;
  }
  public THistorySpecification(int pollingRate,int archiveRate,int depthShort,int depthLong,int heartbeat,
                        float pcntTolerance,float absTolerance,String remoteServerSpecification)
  {
    pRate = pollingRate;
    aRate = archiveRate;
    depthSht = depthShort;
    depthLng = depthLong;
    hbt = heartbeat;
    if (pcntTolerance >= 1) pcntTolerance /= 100;
    pTol = pcntTolerance;
    aTol = absTolerance;
    rhsSrv = remoteServerSpecification;
  }
  public int getArchiveRate()
  {
    return aRate;
  }
  public void setArchiveRate(int rate)
  {
    aRate = rate;
  }
  public float getAbsoluteTolerance()
  {
    return aTol;
  }
  public void setAbsoluteTolerance(float tolerance)
  {
    aTol = tolerance;
  }
  public int getDepthLong()
  {
    return depthLng;
  }
  public int getDepthMonths()
  {
    return depthLng & 0xffff;
  }
  public int getDepthDays()
  {
    int ldd = depthLng >> 16;
    return ldd & 0x1f;            
  }
  public void setDepthLong(int depthLong)
  {
    this.depthLng = depthLong;
  }
  public void setDepthMonths(int depthMonths)
  {
    depthLng |= depthMonths;
  }
  public void setDepthDays(int depthDays)
  {
    int m = depthDays/31;
    depthLng += m;
    depthDays = depthDays%31;
    depthLng |= (depthDays << 16);
  }
  public int getDepthShort()
  {
    return depthSht;
  }
  public void setDepthShort(int depthShort)
  {
    this.depthSht = depthShort;
  }
  public int getDepthShortInSeconds()
  {
    return (int)(depthSht * (pRate/1000.0));
  }
  public int getHeartbeat()
  {
    return hbt;
  }
  public void setHeartbeat(int heartbeat)
  {
    this.hbt = heartbeat;
  }
  public int getPollngRate()
  {
    return pRate;
  }
  public void setPollngRate(int rate)
  {
    pRate = rate;
  }
  public float getPercentTolerance()
  {
    return pTol;
  }
  public void setPercentTolerance(float tolerance)
  {
    pTol = tolerance;
  }
  public String getRemoteServerSpecification()
  {
    return rhsSrv;
  }
  public void setRemoteServerSpecification(String serverSpecification)
  {
    this.rhsSrv = serverSpecification;
  }
}
