package de.desy.tine.server.logger;

import de.desy.tine.dataUtils.TDataTime;
import de.desy.tine.definitions.TStrings;
import de.desy.tine.structUtils.TTaggedStructure;

public class ClogFilter extends TTaggedStructure
{
  private char[] ctx = new char[TStrings.CONTEXT_NAME_SIZE];
  private String ctxString;
  private char[] tag = new char[32];
  private String tagString;
  private char[] logger = new char[32];
  private String loggerString;
  private char[] txt = new char[256];
  private String txtString;
  private int[] pri = new int[1];
  private int[] sts = new int[1];
  private int[] timeStart = new int[1];
  private int[] timeStop = new int[1];
  public String getContext()
  {
    if (ctxString == null) ctxString = new String(ctx);
    return ctxString;
  }
  public String getTag()
  {
    if (tagString == null) tagString = new String(tag);
    return tagString;
  }
  public String getLogger()
  {
    if (loggerString == null) loggerString = new String(logger);
    return loggerString;
  }
  public String getText()
  {
    if (txtString == null) txtString = new String(txt);
    return txtString;
  }
  public int getPriority() { return pri[0]; }
  public int getStatus() { return sts[0]; }
  public long getTimeStart() 
  { 
    return TDataTime.getLongDataTimeStamp(timeStart[0]); 
  }
  public long getTimeStop() 
  { 
    return TDataTime.getLongDataTimeStamp(timeStop[0]); 
  }
  public void setTimeStart(long startTime)
  {
    timeStart[0] = (int)(startTime/1000);
  }
  public void setTimeStop(long stopTime)
  {
    timeStart[0] = (int)(stopTime/1000);
  }
  private void initStructure()
  {
    addField(ctx,"context");
    addField(tag,"tag");
    addField(logger,"logger");
    addField(txt,"text");
    addField(pri,"priority");
    addField(sts,"status");
    addField(timeStart,"timeSent");
    addField(timeStop,"timeLogged");
    initDone();    
  }
  ClogFilter()
  {
    super("CLOGF");
    initStructure();
  }
  public ClogFilter(String text,String context,String tag,String caller,int priority,int status,long start,long stop)
  {
    super("CLOGF");
    pushChars(context,ctx);
    pushChars(tag,this.tag);
    pushChars(caller,logger);
    pushChars(text,txt);
    pri[0] = priority;
    sts[0] = status;
    timeStart[0] = (int)(start/1000);
    timeStop[0] = (int)(stop/1000);
    initStructure();
  }
  public ClogFilter(long start,long stop)
  {
    super("CLOGF");
    timeStart[0] = (int)(start/1000);
    timeStop[0] = (int)(stop/1000);
    initStructure();
  }
}
