package de.desy.tine.server.logger;

import de.desy.tine.client.TLinkFactory;
import de.desy.tine.dataUtils.TDataTime;

public class DbgLog
{
  private static String ttyFilterKeep = null;
  private static String ttyFilterHide = null;
  public static void log(String source, String message)
  {
    try
    {
      String msg = TDataTime.toString(System.currentTimeMillis())+" ["+source+"] "+message;
      if (ttyFilterKeep != null && !msg.contains(ttyFilterKeep)) return;
      if (ttyFilterHide != null && msg.contains(ttyFilterHide)) return;
      TLinkFactory.dbgPrint(msg);
    }
    catch (OutOfMemoryError e)
    {
      e.printStackTrace();      
    }
  }
  public static String getFilter()
  {
    return ttyFilterKeep;
  }
  public static String getNegativeFilter()
  {
    return ttyFilterHide;
  }
  public static void dumpFilters()
  {
    TLinkFactory.dbgPrint("negative text filter: "+ttyFilterHide);
    TLinkFactory.dbgPrint("positive text filter: "+ttyFilterKeep);    
  }
  public static void setFilter(String text)
  {
    if (text == null || text.length() == 0)
    {
      ttyFilterKeep = null;
      ttyFilterHide = null;
      TLinkFactory.dbgPrint("all text filters cleared");
      return;
    }
    String txt = text.trim();
    if (txt.startsWith("-"))
    {
      txt = txt.substring(1).trim();
      if (txt.length() == 0)
      {
        ttyFilterHide = null;
        TLinkFactory.dbgPrint("negative text filter cleared");
        return;
      }
      ttyFilterHide = txt;
      TLinkFactory.dbgPrint("set negative text filter: "+ttyFilterHide);
    }
    else
    {
      ttyFilterKeep = text;
      TLinkFactory.dbgPrint("set text filter: "+ttyFilterKeep);
    }
  }
}
