/*
 * Created on Nov 5, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 * 
 * CHANGES 
 * 
 * 2005-02-10 JW  * min,maxValue renamed to minValue, maxValue
 * 				  * attributes made private and "javaized"
 * 				  * new Constructors
 * 				  
 */
package de.desy.tine.server.properties;

import de.desy.tine.definitions.TGraphType;

/**
 * \internal
 * 
 * @author duval 
 */
public class TPropertyEGU
{
  private String units;
  private float minValue;
  private float maxValue;
  private short graphType;
  private void initialize(String newUnits, short newGraphType, float newMinValue, float newMaxValue)
  {
    this.graphType = newGraphType;
    this.units = newUnits;
    this.minValue = newMinValue;
    this.maxValue = newMaxValue;
  }
  /**
   * Default Constructor. Creates a TPropertyEgu with units="none",
   * graphType=linear, minValue=0, maxValue=10.
   */
  public TPropertyEGU()
  {
    initialize("none", TGraphType.GT_LIN, 0, 10);
  }
  public TPropertyEGU(TPropertyEGU reference)
  {
  	if (reference == null) initialize("none", TGraphType.GT_LIN, 0, 10);
  	else initialize(reference.units, reference.graphType, reference.minValue, reference.maxValue);
  }
  /**
   * Constructs a TPropertyEGU with parameters given
   * 
   * @param newUnits
   * @param newGraphType
   * @param newMinValue
   * @param newMaxValue
   */
  public TPropertyEGU(String newUnits, short newGraphType, float newMinValue, float newMaxValue)
  {
    initialize(newUnits, newGraphType, newMinValue, newMaxValue);
  }
  /**
   * Constructs a TPropertyEGU with graph type GT_LIN
   * 
   * @param newUnits
   * @param newMinValue
   * @param newMaxValue
   */
  public TPropertyEGU(String newUnits, float newMinValue, float newMaxValue)
  {
    initialize(newUnits, TGraphType.GT_LIN, newMinValue, newMaxValue);
  }
  /**
   * @return Returns the graphType.
   */
  public short getGraphType()
  {
    return graphType;
  }
  /**
   * @param graphType
   *          The graphType to set.
   */
  public void setGraphType(short graphType)
  {
    this.graphType = graphType;
  }
  public void setGraphType(String graphTypeString)
  {
    graphType = TGraphType.getType(graphTypeString);
  }
  /**
   * @return Returns the maxValue.
   */
  public float getMaxValue()
  {
    return maxValue;
  }
  /**
   * @param maxValue
   *          The maxValue to set.
   */
  public void setMaxValue(float maxValue)
  {
    this.maxValue = maxValue;
  }
  /**
   * @return Returns the minValue.
   */
  public float getMinValue()
  {
    return minValue;
  }
  /**
   * @param minValue
   *          The minValue to set.
   */
  public void setMinValue(float minValue)
  {
    this.minValue = minValue;
  }
  /**
   * @return Returns the units.
   */
  public String getUnits()
  {
    return units;
  }
  /**
   * @param units
   *          The units to set.
   */
  public void setUnits(String units)
  {
    this.units = units;
  }
}