package de.desy.tine.startup;

public abstract class TInitializerFactory
{
  private static TInitializerFactory factory = null;
  protected TInitializerFactory()
  {
  }
  public synchronized static TInitializerFactory getInstance()
  {
    if (factory != null) return factory;
    String className = System.getProperty("de.desy.tine.client.TInitializerFactory");
    if (className == null)
      factory = new DefaultTInitializerFactory();
    else
    {
      try
      {
        factory = (TInitializerFactory) Class.forName(className).getDeclaredConstructor().newInstance();
      }
      catch (Exception e)
      {
        throw new IllegalStateException(
            "Could not instantiate de.desy.tine.client Initializer Factory, reason: " + e);
      }
    }
    return factory;
  }
  public abstract TInitializer getInitializer();
}
