/*
 * Created on Feb 21, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.desy.tine.stringUtils;

import java.io.DataInput;
import java.io.IOException;

/**
 * \internal
 * 
 * @author jwlg 
 */
public class StringToBytes
{
  /**
   * Converts a string into a fixed-length byte array.
   * 
   * @param txt
   * @param arrayLen
   * @return
   */
  static public byte[] stringToFixedBytes(String txt, int arrayLen)
  {
    byte[] rv = null;
    byte[] buffer = null;
    if (arrayLen > 0)
    { // internal use ALWAYS has arrayLen > 0 !
      rv = new byte[arrayLen]; // automatically initialized with 0 values.      
      if (txt != null)
      {
        buffer = txt.getBytes();
        System.arraycopy(buffer, 0, rv, 0, Math.min(arrayLen, buffer.length));
      }
    }
    return rv;
  }
  /**
   * Searches for first zero in byte array and converts first portion to String.
   * 
   * @param b
   *          A byte array.
   * @return
   */
  static String bytesToString(byte[] b)
  {
    return bytesToString(b, b.length);
  }
  /**
   * Searches for first zero in byte array and converts the first portion to
   * String.
   * 
   * @param b
   *          A byte array.
   * @baram maxlen Maximal length of the resulting string.
   * @return
   */
  static String bytesToString(byte[] b, int maxlen)
  {
    int len = 0;
    maxlen = Math.min(maxlen, b.length);
    // find first zero
    for (int i = 0; i < b.length && b[i] != 0; i++, len++)
      ;
    return new String(b, 0, len);
  }
  public static String readFixedString(DataInput din, int len) throws IOException
  {
    byte[] buffer = new byte[len];
    din.readFully(buffer, 0, len);
    return bytesToString(buffer);
  }
}
