/*
 * Created on Feb 23, 2005
 *
 */
package de.desy.tine.structUtils;

import java.io.IOException;

import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

/**
 * \internal
 * 
 * A base class for Classes which import or export structures. This class is
 * derived from TStructIfc and provides standard methods for reading and writing
 * from/to byte arrays. TODO Maybe drop TStructIfc and TStructIo and
 * incorparate them into this class.
 * 
 * @author jwlg
 */
public abstract class TStructBase implements TStructIfc
{
  /**
   * 
   */
  public TStructBase()
  {
    super();
    // TODO Auto-generated constructor stub
  }
  public final void readBytes(byte[] b)
  {
    try
    {
      TStructIo.bytesToStruct(this, b);
    }
    catch (IOException e)
    {
      e.printStackTrace();
      MsgLog.log("TStructBase.readBytes",e.toString(),TErrorList.code_failure,e,0);        
    }
  }
  public final void readBytes(byte[] b, int offset, int len)
  {
    try
    {
      TStructIo.bytesToStruct(this, b, offset, len);
    }
    catch (IOException e)
    {
      e.printStackTrace();
      MsgLog.log("TStructBase.readBytes",e.toString(),TErrorList.code_failure,e,0);        
    }
  }
  /**
   * Returns a byte array or null on error.
   * 
   * @return TODO Should propably throw IOException?
   */
  public final byte[] toByteArray()
  {
    byte[] rv;
    try
    {
      rv = TStructIo.structToBytes(this);
    }
    catch (IOException e)
    {
      rv = null;
    }
    return rv;
  }
}
