package de.desy.tine.types;

/**
 * \internal
 * 
 * Alias for INTINTINTINT
 *
 * Useful for passing hardware address information (e.g. line, crate, module, subaddress)
 */
public final class ADDRESS extends INTINTINTINT
{
  public ADDRESS() { i1val = 0; i2val = 0; i3val = 0; i4val = 0;}  
  public ADDRESS(int i) { i1val = i; i2val = 0; i3val = 0; i4val = 0;}  
  public ADDRESS(int i1,int i2,int i3, int i4) { i1val = i1; i2val = i2; i3val = i3; i4val = i4;}
  public ADDRESS(ADDRESS instance)
  {
    i1val = instance.i1val; i2val = instance.i2val; 
    i3val = instance.i3val; i4val = instance.i4val;
  }
  public boolean equals(ADDRESS instance)
  {
    if (i1val != instance.i1val) return false; 
    if (i2val != instance.i2val) return false; 
    if (i3val != instance.i3val) return false; 
    if (i4val != instance.i4val) return false;
    return true;
  }
  public boolean equals(Object obj)
  {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    final ADDRESS other = (ADDRESS) obj;
    return equals(other);
  } 
}
