package de.desy.tine.types;

/**
 * \internal
 * 
 * Alias for INTINTFLTFLT
 *
 * Useful for providing data access ranges (windows) in the time domain
 * (the 2 integer fields as UTC values) and data domain (the 2 float fields
 * as min and maxValue values).
 */
public final class FWINDOW extends INTINTFLTFLT
{
  public FWINDOW() { f1val = 0; f2val = 0; i1val = 0; i2val = 0; }  
  public FWINDOW(float f) { f1val = f; f2val = 0; i1val = 0; i2val = 0; }  
  public FWINDOW(int i) { f1val = 0; f2val = 0; i1val = i; i2val = 0; }  
  public FWINDOW(float f1,float f2,int i1,int i2) { f1val = f1; f2val = f2; i1val = i1; i2val = i2; }  
  public FWINDOW(FWINDOW instance) 
  { 
    f1val = instance.f1val; f2val = instance.f2val; i1val = instance.i1val; i2val = instance.i2val; 
  }  
  public boolean equals(FWINDOW instance)
  {
    if (instance.i1val != i1val) return false;
    if (instance.i2val != i2val) return false;
    if (instance.f1val != f1val) return false;
    if (instance.f2val != f2val) return false;
    return true;
  }
  public boolean equals(Object obj)
  {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    final FWINDOW other = (FWINDOW) obj;
    return equals(other);
  }
}
