package de.desy.tine.types;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.endianUtils.Swap;
import de.desy.tine.server.logger.MsgLog;
public class INTFLTFLTFLT implements TCompoundDataObject
{
  public int i1val;
  public float f1val;
  public float f2val;
  public float f3val;
  public double getDoubleValue() { return (double)f1val; }
  public int getIntegerValue() { return (int)f2val; }
  public static int sizeInBytes = 16;
  public static short dFormat = TFormat.CF_INTFLTFLTFLT;
  public void setValues(int newIValue,float newF1Value, float newF2Value, float newF3Value)
  {
    i1val = newIValue; f1val = newF1Value; f2val = newF2Value; f3val = newF3Value;
  }
  public int getSizeInBytes() { return sizeInBytes; }
  public short getFormat() { return dFormat; }    
  public String getTag() { return null; }
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  public byte[] hByteArray;
  public void setByteArray(byte[] byteArray) { hByteArray = byteArray; }
  public byte[] getByteArray() 
  { 
    return hByteArray == null ? toByteArray() : hByteArray; 
  }
  public INTFLTFLTFLT() { i1val = 0; f1val = 0; f2val = 0; f3val = 0; }  
  public INTFLTFLTFLT(float f) { i1val = 0; f1val = f; f2val = 0; f3val = 0; }  
  public INTFLTFLTFLT(int i) { i1val = i; f1val = 0; f2val = 0; f3val = 0; }  
  public INTFLTFLTFLT(int i,float f1,float f2,float f3) { i1val = i; f1val = f1; f2val = f2; f3val = f3; }  
  public INTFLTFLTFLT(INTFLTFLTFLT instance) { f1val = instance.f1val; i1val = instance.i1val; f2val = instance.f2val; f3val = instance.f3val; }
  @Override
  public void copy(TCompoundDataObject from)
  {
    if (from instanceof INTFLTFLTFLT)
    {
      INTFLTFLTFLT instance = (INTFLTFLTFLT)from;
      f1val = instance.f1val; i1val = instance.i1val; f2val = instance.f2val; f3val = instance.f3val;
    }
  }
  protected String separator = ", ";
  public void setFieldSeparator(String value)
  {
    if (value != null) separator = value;
  }
  public String toString()
  {
      return "["+ i1val + separator + f1val + separator + f2val +separator + f3val + "]";
  }
  public String getCsvString()
  {
    return i1val+" "+f1val+" "+f2val+" "+f3val;
  }  
  public INTFLTFLTFLT newInstance()
  {
    return new INTFLTFLTFLT();
  }
  public INTFLTFLTFLT clone()
  {
    return new INTFLTFLTFLT(this);
  }  
  public boolean equals(INTFLTFLTFLT instance)
  {
    if (instance.i1val != i1val) return false;
    if (instance.f1val != f1val) return false;
    if (instance.f2val != f2val) return false;
    if (instance.f3val != f3val) return false;
    return true;
  }
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      ds.writeInt(Swap.Int(i1val));
      byte[] b = Swap.Float(f1val);
      ds.write(b,0,4);
      b = Swap.Float(f2val);
      ds.write(b,0,4);
      b = Swap.Float(f3val);
      ds.write(b,0,4);
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      MsgLog.log("INTFLTFLTFLT",e.getMessage(),TErrorList.code_failure,e,0);        
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }    
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      i1val = Swap.Int(ds.readInt());
      byte[] b = new byte[4];
      ds.read(b,0,4);
      f1val = Swap.Float(b);
      ds.read(b,0,4);
      f2val = Swap.Float(b);
      ds.read(b,0,4);
      f3val = Swap.Float(b);
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      MsgLog.log("INTFLTFLTFLT",e.getMessage(),TErrorList.code_failure,e,0);        
    }  
  }
  @Override
  public int hashCode()
  {
    final int PRIME = 31;
    int result = 1;
    result = PRIME * result + Float.floatToIntBits(f1val);
    result = PRIME * result + Float.floatToIntBits(f2val);
    result = PRIME * result + Float.floatToIntBits(f3val);
    result = PRIME * result + i1val;
    return result;
  }
  @Override
  public boolean equals(Object obj)
  {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    final INTFLTFLTFLT other = (INTFLTFLTFLT) obj;
    return equals(other);
  }    
}