package de.desy.tine.types;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TFormat;
import de.desy.tine.endianUtils.Swap;
import de.desy.tine.server.logger.MsgLog;
public class INTINTINTINT implements TCompoundDataObject
{
  public int i1val;
  public int i2val;
  public int i3val;
  public int i4val;
  public double getDoubleValue() { return (double)i1val; }
  public int getIntegerValue() { return (int)i2val; }
  public static int sizeInBytes = 16;
  public short dFormat = TFormat.CF_INTINTINTINT;
  public int getSizeInBytes() { return sizeInBytes; }
  public short getFormat() { return dFormat; }    
  public String getTag() { return null; }
  public void setValues( int newI1Value, int newI2Value, int newI3Value, int newI4Value)
  {
    i1val = newI1Value; i2val = newI2Value; i3val = newI3Value; i4val = newI4Value;
  }
  ByteArrayOutputStream dBuffer = new ByteArrayOutputStream(sizeInBytes);
  public byte[] hByteArray;
  public void setByteArray(byte[] byteArray) { hByteArray = byteArray; }
  public byte[] getByteArray() 
  { 
    return hByteArray == null ? toByteArray() : hByteArray; 
  }
  public INTINTINTINT() { i1val = 0; i2val = 0; i3val = 0; i4val = 0;}  
  public INTINTINTINT(int i) { i1val = i; i2val = 0; i3val = 0; i4val = 0;}  
  public INTINTINTINT(int i1,int i2,int i3, int i4) { i1val = i1; i2val = i2; i3val = i3; i4val = i4;}  
  public INTINTINTINT(INTINTINTINT instance) { i1val = instance.i1val; i2val = instance.i2val; i3val = instance.i3val; i4val = instance.i4val; }
  @Override
  public void copy(TCompoundDataObject from)
  {
    if (from instanceof INTINTINTINT)
    {
      INTINTINTINT instance = (INTINTINTINT)from;
      i1val = instance.i1val; i2val = instance.i2val; i3val = instance.i3val; i4val = instance.i4val;
    }
  }
  
  protected String separator = ", ";
  public void setFieldSeparator(String value)
  {
    if (value != null) separator = value;
  }
  @Override
  public String toString()
  {
      return "["+ i1val + separator + i2val + separator + i3val+ separator+i4val +"]";
  }
  public String getCsvString()
  {
    return i1val+" "+i2val+" "+i3val+" "+i4val;
  }  
  public INTINTINTINT newInstance()
  {
    return new INTINTINTINT();
  }
  public INTINTINTINT clone()
  {
    return new INTINTINTINT(this);
  }      
  public boolean equals(INTINTINTINT instance)
  {
    if (instance.i1val != i1val) return false;
    if (instance.i2val != i2val) return false;
    if (instance.i3val != i3val) return false;
    if (instance.i4val != i4val) return false;
    return true;
  }
  public byte[] toByteArray()
  {
    try
    {
      dBuffer.reset();
      DataOutputStream ds = new DataOutputStream(dBuffer);
      ds.writeInt(Swap.Int(i1val));
      ds.writeInt(Swap.Int(i2val));
      ds.writeInt(Swap.Int(i3val));
      ds.writeInt(Swap.Int(i4val));
      ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      MsgLog.log("INTINTINTINT",e.getMessage(),TErrorList.code_failure,e,0);        
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }    
  public void toStruct()
  {
    try
    {
      ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
      DataInputStream ds = new DataInputStream(dis);
      i1val = Swap.Int(ds.readInt());
      i2val = Swap.Int(ds.readInt());
      i3val = Swap.Int(ds.readInt());
      i4val = Swap.Int(ds.readInt());
      ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      MsgLog.log("INTINTINTINT",e.getMessage(),TErrorList.code_failure,e,0);        
    }  
  }
  @Override
  public int hashCode()
  {
    final int PRIME = 31;
    int result = 1;
    result = PRIME * result + i1val;
    result = PRIME * result + i2val;
    result = PRIME * result + i3val;
    result = PRIME * result + i4val;
    return result;
  }
  @Override
  public boolean equals(Object obj)
  {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    final INTINTINTINT other = (INTINTINTINT) obj;
    return equals(other);
  }    
}