/*
 * Created on Aug 12, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package de.desy.tine.types;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import de.desy.tine.definitions.*;
import de.desy.tine.server.logger.MsgLog;
public class NAME
{
  public String name;
  private int sizeInBytes = 16;
  ByteArrayOutputStream dBuffer;
  private short dFormat = TFormat.CF_NAME16;
  public short getFormat() { return dFormat; }    
  public String getTag() { return null; }
  public byte[] hByteArray;
  public void toStruct() { toName(); }
  public byte[] getByteArray() 
  { 
    return hByteArray == null ? toByteArray() : hByteArray; 
  }
  public void setByteArray(byte[] byteArray) { hByteArray = byteArray; }
  public NAME() 
  {
    dBuffer = new ByteArrayOutputStream(sizeInBytes);
    name = new String(new StringBuffer(sizeInBytes)); 
  }  
  public NAME(String Name) 
  { 
    dBuffer = new ByteArrayOutputStream(sizeInBytes);
    name = Name; 
    if (name == null) name = new String(new StringBuffer(sizeInBytes)); 
  }
  public NAME(NAME instance) 
  { 
    name = instance.name;
    sizeInBytes = instance.sizeInBytes;
    if (name == null) name = new String(new StringBuffer(sizeInBytes));
    else name = new String(name);
    dBuffer = new ByteArrayOutputStream(sizeInBytes);
  }
  public NAME clone()
  {
    return new NAME(this);
  }        
  public boolean equals(NAME instance)
  {
    if (instance.sizeInBytes != sizeInBytes) return false;
    if (instance.name == null || name == null) return false;
    if (instance.name.compareTo(name)!= 0) return false;
    return true;
  }
  public NAME(int namelength) 
  { 
    switch (namelength)
    {
      case 8: dFormat = TFormat.CF_NAME8; break;
      case 16: dFormat = TFormat.CF_NAME16; break;
      case 32: dFormat = TFormat.CF_NAME32; break;
      case 48: dFormat = TFormat.CF_NAME48; break;
      case 64: dFormat = TFormat.CF_NAME64; break;
      default: return; // TODO: throw exception
    }
    sizeInBytes = namelength;
    dBuffer = new ByteArrayOutputStream(sizeInBytes);
    name = new String(new StringBuffer(sizeInBytes)); 
  }
  public NAME(short format) 
  { 
    if (!TFormat.isName(format)) return; // TODO: throw exception
    dFormat = format;
    sizeInBytes = TFormat.formatSizeOf(format);
    dBuffer = new ByteArrayOutputStream(sizeInBytes);
    name = new String(new StringBuffer(sizeInBytes)); 
  }
  public String getName() { return name; }
  public String toString() { return name; }
  public String getCsvString()
  {
    String tname = name.trim();
    if (tname.contains(",") || tname.contains(" ") ||
        tname.contains("\t") || tname.contains("\n"))
    {
      return "\""+tname+"\"";
    }
    return tname;
  }
  public int getSizeInBytes() { return sizeInBytes; }
  public void setName(String newName) { name = newName; }
  public void setName(byte[] charArray)
  {
    name = new String(charArray);
  }
  public byte[] toByteArray()
  {
    try
    {
        dBuffer.reset();
        DataOutputStream ds = new DataOutputStream(dBuffer);
        byte[] bname = name != null ? name.getBytes() : null;
        byte[] b = new byte[sizeInBytes];
        int nlen = bname != null ? bname.length : 0;
        for (int i=0; i<sizeInBytes && i<nlen; i++) b[i] = bname[i];
        ds.write(b,0,b.length);
        ds.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      MsgLog.log("NAME","could not prepare byte stream",TErrorList.code_failure,e,0);
      return null;
    }
    hByteArray = dBuffer.toByteArray();
    return hByteArray;
  }  
  public void toName()
  {
    try
    {
        ByteArrayInputStream dis = new ByteArrayInputStream(hByteArray);
        DataInputStream ds = new DataInputStream(dis);
        byte[] b = new byte[sizeInBytes];
        ds.read(b,0,sizeInBytes);
        int len = 0; for (int i=0; i<sizeInBytes && b[i] != 0; i++, len++);
        name = new String(b,0,len);
        ds.close(); dis.close();
    }
    catch (IOException e)
    {
      e.printStackTrace();
      MsgLog.log("NAME","could not prepare byte stream",TErrorList.code_failure,e,0);
    }    
  }
  public int hashCode()
  {
    final int PRIME = 31;
    int result = 1;
    result = PRIME * result + ((name == null) ? 0 : name.hashCode());
    result = PRIME * result + sizeInBytes;
    return result;
  }
  public boolean equals(Object obj)
  {
    if (this == obj) return true;
    if (obj == null) return false;
    if (getClass() != obj.getClass()) return false;
    final NAME other = (NAME) obj;
    return equals(other);
  }
  public double getDoubleValue() { return (double)0; }
  public int getIntegerValue() { return 0; }
}
