/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.desy.tine.xmlUtils;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

/**
 *
 * @author karol
 */
public class AlarmDefinitionCfg extends TineConfigItem
{
    private String tag = new String("");
    private ValidatedInt dataFormat = new ValidatedInt();
    private String alarmText = new String("");
    private String deviceText = new String("");
    private String dataText = new String("");
    private String url = new String("");
    private ValidatedInt alarmCode = new ValidatedInt();
    private ValidatedInt alarmMask = new ValidatedInt();
    private ValidatedInt severity = new ValidatedInt();
    private ValidatedInt alarmSystem = new ValidatedInt();
    private ValidatedInt dataSize = new ValidatedInt();

    public AlarmDefinitionCfg(String name)
    {
        super(name);
    }

    public ValidatedInt getAlarmCode()
    {
        return alarmCode;
    }

    public ValidatedInt getAlarmMask()
    {
        return alarmMask;
    }

    public ValidatedInt getAlarmSystem()
    {
        return alarmSystem;
    }

    public String getAlarmText()
    {
        return alarmText;
    }

    public ValidatedInt getDataFormat()
    {
        return dataFormat;
    }

    public ValidatedInt getDataSize()
    {
        return dataSize;
    }

    public String getDataText()
    {
        return dataText;
    }

    public String getDeviceText()
    {
        return deviceText;
    }

    public ValidatedInt getSeverity()
    {
        return severity;
    }

    public String getTag()
    {
        return tag;
    }

    public String getUrl()
    {
        return url;
    }

    public void setAlarmCode(ValidatedInt alarmCode)
    {
        this.alarmCode = alarmCode;
    }

    public void setAlarmMask(ValidatedInt alarmMask)
    {
        this.alarmMask = alarmMask;
    }

    public void setAlarmSystem(ValidatedInt alarmSystem)
    {
        this.alarmSystem = alarmSystem;
    }

    public void setAlarmText(String alarmText)
    {
        this.alarmText = alarmText;
    }

    public void setDataFormat(ValidatedInt dataFormat)
    {
        this.dataFormat = dataFormat;
    }

    public void setDataSize(ValidatedInt dataSize)
    {
        this.dataSize = dataSize;
    }

    public void setDataText(String dataText)
    {
        this.dataText = dataText;
    }

    public void setDeviceText(String deviceText)
    {
        this.deviceText = deviceText;
    }

    public void setSeverity(ValidatedInt severity)
    {
        this.severity = severity;
    }

    public void setTag(String tag)
    {
        this.tag = tag;
    }

    public void setUrl(String url)
    {
        this.url = url;
    }

    void dump(int margin)
    {
       String m = new String("");
       for( int i = 0; i < margin; i++ ) m += " ";
       
       System.out.println( m + "Tag = " + getTag() );
       System.out.println( m + "Data Format = " + getDataFormat());
       System.out.println( m + "Alarm text = " + getDataText());
       System.out.println( m + "Device text = " + getDeviceText());
       System.out.println( m + "Url = " + getUrl());
       System.out.println( m + "Alarm code = " + getAlarmCode());
       System.out.println( m + "Alarm mask = " + getAlarmMask());
       System.out.println( m + "Severity = " + getSeverity());
       System.out.println( m + "Alarm system = " + getAlarmSystem()); 
       System.out.println( m + "Data size = " + getDataSize());
    }

    void parse(Element root)
    {
        NodeList children = root.getChildNodes();
        for (int i = 0; i < children.getLength(); i++)
        {
            Node child = children.item(i);
            if (child instanceof Element)
            {
                Element childElement = (Element) child;
                Text textNode = (Text) childElement.getFirstChild();
                if( textNode == null ) continue;
                String text = textNode.getData().trim();
                if(childElement.getTagName().equalsIgnoreCase("TAG"))
                {
                    setTag(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("DATA_FORMAT"))
                {
                    setDataFormat(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ALARM_TEXT"))
                {
                    setAlarmText(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("DEVICE_TEXT"))
                {
                    setDeviceText(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("DATA_TEXT"))
                {
                    setDataText(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("URL"))
                {
                    setUrl(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("ALARM_CODE"))
                {
                    setAlarmCode(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ALARM_MASK"))
                {
                    setAlarmMask(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("SEVERITY"))
                {
                    setSeverity(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ALARM_SYSTEM"))
                {
                    setAlarmSystem(ValidatedInt.parse(text));                    
                }
                else if(childElement.getTagName().equalsIgnoreCase("DATA_SIZE"))
                {
                    setDataSize(ValidatedInt.parse(text));
                }
                else System.out.println("-WARNING: unsupported tag: " + childElement.getTagName());
            }
        }
    }       
}
