/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.desy.tine.xmlUtils;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

/**
 *
 * @author karol
 */
public class AliasCfg extends TineConfigItem
{
    private String name = new String("");
    private String target = new String("");

    public String getName()
    {
        return name;
    }

    public String getTarget()
    {
        return target;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    public void setTarget(String target)
    {
        this.target = target;
    }
       
    public AliasCfg(String configItemName)
    {
        super(configItemName);
    }

    public AliasCfg(String configItemName, String name, String target)
    {
        super(configItemName);
        this.name = name;
        this.target = target;
    }

    @Override
    public String toString()    
    {
        return "[name = " + getName() + ", target = " + getTarget() +"]";
    }
    
    void parse(Element root)
    {
        NodeList children = root.getChildNodes();
        for (int i = 0; i < children.getLength(); i++)
        {
            Node child = children.item(i);
            if (child instanceof Element)
            {
                Element childElement = (Element) child;
                Text textNode = (Text) childElement.getFirstChild();
                if( textNode == null ) continue;
                String text = textNode.getData().trim();
                if(childElement.getTagName().equalsIgnoreCase("NAME"))
                {
                    setName(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("TARGET"))
                {
                    setTarget(text);
                }
                else MsgLog.log("AliasCfg","-WARNING: unsupported tag: " + childElement.getTagName(),TErrorList.invalid_field,null,0);
            }
        }
    }

    @Override
    void dump(int margin)
    {
        String m = new String("");
        for( int i = 0; i < margin; i++ ) m += " ";
       
        System.out.println( m + "Name = " + getName() );
        System.out.println( m + "Target = " + getTarget() );
    }
        
}
