/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.desy.tine.xmlUtils;

import java.util.LinkedList;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

/**
 *
 * @author karol
 */
public class DeviceCfg extends TineConfigItem
{
    private String name = new String("");
    private ValidatedInt number = new ValidatedInt();
    private String propertySet = new String("");
    private String redirection = new String("");
    private String description = new String("");
    private String location = new String("");
    private String region = new String("");
    private ValidatedInt mask = new ValidatedInt();
    private ValidatedInt offline = new ValidatedInt();
    private ValidatedFloat zpos = new ValidatedFloat(); 
    private LinkedList<NameCfgList> nameCfgList = new LinkedList<NameCfgList>();
    public String getName()
    {
        return name;
    }
    public DeviceCfg(String name)
    {
        super(name);
    }
    public LinkedList<NameCfgList> getNameCfgList()
    {
      return nameCfgList;
    }
    public ValidatedInt getNumber()
    {
      return number;
    }
    public String getPropertySet()
    {
      return propertySet;
    }
    public String getRedirection()
    {
      return redirection;
    }
    public String getDescription()
    {
      return description;
    }
    public void setName(String name)
    {
      this.name = name;
    }
    public void setNumber(ValidatedInt number)
    {
      this.number = number;
    }
    public void setPropertySet(String propertySet)
    {
      this.propertySet = propertySet;
    }
    public void setRedirection(String redirection)
    {
      this.redirection = redirection;
    }
    public void setDescription(String description)
    {
      this.description = description;
    }
    void dump(int margin)
    {
       String m = new String("");
       for( int i = 0; i < margin; i++ ) m += " ";
       
       System.out.println( m + "Name =  " + getName());
       System.out.println( m + "Property set = " + getPropertySet());
       System.out.println( m + "Redirection = " + getRedirection());
       System.out.println( m + "Number = " + getNumber());       
       System.out.println( m + "Description =  " + getDescription());
       System.out.println( m + "Location =  " + getLocation());
       System.out.println( m + "Mask =  " + getMask());
       System.out.println( m + "Z Position =  " + getZpos());
       System.out.println( m + "Online =  " + ((getOffline().getValue() == 0)?"true":"false"));
    }
    void parse(Element root)
    {
        NodeList children = root.getChildNodes();
        for (int i = 0; i < children.getLength(); i++)
        {
            Node child = children.item(i);
            if (child instanceof Element)
            {
                Element childElement = (Element) child;
                Text textNode = (Text) childElement.getFirstChild();
                if( textNode == null ) continue;
                String text = textNode.getData().trim();
                if(childElement.getTagName().equalsIgnoreCase("NAME"))
                {
                    setName(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("NUMBER"))
                {
                    setNumber(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("PROPERTY_SET"))
                {
                    setPropertySet(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("REDIRECTION"))
                {
                    setRedirection(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("DESCRIPTION"))
                {
                    setDescription(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("LOCATION"))
                {
                    setLocation(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("REGION"))
                {
                    setRegion(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("MASK"))
                {
                    setMask(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("OFFLINE"))
                {
                    setOffline(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ZPOS"))
                {
                    setZpos(ValidatedFloat.parse(text));
                }
                else MsgLog.log("DeviceCfg","-WARNING: unsupported tag: " + childElement.getTagName(),TErrorList.invalid_field,null,0);
            }
        }
    }
    public String getLocation()
    {
      return location;
    }
    public void setLocation(String location)
    {
      this.location = location;
    }
    public String getRegion()
    {
      return region;
    }
    public void setRegion(String region)
    {
      this.region = region;
    }
    public ValidatedInt getMask()
    {
      return mask;
    }
    public void setMask(ValidatedInt mask)
    {
      this.mask = mask;
    }
    public ValidatedInt getOffline()
    {
      return offline;
    }
    public void setOffline(ValidatedInt offline)
    {
      this.offline = offline;
    }
    public ValidatedFloat getZpos()
    {
      return zpos;
    }
    public void setZpos(ValidatedFloat zpos)
    {
      this.zpos = zpos;
    }
}
