/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.desy.tine.xmlUtils;

import java.util.LinkedList;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

/**
 * @author karol
 */
public class EqmCfg extends TineConfigItem
{
  private String name = new String("");
  private String server = new String("");
  private String context = new String("");
  private String subsystem = new String("");
  private String group = new String("");
  private String groupDevicePrefix = new String("");
  private String groupDevicePostfix = new String("");
  private String description = new String("");
  private String hardware = new String("");
  private String responsible = new String("");
  private String region = new String("");
  private ValidatedInt groupIndex = new ValidatedInt();
  private String master = new String("");
  private String slaveMaster = new String("");
  private LinkedList<AlarmDefinitionCfg> alarmDefinitions = new LinkedList<AlarmDefinitionCfg>();
  private LinkedList<NameCfgList> nameCfgList = new LinkedList<NameCfgList>();
  private ValidatedInt deviceSpace = new ValidatedInt();
  private LinkedList<DeviceCfg> devices = new LinkedList<DeviceCfg>();
  private LinkedList<PropertyCfg> properties = new LinkedList<PropertyCfg>();
  public EqmCfg(String n)
  {
    super(n);
  }
  public LinkedList<AlarmDefinitionCfg> getAlarmDefinitions()
  {
    return alarmDefinitions;
  }
  public void setResponsible(String responsible)
  {
    this.responsible = responsible;
  }
  public String getResponsible()
  {
    return responsible;
  }
  public void setRegion(String region)
  {
    this.region = region;
  }
  public String getRegion()
  {
    return region;
  }
  public void setDescription(String description)
  {
    this.description = description;
  }
  public String getDescription()
  {
    return description;
  }
  public String getContext()
  {
    return context;
  }
  public void setHardware(String hardware)
  {
    this.hardware = hardware;
  }
  public String getHardware()
  {
    return hardware;
  }
  public LinkedList<DeviceCfg> getDeviceList()
  {
    return devices;
  }
  public ValidatedInt getDeviceSpace()
  {
    return deviceSpace;
  }
  public String getGroup()
  {
    return group;
  }
  public String getGroupDevicePrefix()
  {
    return groupDevicePrefix;
  }
  public String getGroupDevicePostfix()
  {
    return groupDevicePostfix;
  }
  public String getMaster()
  {
    return master;
  }
  public String getSlaveMaster()
  {
    return slaveMaster;
  }
  public LinkedList<DeviceCfg> getDevices()
  {
    return devices;
  }
  public LinkedList<PropertyCfg> getProperties()
  {
    return properties;
  }
  public ValidatedInt getGroupIndex()
  {
    return groupIndex;
  }
  public String getName()
  {
    return name;
  }
  public LinkedList<NameCfgList> getNameCfgList()
  {
    return nameCfgList;
  }
  public LinkedList<PropertyCfg> getPropertyList()
  {
    return properties;
  }
  public String getServer()
  {
    return server;
  }
  public String getSubsystem()
  {
    return subsystem;
  }
  public void setAlarmDefinition(LinkedList<AlarmDefinitionCfg> alarmDefinitions)
  {
    this.alarmDefinitions = alarmDefinitions;
  }
  public void setContext(String context)
  {
    this.context = context;
  }
  public void setDeviceList(LinkedList<DeviceCfg> devices)
  {
    this.devices = devices;
  }
  public void setDeviceSpace(ValidatedInt deviceSpace)
  {
    this.deviceSpace = deviceSpace;
  }
  public void setGroup(String group)
  {
    this.group = group;
  }
  public void setGroupDevicePrefix(String prefix)
  {
    this.groupDevicePrefix = prefix;
  }
  public void setGroupDevicePostfix(String postfix)
  {
    this.groupDevicePostfix = postfix;
  }
  public void setGroupIndex(ValidatedInt groupIndex)
  {
    this.groupIndex = groupIndex;
  }
  public void setMaster(String master)
  {
    this.master = master;
  }
  public void setSlaveMaster(String slaveMaster)
  {
    this.slaveMaster = slaveMaster;
  }
  public void setName(String name)
  {
    this.name = name;
  }
  public void setNameCfgList(LinkedList<NameCfgList> NameCfgList)
  {
    this.nameCfgList = NameCfgList;
  }
  public void setPropertyList(LinkedList<PropertyCfg> properties)
  {
    this.properties = properties;
  }
  public void setServer(String server)
  {
    this.server = server;
  }
  public void setSubsystem(String subsystem)
  {
    this.subsystem = subsystem;
  }
  void dump(int margin)
  {
    String m = new String("");
    for (int i = 0; i < margin; i++)
      m += " ";
    System.out.println(m + "Name = " + getName());
    System.out.println(m + "Server = " + getServer());
    System.out.println(m + "Description = " + getDescription());
    System.out.println(m + "Context = " + getContext());
    System.out.println(m + "Hardware = " + getHardware());
    System.out.println(m + "Responsible = " + getResponsible());
    System.out.println(m + "Subsystem = " + getSubsystem());
    System.out.println(m + "Subsystem = " + getRegion());
    System.out.println(m + "Group Index = " + getGroupIndex().toString());
    System.out.println(m + "Group = " + getGroup());
    System.out.println(m + "Master = " + getMaster());
    System.out.println(m + "SlaveMaster = " + getSlaveMaster());
    System.out.println(m + "Device space = " + getDeviceSpace());
    System.out.println(m + "ALARM DEFINITIONS:");
    for (AlarmDefinitionCfg a : alarmDefinitions)
    {
      a.dump(margin + 3);
      System.out.println();
    }
    System.out.println(m + "NAME LIST:");
    for (NameCfgList n : nameCfgList)
    {
      n.dump(margin + 3);
      System.out.println();
    }
    System.out.println(m + "DEVICES:");
    for (DeviceCfg d : devices)
    {
      d.dump(margin + 3);
      System.out.println();
    }
    System.out.println(m + "PROPERTIES:");
    for (PropertyCfg p : properties)
    {
      p.dump(margin + 3);
      System.out.println();
    }
  }
  void parse(Element root)
  {
    NodeList children = root.getChildNodes();
    for (int i = 0; i < children.getLength(); i++)
    {
      Node child = children.item(i);
      if (child instanceof Element)
      {
        Element childElement = (Element) child;
        Text textNode = (Text) childElement.getFirstChild();
        if (textNode == null) continue;
        String text = textNode.getData().trim();
        if (childElement.getTagName().equalsIgnoreCase("NAME"))
        {
          setName(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("SERVER"))
        {
          setServer(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("CONTEXT"))
        {
          setContext(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("DESCRIPTION"))
        {
          setDescription(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("HARDWARE"))
        {
          setHardware(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("RESPONSIBLE"))
        {
          setResponsible(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("SUBSYSTEM"))
        {
          setSubsystem(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("REGION"))
        {
          setRegion(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("GROUP"))
        {
          setGroup(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("GROUP_INDEX"))
        {
          setGroupIndex(ValidatedInt.parse(text));
        }
        else if (childElement.getTagName().equalsIgnoreCase("GROUP_DEVICE_PREFIX"))
        {
          setGroupDevicePrefix(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("MASTER"))
        {
          setMaster(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("SLAVE_MASTER"))
        {
          setSlaveMaster(text);
        }
        else if (childElement.getTagName().equalsIgnoreCase("ALARM_DEFINITION"))
        {
          AlarmDefinitionCfg adc = new AlarmDefinitionCfg("ALARM DEFINITION");
          alarmDefinitions.add(adc);
          adc.parse(childElement);
        }
        else if (childElement.getTagName().equalsIgnoreCase("NAME_LIST"))
        {
          NameCfgList ncl = new NameCfgList("NAME LIST");
          nameCfgList.add(ncl);
          ncl.parse(childElement);
        }
        else if (childElement.getTagName().equalsIgnoreCase("DEVICE_SPACE"))
        {
          setDeviceSpace(ValidatedInt.parse(text));
        }
        else if (childElement.getTagName().equalsIgnoreCase("DEVICE"))
        {
          DeviceCfg dc = new DeviceCfg("DEVICE");
          devices.add(dc);
          dc.parse(childElement);
        }
        else if (childElement.getTagName().equalsIgnoreCase("PROPERTY"))
        {
          PropertyCfg pc = new PropertyCfg("PROPERTY");
          properties.add(pc);
          pc.parse(childElement);
        }
        // dorobic property linia 78 w fec.xml
        else
          MsgLog.log("EqmCfg", "-WARNING: unsupported tag: " + childElement.getTagName(),
              TErrorList.invalid_field, null, 0);
      }
    }
  }
}
