/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.desy.tine.xmlUtils;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

/**
 *
 * @author karol
 */
public class HistoryCfg extends TineConfigItem
{
    private String deviceName = new String("");
    private ValidatedTolerance tolerance = new ValidatedTolerance();
    private String redirection = new String("");
    private ValidatedInt index = new ValidatedInt();
    private ValidatedInt heartbeat = new ValidatedInt();
    private ValidatedInt pollRate = new ValidatedInt();
    private ValidatedInt archiveRate = new ValidatedInt();
    private ValidatedInt depthShort = new ValidatedInt();
    private ValidatedInt depthLong = new ValidatedInt();

    public ValidatedInt getArchiveRate()
    {
        return archiveRate;
    }

    public HistoryCfg(String name)
    {
        super( name );
    }

    public ValidatedInt getDepthLong()
    {
        return depthLong;
    }

    public ValidatedInt getDepthShort()
    {
        return depthShort;
    }

    public String getDeviceName()
    {
        return deviceName;
    }

    public ValidatedInt getHeartbeat()
    {
        return heartbeat;
    }

    public ValidatedInt getIndex()
    {
        return index;
    }

    public ValidatedInt getPollRate()
    {
        return pollRate;
    }

    public String getRedirection()
    {
        return redirection;
    }

    public ValidatedTolerance getTolerance()
    {
        return tolerance;
    }

    public void setArchiveRate(ValidatedInt archiveRate)
    {
        this.archiveRate = archiveRate;
    }

    public void setDepthLong(ValidatedInt depthLong)
    {
        this.depthLong = depthLong;
    }

    public void setDepthShort(ValidatedInt depthShort)
    {
        this.depthShort = depthShort;
    }

    public void setDeviceName(String deviceName)
    {
        this.deviceName = deviceName;
    }

    public void setHeartbeat(ValidatedInt heartbeat)
    {
        this.heartbeat = heartbeat;
    }

    public void setIndex(ValidatedInt index)
    {
        this.index = index;
    }

    public void setPollRate(ValidatedInt pollRate)
    {
        this.pollRate = pollRate;
    }

    public void setRedirection(String redirection)
    {
        this.redirection = redirection;
    }

    public void setTolerance(ValidatedTolerance tolerance)
    {
        this.tolerance = tolerance;
    }

    void dump(int margin)
    {
       String m = new String("");
       for( int i = 0; i < margin; i++ ) m += " ";
       
       System.out.println( m + "Device name = " + getDeviceName());
       System.out.println( m + "Tolerance = " + getTolerance());
       System.out.println( m + "Redirection = " + getRedirection());
       System.out.println( m + "Index = " + getIndex());
       System.out.println( m + "Heartbeat = " + getHeartbeat());
       System.out.println( m + "Poll rate = " + getPollRate());
       System.out.println( m + "Archive rate = " + getArchiveRate());
       System.out.println( m + "Depth short = " + getDepthShort());
       System.out.println( m + "Depth long = " + getDepthLong());
    }

    void parse(Element root)
    {
        NodeList children = root.getChildNodes();
        for (int i = 0; i < children.getLength(); i++)
        {
            Node child = children.item(i);
            if (child instanceof Element)
            {
                Element childElement = (Element) child;
                Text textNode = (Text) childElement.getFirstChild();
                if( textNode == null ) continue;
                String text = textNode.getData().trim();
                if(childElement.getTagName().equalsIgnoreCase("DEVICE_NAME"))
                {
                    setDeviceName(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("TOLERANCE"))
                {
                    setTolerance(ValidatedTolerance.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("REDIRECTION"))
                {
                    setRedirection(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("INDEX"))
                {
                    setIndex(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("HEARTBEAT"))
                {
                    setHeartbeat(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("POLL_RATE"))
                {
                    setPollRate(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ARCHIVE_RATE"))
                {
                    setArchiveRate(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("DEPTH_SHORT"))
                {
                    setDepthShort(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("DEPTH_LONG"))
                {
                    setDepthLong(ValidatedInt.parse(text));
                }
                else MsgLog.log("HistoryCfg","-WARNING: unsupported tag: " + childElement.getTagName(),TErrorList.invalid_field,null,0);
            }   
        }
    }
}
    
    

