/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.desy.tine.xmlUtils;

import java.util.LinkedList;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

/**
 *
 * @author karol
 */
public class NameCfgList extends TineConfigItem
{
    private String name = new String("");
    private LinkedList<String> members = new LinkedList<String>();

    public NameCfgList(String configItemName)
    {       
        super( configItemName );
    }

    public LinkedList<String> getMembers()
    {
        return members;
    }

    public String getName()
    {
        return name;
    }

    public void setMembers(LinkedList<String> members)
    {
        this.members = members;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    void dump(int margin)
    {
       String m = new String("");
       for( int i = 0; i < margin; i++ ) m += " ";
       
       System.out.println( m + "Name = " + getName() );
       System.out.println( m + "MEMEBERS:" );
       for( String s : members ) System.out.println( m + " " + s );
    }

    void parse(Element root)
    {
        NodeList children = root.getChildNodes();
        for (int i = 0; i < children.getLength(); i++)
        {
            Node child = children.item(i);
            if (child instanceof Element)
            {
                Element childElement = (Element) child;
                Text textNode = (Text) childElement.getFirstChild();
                if( textNode == null ) continue;
                String text = textNode.getData().trim();
                if(childElement.getTagName().equalsIgnoreCase("NAME"))
                {
                    setName(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("MEMBER"))
                {
                    members.add(text);
                }
                else MsgLog.log("NameCfg","-WARNING: unsupported tag: " + childElement.getTagName(),TErrorList.invalid_field,null,0);
            }
        }
    }

}
