/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.desy.tine.xmlUtils;

import java.util.LinkedList;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import de.desy.tine.definitions.TAccess;
import de.desy.tine.definitions.TArrayType;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

/**
 *
 * @author karol
 */
public class PropertyCfg extends TineConfigItem
{

    public PropertyCfg(String name)
    {
        super(name);
    }
    
    private String name = new String("");
    private LinkedList<String> devices = new LinkedList<String>();
    private String egu = new String("");
    private String xEgu = new String("");
    private ValidatedFloat max = new ValidatedFloat();
    private ValidatedFloat min = new ValidatedFloat();
    private ValidatedFloat xmax = new ValidatedFloat();
    private ValidatedFloat xmin = new ValidatedFloat();
    private ValidatedInt id = new ValidatedInt();
    private String description = new String("");
    private ValidatedInt sizeIn = new ValidatedInt();
    private ValidatedInt dTypeIn = new ValidatedInt();
    private ValidatedInt sizeOut = new ValidatedInt();
    private ValidatedInt dTypeOut = new ValidatedInt();
    private ValidatedInt access = new ValidatedInt();
    private ValidatedInt deadband = new ValidatedInt();
    public boolean hasExclusiveRead = false;
    public boolean hasUnlockedExclusiveRead = true;
    public boolean isEnforceOutput = false;
    private String dTagIn = new String("");
    private String dTagOut = new String("");
    private int dArrayTypeOut = TArrayType.AT_UNKNOWN;
    private String redirection = new String("");
    private AlarmCfg alarm = null; //new AlarmCfg("ALARM");
    private HistoryCfg history = null; //new HistoryCfg("HISTORY");
    private LinkedList<NameCfgList> nameCfgList = new LinkedList<NameCfgList>();

    public LinkedList<NameCfgList> getNameCfgList()
    {
      return nameCfgList;
    }
    public ValidatedInt getAccess()
    {
      return access;
    }

    public AlarmCfg getAlarm()
    {
      return alarm;
    }

    public ValidatedInt getDTypeIn()
    {
      return dTypeIn;
    }

    public ValidatedInt getDTypeOut()
    {
      return dTypeOut;
    }

    public String getDescription()
    {
      return description;
    }

    public LinkedList<String> getDevices()
    {
      return devices;
    }

    public String getEgu()
    {
      return egu;
    }

    public HistoryCfg getHistory()
    {
      return history;
    }

    public ValidatedInt getId()
    {
      return id;
    }

    public ValidatedFloat getMax()
    {
      return max;
    }

    public ValidatedFloat getMin()
    {
      return min;
    }

    public String getName()
    {
      return name;
    }

    public String getRedirection()
    {
      return redirection;
    }

    public ValidatedInt getSizeIn()
    {
      return sizeIn;
    }

    public ValidatedInt getSizeOut()
    {
      return sizeOut;
    }

    public ValidatedInt getDeadband()
    {
      return deadband;
    }

    public String getXEgu()
    {
      return xEgu;
    }

    public ValidatedFloat getXmax()
    {
      return xmax;
    }

    public ValidatedFloat getXmin()
    {
      return xmin;
    }

    public void setAccess(ValidatedInt access)
    {
      this.access = access;
    }

    public void setAlarm(AlarmCfg alarm)
    {
      this.alarm = alarm;
    }

    public void setDTypeIn(ValidatedInt dTypeIn)
    {
      this.dTypeIn = dTypeIn;
    }

    public void setDTypeOut(ValidatedInt dTypeOut)
    {
      this.dTypeOut = dTypeOut;
    }

    public void setDescription(String description)
    {
      this.description = description;
    }

    public void setDevices(LinkedList<String> devices)
    {
      this.devices = devices;
    }

    public void setEgu(String egu)
    {
      this.egu = egu;
    }

    public void setHistory(HistoryCfg history)
    {
      this.history = history;
    }

    public void setId(ValidatedInt id)
    {
      this.id = id;
    }

    public void setMax(ValidatedFloat max)
    {
      this.max = max;
    }

    public void setMin(ValidatedFloat min)
    {
      this.min = min;
    }

    public void setName(String name)
    {
      this.name = name;
    }

    public void setRedirection(String redirection)
    {
      this.redirection = redirection;
    }

    public void setSizeIn(ValidatedInt sizeIn)
    {
      this.sizeIn = sizeIn;
    }

    public void setSizeOut(ValidatedInt sizeOut)
    {
      this.sizeOut = sizeOut;
    }

    public void setDeadband(ValidatedInt deadbandInMilliseconds)
    {
      this.deadband = deadbandInMilliseconds;
    }

    public void setXEgu(String xEgu)
    {
      this.xEgu = xEgu;
    }

    public void setXmax(ValidatedFloat xmax)
    {
      this.xmax = xmax;
    }

    public void setXmin(ValidatedFloat xmin)
    {
      this.xmin = xmin;
    }

    void dump(int margin)
    {
       String m = new String("");
       for( int i = 0; i < margin; i++ ) m += " ";
       
       System.out.println( m + "Name = " + getName());
       System.out.println( m + "Device set" );
       for( String s : devices ) System.out.println( m + "  " + s);
       System.out.println( m + "Egu = " + getEgu());
       System.out.println( m + "Xegu = " + getXEgu()); 
       System.out.println( m + "Max = " + getMax());
       System.out.println( m + "Min = " + getMin());
       System.out.println( m + "xMax = " + getXmax());
       System.out.println( m + "xMin = " + getXmin());
       System.out.println( m + "Id = " + getId());
       System.out.println( m + "Description = " + getDescription());
       System.out.println( m + "SizeIn = " + getSizeIn());
       System.out.println( m + "DtypeIn = " + getDTypeIn());
       System.out.println( m + "SizeOut = " + getSizeOut());
       System.out.println( m + "DtypeOut = " + getDTypeOut());
       System.out.println( m + "Access = " + getAccess());
       System.out.println( m + "Redirection = " + getRedirection());
       System.out.println( m + "Deadband = " + getDeadband());
       System.out.println( m + "ALARM:" );
       AlarmCfg ac =  getAlarm();
       if( ac != null ) ac.dump( margin+3 );
       System.out.println( m + "HISTORY:" );
       HistoryCfg hc = getHistory();
       if( hc != null ) hc.dump( margin+3 );
    }

    void parse(Element root)
    {
        NodeList children = root.getChildNodes();
        for (int i = 0; i < children.getLength(); i++)
        {
            Node child = children.item(i);
            if (child instanceof Element)
            {
                Element childElement = (Element) child;
                Text textNode = (Text) childElement.getFirstChild();
                if( textNode == null ) continue;
                String text = textNode.getData().trim();
                if(childElement.getTagName().equalsIgnoreCase("NAME"))
                {
                    setName(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("DEVICE_SET"))
                {
                    devices.add(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("EGU"))
                {
                    setEgu(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("XEGU"))
                {
                    setXEgu(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("MAX"))
                {
                    setMax(ValidatedFloat.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("MIN"))
                {
                    setMin(ValidatedFloat.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("XMAX"))
                {
                    setXmax(ValidatedFloat.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("XMIN"))
                {
                  setXmin(ValidatedFloat.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ID"))
                {
                  setId(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("DESCRIPTION"))
                {
                  setDescription(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("SIZE_IN"))
                {
                  setSizeIn(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("DTYPE_IN"))
                {
                  ValidatedFormat vf = ValidatedFormat.parse(text);
                  setDTypeIn(vf.getFormat());
                  setDTagIn(vf.getTag());
                }
                else if(childElement.getTagName().equalsIgnoreCase("SIZE_OUT"))
                {
                  setSizeOut(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("DTYPE_OUT"))
                {
                  ValidatedFormat vf = ValidatedFormat.parse(text);
                  setDTypeOut(vf.getFormat());
                  setDTagOut(vf.getTag());
                  setDArrayTypeOut(vf.getArrayType());
                }
                else if(childElement.getTagName().equalsIgnoreCase("ACCESS_DEADBAND"))
                {
                  setDeadband(ValidatedInt.parse(text));
                }
                else if(childElement.getTagName().equalsIgnoreCase("ACCESS"))
                {
                  ValidatedAccess va = ValidatedAccess.parse(text);
                  setAccess(va.getAccess());
                  hasExclusiveRead = TAccess.hasExclusiveRead(text);
                  hasUnlockedExclusiveRead = TAccess.hasUnlockedExclusiveRead(text);
                  isEnforceOutput = TAccess.isEnforceOutput(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("REDIRECTION"))
                {
                  setRedirection(text);
                }
                else if(childElement.getTagName().equalsIgnoreCase("ALARM"))
                {
                  AlarmCfg ac = new AlarmCfg("ALARM");
                  setAlarm(ac);
                  ac.parse(childElement);
                }
                else if(childElement.getTagName().equalsIgnoreCase("HISTORY"))
                {
                  HistoryCfg hc = new HistoryCfg("HISTORY");
                  setHistory(hc);
                  hc.parse(childElement);
                }
                else MsgLog.log("PropertyCfg","-WARNING: unsupported tag: " + childElement.getTagName(),TErrorList.invalid_field,null,0);
            }
        }
    
    }

    public int getDArrayTypeOut()
    {
      return dArrayTypeOut;
    }

    public void setDArrayTypeOut(int arrayTypeOut)
    {
      dArrayTypeOut = arrayTypeOut;
    }

    public String getDTagIn()
    {
      return dTagIn;
    }

    public void setDTagIn(String tagIn)
    {
      dTagIn = tagIn;
    }

    public String getDTagOut()
    {
      return dTagOut;
    }

    public void setDTagOut(String tagOut)
    {
      dTagOut = tagOut;
    }
}
