/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package de.desy.tine.xmlUtils;

import java.lang.String;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.LinkedList;
import javax.swing.event.EventListenerList;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.server.logger.MsgLog;

/**
 *
 * @author karol
 */
class TineCfgTreeModel implements TreeModel
{
    @SuppressWarnings("unused")
    private FecCfg fecCfg;
    private EventListenerList eventListenerList = new EventListenerList();
    TineConfigTreeItem root;
            
            
    public TineCfgTreeModel(FecCfg fecCfg) 
    {
        this.fecCfg = fecCfg;
        root = new TineConfigTreeItem( getClass(), "fecCfg", fecCfg );
    }

    public Object getRoot()
    {
        return  root;
    }

    public Object getChild(Object parent, int index)
    {
      
       if( ((TineConfigTreeItem)parent).getValue().getClass().equals(LinkedList.class))
       {
            return new TineConfigTreeItem( String.class, "member", ((LinkedList<?>)((TineConfigTreeItem)parent).getValue()).get(index));
       }
       try
       {
            ArrayList<Field> fields = ((TineConfigTreeItem)parent).getFields();
            Field f = (Field)fields.get(index);
            Object parentValue = ((TineConfigTreeItem)parent).getValue();
            return new TineConfigTreeItem(f.getType(), f.getName(), f.get(parentValue));
       }
       catch(IllegalAccessException e)
       {
           MsgLog.log("TineCfgTreeModel","Illegal Access Exception handler",TErrorList.code_failure,e,0);
           return null;
       }
    }

    public int getChildCount(Object parent)
    {
      if( ((TineConfigTreeItem)parent).getValue().getClass().equals(LinkedList.class))  
          return ((LinkedList<?>)((TineConfigTreeItem)parent).getValue()).size();
      return ((TineConfigTreeItem)parent).getFields().size();
    }

    public boolean isLeaf(Object node)
    {
        return getChildCount(node) == 0;
    }

    public void valueForPathChanged(TreePath path, Object newValue)
    {        
    }

    public int getIndexOfChild(Object parent, Object child)
    {  
       int n = getChildCount(parent);
       for( int i = 0; i < n; i++ )
       {
           if( getChild(parent, i).equals(child)) return i;
       }
       return -1;
    }

    public void addTreeModelListener(TreeModelListener l)
    {
        eventListenerList.add(TreeModelListener.class, l);
    }

    public void removeTreeModelListener(TreeModelListener l)
    {
        eventListenerList.remove(TreeModelListener.class, l);
    }

}
