/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.desy.tine.xmlUtils;

import de.desy.tine.definitions.TArrayType;
import de.desy.tine.definitions.TFormat;

/**
 * @author karol
 */
public class ValidatedFormat
{
  private boolean valid;
  private int format;
  private String tag;
  private int arrayType;
  public boolean isValid()
  {
    return valid;
  }
  public ValidatedInt getFormat()
  {
    return new ValidatedInt(format,valid);
  }
  public void setValid(boolean valid)
  {
    this.valid = valid;
  }
  public void setFormat(int value)
  {
    this.format = value;
  }
  public ValidatedFormat()
  {
    this.valid = false;
    this.format = 0;
  }
  public void set(int value, boolean valid)
  {
    this.valid = valid;
    this.format = value;
  }
  public ValidatedFormat(int format, String tag, int arrayType, boolean valid)
  {
    this.valid = valid;
    this.format = format;
    this.tag = tag;
    this.arrayType = arrayType;
  }
  @Override
  public String toString()
  {
    return "[" + Integer.toString(format) + "," + (valid ? " VALID]" : "NOT VALID]");
  }
  static ValidatedFormat parse(String s)
  {
    if (s == null || s.length() == 0)
      return new ValidatedFormat(TFormat.CF_NULL, "", TArrayType.AT_UNKNOWN, false);
    int fmt = TFormat.getFormatCode(s);
    String tag = TFormat.getFormatTag(s);
    int atyp = TFormat.getFormatArrayType(s);
    return new ValidatedFormat(fmt,tag,atyp,true);
  }
  public int getArrayType()
  {
    return arrayType;
  }
  public void setArrayType(int arrayType)
  {
    this.arrayType = arrayType;
  }
  public String getTag()
  {
    return tag;
  }
  public void setTag(String tag)
  {
    this.tag = tag;
  }
}
