/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.desy.tine.xmlUtils;

/**
 * @author karol
 */
public class ValidatedTolerance
{
  private boolean valid;
  private float toleranceAbsolute;
  private float tolerancePercent;
  public boolean isValid()
  {
    return valid;
  }
  public void setValid(boolean valid)
  {
    this.valid = valid;
  }
  public ValidatedTolerance()
  {
    this.valid = false;
    this.toleranceAbsolute = 0;
  }
  public void set(float toleranceAbsolute, float tolerancePercent, boolean valid)
  {
    this.valid = valid;
    this.toleranceAbsolute = toleranceAbsolute;
    this.tolerancePercent = tolerancePercent;
  }
  public ValidatedTolerance(float toleranceAbsolute, float tolerancePercent, boolean valid)
  {
    this.valid = valid;
    this.toleranceAbsolute = toleranceAbsolute;
    this.tolerancePercent = tolerancePercent;
  }
  @Override
  public String toString()
  {
    return "[" + Float.toString(toleranceAbsolute) + "," + (valid ? " VALID]" : "NOT VALID]");
  }
  static ValidatedTolerance parse(String s)
  {
    if (s == null || s.length() == 0) return new ValidatedTolerance(0, 0, false);
    float tolA = 0, tolP = 0;
    String[] parts = s.split("\\+");
    try
    {
      int idx = -1;
      for (String ss : parts)
      {
        idx = ss.indexOf("%");
        if (idx >= 0)
        {
          tolP = Float.parseFloat(ss.substring(0, idx));
        }
        else
        {
          tolA = Float.parseFloat(ss);
        }
      }
      return new ValidatedTolerance(tolA, tolP, true);
    }
    catch (NumberFormatException e)
    {
      tolA = 0; tolP = 0;
    }
    return new ValidatedTolerance(0, 0, false);
  }
  public float getToleranceAbsolute()
  {
    return toleranceAbsolute;
  }
  public void setToleranceAbsolute(float toleranceAbsolute)
  {
    this.toleranceAbsolute = toleranceAbsolute;
  }
  public float getTolerancePercent()
  {
    return tolerancePercent;
  }
  public void setTolerancePercent(float tolerancePercent)
  {
    this.tolerancePercent = tolerancePercent;
  }
}
