package de.desy.acop.chart;

import java.awt.AWTEvent;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.AffineTransform;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.awt.print.*;
import java.beans.Beans;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.util.Date;
import java.util.Vector;
import javax.swing.plaf.basic.BasicGraphicsUtils;
import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageDecoder;
import de.desy.acop.transport.AcopTransport;
import de.desy.acop.transport.AcopTransportPlug;
import de.desy.acop.transport.AcopTransportRequest;

/**
 * @brief Advanced Component Oriented Programming ACOP offers a powerful
 *        interface for both data acquisition and data rendition in a common
 *        bean.
 */
public class Acop extends java.awt.Panel implements Printable,Serializable
{
  /**
   * 
   */
  private static final long serialVersionUID = 351823797042270731L;
  protected AcopHisto[] histo = new AcopHisto[AcopConst.MAX_DISPLAY]; // maximum
                                                                      // 100
  private int n_display;
  protected int m_lock;
  protected boolean drawTicks = true; // after new scalling
  protected boolean repainHisto = false;
  protected int rescaleFlag = 2;
  protected int histIndex = -1;
  private int loadXYindex = 0;
  private int m_filled = 0; // N_DISPLAY is filled
  private int m_keep = 0; // # of keeped histogram
  protected int lastDisp = 0;
  protected int lastTagHisto = 0;
  private int m_numberkeep = 0;
  private int m_keepstart = 0;
  protected AcopAxis[] axis = new AcopAxis[AcopConst.MAX_AXIS];
  protected AcopText[] ptext = new AcopText[AcopConst.MAX_TEXT]; // maximum 100
  private int n_text;
  private int loadTextIndex = 0;
  protected boolean textFlag = false; // Ondraw text?
  protected int rescaleTextFlag = 0;
  private double[] g_rdata = new double[512];
  private boolean RandomInitialized = false;
  private BasicStroke stroke = new BasicStroke(1.0f);
  // private Stroke penLine = null;
  // private int dxmin, dxmax, dymin, dymax, dxwidth, dywidth;
  private double xwidth, ywidth;
  private Rectangle titleRect = new Rectangle();
  // private Rectangle histRect = new Rectangle();
  protected Rectangle histRoundRect = new Rectangle();
  private Rectangle xRect = new Rectangle();
  private Rectangle yRect = new Rectangle();
  protected Rectangle yAxisRect = new Rectangle();
  protected Rectangle tagRect = new Rectangle();
  private Rectangle zoomRect = new Rectangle();
  private int changeScaleWidth;
  private int fLeft, fRight, fTop, fBottom;
  private int fLeftPixel, fRightPixel, fTopPixel, fBottomPixel;
  private int HistLeft, HistRight, leftPixel, HistRectleftReference;
  protected boolean errWindowOn = false;
  protected boolean ScaleEnable = false; // yScaleArray on-off
  protected boolean ReferenceEnable = false;
  // protected int xleft, xright, dxwidth;
  protected double[][] bufferedMin = new double[AcopConst.lengthZoom][3];
  protected double[][] bufferedMax = new double[AcopConst.lengthZoom][3];
  protected int zoomIndex, zoomLogFlag;
  protected boolean isZoomed;
  protected boolean zoomFlag, movie; // zoom is on?
  protected Point moviepoint;
  protected int saveBestFlag;
  protected double moviePercent = 0.01;
  protected int movieLogCnt = 10;
  protected int xCnt = 0;
  protected int yCnt = 0;
  // protected double s_xmin, s_xmax, s_ymin, s_ymax; // user display rectangle
  protected int time_scale;
  protected double tick_xmin, tick_xmax; // ticks area
  protected int m_histstart = 0; // reference index of base histogram
  protected double wrapxmin, wrapxmax; // wrap x range
  private int mouseX, mouseY, mouseLastX, mouseLastY;
  private Point mStart, mEnd, mousepoint;
  private double mouseConvert[] = new double[2];
  private int mouseIndex;
  protected AcopScale[] sca = new AcopScale[3];
  // private AcopLine gridLine = new AcopLine();
  protected AcopFrame aFrame = new AcopFrame();
  protected AcopTransport transport = new AcopTransport(this);
  // private BasicGraphicsUtils bGraphic = new BasicGraphicsUtils();
  private Vector AcopListeners = new Vector();
  private java.awt.image.BufferedImage ima;
  private java.awt.Graphics2D g2dima;
  private String yZoomRatio, xZoomRatio, bufferedZoomRatio;
  protected int yzero;
  protected java.awt.Color foreColor;
  private boolean captionChanged;
  private java.awt.Font captionFont;
  private double lastTextx, lastTexty;
  private int nBackRegions;
  private boolean backgroundRegionFixed;
  private int backkgroundRegionType[] = new int[AcopConst.MAX_BACKGROUND_REGION];
  private Rectangle2D.Double[] backRegionUserRect = new Rectangle2D.Double[AcopConst.MAX_BACKGROUND_REGION]; // userinput
                                                                                                              // rectangle
  private Rectangle[] backRegionRect = new Rectangle[AcopConst.MAX_BACKGROUND_REGION]; // converted
                                                                                        // device
                                                                                        // rect
  private Color[] backRegionColor = new Color[AcopConst.MAX_BACKGROUND_REGION]; // userinput
                                                                                // color
  private BufferedImage[] backRegionImage = new BufferedImage[AcopConst.MAX_BACKGROUND_REGION]; // userinput
                                                                                                // images
  protected Color pTagColorArray[];
  protected int nElement;
  protected Color TagBackColor; // init with forecolor
  private long mousePreviousClickTime, previousButton;
  private Point rButtonPoint;
  protected double yReferenceArray[];
  protected int yRASize, yRAdataSize;
  protected double yWindowArray[];
  protected int yWASize, yWAdataSize;
  protected double e_xmin, e_xmax, e_ymin, e_ymax; // error window display
                                                    // rectangle
  protected BasicStroke markerStroke;
  protected int m_marker;
  protected int saveMarkerWidth;
  protected double xlabelRotateGrad, xlabelcos, xlabelsin;
  protected int xlabelQudrant, xlabelAxis;
  protected int printScreenPosition;
  private int averagingIndex, averagingLength, NumberAveragingData;
  private double totalWeight;
  private double[] averageWeight = new double[AcopConst.N_DEF_DISPLAY];
  private double[][] averagingBuffer = new double[AcopConst.N_DEF_DISPLAY][];
  protected BasicStroke cursorMarkerStroke;
  private Point mMovePoint = new Point(); // for mouse
  private Point mOffsetMovePoint = new Point(); // for traslated coordinate
  private int cursorStay, cursorMarkerFlag, cursorix, cursoriy, cursorwx, cursorwy;
  private double cursorXPercent, cursorYPercent;
  private double cursorXposition, cursorYposition;
  public int PrintScreen()
  {
    return PrintScreen(0);
  }
  public int PrintScreen(int position)
  {
    PrinterJob printerJob = PrinterJob.getPrinterJob();
    PageFormat pageFormat = printerJob.defaultPage();
    printScreenPosition = (position < 0 || position > 2) ? 0 : position;
    if (printerJob.pageDialog(pageFormat) != pageFormat)
    {
      if (printerJob.printDialog())
      {
        printerJob.setPrintable(this);
        try
        {
          printerJob.print();
        }
        catch (PrinterException e)
        {
          // TODO Auto-generated catch block
          e.printStackTrace();
        }
      }
      else
        System.out.println("PrintDialog was cancelled");
    }
    return 0;
  }
  public int print(Graphics printG, PageFormat pageFormat, int pageIndex)
  {
    if (pageIndex == 0)
    {
      Graphics2D g = (Graphics2D) printG;
      double x1, x2, x3, y1, y2, y3, tmp, scale, offsetX, offsetY;
      x1 = pageFormat.getImageableWidth();
      x2 = this.getSize().width;
      x3 = pageFormat.getImageableX();
      y1 = pageFormat.getImageableHeight();
      y2 = this.getSize().height;
      y3 = pageFormat.getImageableY();
      tmp = x1 / x2;
      scale = y1 / y2;
      offsetX = 0;
      offsetY = 0;
      if (printScreenPosition != 0)
      {
        if (tmp < scale)
        {
          offsetY = y1 - y2 * tmp;
          if (printScreenPosition == 1) offsetY /= 2;
        }
        else
        {
          offsetX = x1 - x2 * scale;
          if (printScreenPosition == 1) offsetX /= 2;
        }
      }
      if (tmp < scale) scale = tmp;
      double xMargin = (pageFormat.getImageableWidth() - this.getSize().width * scale) / 2 + offsetX;
      double yMargin = (pageFormat.getImageableHeight() - this.getSize().height * scale) / 2 + offsetY;
      g.translate(pageFormat.getImageableX() + xMargin, pageFormat.getImageableY() + yMargin);
      g.scale(scale, scale);
      paint(g);
      return PAGE_EXISTS;
    }
    else
      return NO_SUCH_PAGE;
  }
  public int setBackgroundRegion(Rectangle2D.Double[] colorRegionRect, Color[] regionColor, boolean fixed)
  {
    return setBackgroundRegion(colorRegionRect, regionColor, null, null, fixed);
  }
  public int setBackgroundRegion(Rectangle2D.Double[] imageRegionRect, String[] imageFilename, boolean fixed)
  {
    return setBackgroundRegion(null, null, imageRegionRect, imageFilename, fixed);
  }
  public int setBackgroundRegion(Rectangle2D.Double[] colorRegionRect, Color[] regionColor,
      Rectangle2D.Double[] imageRegionRect, String[] imageFilename, boolean fixed)
  {
    int numColorRegion, numImageRegion, numRegion, colorLength, imageLength;
    if ((colorRegionRect == null && imageRegionRect == null) || // no rectangle
        (regionColor == null && imageFilename == null))
    {
      nBackRegions = 0;
      return 0;
    }
    numColorRegion = (colorRegionRect != null && regionColor != null) ? colorRegionRect.length : 0;
    numImageRegion = (imageRegionRect != null && imageFilename != null) ? imageRegionRect.length : 0;
    if (numColorRegion <= 0 && numImageRegion <= 0)
    {
      nBackRegions = 0;
      return 0;
    }
    colorLength = regionColor != null ? regionColor.length : 0;
    imageLength = imageFilename != null ? imageFilename.length : 0;
    numRegion = numColorRegion + numImageRegion;
    if (numRegion > AcopConst.MAX_BACKGROUND_REGION) numRegion = AcopConst.MAX_BACKGROUND_REGION;
    for (int i = 0; i < numRegion; i++) // load user region and color array or
                                        // images
    {
      backRegionUserRect[i] = i < numColorRegion ? colorRegionRect[i] : imageRegionRect[i - numColorRegion];
      if (backRegionUserRect[i] == null)
      {
        backkgroundRegionType[i] = 0;
        continue;
      }
      if (i < numColorRegion)
      {
        backRegionColor[i] = i < colorLength ? regionColor[i] : regionColor[i - 1];
        backkgroundRegionType[i] = 1;
      }
      else
      {
        backkgroundRegionType[i] = 2;
        if (i - numColorRegion >= imageLength)
          backRegionImage[i] = backRegionImage[i - 1];
        else
          try
          {
            InputStream in = new FileInputStream(imageFilename[i - numColorRegion]);
            JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);
            backRegionImage[i] = decoder.decodeAsBufferedImage();
          }
          catch (IOException e)
          {
            e.printStackTrace();
            throw new Error("Could not load " + backRegionImage[i] + " with JPEGImageDecoder");
          }
      }
    }
    backgroundRegionFixed = fixed;
    if (numRegion > 0)
    {
      nBackRegions = numRegion;
      convertBackgroundRegion(true);
    }
    return numRegion;
  }
  private void convertBackgroundRegion(boolean fourceConvert)
  {
    int xpos, xlength, ypos, ylength;
    if (nBackRegions == 0) return;
    if (!fourceConvert && backgroundRegionFixed) return;
    for (int i = 0; i < nBackRegions; i++) // convert
    {
      if (backkgroundRegionType[i] == 0) continue;
      ylength = (int) (aFrame.histRect.height * backRegionUserRect[i].height / sca[1].dispSize);
      ypos = (int) (aFrame.histRect.y - ylength + aFrame.histRect.height
          * (1. - (backRegionUserRect[i].y - sca[1].min) / sca[1].dispSize));
      xpos = (int) (aFrame.histRect.x + aFrame.histRect.width * (backRegionUserRect[i].x - sca[0].min)
          / sca[0].dispSize);
      xlength = (int) (aFrame.histRect.width * backRegionUserRect[i].width / sca[0].dispSize);
      backRegionRect[i] = new Rectangle(xpos, ypos, xlength, ylength);
    }
  }
  public int setDisplayGap(int pixel)
  {
    return setDisplayGap(pixel, pixel);
  }
  public int setDisplayGap(int xPixel, int yPixel)
  {
    return setDisplayGap(xPixel, xPixel, yPixel, yPixel);
  }
  public int setDisplayGap(int xLeftPixel, int xRightPixel, int yTopPixel, int yBottomPixel)
  {
    if (xLeftPixel < 0 || xLeftPixel >= aFrame.histRect.width / 2) xLeftPixel = 0;
    if (xRightPixel < 0 || xRightPixel >= aFrame.histRect.width / 2) xRightPixel = 0;
    if (yTopPixel < 0 || yTopPixel >= aFrame.histRect.height / 2) yTopPixel = 0;
    if (yBottomPixel < 0 || yBottomPixel >= aFrame.histRect.height / 2) yBottomPixel = 0;
    fLeftPixel = xLeftPixel;
    fRightPixel = xRightPixel;
    fTopPixel = yTopPixel;
    fBottomPixel = yBottomPixel;
    scaleFrameDraw();
    return xLeftPixel;
  }
  protected void AveragingScaling(double df[], int start, int stop, int index)
  {
    int i, j, max;
    double maximum;
    if (averagingDepth > 0) // averaging
    {
      if (averagingLength == 0)
        NumberAveragingData = histo[index].npoints;
      else if (++averagingIndex == averagingDepth) averagingIndex = 0;
      if (averagingLength < averagingDepth)
      {
        if (averagingBuffer[averagingIndex].length < NumberAveragingData)
          averagingBuffer[averagingIndex] = new double[NumberAveragingData];
        averagingLength++;
        // calculate averaging exponential function
        totalWeight = 0;
        for (i = 0; i < averagingLength; i++)
          totalWeight += averageWeight[i];
      }
      max = histo[index].npoints < NumberAveragingData ? histo[index].npoints : NumberAveragingData;
      System.arraycopy(df, 0, averagingBuffer[averagingIndex], 0, max);
      if (averagingLength > 1) for (j = start; j < stop; j++)
      {
        if (j >= max) break;
        maximum = 0;
        for (i = 0; i < averagingLength; i++)
        {
          if (averagingMode == 0)
            maximum += averagingBuffer[i][j];
          else
            maximum += (averagingBuffer[i][j] * averageWeight[i]);
        }
        df[j] = maximum / (averagingMode == 0 ? averagingLength : totalWeight);
      }
    }
    if (yWAdataSize > 0 && histo[index].yScaleEnable)
    {
      max = histo[index].npoints < yWAdataSize ? histo[index].npoints : yWAdataSize;
      for (i = start; i < stop && i < max; i++)
        df[i] *= yWindowArray[i];
    }
    if (yRAdataSize > 0 && histo[index].yReferenceEnable)
    {
      max = histo[index].npoints < yRAdataSize ? histo[index].npoints : yRAdataSize;
      for (i = start; i < stop && i < max; i++)
        df[i] -= yReferenceArray[i];
    }
  }
  public int WeightFunction(Object WeightArray)
  {
    return WeightFunction(WeightArray, 0);
  }
  public int WeightFunction(Object WeightArray, int ArraySize)
  {
    int ndata;
    ndata = AcopHisto.getArrayLength(WeightArray);
    if (ndata <= 0) return -1;
    if (ArraySize > 0 && ArraySize < ndata) ndata = ArraySize;
    if (yWindowArray == null || yWASize < ndata)
    {
      yWindowArray = new double[ndata];
      yWASize = ndata;
    }
    AcopHisto.copyArray(yWindowArray, WeightArray, 0, ndata, ndata, 1);
    yWAdataSize = ndata;
    return 0;
  }
  public int ReferenceFunction(Object ReferenceArray)
  {
    return ReferenceFunction(ReferenceArray, 0);
  }
  public int ReferenceFunction(Object ReferenceArray, int ArraySize)
  {
    int ndata;
    ndata = AcopHisto.getArrayLength(ReferenceArray);
    if (ndata <= 0) return -1;
    if (ArraySize > 0 && ArraySize < ndata) ndata = ArraySize;
    if (yReferenceArray == null || yRASize < ndata)
    {
      yReferenceArray = new double[ndata];
      yRASize = ndata;
    }
    AcopHisto.copyArray(yReferenceArray, ReferenceArray, 0, ndata, ndata, 1);
    yRAdataSize = ndata;
    return 0;
  }
  public boolean IsErrorWindowOn()
  {
    return IsErrorWindowOn(-1, -1);
  }
  public boolean IsErrorWindowOn(int hDisplay)
  {
    return IsErrorWindowOn(hDisplay, -1);
  }
  public boolean IsErrorWindowOn(boolean turnON)
  {
    return IsErrorWindowOn(-1, turnON ? 1 : 0);
  }
  public boolean IsErrorWindowOn(int hDisplay, boolean turnON)
  {
    return IsErrorWindowOn(hDisplay, turnON ? 1 : 0);
  }
  private boolean IsErrorWindowOn(int hDisplay, int value)
  {
    boolean arayon;
    if (hDisplay < -1 || hDisplay >= n_display) return false; // out of range,
                                                              // -1 to set for
                                                              // default value
    if (value < 0 || value > 1) // reading
      return (hDisplay == -1 || histo[hDisplay] == null) ? errWindowOn : histo[hDisplay].errWindowEnable;
    arayon = value != 0 ? true : false;
    if (hDisplay != -1)
    {
      if (histo[hDisplay] == null) return false;
      histo[hDisplay].errWindowEnable = arayon;
      return histo[hDisplay].errWindowEnable;
    }
    errWindowOn = arayon; // set default value and all the rest
    for (int i = 0; i < n_display; i++)
    {
      if (histo[i] == null) break;
      histo[i].errWindowEnable = arayon;
    }
    return arayon;
  }
  public boolean IsWeighted(int hDisplay)
  {
    return IsWeighted(hDisplay, -1);
  }
  public boolean IsWeighted(int hDisplay, int value)
  {
    boolean arayon;
    if (hDisplay < -1 || hDisplay >= n_display) return false; // out of range,
                                                              // -1 to set for
                                                              // default value
    if (value < 0 || value > 1) // reading
      return (hDisplay == -1 || histo[hDisplay] == null) ? ScaleEnable : histo[hDisplay].yScaleEnable;
    arayon = value != 0 ? true : false;
    if (hDisplay != -1)
    {
      if (histo[hDisplay] == null) return false;
      histo[hDisplay].yScaleEnable = arayon;
      return histo[hDisplay].yScaleEnable;
    }
    ScaleEnable = arayon; // set default value and all the rest
    for (int i = 0; i < n_display; i++)
    {
      if (histo[hDisplay] == null) break;
      histo[hDisplay].yScaleEnable = arayon;
    }
    return arayon;
  }
  public boolean IsReferenced(int hDisplay)
  {
    return IsReferenced(hDisplay, -1);
  }
  public boolean IsReferenced(int hDisplay, int value)
  {
    boolean arayon;
    if (hDisplay < -1 || hDisplay >= n_display) return false; // out of range,
                                                              // -1 to set for
                                                              // default value
    if (value < 0 || value > 1)
      // reading
      return (hDisplay == -1 || histo[hDisplay] == null) ? ReferenceEnable : histo[hDisplay].yReferenceEnable;
    arayon = value != 0 ? true : false;
    if (hDisplay != -1)
    {
      if (histo[hDisplay] == null) return false;
      histo[hDisplay].yReferenceEnable = arayon;
      return histo[hDisplay].yReferenceEnable;
    }
    ReferenceEnable = arayon; // set default value and all the rest
    for (int i = 0; i < n_display; i++)
    {
      if (histo[i] == null) break;
      histo[i].yReferenceEnable = arayon;
    }
    return arayon;
  }
  public void SetZoom(boolean XMax, boolean XMin, boolean YMax, boolean YMin, double xmx, double xmn,
      double ymx, double ymn)
  {
    int dezoomFlag = 0, i;
    double[] storemin = new double[3];
    double[] storemax = new double[3];
    if (histo[m_histstart] == null || !aFrame.drawFlag) return;
    if (!XMax) xmx = sca[0].getMax();
    if (!XMin) xmn = sca[0].getMin();
    if (!YMax) ymx = sca[1].getMax();
    if (!YMin) ymn = sca[1].getMin();
    if (xmn >= xmx)
    {
      xmn = sca[0].usermin;
      xmx = sca[0].usermax;
    }
    if (ymn >= ymx)
    {
      ymn = sca[1].usermin;
      ymx = sca[1].usermax;
    }
    if ((zooming & 0x4) != 0)
    {
      dezoomFlag = 0;
      if (zoomIndex > 0) // compare size
      {
        for (i = 0; i < 3; i++)
        {
          storemin[i] = sca[i].getMin();
          storemax[i] = sca[i].getMax();
        }
        if (Math.abs((xmx - xmn) - (storemax[0] - storemin[0])) < AcopConst.zero_check
            && Math.abs((ymx - ymn) - (storemax[1] - storemin[1])) < AcopConst.zero_check) return;
        if ((xmx - xmn) > (storemax[0] - storemin[0]) || (ymx - ymn) > (storemax[1] - storemin[1]))
        {
          dezoomFlag = 1;
          if (zoomIndex == 1) // finish zoom
          {
            xmn = sca[0].usermin;
            xmx = sca[0].usermax;
            ymn = sca[1].usermin;
            ymx = sca[1].usermax;
          }
        }
      }
      if (dezoomFlag == 0 && zoomIndex < AcopConst.lengthZoom)
      {
        for (i = 0; i < 3; i++)
        {
          storemin[i] = sca[i].getMin();
          storemax[i] = sca[i].getMax();
        }
      }
    }
    sca[0].setDispscale(xmn, xmx);
    sca[1].setDispscale(ymn, ymx);
    if (sca[0].isOriginMaxMin() && sca[1].isOriginMaxMin())
    {
      isZoomed = false;
      if ((zooming & 0x4) != 0) zoomIndex = 0;
    }
    else
    {
      isZoomed = true;
      if ((zooming & 0x4) != 0)
      {
        if (dezoomFlag != 0)
        {
          zoomIndex--;
          for (i = 0; i < 3; i++)
            sca[i].setDispscale(bufferedMin[zoomIndex][i], bufferedMax[zoomIndex][i]);
          if (sca[0].log != 0) sca[0].setDispscale(Math.pow(10.0, sca[0].min), Math.pow(10.0, sca[0].max));
          if (sca[1].log != 0) sca[1].setDispscale(Math.pow(10.0, sca[1].min), Math.pow(10.0, sca[1].max));
          bufferedZoomRatio = "Z" + zoomIndex;
        }
        else if (zoomIndex < AcopConst.lengthZoom)
        {
          for (i = 0; i < 3; i++)
          {
            bufferedMin[zoomIndex][i] = storemin[i];
            bufferedMax[zoomIndex][i] = storemax[i];
          }
          zoomIndex++;
          bufferedZoomRatio = "Z" + zoomIndex;
        }
      }
    }
    zoomFlag = false;
    sca[0].ScaleToGrid();
    if (m_marker == 2) setmarkerflag(2); // recalculate marker array
      // prepareDraw(TRUE, -1, FALSE, nScaleText); // rescale and not set max
      // limit
    rescaleFlag = 1;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw(); // rescale and not set max limit
    yZoomRatio = "V" + (int) (sca[1].userSize / sca[1].dispSize + 0.5) + ":1";
    xZoomRatio = "H" + (int) (sca[0].userSize / sca[0].dispSize + 0.5) + ":1";
  }
  public int GetScaledCoordinates(Object Coordinates)
  {
    int arySize, i; // return up to 6 values: Left, Right, Bottom, Top,
                    // SecondaryBottom, SecondaryTop
    if (Coordinates == null) return 0;
    arySize = AcopHisto.getArrayLength(Coordinates);
    if (arySize == 0) return 0;
    if (arySize > 6) arySize = 6;
    double[] tmpData = new double[arySize];
    for (i = 0; i < arySize; i++)
      tmpData[i] = (i % 2 == 0) ? sca[i / 2].getMin() : sca[i / 2].getMax();
    arySize = AcopHisto.copyArray(tmpData, Coordinates, 0, arySize, arySize, 0);
    return arySize;
  }
  public int GetDrawnData(Object Yarray, Object Xarray, int Npoints, int StartIndex, int hDisplay)
  {
    if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
    return histo[hDisplay].GetDrawnData(Yarray, Xarray, Npoints, StartIndex, hDisplay);
  }
  public int GetDrawnData(Object Yarray, Object Xarray, int hDisplay, double xPosition, double yPosition)
  {
    int dataIndex;
    if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
    dataIndex = histo[hDisplay].getHistoIndex(xPosition, yPosition);
    return histo[hDisplay].GetDrawnData(Yarray, Xarray, 1, dataIndex, hDisplay);
  }
  private void setlimit()
  {
    isZoomed = false; // new change!
    if ((zooming & 0x4) != 0) zoomIndex = 0;
    for (int i = 0; i < 3; i++)
      sca[i].setscale();
  }
  // setup HistoRect... ...
  private void scaleframe()
  {
    Rectangle r = getBounds();
    fLeft = frameWidth + frameLeftOffset; // init 4 offset
    fRight = frameWidth + frameRightOffset;
    fTop = frameWidth + frameTopOffset;
    fBottom = frameWidth + frameBottomOffset;
    if (fLeft < 0)
      fLeft = 0; // check x
    else if (fLeft >= r.width) fLeft = r.width - 1;
    if (fRight < 0)
      fRight = 0;
    else if ((fRight + fLeft) >= r.width) fRight = r.width - fLeft - 1;
    if (fTop < 0)
      fTop = 0; // check y
    else if (fTop >= r.height) fTop = r.height - 1;
    if (fBottom < 0)
      fBottom = 0;
    else if ((fBottom + fTop) >= r.height) fBottom = r.height - fTop - 1;
    // titleRect.setBounds(r.x+fLeft, r.y, r.width-fLeft-fRight, fTop);
    // titleRect.setBounds(fLeft, 0, r.width-fLeft-fRight, fTop);
    titleRect.setBounds(0, 0, r.width, fTop);
    // histRect.setBounds(r.x+fLeft, r.y+fTop, r.width-fLeft-fRight,
    // r.height-fTop-fBottom);
    // aFrame.histRect.setBounds(fLeft, fTop, r.width-fLeft-fRight,
    // r.height-fTop-fBottom);
    aFrame.histRect.setBounds(fLeft + fLeftPixel, fTop + fTopPixel, r.width - fLeft - fRight - fLeftPixel
        - fRightPixel, r.height - fTop - fBottom - fTopPixel - fBottomPixel);
    aFrame.zoomIcon.setBounds(aFrame.histRect.x + aFrame.histRect.width - aFrame.ZoomExtent,
        aFrame.histRect.y + 1, aFrame.ZoomExtent - 1, aFrame.ZoomExtent - 1);
    // histRoundRect.setBounds(aFrame.histRect.x - 1,aFrame.histRect.y -
    // 1,aFrame.histRect.width + 2,aFrame.histRect.height + 2);
    histRoundRect.setBounds(aFrame.histRect.x - fLeftPixel - 1, aFrame.histRect.y - fTopPixel - 1,
        aFrame.histRect.width + fLeftPixel + fRightPixel + 2, aFrame.histRect.height + fTopPixel
            + fBottomPixel + 2);
    // xRect.setBounds(r.x, r.y+r.height-fBottom, r.width, fBottom);
    xRect.setBounds(0, r.height - fBottom, r.width, fBottom);
    setTickRectangle(0);
    // yRect.setBounds(r.x, r.y, fLeft, r.height);
    yRect.setBounds(0, 0, fLeft, r.height);
    // yAxisRect.setBounds(r.x+r.width-fRight, r.y, fRight, r.height);
    yAxisRect.setBounds(r.width - fRight, 0, fRight, r.height);
    setTickRectangle(1);
    tagRect.setBounds(histRoundRect); // tagging
    HistRectleftReference = aFrame.histRect.x + leftPixel;
    listTextBox
        .setBounds(aFrame.histRect.x, aFrame.histRect.y, aFrame.histRect.width, aFrame.histRect.height);
  }
  // setup which rectangle used for ticks
  private void setTickRectangle(int i)
  {
    Rectangle tmpRect;
    if (sca[i].leftBottom) // take lower Rect for x and left Rect for y
    {
      sca[i].ticksRect = i == 0 ? xRect : yRect;
      tmpRect = i == 0 ? titleRect : yAxisRect;
    }
    else
    {
      sca[i].ticksRect = i == 0 ? titleRect : yAxisRect;
      tmpRect = i == 0 ? xRect : yRect;
    }
    if (i == 1) // secondasy Y ticks and label area
    {
      sca[2].ticksRect = tmpRect;
      sca[2].labelRect = sca[i].leftBottom != sca[i].leftBottLabel ? sca[i].ticksRect : tmpRect;
      sca[2].leftBottom = sca[i].leftBottom ? false : true;
      sca[2].leftBottLabel = sca[i].leftBottLabel ? false : true;
    }
    sca[i].labelRect = sca[i].leftBottom == sca[i].leftBottLabel ? sca[i].ticksRect : tmpRect;
  }
  private boolean drawOneHist(int num)
  {
    Graphics2D a = (Graphics2D) getGraphics();
    if (a == null) return false; // currently not displayable!!
    a.setClip(histRoundRect.x, histRoundRect.y, histRoundRect.width, histRoundRect.height);
    a.translate(aFrame.histRect.x, aFrame.histRect.y);
    histo[num].drawhist(a);
    a.translate(-aFrame.histRect.x, -aFrame.histRect.y);
    a.dispose();
    return true;
  }
  protected void prepareDraw()
  {
    double xtemp, ytemp;
    int i, j, start, ende, ret;
    if (randomData == true && sca[0].usermax > sca[0].usermin && sca[1].usermax > sca[1].usermin)
    {
      if (RandomInitialized == false)
      {
        for (i = 0; i < 512; i++)
          g_rdata[i] = Math.sin(i * 6.2832 / 512.);
        RandomInitialized = true;
      }
      xtemp = sca[0].userSize + 1; // one more point for the right edge!
      if (xtemp < 1.0) xtemp = 1.0;
      j = (int) xtemp;
      double[] ppvdata = new double[j];
      for (i = 0; i < j; i++)
        ppvdata[i] = sca[1].usermin + (1 + g_rdata[j >= 512 ? i % 512 : (int) (i * 512 / xtemp) % 512])
            * sca[1].userSize / 2;
      if (histo[0] == null)
      {
        histo[0] = new AcopHisto(this, 0);
      }
      if (histo[0].setHisto(ppvdata, null, null, null, 0, 0, foreColor) == 0)
      {
        if (wrapAround) histo[0].getMaxWindow();
        aFrame.drawFlag = true;
        histo[0].displayON = 1;
        histo[0].dismode = displayMode;
        histo[0].xext = XExtent;
        histo[0].yext = YExtent;
        histo[0].colorfilled = colorFilled;
        loadXYindex = 0;
        lastDisp = 0;
      }
    }
    if (rescaleFlag == 2)
    {
      setlimit(); // load m_xmin... ...
      sca[0].ScaleToGrid();
    }
    if (rescaleFlag > 0)
    {
      for (i = 0; i < 3; i++)
        sca[i].xyscale(true); // set new min max
      convertBackgroundRegion(false);
    }
    if (histIndex < 0 || histIndex >= n_display)
    {
      start = 0;
      ende = n_display;
    }
    else
    {
      start = histIndex;
      ende = histIndex + 1;
    }
    if (aFrame.drawFlag) for (i = start; i < ende; i++)
    {
      if (histo[i] == null) break;
      if (histo[i].displayON == 0 && i != m_histstart) continue;
      // if ( disp[n]->dismode >= AcopConst.mode_textbox ) continue;
      // scale screen: xleft, xright and dxwidth! getOxleftright(0);
      if (i == m_histstart) aFrame.getOxleftright(histo[i], sca[0]);
      // find wrapindex
      if (wrapAround && rescaleFlag != 0 && sca[0].log == 0) histo[i].setwrapindex();
      histo[i].setExtent();
      if (i == m_histstart)
      {
        if (histo[i].dismode == AcopConst.mode_textbox)
          listTextBox.removeAll();
        else
          listTextBox.setVisible(false);
      }
      // map to screen coordinate
      histo[i].mapScreen(-1);
    }
    if (rescaleTextFlag > 0) for (i = 0; i < n_text; i++)
    {
      if (ptext[i] == null) break;
      ptext[i].rescaleText(rescaleTextFlag);
    }
    // if ( aFrame.drawFlag == false )
    // {
    // aFrame.xleft = 0;
    // aFrame.xright = aFrame.histRect.width;
    // aFrame.dxwidth =aFrame.xright - aFrame.xleft;
    // aFrame.absxleft = aFrame.xleft + aFrame.histRect.x;
    // return;
    // }
    if (rescaleFlag > 0 && cursorStay > 0)
    {
      mMovePoint.x = sca[0].getScreenPosition(cursorXposition);
      mMovePoint.y = sca[1].getScreenPosition(cursorYposition);
    }
    if (sca[1].log != 0)
      yzero = aFrame.histRect.height;
    else if (sca[1].max >= 0 && sca[1].min <= 0)
      yzero = (int) (aFrame.histRect.height * (1 + sca[1].min / sca[1].dispSize));
    else
      yzero = (int) ((sca[1].max > 0 && sca[1].min > 0) ? aFrame.histRect.height : 0);
    if (repainHisto == true && drawTicks == false && rescaleFlag == 0 && rescaleTextFlag == 0
        && start + 1 == ende)
    {
      if (drawOneHist(start) == false) repaintHisto();
    }
    else if (rescaleFlag > 0 || drawTicks)
      repaint();
    // else if ( start == ende - 1 && repainHisto == false )
    // histo[start].drawhist(null);
    else
      repaintHisto();
    rescaleTextFlag = 0;
    rescaleFlag = 0;
    drawTicks = false;
    histIndex = -1;
    repainHisto = false;
  }
  public Acop()
  {
    // {{INIT_CONTROLS
    setLayout(null);
    setSize(502, 350);
    captionPosition = 1;
    captionChanged = true;
    keepColor = Color.gray;
    keepWidth = 1;
    keepStyle = AcopConst.PS_SOLID;
    m_tagColor = Color.cyan;
    m_tagging = false;
    pTagColorArray = null;
    nElement = 0;
    m_marker = 0;
    saveMarkerWidth = 0;
    m_markerColor = Color.black;
    m_markerMode = 0;
    m_markerStyle = AcopConst.PS_SOLID;
    m_markerWidth = 1;
    m_markerXExtent = -1;
    m_markerYExtent = -1;
    m_cursorMarkerColor = Color.black;
    m_cursorMarkerMode = 0;
    m_cursorMarkerStyle = AcopConst.PS_SOLID;
    m_cursorMarkerWidth = 1;
    cursorMarkerStroke = AcopConst.createStroke(m_cursorMarkerWidth, m_cursorMarkerStyle);
    m_cursorMarkerXExtent = -1;
    m_cursorMarkerYExtent = -1;
    mMovePoint.setLocation(-1, -1);
    mOffsetMovePoint.setLocation(-1, -1);
    cursorStay = 0;
    cursorXPercent = -1;
    cursorYPercent = -1;
    cursorMarkerFlag = 0;
    cursorix = 0;
    cursoriy = 0;
    cursorwx = 0;
    cursorwy = 0;
    m_errorColor = Color.red;
    colorFilled = 1;
    averagingMode = 0;
    averagingDepth = 0;
    averagingIndex = 0;
    averagingLength = 0;
    NumberAveragingData = 0;
    for (int i = 0; i < AcopConst.N_DEF_DISPLAY; i++)
      averageWeight[i] = Math.exp((double) i);
    FFT = 0;
    printScreenPosition = 0;
    for (int i = 0; i < 3; i++)
    {
      if (i < 2) axis[i] = new AcopAxis(this, i);
      sca[i] = new AcopScale(this, i == 0 ? true : false);
      // load pointer into AcopScale class
      sca[i].ticks = -1;
      sca[i].fineTicks = 1;
      sca[i].grid = false;
      sca[i].leftBottom = i < 2 ? true : false;
      sca[i].bestScale = false;
      sca[i].ticktext = true;
      sca[i].log = 0;
      sca[i].xtime = 0;
      sca[i].tickLabelForeColor = Color.gray;
      sca[i].leftBottLabel = true;
      sca[i].OnFlag = i < 2 ? true : false;
      sca[i].setUserscale(i == 0 ? 0 : -100, 100);
    }
    listTextBox = new java.awt.List();
    this.add(listTextBox);
    listTextBox.setVisible(false);
    nBackRegions = 0;
    changeScaleWidth = 0;
    invert = false;
    XShift = 0;
    XScale = 1;
    YShift = 0;
    YScale = 1;
    leftPixel = 0;
    RandomInitialized = false;
    randomData = Beans.isDesignTime();
    randomText = Beans.isDesignTime();
    frameWidth = 30;
    frameLeftOffset = 0;
    frameRightOffset = 0;
    frameTopOffset = 0;
    frameBottomOffset = 0;
    graphStyle = 0;
    aFrame.leftTimeLabel = true;
    aFrame.histogramPosition = 1;
    aFrame.frameForeColor = Color.gray;
    aFrame.frameFont = new Font("MonoSpaced", Font.PLAIN, 12);
    caption = "test";
    displayMode = AcopConst.mode_polyline; // AcopConst.mode_histogram;
    e_xmin = 0;
    e_xmax = 100;
    drawWidth = 1; // 1 pixel
    drawStyle = AcopConst.PS_SOLID;// DASH_DOT ;//AcopConst.PS_SOLID;
    e_ymin = -100;
    e_ymax = 100;
    // penLine = new BasicStroke(3);
    m_lock = 0;
    screenDepth = 20;
    n_display = screenDepth;
    textDepth = 20;
    n_text = textDepth; // copConst.MAX_TEXT;
    m_filled = 0;
    wrapxmin = -1.7e+308;
    wrapxmax = 1.7e+308; // wrap x range
    zoomIndex = 0;
    zoomLogFlag = 0;
    zooming = 3;
    isZoomed = false;
    zoomFlag = false;
    reuseScreen = false;
    reuseText = false;
    XExtent = 0;
    YExtent = 0;
    xlabelRotation = 0;
    foreColor = getForeground();
    wrapAround = false;
    printTextStickyAttribute = 0;
    printTextLocation = 0;
    printTextRotation = 0;
    LeadingEdgeColor = getForeground();
    LeadingEdgeGapSize = 0;
    LeadingEdgeMotion = 0;
    LeadingEdgeMode = 0;
    LeadingEdgeWidth = 1;
    LeadingEdgeStyle = AcopConst.PS_SOLID;
    LeadingEdgeXExtent = -1;
    LeadingEdgeYExtent = -1;
    yRASize = yRAdataSize = 0;
    yWASize = yWAdataSize = 0;
    fLeft = 0;
    fRight = 0;
    fTop = 0;
    fBottom = 0;
    fLeftPixel = 0;
    fRightPixel = 0;
    fTopPixel = 0;
    fBottomPixel = 0;
    if ((zooming & 0x7) != 0) setZoomingWindow(zooming & 0x4);
    scaleFrameDraw();
    if (Beans.isDesignTime() && randomData == true)
    {
      prepareDraw();
      // System.out.println("DesignTime and RandomData");
    }
    // if ( randomData == true ) prepareDraw();
    enableEvents(AWTEvent.MOUSE_EVENT_MASK | AWTEvent.MOUSE_MOTION_EVENT_MASK | AWTEvent.COMPONENT_EVENT_MASK);
    // }}
  }
  // {{DECLARE_CONTROLS
  // }}
  public int LockCursorMarker(boolean Enable)
  {
    return LockCursorMarker(Enable, false, 0, false, 0);
  }
  public int LockCursorMarker(boolean Enable, double Xposition, double Yposition)
  {
    return LockCursorMarker(Enable, true, Xposition, true, Yposition);
  }
  public int LockCursorMarker(boolean Enable, boolean xInput, double Xposition, boolean yInput,
      double Yposition)
  {
    int on;
    if (m_cursorMarkerMode == 0) return -1; // has to turn mode on first!
    on = Enable ? 1 : 0;
    cursorStay = on;
    if (cursorStay > 0)
    {
      if (xInput)
        mMovePoint.x = sca[0].getScreenPosition(Xposition);
      else
        Xposition = sca[0].getUserPosition(mMovePoint.x);
      if (yInput)
        mMovePoint.y = sca[1].getScreenPosition(Yposition);
      else
        Yposition = sca[1].getUserPosition(mMovePoint.y);
      cursorXposition = Xposition;
      cursorYposition = Yposition;
    }
    if (aFrame.drawFlag) repaintHisto();
    return on;
  }
  private void drawCursorMarker(Graphics2D g2d, Point point)
  {
    Rectangle Cliprect = null;
    int initFlag = g2d == null ? 0 : 1;
    if (g2d == null) // called from mouse move, first map and clip, then remove
                      // previous line first
    {
      g2d = (Graphics2D) getGraphics();
      Cliprect = g2d.getClipBounds();
      if (Cliprect != null)
      {
        if (Cliprect.intersects(histRoundRect) == false) return;
      }
    }
    g2d.setXORMode(m_cursorMarkerColor);
    // g2d.setColor(m_cursorMarkerColor);
    g2d.setStroke(cursorMarkerStroke);
    if (initFlag == 0) // called from mouse move, first map and clip, then
                        // remove previous line first
    {
      g2d.clipRect(histRoundRect.x, histRoundRect.y, histRoundRect.width, histRoundRect.height);
      // g2d.translate(aFrame.histRect.x, aFrame.histRect.y);
      if (cursorMarkerFlag != 0) // if already onscreen, remove previous line
                                  // first
      {
        if ((m_cursorMarkerMode & 0x2) != 0)
          g2d.drawLine(cursorwy, cursorwx - cursoriy, cursorwy, cursorwx + cursoriy);
        if ((m_cursorMarkerMode & 0x1) != 0)
          g2d.drawLine(cursorwy - cursorix, cursorwx, cursorwy + cursorix, cursorwx);
      }
    }
    // calculate new position
    cursorwx = point.y;
    cursorwy = point.x;
    if (initFlag != 0)
    {
      cursorwx -= aFrame.histRect.x;
      cursorwy -= aFrame.histRect.y;
    }
    if ((m_cursorMarkerMode & 0x1) != 0)
    {
      if (initFlag != 0)
      {
        if (cursorXPercent < 0)
        {
          if (m_cursorMarkerXExtent < 0)
            cursorXPercent = 1;
          else
            cursorXPercent = ((sca[0].log != 0) ? Math.log(m_cursorMarkerXExtent) / Math.log(10)
                : m_cursorMarkerXExtent)
                / (sca[0].tick_max - sca[0].tick_min) / 2;
        }
        cursorix = (int) (aFrame.histRect.width * cursorXPercent);
      }
      g2d.drawLine(cursorwy - cursorix, cursorwx, cursorwy + cursorix, cursorwx);
    }
    if ((m_cursorMarkerMode & 0x2) != 0)
    {
      if (initFlag != 0)
      {
        if (cursorYPercent < 0)
        {
          if (m_cursorMarkerYExtent < 0)
            cursorYPercent = 1;
          else
            cursorYPercent = ((sca[1].log != 0) ? Math.log(m_cursorMarkerYExtent) / Math.log(10)
                : m_cursorMarkerYExtent)
                / sca[1].dispSize / 2;
        }
        cursoriy = (int) (aFrame.histRect.height * cursorYPercent);
      }
      g2d.drawLine(cursorwy, cursorwx - cursoriy, cursorwy, cursorwx + cursoriy);
    }
    g2d.setPaintMode();
    if (initFlag == 0)
    {
      // g2d.translate(-aFrame.histRect.x, -aFrame.histRect.y);
      g2d.setClip(Cliprect);
      g2d.dispose();
    }
    if (initFlag != 0)
    {
      cursorwx += aFrame.histRect.x;
      cursorwy += aFrame.histRect.y;
    }
    cursorMarkerFlag = 1; // cursor is on screen!
  }
  private void setZoomingWindow(int bufferedZoomFlag)
  {
    aFrame.ZoomExtent = bufferedZoomFlag != 0 ? 20 : 36;
    // zoom icon indicator
    aFrame.zoomIcon.setBounds(aFrame.histRect.x + aFrame.histRect.width - aFrame.ZoomExtent,
        aFrame.histRect.y + 1, aFrame.ZoomExtent - 1, aFrame.ZoomExtent - 1);
  }
  public java.lang.String GetPrintedText(double[] leftBottom, double[] size, double[] position, int hText)
  {
    if (hText < 0 || hText >= n_text || ptext[hText] == null) return "Input Error!";
    return ptext[hText].GetPrintedText(leftBottom, size, position);
  }
  public boolean IsZoomed()
  {
    return this.isZoomed;
  }
  public int GetHistogramOffsetLeft()
  {
    return aFrame.xleft;
  }
  public int GetHistogramOffsetRight()
  {
    return aFrame.histRect.width - aFrame.xright;
  }
  public double GetScaleLeft()
  {
    return sca[0].getMin();
  }
  public double GetScaleRight()
  {
    return sca[0].getMax();
  }
  public double GetScaleTop()
  {
    return sca[1].getMax();
  }
  public double GetScaleBottom()
  {
    return sca[1].getMin();
  }
  private int loadAxis(int index, boolean AxisOn, Object PositionArray, int ArraySize, Color[] ColorArray,
      int[] StyleArray, int[] WidthArray)
  {
    int ret;
    ret = axis[index].axisON != AxisOn ? 1 : 0;
    axis[index].axisON = AxisOn;
    if (ArraySize < 1 && ArraySize != -1) return -1; // wrong input
    if (ArraySize != -1)
      ret += axis[index].loadData(ArraySize, PositionArray, ColorArray, StyleArray, WidthArray);
    if (ret != 0 && aFrame.drawFlag) repaintHisto();
    return 0;
  }
  public int XAxis(boolean AxisOn)
  {
    return loadAxis(0, AxisOn, null, -1, null, null, null);
  }
  public int YAxis(boolean AxisOn)
  {
    return loadAxis(1, AxisOn, null, -1, null, null, null);
  }
  public int XAxis(boolean AxisOn, Object PositionArray, int ArraySize, Color[] ColorArray, int[] StyleArray,
      int[] WidthArray)
  {
    return loadAxis(0, AxisOn, PositionArray, ArraySize, ColorArray, StyleArray, WidthArray);
  }
  public int YAxis(boolean AxisOn, Object PositionArray, int ArraySize, Color[] ColorArray, int[] StyleArray,
      int[] WidthArray)
  {
    return loadAxis(1, AxisOn, PositionArray, ArraySize, ColorArray, StyleArray, WidthArray);
  }
  public int RefreshScreen(Object Yarray, int hDisplay, int Npoints, int StartIndex, Object Xarray)
  {
    if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
    return histo[hDisplay].updateScreen(false, Yarray, Npoints, StartIndex, Xarray);
  }
  public int RefreshScreen(Object Yarray, int hDisplay, Object Xarray)
  {
    if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
    return histo[hDisplay].updateScreen(false, Yarray, -1, -1, Xarray);
  }
  public int RefreshScreen(Object Yarray, int hDisplay)
  {
    if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
    return histo[hDisplay].updateScreen(false, Yarray, -1, -1, null);
  }
  public int AppendScreen(Object Yarray, int hDisplay, int Npoints, int StartIndex, Object Xarray)
  {
    if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
    return histo[hDisplay].updateScreen(true, Yarray, Npoints, StartIndex, Xarray);
  }
  public int AppendScreen(Object Yarray, int hDisplay, Object Xarray)
  {
    if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
    return histo[hDisplay].updateScreen(true, Yarray, -1, -1, Xarray);
  }
  public int AppendScreen(Object Yarray, int hDisplay)
  {
    if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
    return histo[hDisplay].updateScreen(true, Yarray, -1, -1, null);
  }
  public int Draw(Object ydata)
  {
    return Draw(ydata, null, null, null, 0, 0);
  }
  public int Draw(Object ydata, Object xdata)
  {
    return Draw(ydata, xdata, null, null, 0, 0);
  }
  public int Draw(Object ydata, Object xdata, Object disable)
  {
    return Draw(ydata, xdata, disable, null, 0, 0);
  }
  public int Draw(Object ydata, Object xdata, Object disable, java.lang.String[] xlabel)
  {
    return Draw(ydata, xdata, disable, xlabel, 0, 0);
  }
  public int Draw(Object ydata, Object xdata, Object disable, java.lang.String[] xlabel, int ArraySize,
      int MaxNumber)
  {
    int i, tmp;
    if (m_lock == n_display) return -1; // no free slot to draw
    // this slot should not be overwrite
    if (aFrame.drawFlag == true && histo[loadXYindex] != null && histo[loadXYindex].displayON == 1)
    {
      // find next free slot
      for (i = loadXYindex + 1, tmp = 0; tmp < n_display; i++, tmp++)
      {
        if (i == n_display)
        {
          i = 0;
          m_filled = 1;
        }
        if (histo[i] == null || (histo[i].lockFlag == 0 && histo[i].displayON == 0))
          break;
        else if (reuseScreen && histo[i].lockFlag == 0) break;
      }
      if (tmp < n_display)
        loadXYindex = i;
      else
        return -2; // no free slot to draw
    }
    if (histo[loadXYindex] == null)
    {
      histo[loadXYindex] = new AcopHisto(this, loadXYindex);
      if (loadXYindex == 0 && aFrame.drawFlag == false && textFlag == true)
        rescaleTextFlag = AcopConst.NEW_PRINT_WINDOW;
      if (loadXYindex == 0 && textFlag == false) // first time;
      {
      }
    }
    if (histo[loadXYindex].setHisto(ydata, xdata, disable, xlabel, ArraySize, MaxNumber, foreColor) != 0)
      return -3;
    // if ( aFrame.drawFlag == false && textFlag == false ) drawTicks = true;
    if (aFrame.drawFlag == false)
      drawTicks = true;
    else
      drawTicks = false;
    // if ( histo[0].displayON != 0 ) repainHisto = true; // it was On
    if (aFrame.drawFlag == true && histo[loadXYindex].displayON == 0) repainHisto = true; // it
                                                                                          // was
                                                                                          // On
    aFrame.drawFlag = true;
    histo[loadXYindex].displayON = 1;
    histo[loadXYindex].dismode = displayMode;
    histo[loadXYindex].xext = XExtent;
    histo[loadXYindex].yext = YExtent;
    histo[loadXYindex].colorfilled = colorFilled;
    if (m_keep == 0)
    {
      if (m_filled != 0 && m_lock == 0) // no refrence!
      {
        m_histstart = loadXYindex + 1;
        if (m_histstart >= n_display) m_histstart = 0;
      }
    }
    else
    // move start pointer, change lasthist to keeppen
    {
      if (m_numberkeep == m_keep)
      {
        histo[m_keepstart].displayON = 0; // turn off one
        if (m_lock == 0) for (i = ++m_keepstart;; i++) // find histstart
          {
            if (i >= n_display) i = 0;
            if (i == loadXYindex) break;
            if (histo[i].displayON != 0)
            {
              m_histstart = i;
              break;
            }
          }
      }
    }
    if (wrapAround)
      histo[loadXYindex].getMaxWindow();
    else
      histo[loadXYindex].wrapindex = 0;
    histIndex = loadXYindex;
    lastDisp = loadXYindex;
    prepareDraw();
    m_keep = 0;
    return (loadXYindex);
  }
  public void ClearScreen()
  {
    ClearScreen(-1, 0);
  }
  public void ClearScreen(int hDisplay)
  {
    ClearScreen(hDisplay, 0);
  }
  public void ClearScreen(int hDisplay, int KeepDepth)
  {
    int i, j, num, tmp;
    if (aFrame.drawFlag == false) return;
    m_keep = KeepDepth; // number of kepted histogram
    if (m_keep < 0 || m_keep >= n_display) m_keep = 0;
    num = hDisplay; // histo number to be turned off
    if (num < 0 || num >= n_display) num = -1;
    // RedrawTextHist = 1;
    if (m_keep == 0 && num < 0) // turn all off, if not locked
    {
      if (m_lock == 0) // no locked histo, then reset
      {
        if (textFlag == false) drawTicks = true;
        aFrame.drawFlag = false;
        m_filled = 0;
        m_histstart = 0;
        loadXYindex = 0; // reset index, make displayflag to FALSE
        // if ( modeChange == TRUE )
        // {
        // drawTicks = TRUE;
        // modeChange = FALSE;
        // }
      }
      for (i = 0; i < n_display; i++)
        if (histo[i] != null && histo[i].lockFlag == 0) histo[i].displayON = 0;
    }
    else
    {
      if (num >= 0) // clear hist num
      {
        if (histo[num] != null && histo[num].displayON != 0 && histo[num].lockFlag == 0)
        {
          histo[num].displayON = 0;
          if (num == m_histstart) // change m_histstart to next visible histo
          {
            for (i = 0, j = m_histstart; i < n_display; i++, j++) // is all
                                                                  // histo off?
            {
              if (j >= n_display) j = 0;
              if (histo[j] != null && histo[j].displayON != 0)
              {
                m_histstart = num;
                break;
              }
            }
          }
        }
        else if (m_keep == 0) return; // already off -> nothing changed
      }
      if (m_keep > n_display - m_lock) m_keep = n_display - m_lock;
      if (m_keep != 0) // keep # of background histograms
      { // find keep start
        for (m_numberkeep = tmp = j = 0, i = loadXYindex + 1; j < m_keep;)
        {
          if (--i < 0) i += n_display;
          if (histo[i] == null || histo[i].lockFlag == 0) j++; // keep empty or
                                                                // notlocked
          if (histo[i] != null && histo[i].displayON != 0)
          {
            tmp++; // # of displayON
            if (histo[i].lockFlag == 0)
            {
              // turn keep to keep-pen, -color....
              histo[i].keephisto();
              m_numberkeep++;
              m_keepstart = i; // keephisto start #
              // hide tagging display for this keeped histogram!
              if (histo[i].dismode == AcopConst.mode_histogram
                  || histo[i].dismode == AcopConst.mode_histogram_rastoring
                  || histo[i].dismode == AcopConst.mode_dots || histo[i].dismode == AcopConst.mode_rectangle
                  || histo[i].dismode == AcopConst.mode_circle) histo[i].tagHist = 0;
            }
          }
        }
        if (m_lock == 0 && m_numberkeep != 0) m_histstart = m_keepstart; // first
                                                                          // visible
                                                                          // histo
        aFrame.drawFlag = (m_lock != 0 || tmp != 0) ? true : false;
        if (textFlag == false && aFrame.drawFlag == false) drawTicks = true;
        for (j = loadXYindex + 1;; j++) // turn rest off
        {
          if (j >= n_display) j = 0;
          if (j == i) break;
          if (histo[j] != null && histo[j].lockFlag == 0) histo[j].displayON = 0;
        }
      }
      else
      { // is all histo off?
        for (i = 0, j = m_histstart; i < n_display; i++, j++)
        {
          if (j >= n_display) j = 0;
          if (histo[j] != null && histo[j].displayON != 0) break;
        }
        if (i == n_display)
        {
          aFrame.drawFlag = false;
          if (textFlag == false) drawTicks = true;
        }
      }
    }
    if (drawTicks || histo[m_histstart].dismode >= AcopConst.mode_textbox
        || (aFrame.drawFlag == false && textFlag == false))
      this.repaint();
    else
      repaintHisto();
  }
  public void RecallScreen(int hDisplay)
  {
    int num;
    num = hDisplay; // number to be turned on
    if (num < 0 || num >= n_display) return;
    if (histo[num] == null) return;
    if (aFrame.drawFlag == false && m_lock == 0) m_histstart = num;
    if (histo[num].displayON == 0)
    {
      // RedrawTextHist = 1;
      histo[num].displayON = 1;
      aFrame.drawFlag = true;
      if (histo[num].dismode == AcopConst.mode_histogram
          || histo[num].dismode == AcopConst.mode_histogram_rastoring
          || histo[num].dismode == AcopConst.mode_dots || histo[num].dismode == AcopConst.mode_rectangle
          || histo[num].dismode == AcopConst.mode_circle)
      { // bring to top histogram!
        histo[num].tagHist = 1;
        lastTagHisto = num;
      }
      lastDisp = num;
      // find wrapindex
      if (wrapAround && sca[0].log == 0) histo[num].setwrapindex();
      // prepareDraw(FALSE,num,FALSE, 0);
      if (drawTicks)
      {
        this.repaint();
        drawTicks = false;
      }
      else
        drawOneHist(num);
    }
  }
  public long LockScreen(int LockOn, int hDisplay)
  {
    int num, ende, lock, i;
    lock = LockOn; // lock all the histo you see! (<0, 0, >0)
    num = hDisplay; // or unlock them as user requested
    if (num < 0 || num >= n_display)
    {
      num = 0;
      ende = n_display - 1;
    }
    else
    {
      ende = num;
    }
    if (lock < 0) // return current lock flag (ON or OFF) -> read only
    {
      if (num != ende)
        return m_lock; // number of locked histos
      else
        return histo[num] != null ? histo[num].lockFlag : -1;
    }
    else if (lock > 0 && aFrame.drawFlag == false) return -1; // nothing to lock
    for (i = num; num <= ende; num++)
    {
      if (histo[num] == null) continue;
      if (lock == 0) // unlock
      {
        if (histo[num].lockFlag == 1)
        {
          histo[num].lockFlag = 0;
          m_lock--;
        }
      }
      else if (histo[num].displayON != 0) // lock it if on the screen
      {
        if (histo[num].lockFlag == 0)
        {
          histo[num].lockFlag = 1;
          // first locked as histstart
          if (m_lock++ == 0 && num != m_histstart) m_histstart = num;
        }
      }
    }
    return (i != ende) ? m_lock : (histo[num] == null ? 0 : histo[ende].lockFlag);
  }
  public int PrintText(java.lang.String Text)
  {
    return callPrintText(Text, 0, 0, false);
  }
  public int PrintText(java.lang.String Text, double Xposition, double Yposition)
  {
    return callPrintText(Text, Xposition, Yposition, true);
  }
  protected int callPrintText(java.lang.String Text, double Xposition, double Yposition, boolean positionFlag)
  {
    int resca, i, firstDraw;
    if (Text.indexOf(13) == 0) return -1; // linefeed in the begining
    // the current visible slot should not be overwrite
    if (textFlag == true && ptext[loadTextIndex] != null && ptext[loadTextIndex].textON == true)
    {
      // find next free slot
      for (i = loadTextIndex + 1, resca = 0; resca < n_text; i++, resca++)
      {
        if (i == n_text) i = 0;
        if (ptext[i] == null)
        {
          ptext[i] = new AcopText(this);
          break;
        }
        else if (ptext[i].textON == false)
          break;
        else if (reuseText) break;
      }
      if (resca < n_text)
      {
        loadTextIndex = i;
      }
      else
      {
        return -1; // no free slot to prntText
      }
    }
    firstDraw = 0;
    if (ptext[loadTextIndex] == null)
    {
      ptext[loadTextIndex] = new AcopText(this);
      if (loadTextIndex == 0 && aFrame.drawFlag == false)
      {
        firstDraw = 1;
        setlimit(); // load m_xmin... ...
        sca[0].ScaleToGrid();
        for (i = 0; i < 3; i++)
          sca[i].xyscale(true); // set new min max
        scaleframe();
        aFrame.xleft = 0;
        aFrame.xright = aFrame.histRect.width;
        aFrame.dxwidth = aFrame.xright - aFrame.xleft;
        aFrame.absxleft = aFrame.xleft + aFrame.histRect.x;
      }
    }
    if (positionFlag == false) // load last positions
    {
      Xposition = lastTextx;
      Yposition = lastTexty;
    }
    if (ptext[loadTextIndex].PrintText(Text, Xposition, Yposition, foreColor, getFont()) == 0)
    {
      // i = loadTextIndex;
      // if ( ++loadTextIndex == n_text ) loadTextIndex = 0;
      // return i;
      // store last positions
      lastTextx = ptext[loadTextIndex].lastTextx;
      lastTexty = ptext[loadTextIndex].lastTexty;
      if (firstDraw != 0) repaint();
      // resca = loadTextIndex;
      // if ( ++loadTextIndex == n_text ) loadTextIndex = 0;
      // if ( disp[0] == 0 && scalecall < 2 ) {
      // InvalidateControl(NULL); // draw ticks and grid...if no histo at all
      // scalecall = 2;
      // }
      return (loadTextIndex);
    }
    return -1;
  }
  public void ClearText()
  {
    ClearText(-1);
  }
  public void ClearText(int hText)
  {
    int start, ende, i, cnt;
    start = hText;
    if (start < 0 || start >= n_text)
    {
      start = 0;
      ende = n_text - 1;
    }
    else
      ende = start;
    for (cnt = 0, i = 0; i < n_text; i++)
    {
      if (ptext[i] == null) continue;
      if (ptext[i].textON == false) continue;
      if (i >= start && i <= ende)
      {
        ptext[i].textON = false;
        if (ptext[i].outside == false)
          this.repaint(ptext[i].textRect.x, ptext[i].textRect.y, ptext[i].textRect.width,
              ptext[i].textRect.height);
      }
      else
        cnt++;
    }
    textFlag = cnt != 0 ? true : false;
    if (textFlag == false)
    {
      // scalecall = 0;
      if (aFrame.drawFlag == false)
      {
        this.repaint();
        drawTicks = true;
      }
    }
    if (start != ende) loadTextIndex = 0;
  }
  public void RecallText(int hText)
  {
    int start;
    start = hText;
    if (start < 0 || start >= n_text) return;
    if (ptext[start] == null || ptext[start].textON == true) return;
    // if ( ptext[start].moveable && ptext[start].rescaled ) rescaleText(start,
    // ptext[start]->moveable, FALSE, ptext[start]->scalable);
    textFlag = true;
    ptext[start].textON = true;
    ptext[start].rescaleText(0); // use intern flag
    if (ptext[start].outside == true) return;
    if (drawTicks)
    {
      this.repaint();
      drawTicks = false;
    }
    else
      ptext[start].printUserText(null);
  }
  public int RefreshText(java.lang.String Text, int hText)
  {
    if (hText < 0 || hText >= n_text || ptext[hText] == null) return -1;
    ptext[hText].RefreshText(Text);
    return hText;
  }
  public void setAveragingDepth(int averagingDepth)
  {
    if (this.averagingDepth == averagingDepth) return;
    if (averagingDepth < 2 || averagingDepth > AcopConst.N_DEF_DISPLAY) averagingDepth = 0;
    averagingIndex = 0;
    averagingLength = 0;
    NumberAveragingData = 0;
    this.averagingDepth = averagingDepth;
  }
  public int getAveragingDepth()
  {
    return this.averagingDepth;
  }
  public void setAveragingMode(int averagingMode)
  {
    if (this.averagingMode == averagingMode || averagingMode < 0 || averagingMode > 1) return;
    this.averagingMode = averagingMode;
  }
  public int getAveragingMode()
  {
    return this.averagingMode;
  }
  public void setCaption(java.lang.String caption)
  {
    captionChanged = true;
    this.caption = caption;
    this.repaint(titleRect.x, titleRect.y, titleRect.width, titleRect.height);
  }
  public java.lang.String getCaption()
  {
    return this.caption;
  }
  public void setCaptionLocation(int captionPosition)
  {
    this.captionPosition = captionPosition;
    this.repaint(titleRect.x, titleRect.y, titleRect.width, titleRect.height);
  }
  public int getCaptionLocation()
  {
    return this.captionPosition;
  }
  public void setDisplayMode(int displayMode)
  // throws PropertyVetoException
  {
    if (this.displayMode == displayMode) return;
    /*
     * Integer oldValue = new Integer(this.displayMode); Integer newValue = new
     * Integer(displayMode); veto.fireVetoableChange("displayMode" ,oldValue,
     * newValue); this.displayMode = displayMode;
     * changes.firePropertyChange("displayMode" ,oldValue, newValue); if (
     * displayMode < AcopConst.mode_polyline ) displayMode =
     * AcopConst.mode_polyline; if ( displayMode > AcopConst.mode_textbox )
     * displayMode = AcopConst.mode_textbox;
     */
    if (displayMode < AcopConst.mode_polyline || displayMode > AcopConst.mode_textbox) return;
    this.displayMode = displayMode;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int getDisplayMode()
  {
    return this.displayMode;
  }
  public void setDrawWidth(int drawWidth)
  {
    if (this.drawWidth == drawWidth) return;
    if (drawWidth < 1) drawWidth = 1;
    this.drawWidth = drawWidth;
    if (randomData == true) repaintHisto();
    // prepareDraw(2, -1); // rescale and reset limit
  }
  public int getDrawWidth()
  {
    return this.drawWidth;
  }
  public void setXMin(double xMin)
  {
    if (Math.abs(sca[0].usermin - xMin) < AcopConst.zero_check) return;
    drawTicks = true;
    if (sca[0].usermax <= xMin + AcopConst.zero_check)
    {
      if (Math.abs(xMin) < AcopConst.zero_check)
        sca[0].usermax = xMin + 10;
      else
        sca[0].usermax = xMin + 0.5 * Math.abs(xMin);
    }
    sca[0].setUserscale(xMin, sca[0].usermax);
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw();
    // prepareDraw(TRUE, -1, TRUE, 0);
  }
  public double getXMin()
  {
    return sca[0].usermin;
  }
  public void setXMax(double xMax)
  {
    if (Math.abs(sca[0].usermax - xMax) < AcopConst.zero_check) return;
    drawTicks = true;
    if (xMax <= sca[0].usermin + AcopConst.zero_check)
    {
      if (Math.abs(xMax) < AcopConst.zero_check)
        sca[0].usermin = xMax - 10;
      else
        sca[0].usermin = xMax - 0.5 * Math.abs(xMax);
    }
    sca[0].setUserscale(sca[0].usermin, xMax);
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw();
  }
  public double getXMax()
  {
    return sca[0].usermax;
  }
  public void setYMin(double yMin)
  {
    if (Math.abs(sca[1].usermin - yMin) < AcopConst.zero_check) return;
    ;
    if (m_marker == 2) setmarkerflag(2); // store origin value
    drawTicks = true;
    if (sca[1].usermax <= yMin + AcopConst.zero_check)
    {
      if (Math.abs(yMin) < AcopConst.zero_check)
        sca[1].usermax = yMin + 10;
      else
        sca[1].usermax = yMin + 0.5 * Math.abs(yMin);
    }
    sca[1].setUserscale(yMin, sca[1].usermax);
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw();
  }
  public double getYMin()
  {
    return sca[1].usermin;
  }
  public void setYMax(double yMax)
  {
    if (Math.abs(sca[1].usermax - yMax) < AcopConst.zero_check) return;
    ;
    if (m_marker == 2) setmarkerflag(2); // store origin value
    drawTicks = true;
    if (yMax <= sca[1].usermin + AcopConst.zero_check)
    {
      if (Math.abs(yMax) < AcopConst.zero_check)
        sca[1].usermin = yMax - 10;
      else
        sca[1].usermin = yMax - 0.5 * Math.abs(yMax);
    }
    sca[1].setUserscale(sca[1].usermin, yMax);
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw();
  }
  public double getYMax()
  {
    return sca[1].usermax;
  }
  public void setSecondaryYMin(double SecondaryYMin)
  {
    if (Math.abs(sca[2].usermin - SecondaryYMin) < AcopConst.zero_check) return;
    ;
    if (sca[2].usermax <= SecondaryYMin + AcopConst.zero_check)
    {
      if (Math.abs(SecondaryYMin) < AcopConst.zero_check)
        sca[2].usermax = SecondaryYMin + 10;
      else
        sca[2].usermax = SecondaryYMin + 0.5 * Math.abs(SecondaryYMin);
    }
    sca[2].setUserscale(SecondaryYMin, sca[2].usermax);
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw();
  }
  public double getSecondaryYMin()
  {
    return sca[1].usermin;
  }
  public void setSecondaryYMax(double setSecondaryYMax)
  {
    if (Math.abs(sca[2].usermax - setSecondaryYMax) < AcopConst.zero_check) return;
    ;
    if (setSecondaryYMax <= sca[2].usermin + AcopConst.zero_check)
    {
      if (Math.abs(setSecondaryYMax) < AcopConst.zero_check)
        sca[2].usermin = setSecondaryYMax - 10;
      else
        sca[2].usermin = setSecondaryYMax - 0.5 * Math.abs(setSecondaryYMax);
    }
    sca[2].setUserscale(sca[2].usermin, setSecondaryYMax);
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw();
  }
  public double getSecondaryYMax()
  {
    return sca[2].usermax;
  }
  private void scaleFrameDraw()
  {
    scaleframe();
    // rescaleFlag = 1; 2005-Feb
    rescaleTextFlag = AcopConst.NEW_TEXT_WINDOW;
    if (aFrame.drawFlag)
      prepareDraw();
    else
      changeScaleWidth = 0;
  }
  public void setFrameWidth(int frameWidth)
  {
    if (this.frameWidth == frameWidth) return;
    this.frameWidth = frameWidth;
    scaleFrameDraw();
  }
  public int getFrameWidth()
  {
    return this.frameWidth;
  }
  public void setFrameLeftOffset(int frameLeftOffset)
  {
    if (this.frameLeftOffset == frameLeftOffset) return;
    this.frameLeftOffset = frameLeftOffset;
    scaleFrameDraw();
  }
  public int getFrameLeftOffset()
  {
    return this.frameLeftOffset;
  }
  public void setFrameRightOffset(int frameRightOffset)
  {
    if (this.frameRightOffset == frameRightOffset) return;
    this.frameRightOffset = frameRightOffset;
    scaleFrameDraw();
  }
  public int getFrameRightOffset()
  {
    return this.frameRightOffset;
  }
  public void setFrameTopOffset(int frameTopOffset)
  {
    if (this.frameTopOffset == frameTopOffset) return;
    this.frameTopOffset = frameTopOffset;
    scaleFrameDraw();
  }
  public int getFrameTopOffset()
  {
    return this.frameTopOffset;
  }
  public void setFrameBottomOffset(int frameBottomOffset)
  {
    if (this.frameBottomOffset == frameBottomOffset) return;
    this.frameBottomOffset = frameBottomOffset;
    scaleFrameDraw();
  }
  public int getFrameBottomOffset()
  {
    return this.frameBottomOffset;
  }
  public void setFrameForeColor(java.awt.Color frameForeColor)
  {
    aFrame.frameForeColor = frameForeColor;
    this.repaint();
  }
  public java.awt.Color getFrameForeColor()
  {
    return aFrame.frameForeColor;
  }
  public void setXTickLabelColor(java.awt.Color xTickLabelColor)
  {
    sca[0].tickLabelForeColor = xTickLabelColor;
    this.repaint(sca[0].ticksRect.x, sca[0].ticksRect.y, sca[0].ticksRect.width, sca[0].ticksRect.height);
    if (sca[0].leftBottom != sca[0].leftBottLabel)
      this.repaint(sca[0].labelRect.x, sca[0].labelRect.y, sca[0].labelRect.width, sca[0].labelRect.height);
  }
  public java.awt.Color getXTickLabelColor()
  {
    return sca[0].tickLabelForeColor;
  }
  public void setYTickLabelColor(java.awt.Color yTickLabelColor)
  {
    sca[1].tickLabelForeColor = yTickLabelColor;
    this.repaint(sca[1].ticksRect.x, sca[1].ticksRect.y, sca[1].ticksRect.width, sca[1].ticksRect.height);
    if (sca[1].leftBottom != sca[1].leftBottLabel)
      this.repaint(sca[1].labelRect.x, sca[1].labelRect.y, sca[1].labelRect.width, sca[1].labelRect.height);
  }
  public java.awt.Color getYTickLabelColor()
  {
    return sca[1].tickLabelForeColor;
  }
  public void setSecondaryYTickLabelColor(java.awt.Color secondaryYTickLabelColor)
  {
    sca[2].tickLabelForeColor = secondaryYTickLabelColor;
    if (sca[2].OnFlag == false) return;
    this.repaint(sca[2].ticksRect.x, sca[2].ticksRect.y, sca[2].ticksRect.width, sca[2].ticksRect.height);
    if (sca[2].leftBottom != sca[2].leftBottLabel)
      this.repaint(sca[2].labelRect.x, sca[2].labelRect.y, sca[2].labelRect.width, sca[2].labelRect.height);
  }
  public java.awt.Color getSecondaryYTickLabelColor()
  {
    return sca[2].tickLabelForeColor;
  }
  public void setSecondaryYAxisOn(boolean secondaryYAxisOn)
  {
    sca[2].OnFlag = secondaryYAxisOn;
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    if (aFrame.drawFlag == false) return;
    prepareDraw(); // rescale and reset limit
  }
  public boolean getSecondaryYAxisOn()
  {
    return sca[2].OnFlag;
  }
  public void setSecondaryYLogOn(int secondaryYLogOn)
  {
    sca[2].log = secondaryYLogOn;
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    if (aFrame.drawFlag == false) return;
    prepareDraw(); // rescale and reset limit
  }
  public int getSecondaryYLogOn()
  {
    return sca[2].log;
  }
  public void setFrameFont(java.awt.Font frameFont)
  {
    aFrame.frameFont = frameFont;
    this.repaint();
  }
  public java.awt.Font getFrameFont()
  {
    return aFrame.frameFont;
  }
  public void setDrawStyle(int drawStyle)
  // throws PropertyVetoException
  {
    if (this.drawStyle != drawStyle)
    {
      /*
       * Integer oldValue = new Integer(this.drawStyle); Integer newValue = new
       * Integer(drawStyle); veto.fireVetoableChange("drawStyle" ,oldValue,
       * newValue); this.drawStyle = drawStyle;
       * changes.firePropertyChange("drawStyle" ,oldValue, newValue);
       */
      if (drawStyle < AcopConst.PS_SOLID || drawStyle > AcopConst.PS_DASH_DOT) return;
      this.drawStyle = drawStyle;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
    }
  }
  public int getDrawStyle()
  {
    return this.drawStyle;
  }
  public void setFFT(int FFT)
  {
    if (FFT < 0 || FFT > AcopConst.FFT_RI_INVERSE) FFT = 0;
    if (this.FFT == FFT) return;
    this.FFT = FFT;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int getFFT()
  {
    return this.FFT;
  }
  public void setGraphStyle(int graphStyle)
  {
    int changeYlog = 0;
    if (this.graphStyle == graphStyle) return;
    if (graphStyle < 0 || graphStyle > 5) graphStyle = 0;
    switch (graphStyle)
    {
      default:
      case 0: // lin-lin
        if (sca[1].log != 0) changeYlog = 1;
        sca[0].log = 0;
        sca[1].log = 0;
        sca[0].xtime = 0;
        break;
      case 1: // lin-log
        if (sca[1].log == 0) changeYlog = 1;
        sca[0].log = 0;
        sca[1].log = 1;
        sca[0].xtime = 0;
        break;
      case 2: // log-lin
        if (sca[1].log != 0) changeYlog = 1;
        sca[0].log = 1;
        sca[1].log = 0;
        sca[0].xtime = 0;
        break;
      case 3: // log-log
        if (sca[1].log == 0) changeYlog = 1;
        sca[0].log = 1;
        sca[1].log = 1;
        sca[0].xtime = 0;
        break;
      case 4: // time-lin
        if (sca[1].log != 0) changeYlog = 1;
        sca[0].log = 0;
        sca[1].log = 0;
        sca[0].xtime = 1;
        break;
      case 5: // time-log
        if (sca[1].log == 0) changeYlog = 1;
        sca[0].log = 0;
        sca[1].log = 1;
        sca[0].xtime = 1;
        break;
    }
    if (changeYlog != 0 && m_marker == 2) setmarkerflag(2); // recalculate
                                                            // marker array
    this.graphStyle = graphStyle;
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw(); // rescale and reset limit
  }
  public int getGraphStyle()
  {
    return this.graphStyle;
  }
  public void setGridStyle(int gridStyle)
  {
    if (AcopScale.gridLineMode == gridStyle) return;
    AcopScale.gridLineMode = gridStyle;
    AcopScale.gridStroke = AcopConst.createStroke(AcopScale.gridLineWidth, AcopScale.gridLineMode);
    if (aFrame.drawFlag) repaintHisto();
  }
  public int getGridStyle()
  {
    return AcopScale.gridLineMode;
  }
  public void setGridColor(java.awt.Color gridColor)
  {
    if (AcopScale.gridLineColor == gridColor) return;
    AcopScale.gridLineColor = gridColor;
    AcopScale.gridStroke = AcopConst.createStroke(AcopScale.gridLineWidth, AcopScale.gridLineMode);
    if (aFrame.drawFlag) repaintHisto();
  }
  public java.awt.Color getGridColor()
  {
    return AcopScale.gridLineColor;
  }
  public void setGridWidth(int gridWidth)
  {
    if (AcopScale.gridLineWidth == gridWidth) return;
    if (gridWidth < 1) gridWidth = 1;
    AcopScale.gridLineWidth = gridWidth;
    AcopScale.gridStroke = AcopConst.createStroke(AcopScale.gridLineWidth, AcopScale.gridLineMode);
    if (aFrame.drawFlag) repaintHisto();
  }
  public int getGridWidth()
  {
    return AcopScale.gridLineWidth;
  }
  public void setKeepStyle(int keepStyle)
  {
    this.keepStyle = keepStyle;
    if (aFrame.drawFlag && m_keep != 0) repaintHisto();
  }
  public int getKeepStyle()
  {
    return this.keepStyle;
  }
  public void setKeepColor(java.awt.Color keepColor)
  {
    this.keepColor = keepColor;
    if (aFrame.drawFlag && m_keep != 0) repaintHisto();
  }
  public java.awt.Color getKeepColor()
  {
    return this.keepColor;
  }
  public void setKeepWidth(int keepWidth)
  {
    if (keepWidth < 1) keepWidth = 1;
    this.keepWidth = keepWidth;
    if (aFrame.drawFlag && m_keep != 0) repaintHisto();
  }
  public int getKeepWidth()
  {
    return this.keepWidth;
  }
  public void setHistogramPosition(int histogramPosition)
  {
    aFrame.histogramPosition = histogramPosition;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int getHistogramPosition()
  {
    return aFrame.histogramPosition;
  }
  public void setInvert(boolean invert)
  {
    this.invert = invert;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public boolean isInvert()
  {
    return this.invert;
  }
  public void setRandomData(boolean randomData)
  {
    this.randomData = randomData;
    if (randomData)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
    else
      ClearScreen(-1, 0);
  }
  public boolean isRandomData()
  {
    return this.randomData;
  }
  public void setRandomText(boolean randomText)
  {
    this.randomText = randomText;
    if (randomData)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
    else
      ClearScreen(-1, 0);
  }
  public boolean isRandomText()
  {
    return this.randomText;
  }
  public void setReuseScreen(boolean reuseScreen)
  {
    this.reuseScreen = reuseScreen;
  }
  public boolean isReuseScreen()
  {
    return this.reuseScreen;
  }
  public void setReuseText(boolean reuseText)
  {
    this.reuseText = reuseText;
  }
  public boolean isReuseText()
  {
    return this.reuseText;
  }
  public void setScreenDepth(int screenDepth)
  {
    int itmp = screenDepth;
    // if ( Beans.isDesignTime() == false ) return;
    // design mode
    if (itmp > AcopConst.MAX_DISPLAY)
      itmp = AcopConst.MAX_DISPLAY;
    else if (itmp < 1) itmp = 1;
    if (histo[itmp - 1] != null) return;
    screenDepth = itmp;
    n_display = screenDepth;
    this.screenDepth = screenDepth;
  }
  public int getScreenDepth()
  {
    return this.screenDepth;
  }
  public void setTextDepth(int textDepth)
  {
    int itmp = textDepth;
    // if ( Beans.isDesignTime() == false ) return;
    // design mode
    if (itmp > AcopConst.MAX_TEXT)
      itmp = AcopConst.MAX_TEXT;
    else if (itmp < 1) itmp = 1;
    if (ptext[itmp - 1] != null) return;
    textDepth = itmp;
    n_text = textDepth;
    this.textDepth = textDepth;
  }
  public int getTextDepth()
  {
    return this.textDepth;
  }
  public void setWrapAround(boolean wrapAround)
  {
    int i;
    if (this.wrapAround == wrapAround) return;
    this.wrapAround = wrapAround;
    if (wrapAround) for (i = 0; i < n_display; i++)
      if (histo[i] != null && histo[i].displayON != 0)
        histo[i].getMaxWindow();
      else
        for (i = 0; i < n_display; i++)
          if (histo[i] != null && histo[i].displayON != 0) histo[i].wrapindex = 0;
    if (aFrame.drawFlag || textFlag)
    {
      // if ( wrapAround == false ) rescaleFlag = 1;
      // rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      rescaleFlag = wrapAround == false ? 2 : 0;
      rescaleTextFlag = wrapAround == false ? AcopConst.NEW_ZOOM_WINDOW : 0;
      prepareDraw();
    }
    else if (wrapAround == false) drawTicks = true;
  }
  public boolean isWrapAround()
  {
    return this.wrapAround;
  }
  public void setZooming(int zooming)
  {
    if (this.zooming == zooming) return;
    if (zooming <= 7 && zooming >= 4)
      zoomIndex = 0;
    else if (zooming < 0 || zooming > 3) zooming = 0;
    if ((zooming & 0x7) != 0) setZoomingWindow(zooming & 0x4);
    if ((zooming & 0x7) == 0 && isZoomed == true)
    {
      if (m_marker == 2) setmarkerflag(2); // restore marker array
        // prepareDraw(TRUE, -1, TRUE, nScaleText); // rescale and set max limit
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      isZoomed = false;
      zoomIndex = 0;
    }
    this.zooming = zooming;
  }
  public int getZooming()
  {
    return this.zooming;
  }
  public void setXAxisLabel(java.lang.String XAxisLabel)
  {
    sca[0].AxisLabel = XAxisLabel;
    this.repaint(sca[0].labelRect.x, sca[0].labelRect.y, sca[0].labelRect.width, sca[0].labelRect.height);
  }
  public java.lang.String getXAxisLabel()
  {
    return sca[0].AxisLabel;
  }
  public void setYAxisLabel(java.lang.String YAxisLabel)
  {
    sca[1].AxisLabel = YAxisLabel;
    this.repaint(sca[1].labelRect.x, sca[1].labelRect.y, sca[1].labelRect.width, sca[1].labelRect.height);
  }
  public java.lang.String getYAxisLabel()
  {
    return sca[1].AxisLabel;
  }
  public void setSecondaryYAxisLabel(java.lang.String SecondaryYAxisLabel)
  {
	sca[2].AxisLabel = SecondaryYAxisLabel;
    this.repaint(sca[2].labelRect.x,sca[2].labelRect.y,sca[2].labelRect.width,sca[2].labelRect.height);
  }

  public java.lang.String getSecondaryYAxisLabel()
  {
	return sca[2].AxisLabel;
  }
  public void setXBestScale(boolean XBestScale)
  {
    sca[0].bestScale = XBestScale;
    if (sca[0].log != 0) return;
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw(); // rescale and reset limit
  }
  public boolean isXBestScale()
  {
    return sca[0].bestScale;
  }
  public void setYBestScale(boolean YBestScale)
  {
    sca[1].bestScale = YBestScale;
    if (sca[1].log != 0) return;
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw(); // rescale and reset limit
  }
  public boolean isYBestScale()
  {
    return sca[1].bestScale;
  }
  public void setSecondaryYBestScale(boolean SecondaryYBestScale)
  {
    sca[2].bestScale = SecondaryYBestScale;
    if (sca[2].log != 0) return;
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw(); // rescale and reset limit
  }
  public boolean isSecondaryYBestScale()
  {
    return sca[2].bestScale;
  }
  public void setXExtent(double XExtent)
  {
    this.XExtent = XExtent;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public double getXExtent()
  {
    return this.XExtent;
  }
  public void setYExtent(double YExtent)
  {
    this.YExtent = YExtent;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public double getYExtent()
  {
    return this.YExtent;
  }
  public void setXFineTicks(int XFineTicks)
  {
    sca[0].fineTicks = XFineTicks;
    if (randomData == true || sca[0].log == 0)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int getXFineTicks()
  {
    return sca[0].fineTicks;
  }
  public void setYFineTicks(int YFineTicks)
  {
    sca[1].fineTicks = YFineTicks;
    if (randomData == true || sca[1].log == 0)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int getYFineTicks()
  {
    return sca[1].fineTicks;
  }
  public void setSecondaryYFineTicks(int SecondaryYFineTicks)
  {
    sca[2].fineTicks = SecondaryYFineTicks;
    if (randomData == true || sca[2].log == 0)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int getSecondaryYFineTicks()
  {
    return sca[2].fineTicks;
  }
  public void setXGrid(boolean XGrid)
  {
    sca[0].grid = XGrid;
    repaintHisto();
  }
  public boolean isXGrid()
  {
    return sca[0].grid;
  }
  public void setYGrid(boolean YGrid)
  {
    sca[1].grid = YGrid;
    repaintHisto();
  }
  public boolean isYGrid()
  {
    return sca[1].grid;
  }
  public void setXScale(double XScale)
  {
    this.XScale = XScale;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public double getXScale()
  {
    return this.XScale;
  }
  public void setYScale(double YScale)
  {
    this.YScale = YScale;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public double getYScale()
  {
    return this.YScale;
  }
  public void setXShift(double XShift)
  {
    this.XShift = XShift;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public double getXShift()
  {
    return this.XShift;
  }
  public void setYShift(double YShift)
  {
    this.YShift = YShift;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public double getYShift()
  {
    return this.YShift;
  }
  public void setXTicks(int XTicks)
  {
    sca[0].ticks = XTicks;
    if (randomData == true || sca[0].log == 0)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int getXTicks()
  {
    return sca[0].ticks;
  }
  public void setYTicks(int YTicks)
  {
    sca[1].ticks = YTicks;
    if (randomData == true || sca[1].log == 0)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int getYTicks()
  {
    return sca[1].ticks;
  }
  public void setSecondaryYTicks(int SecondaryYTicks)
  {
    sca[2].ticks = SecondaryYTicks;
    if (randomData == true || sca[2].log == 0)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int getSecondaryYTicks()
  {
    return sca[2].ticks;
  }
  public void setXTicksBottom(boolean XTicksBottom)
  {
    if (sca[0].leftBottom == XTicksBottom) return;
    sca[0].leftBottom = XTicksBottom;
    setTickRectangle(0);
    this.repaint();
  }
  public boolean getXTicksBottom()
  {
    return sca[0].leftBottom;
  }
  public void setYTicksLeft(boolean YTicksLeft)
  {
    if (sca[1].leftBottom == YTicksLeft) return;
    sca[1].leftBottom = YTicksLeft;
    setTickRectangle(1);
    this.repaint();
  }
  public boolean getYTicksLeft()
  {
    return sca[1].leftBottom;
  }
  public void setXTickText(boolean XTickText)
  {
    sca[0].ticktext = XTickText;
    this.repaint(sca[0].ticksRect.x, sca[0].ticksRect.y, sca[0].ticksRect.width, sca[0].ticksRect.height);
  }
  public boolean isXTickText()
  {
    return sca[0].ticktext;
  }
  public void setYTickText(boolean YTickText)
  {
    sca[1].ticktext = YTickText;
    this.repaint(sca[1].ticksRect.x, sca[1].ticksRect.y, sca[1].ticksRect.width, sca[1].ticksRect.height);
  }
  public boolean isYTickText()
  {
    return sca[1].ticktext;
  }
  public void setSecondaryYTickText(boolean SecondaryYTickText)
  {
	sca[2].ticktext = SecondaryYTickText;
    this.repaint(sca[2].ticksRect.x,sca[2].ticksRect.y,sca[2].ticksRect.width,sca[2].ticksRect.height);
  }
  public boolean isSecondaryYTickText()
  {
	return sca[2].ticktext;
  }
  public void setcolorFilled(int colorFilled)
  {
    this.colorFilled = colorFilled;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public int iscolorFilled()
  {
    return this.colorFilled;
  }
  public void setleftTimeLabel(boolean leftTimeLabel)
  {
    aFrame.leftTimeLabel = leftTimeLabel;
    if (sca[0].xtime != 0)
    {
      sca[0].ScaleToGrid();
      // if ( fBottom > 0 ) Invalidate(&xRect);
    }
  }
  public boolean isleftTimeLabel()
  {
    return aFrame.leftTimeLabel;
  }
  public void setleftYLabel(boolean leftYLabel)
  {
    if (sca[1].leftBottLabel == leftYLabel) return;
    sca[1].leftBottLabel = leftYLabel;
    setTickRectangle(1);
    if (aFrame.drawFlag == false || randomData == false) return;
    this.repaint();
  }
  public boolean isleftYLabel()
  {
    return sca[1].leftBottLabel;
  }
  public void setbottomXLabel(boolean bottomXLabel)
  {
    if (sca[0].leftBottLabel == bottomXLabel) return;
    sca[0].leftBottLabel = bottomXLabel;
    setTickRectangle(0);
    if (aFrame.drawFlag == false || randomData == false) return;
    this.repaint();
  }
  public boolean isbottomXLabel()
  {
    return sca[0].leftBottLabel;
  }
  public void setprintTextStickyAttribute(int printTextStickyAttribute)
  {
    if (this.printTextStickyAttribute == printTextStickyAttribute) return;
    this.printTextStickyAttribute = printTextStickyAttribute;
  }
  public int getprintTextStickyAttribute()
  {
    return this.printTextStickyAttribute;
  }
  public void setprintTextLocation(int printTextLocation)
  {
    if (this.printTextLocation == printTextLocation) return;
    this.printTextLocation = printTextLocation;
  }
  public int getprintTextLocation()
  {
    return this.printTextLocation;
  }
  public void setprintTextRotation(int printTextRotation)
  {
    if (this.printTextRotation == printTextRotation) return;
    this.printTextRotation = printTextRotation;
  }
  public int getprintTextRotation()
  {
    return this.printTextRotation;
  }
  public void setxlabelRotation(int xlabelRotation)
  {
    xlabelRotation = xlabelRotation % 360;
    if (this.xlabelRotation == xlabelRotation) return;
    this.xlabelRotation = xlabelRotation;
    if (xlabelRotation == 90 || xlabelRotation == -270)
      xlabelAxis = 1;
    else if (xlabelRotation == 180 || xlabelRotation == -180)
      xlabelAxis = 2;
    else if (xlabelRotation == 270 || xlabelRotation == -90)
      xlabelAxis = 3;
    else
      xlabelAxis = 0;
    xlabelRotateGrad = xlabelRotation * Math.PI / 180;
    xlabelcos = Math.cos(xlabelRotateGrad);
    xlabelsin = Math.sin(xlabelRotateGrad);
    if (xlabelsin > 0)
      xlabelQudrant = xlabelcos < 0 ? 2 : 1;
    else
      xlabelQudrant = xlabelcos < 0 ? 3 : 4;
  }
  public int getxlabelRotation()
  {
    return this.xlabelRotation;
  }
  public int LeadingEdge(int LeadingEdgeMode, int hDisplay)
  {
    int num, ende;
    if (LeadingEdgeMode < 0 || LeadingEdgeMode > 3) LeadingEdgeMode = 0;
    if (hDisplay < 0 || hDisplay >= n_display)
    {
      num = 0;
      ende = n_display - 1;
    }
    else
      ende = num = n_display;
    for (; num <= ende; num++)
    {
      if (histo[hDisplay] == null) continue;
      histo[num].edgeMode = LeadingEdgeMode;
    }
    return LeadingEdgeMode;
  }
  public int LeadingEdge(int hDisplay)
  {
    if (hDisplay < 0 || hDisplay >= n_display)
      return LeadingEdgeMode;
    else if (histo[hDisplay] == null)
      return 0;
    else
      return histo[hDisplay].edgeMode;
  }
  public void setLeadingEdgeColor(java.awt.Color LeadingEdgeColor)
  {
    if (this.LeadingEdgeColor == LeadingEdgeColor) return;
    this.LeadingEdgeColor = LeadingEdgeColor;
  }
  public java.awt.Color getLeadingEdgeColor()
  {
    return this.LeadingEdgeColor;
  }
  public void setLeadingEdgeGapSize(int LeadingEdgeGapSize)
  {
    if (this.LeadingEdgeGapSize == LeadingEdgeGapSize) return;
    this.LeadingEdgeGapSize = LeadingEdgeGapSize;
  }
  public int getLeadingEdgeGapSize()
  {
    return this.LeadingEdgeGapSize;
  }
  public void setLeadingEdgeMotion(int LeadingEdgeMotion)
  {
    if (this.LeadingEdgeMotion == LeadingEdgeMotion) return;
    this.LeadingEdgeMotion = LeadingEdgeMotion;
    if (aFrame.drawFlag) repaintHisto();
  }
  public int getLeadingEdgeMotion()
  {
    return this.LeadingEdgeMotion;
  }
  public void setLeadingEdgeMode(int LeadingEdgeMode)
  {
    if (LeadingEdgeMode < 0 || LeadingEdgeMode > 3) LeadingEdgeMode = 0;
    if (this.LeadingEdgeMode == LeadingEdgeMode) return;
    this.LeadingEdgeMode = LeadingEdgeMode;
    if (aFrame.drawFlag) repaintHisto();
  }
  public int getLeadingEdgeMode()
  {
    return this.LeadingEdgeMode;
  }
  public void setLeadingEdgeWidth(int LeadingEdgeWidth)
  {
    if (LeadingEdgeWidth < 0) LeadingEdgeWidth = 1;
    if (this.LeadingEdgeWidth == LeadingEdgeWidth) return;
    this.LeadingEdgeWidth = LeadingEdgeWidth;
  }
  public int getLeadingEdgeWidth()
  {
    return this.LeadingEdgeWidth;
  }
  public void setLeadingEdgeStyle(int LeadingEdgeStyle)
  {
    if (LeadingEdgeStyle < AcopConst.PS_SOLID) LeadingEdgeStyle = AcopConst.PS_SOLID;
    if (this.LeadingEdgeStyle == LeadingEdgeStyle) return;
    this.LeadingEdgeStyle = LeadingEdgeStyle;
  }
  public int getLeadingEdgeStyle()
  {
    return this.LeadingEdgeStyle;
  }
  public void setLeadingEdgeXExtent(double LeadingEdgeXExtent)
  {
    if (Math.abs(this.LeadingEdgeXExtent - LeadingEdgeXExtent) < AcopConst.zero_check) return;
    this.LeadingEdgeXExtent = LeadingEdgeXExtent;
  }
  public double getLeadingEdgeXExtent()
  {
    return this.LeadingEdgeXExtent;
  }
  public void setLeadingEdgeYExtent(double LeadingEdgeYExtent)
  {
    if (Math.abs(this.LeadingEdgeYExtent - LeadingEdgeYExtent) < AcopConst.zero_check) return;
    this.LeadingEdgeYExtent = LeadingEdgeYExtent;
  }
  public double getLeadingEdgeYExtent()
  {
    return this.LeadingEdgeYExtent;
  }
  // public void addMouseMoveListener(MouseMoveListener mo)
  // {
  // }
  // public void removeMouseMoveListener(MouseMoveListener mo)
  // {
  // }
  public void AutoScale(boolean xmx, boolean xmn, boolean ymx, boolean ymn)
  {
    AutoScale(xmx, xmn, ymx, ymn, -1);
  }
  public void AutoScale(boolean xmx, boolean xmn, boolean ymx, boolean ymn, int hIndex)
  {
    double autotmp, checkXmin, checkXmax, xMax, xMin, yMax, yMin;
    int i, j, autoflg, start, stop;
    if (!xmx && !xmn && !ymx && !ymn) return;
    if (histo[m_histstart] == null) return;
    if (hIndex < -1 || hIndex >= n_display) return;
    if (hIndex != -1 && histo[hIndex] == null) return;
    if (hIndex != -1)
    {
      start = hIndex;
      stop = hIndex + 1;
    }
    else
    {
      start = 0;
      stop = n_display;
    }
    xMax = sca[0].usermax;
    if (xmx) for (i = start, autoflg = 0; i < stop && histo[i] != null; i++)
    {
      if (i != m_histstart && histo[i].displayON == 0) continue;
      autotmp = histo[i].MaxOf(histo[i].x);
      if (autoflg == 0)
      {
        xMax = autotmp;
        autoflg = 1;
      }
      else if (xMax < autotmp) xMax = autotmp;
    }
    xMin = sca[0].usermin;
    if (xmn) for (i = start, autoflg = 0; i < stop && histo[i] != null; i++)
    {
      if (i != m_histstart && histo[i].displayON == 0) continue;
      autotmp = histo[i].MinOf(histo[i].x);
      if (autoflg == 0)
      {
        xMin = autotmp;
        autoflg = 1;
      }
      else if (xMin > autotmp) xMin = autotmp;
    }
    yMax = sca[1].usermax;
    if (ymx) for (i = start, autoflg = 0; i < stop && histo[i] != null; i++)
    {
      if (i != m_histstart && histo[i].displayON == 0) continue;
      if (xmx && xmn)
        autotmp = histo[i].MaxOf(histo[i].y);
      else
      {
        checkXmin = sca[0].getMin();
        checkXmax = sca[0].getMax();
        autotmp = -1.7E308;
        for (j = 0; j < histo[i].npoints; j++)
        {
          if (histo[i].disable[j] != 0) continue;
          if (xmx == false && histo[i].x[j] > checkXmax) continue;
          if (xmn == false && histo[i].x[j] < checkXmin) continue;
          if (histo[i].y[j] > autotmp) autotmp = histo[i].y[j];
        }
      }
      if (autoflg == 0)
      {
        yMax = autotmp;
        autoflg = 1;
      }
      else if (yMax < autotmp) yMax = autotmp;
    }
    yMin = sca[1].usermin;
    if (ymn)
      for (i = start, autoflg = 0; i < stop && histo[i] != null; i++)
      {
        if (i != m_histstart && histo[i].displayON == 0) continue;
        if (xmx && xmn)
          autotmp = histo[i].MinOf(histo[i].y);
        else
        {
          checkXmin = sca[0].getMin();
          checkXmax = sca[0].getMax();
          autotmp = 1.7E308;
          for (j = 0; j < histo[i].npoints; j++)
          {
            if (histo[i].disable[j] != 0) continue;
            if (xmx == false && histo[i].x[j] > checkXmax) continue;
            if (xmn == false && histo[i].x[j] < checkXmin) continue;
            if (histo[i].y[j] < autotmp)
              if (sca[1].log == 0 || histo[i].y[j] > 1.0e-30) autotmp = histo[i].y[j];
          }
        }
        if (autoflg == 0)
        {
          yMin = autotmp;
          autoflg = 1;
        }
        else if (yMin > autotmp) yMin = autotmp;
      }
    if (xMax <= xMin + AcopConst.zero_check)
    {
      autotmp = Math.abs(xMin);
      if (autotmp < AcopConst.zero_check)
      {
        xMin -= 5;
        xMax = xMin + 10;
      }
      else
      {
        xMin -= (0.5 * autotmp);
        xMax = xMin + autotmp;
      }
    }
    if (yMax <= yMin + AcopConst.zero_check)
    {
      autotmp = Math.abs(yMin);
      if (autotmp < AcopConst.zero_check)
      {
        yMin -= 5;
        yMax = yMin + 10;
      }
      else
      {
        yMin -= (0.5 * autotmp);
        yMax = yMin + autotmp;
      }
    }
    if (xmx || xmn) sca[0].setUserscale(xMin, xMax);
    if (ymx || ymn) sca[1].setUserscale(yMin, yMax);
    // prepareDraw(TRUE, -1, TRUE, 0);
    rescaleFlag = 2;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw();
  }
  protected void OnRButtonDown(Point point)
  {
    if (aFrame.drawFlag == false && textFlag == false) return;
    if (aFrame.drawFlag && histo[m_histstart].dismode == AcopConst.mode_textbox) return;
    if ((isZoomed || (wrapAround && sca[0].log == 0)) && histRoundRect.contains(point))
    {
      movie = true;
      moviepoint = point;
      saveBestFlag = (sca[0].bestScale ? 1 : 0) + (sca[1].bestScale ? 2 : 0);
      sca[0].bestScale = false;
      sca[1].bestScale = false;
    }
    if (isZoomed) rButtonPoint = point;
  }
  private void doBufferedZoom()
  {
    int i;
    if ((zooming & 0x4) != 0)
    {
      zoomIndex--;
      for (i = 0; i < 3; i++)
        sca[i].setDispscale(bufferedMin[zoomIndex][i], bufferedMax[zoomIndex][i]);
      if (sca[0].log != 0) sca[0].setDispscale(Math.pow(10.0, sca[0].min), Math.pow(10.0, sca[0].max));
      if (sca[1].log != 0) sca[1].setDispscale(Math.pow(10.0, sca[1].min), Math.pow(10.0, sca[1].max));
      bufferedZoomRatio = "Z" + zoomIndex;
      if (zoomIndex != 0) sca[0].ScaleToGrid();
    }
    if (m_marker == 2) setmarkerflag(2); // recalculate marker array
    rescaleFlag = zoomIndex == 0 ? 2 : 1;
    rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    prepareDraw(); // rescale and not set max limit
    if (zoomIndex == 0) isZoomed = false;
    notifyAcop(AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
  }
  protected void OnRButtonUp(Point point)
  {
    if (movie == false)
    {
      if (!isZoomed || (zooming & 0x4) == 0 || rButtonPoint != point) return;
      doBufferedZoom();
      return;
    }
    movie = false;
    if (saveBestFlag != 0)
    {
      if ((saveBestFlag & 0x1) != 0) sca[0].bestScale = true;
      if ((saveBestFlag & 0x2) != 0) sca[1].bestScale = true;
    }
  }
  protected void OnMouseMove(Point point)
  {
    double mx, my, x, y, tx, ty, xcheckmin, xcheckmax;
    boolean reScale;
    int i;
    double[] low = new double[3];
    double[] high = new double[3];
    reScale = true;
    // from log back to nomal for re-scaling
    for (i = 0; i < 3; i++)
    {
      if (i == 2 && sca[i].OnFlag == false) continue;
      low[i] = sca[i].getMin();
      high[i] = sca[i].getMax();
      // x = sca[0].getMin();
      // tx= sca[0].getMax();
      // y = sca[1].getMin();
      // ty= sca[1].getMax();
    }
    if (wrapAround == false || sca[0].log != 0)
    {
      xcheckmin = sca[0].usermin;
      xcheckmax = sca[0].usermax;
    }
    else
    {
      xcheckmin = wrapxmin - sca[0].dispSize - AcopConst.zero_check;
      xcheckmax = wrapxmax + sca[0].dispSize + AcopConst.zero_check;
    }
    if ((point.x < moviepoint.x && low[0] > xcheckmin) || (point.x > moviepoint.x && high[0] < xcheckmax)
        || (point.y > moviepoint.y && low[1] > sca[1].usermin)
        || (point.y < moviepoint.y && high[1] < sca[1].usermax))
    {
      for (i = 0; i < 3; i++)
      {
        if (i == 2 && sca[i].OnFlag == false) continue;
        if (sca[i].log != 0) sca[i].setDispscale(low[i], high[i]);
      }
      x = sca[0].dispSize * moviePercent; // shift 10 percent
      if (point.x < moviepoint.x)
      {
        if (sca[0].log != 0)
        {
          if ((++xCnt < movieLogCnt) || (sca[0].usermin < AcopConst.zero_check && sca[0].min < 0.1)
              || sca[0].min / 10 < sca[0].usermin)
            reScale = false;
          else
          {
            sca[0].setDispscale(sca[0].min / 10, sca[0].max / 10);
            xCnt = 0;
          }
        }
        else
        {
          if (sca[0].min - x < xcheckmin) x = sca[0].min - xcheckmin;
          sca[0].setDispscale(sca[0].min - x, sca[0].max - x);
          if (wrapAround && sca[0].max <= wrapxmin)
            sca[0].setDispscale(wrapxmax - sca[0].dispSize, wrapxmax);
        }
      }
      else if (point.x > moviepoint.x)
      {
        if (sca[0].log != 0)
        {
          if ((--xCnt <= -movieLogCnt) && sca[0].max * 10 <= sca[0].usermax)
          {
            sca[0].setDispscale(sca[0].min * 10, sca[0].max * 10);
            xCnt = 0;
          }
          else
            reScale = false;
        }
        else
        {
          if (sca[0].max + x > xcheckmax) x = xcheckmax - sca[0].max;
          sca[0].setDispscale(sca[0].min + x, sca[0].max + x);
          if (wrapAround && sca[0].min >= wrapxmax)
            sca[0].setDispscale(wrapxmin, wrapxmin + sca[0].dispSize);
        }
      }
      for (i = 1; i < 3; i++) // loop y and y2
      {
        if (i == 2 && sca[i].OnFlag == false) continue;
        y = sca[i].dispSize * moviePercent; // shift 10 percent
        if (point.y > moviepoint.y)
        {
          if (sca[i].log != 0)
          {
            if ((++yCnt < movieLogCnt) || (sca[i].usermin < AcopConst.zero_check && sca[i].min < 0.1)
                || sca[i].min / 10 < sca[i].usermin)
              reScale = false;
            else
            {
              sca[i].setDispscale(sca[i].min / 10, sca[i].max / 10);
              yCnt = 0;
            }
          }
          else
          {
            if (sca[i].min - y < sca[i].usermin) y = sca[i].min - sca[i].usermin;
            sca[i].setDispscale(sca[i].min - y, sca[i].max - y);
          }
        }
        else if (point.y < moviepoint.y)
        {
          if (sca[i].log != 0)
          {
            if ((--yCnt <= -movieLogCnt) && sca[i].max * 10 <= sca[i].usermax)
            {
              sca[i].setDispscale(sca[i].min * 10, sca[i].max * 10);
              yCnt = 0;
            }
            else
              reScale = false;
          }
          else
          {
            if (sca[i].max + y > sca[i].usermax) y = sca[i].usermax - sca[i].max;
            sca[i].setDispscale(sca[i].min + y, sca[i].max + y);
          }
        }
      }
      if (reScale == true)
      {
        sca[0].ScaleToGrid();
        if (m_marker == 2) setmarkerflag(2); // restore marker array
        rescaleFlag = 1;
        rescaleTextFlag = AcopConst.NEW_MOVE_WINDOW;
        prepareDraw(); // rescale but keep present limit
        // prepareDraw(TRUE, -1, FALSE, 0); // rescale but keep present limit
        if (isZoomed && zooming != 0x4) notifyAcop(AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
        // if ( isZoomed ) FireCursorZoom(s_xmax, s_xmin, s_ymax, s_ymin);
      }
      else
        for (i = 0; i < 3; i++)
        {
          if (i == 2 && sca[i].OnFlag == false) continue;
          if (sca[i].log != 0)
            sca[i].setDispscale(Math.log(sca[i].min) / Math.log(10), Math.log(sca[i].max) / Math.log(10));
        }
    }
    moviepoint = point;
  }
  protected void OnLButtonDown(Point point)
  {
    if (histo[m_histstart] == null || aFrame.drawFlag == false) return;
    if (histo[m_histstart].dismode == AcopConst.mode_textbox) return;
    if ((zooming & 0x7) != 0)
    {
      zoomFlag = true;
      zoomRect.setBounds(point.x, point.y, 0, 0);
      mStart = point;
      mEnd = point;
      Graphics2D a = (Graphics2D) getGraphics();
      a.setXORMode(Color.darkGray);
      BasicGraphicsUtils.drawDashedRect(a, point.x, point.y, 0, 0);
      a.setPaintMode();
      a.dispose();
      // mEnd = mStart = point;
      // zoomRect2 = zoomRect;
      // CClientDC dc(this); // draw zoom rectangle
      // dc.DrawDragRect( &zoomRect2, size, NULL, size, NULL, NULL );
    }
    else
    {
      // mClickPoint = point;
      // mDoubleClickPoint = mClickPoint;
      // mDoubleClickPoint.x++;
    }
  }
  protected void OnLButtonUp(Point point)
  {
    double ftmp, curPos;
    double x, y;
    double[] storemin = new double[3];
    double[] storemax = new double[3];
    int i;
    if (zoomFlag == false) return;
    zoomFlag = false;
    if (mEnd.equals(point) == false || mStart == point) return;
    Graphics2D a = (Graphics2D) getGraphics(); // get rid of zoom drag
                                                // rectangle
    a.setXORMode(Color.darkGray);
    BasicGraphicsUtils.drawDashedRect(a, zoomRect.x, zoomRect.y, zoomRect.width, zoomRect.height);
    a.setPaintMode();
    a.dispose();
    // zoom outside the histo rectangle
    if (zoomRect.x + zoomRect.width < aFrame.histRect.x
        || zoomRect.x > aFrame.histRect.x + aFrame.histRect.width
        || zoomRect.y + zoomRect.height < aFrame.histRect.y
        || zoomRect.y > aFrame.histRect.y + aFrame.histRect.height) return;
    // zoom inside the histo rectangle and 2 pixel at least
    if (zoomRect.width > 2 && zoomRect.height > 2
        && (zoomRect.width < aFrame.histRect.width || zoomRect.height < aFrame.histRect.height))
    {
      if ((zooming & 0x4) != 0 && zoomIndex < AcopConst.lengthZoom) for (i = 0; i < 3; i++)
      {
        storemin[i] = sca[i].min;
        storemax[i] = sca[i].max;
      }
      if ((zooming & 0x1) != 0 || zooming == 0x4) // x zooming
      {
        ftmp = (zoomRect.x - aFrame.absxleft) * sca[0].dispSize / aFrame.dxwidth + sca[0].min;
        curPos = (zoomRect.x + zoomRect.width - aFrame.absxleft) * sca[0].dispSize / aFrame.dxwidth
            + sca[0].min;
        if (curPos < sca[0].max) sca[0].setDispscale(sca[0].min, curPos);
        if (ftmp > sca[0].min) sca[0].setDispscale(ftmp, sca[0].max);
      }
      if ((zooming & 0x2) != 0 || zooming == 0x4)
        // y and y2 zooming
        for (i = 1; i < 3; i++)
        {
          if (i == 2 && sca[i].OnFlag == false) continue;
          ftmp = (1. - (double) (zoomRect.y - aFrame.histRect.y) / aFrame.histRect.height) * sca[i].dispSize
              + sca[i].min;
          curPos = (1. - (double) (zoomRect.y + zoomRect.height - aFrame.histRect.y) / aFrame.histRect.height)
              * sca[i].dispSize + sca[i].min;
          if (curPos > sca[i].min) sca[i].setDispscale(curPos, sca[i].max);
          if (ftmp < sca[i].max) sca[i].setDispscale(sca[i].min, ftmp);
        }
      for (i = 0; i < 3; i++) // from log back to nomal for re-scaling
      {
        if (sca[i].log != 0)
          sca[i].setDispscale(Math.pow(10.0, sca[i].min), Math.pow(10.0, sca[i].max));
        else if (sca[i].max < sca[i].min + AcopConst.zero_check)
          sca[i].setDispscale(sca[i].min, sca[i].min + AcopConst.zero_check);
      }
      if (wrapAround && sca[0].log == 0)
      {
        if (sca[0].min > wrapxmax)
        {
          ftmp = wrapxmax - wrapxmin;
          sca[0].max -= ftmp;
          sca[0].min -= ftmp;
        }
        else if (sca[0].max < wrapxmin)
        {
          ftmp = wrapxmax - wrapxmin;
          sca[0].max += ftmp;
          sca[0].min += ftmp;
        }
      }
      isZoomed = true;
      sca[0].ScaleToGrid();
      if (m_marker == 2) setmarkerflag(2); // recalculate marker array
        // prepareDraw(TRUE, -1, FALSE, nScaleText); // rescale and not set max
        // limit
      rescaleFlag = 1;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw(); // rescale and not set max limit
      yZoomRatio = "V" + (int) (sca[1].userSize / sca[1].dispSize + 0.5) + ":1";
      xZoomRatio = "H" + (int) (sca[0].userSize / sca[0].dispSize + 0.5) + ":1";
      if ((zooming & 0x4) != 0 && zoomIndex < AcopConst.lengthZoom)
      {
        for (i = 0; i < 3; i++)
        {
          bufferedMin[zoomIndex][i] = storemin[i];
          bufferedMax[zoomIndex][i] = storemax[i];
        }
        zoomIndex++;
        bufferedZoomRatio = "Z" + zoomIndex;
      }
      notifyAcop(AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
      // FireCursorZoom(s_xmax, s_xmin, s_ymax, s_ymin);
    }
    // else if ( isZoomed && aFrame.zoomIcon.contains(point) ) doBufferedZoom();
    else if (zoomRect.width >= aFrame.histRect.width && zoomRect.height >= aFrame.histRect.height)
      doBufferedZoom(); // return back to original setting
      // { // return back to original setting
      // if ( isZoomed && (sca[0].isOriginMaxMin() == false ||
      // sca[1].isOriginMaxMin() == false) )
      // {
      // rescaleFlag = 2;
      // if ( m_marker == 2 ) setmarkerflag(2); // restore marker array
      // rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      // prepareDraw();
      // notifyAcop(AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
      // }
      // isZoomed = false;
    // }
    // else
    // {
    // InvalidateControl(&zoomRect);
    // if ( getMousePosition(point, x, y, TRUE) ) FireCursorClick(XarrayElement,
    // x, y);
    // }
    // }
  }
  // public void resize(int width, int height)
  // {
  // if ( changeScaleWidth == 0 ) return;
  // scaleframe();
  // this.repaint();
  // }
  protected void processComponentEvent(ComponentEvent componentEvent)
  {
    // make sue listeners are notified
    super.processComponentEvent(componentEvent);
    switch (componentEvent.getID())
    {
      case ComponentEvent.COMPONENT_RESIZED: // resized
        scaleFrameDraw();
        break;
      case ComponentEvent.COMPONENT_MOVED: // moved
        break;
      default:
        break;
    }
  }
  protected void processMouseEvent(MouseEvent mouseEvent)
  {
    // make sue listeners are notified
    super.processMouseEvent(mouseEvent);
    mouseX = mouseEvent.getX();
    mouseY = mouseEvent.getY();
    mousepoint = mouseEvent.getPoint();
    switch (mouseEvent.getID())
    {
      case MouseEvent.MOUSE_ENTERED: // enter to de.desy.acop.chart area
        mouseIndex = -1;
        notifyAcop(AcopEvent.ACOP_MOUSE_ENTER_EVENT);
        break;
      case MouseEvent.MOUSE_EXITED: // go out of de.desy.acop.chart area
        mouseIndex = -1;
        notifyAcop(AcopEvent.ACOP_MOUSE_EXIT_EVENT);
        break;
      case MouseEvent.MOUSE_PRESSED: // mouse down
        if ((mouseEvent.getModifiers() & MouseEvent.BUTTON1_MASK) != 0)
          OnLButtonDown(mousepoint); // left button
        else if ((mouseEvent.getModifiers() & MouseEvent.BUTTON3_MASK) != 0) // right
                                                                              // button
          OnRButtonDown(mousepoint); // left button
        break;
      case MouseEvent.MOUSE_RELEASED: // mouse up
        if ((mouseEvent.getModifiers() & MouseEvent.BUTTON1_MASK) != 0)
          OnLButtonUp(mousepoint); // left button
        else if ((mouseEvent.getModifiers() & MouseEvent.BUTTON3_MASK) != 0) // right
                                                                              // button
          OnRButtonUp(mousepoint); // left button
        break;
      case MouseEvent.MOUSE_CLICKED: // mouse click
        long mouseEventTime = mouseEvent.getWhen();
        long mouseButton = mouseEvent.getButton();
        boolean doubleClick;
        if (mouseButton == previousButton && (mouseEventTime - mousePreviousClickTime < 300))
          doubleClick = true;
        else
          doubleClick = false;
        mousePreviousClickTime = mouseEventTime;
        previousButton = mouseEvent.getButton();
        if (doubleClick) // implement double click events
        {
          if (histRoundRect.contains(mousepoint) && aFrame.drawFlag)
            mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
          else
            mouseIndex = -1;
          if (isZoomed) // return to original size
          {
            rescaleFlag = 2;
            if (m_marker == 2) setmarkerflag(2); // restore marker array
            rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
            prepareDraw();
            isZoomed = false;
            notifyAcop(AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
          }
          notifyAcop(AcopEvent.ACOP_MOUSE_DCLICK_EVENT);
        }
        // FireCursorClick(XarrayElement, x, y);
        // mouseEvent.notifyAll();
        else if (isZoomed && aFrame.zoomIcon.contains(mousepoint))
          doBufferedZoom();
        // / {
        // / rescaleFlag = 2;
        // /// if ( m_marker == 2 ) setmarkerflag(2); // restore marker array
        // / rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
        // / prepareDraw();
        // / isZoomed = false;
        // / notifyAcop(AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
        // / }
        else
        {
          if (histRoundRect.contains(mousepoint) && aFrame.drawFlag)
            mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
          else
            mouseIndex = -1;
          notifyAcop(AcopEvent.ACOP_MOUSE_CLICK_EVENT);
        }
        break;
      default:
        break;
    }
  }
  protected void processMouseMotionEvent(MouseEvent mouseMotionEvent)
  {
    int rWidth, rHeight, recX, recY;
    // make sue listeners are notified
    super.processMouseMotionEvent(mouseMotionEvent);
    mouseX = mouseMotionEvent.getX();
    mouseY = mouseMotionEvent.getY();
    mousepoint = mouseMotionEvent.getPoint();
    switch (mouseMotionEvent.getID())
    {
      case MouseEvent.MOUSE_MOVED: // mouse move
        if (aFrame.drawFlag && histRoundRect.contains(mousepoint))
        {
          if (m_cursorMarkerMode != 0 && cursorStay == 0) drawCursorMarker(null, mousepoint);
          mMovePoint.x = mousepoint.x;
          mMovePoint.y = mousepoint.y;
          mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
          notifyAcop(AcopEvent.ACOP_MOUSE_MOVE_EVENT);
        }
        // if ( getMousePosition(point, mx, my, TRUE) )
        // FireCursorMove(XarrayElement, mx, my);
        break;
      case MouseEvent.MOUSE_DRAGGED: // mouse dragging
        if (zoomFlag)
        {
          Graphics2D a = (Graphics2D) getGraphics();
          a.setXORMode(Color.darkGray);
          BasicGraphicsUtils.drawDashedRect(a, zoomRect.x, zoomRect.y, zoomRect.width, zoomRect.height);
          mEnd = mousepoint;
          rWidth = Math.abs(mEnd.x - mStart.x);
          rHeight = Math.abs(mEnd.y - mStart.y);
          recX = Math.min(mEnd.x, mStart.x);
          recY = Math.min(mEnd.y, mStart.y);
          zoomRect.setBounds(recX, recY, rWidth, rHeight);
          BasicGraphicsUtils.drawDashedRect(a, recX, recY, rWidth, rHeight);
          a.setPaintMode();
          a.dispose();
        }
        else if (movie)
          OnMouseMove(mousepoint);
        else if (aFrame.drawFlag && m_cursorMarkerMode != 0 && cursorStay == 0
            && histRoundRect.contains(mousepoint))
        {
          drawCursorMarker(null, mousepoint);
          mMovePoint.x = mousepoint.x;
          mMovePoint.y = mousepoint.y;
        }
        break;
      default:
        break;
    }
  }
  private void drawtext(java.awt.Graphics2D g2d)
  {
    if (textFlag == false) return;
    Rectangle Cliprect = g2d.getClipBounds();
    if (Cliprect != null)
    {
      if (Cliprect.intersects(histRoundRect) == false) return;
    }
    g2d.clipRect(histRoundRect.x, histRoundRect.y, histRoundRect.width, histRoundRect.height);
    g2d.translate(aFrame.histRect.x, aFrame.histRect.y);
    for (int i = 0; i < n_text; i++)
    {
      if (ptext[i] == null) break;
      ptext[i].printUserText(g2d);
    }
    g2d.translate(-aFrame.histRect.x, -aFrame.histRect.y);
    g2d.setClip(Cliprect);
  }
  private void drawhist(java.awt.Graphics2D g2d)
  {
    if (aFrame.drawFlag == false && textFlag == false) return;
    Rectangle Cliprect = g2d.getClipBounds();
    if (Cliprect != null)
    {
      if (Cliprect.intersects(histRoundRect) == false) return;
    }
    g2d.clipRect(histRoundRect.x, histRoundRect.y, histRoundRect.width, histRoundRect.height);
    g2d.translate(aFrame.histRect.x, aFrame.histRect.y);
    for (int i = 0; i < 2; i++)
      sca[i].drawGrid(g2d);
    for (int i = 0; i < 2; i++)
      axis[i].drawAxis(g2d);
    if (aFrame.drawFlag) for (int i = 0; i < n_display; i++)
    {
      if (histo[i] == null) break;
      histo[i].drawhist(g2d);
    }
    if (aFrame.drawFlag && m_cursorMarkerMode != 0 && histRoundRect.contains(mMovePoint))
      drawCursorMarker(g2d, mMovePoint);
    else
      cursorMarkerFlag = 0; // no cursor drawn on screen!
    g2d.translate(-aFrame.histRect.x, -aFrame.histRect.y);
    g2d.setClip(Cliprect);
  }
  private void captionPaint(java.awt.Graphics2D g2d)
  {
    FontMetrics fMetrix;
    int xPosition, len, hei;
    Rectangle Cliprect = g2d.getClipBounds();
    if (Cliprect != null)
    {
      if (Cliprect.intersects(titleRect) == false) return;
    }
    if (captionFont == null || captionChanged == true || randomData == true)
    {
      captionFont = new Font(g2d.getFont().getAttributes());
      captionChanged = false;
    }
    Font tmpFont = g2d.getFont();
    AffineTransform transform = g2d.getTransform();
    g2d.clipRect(titleRect.x, titleRect.y, titleRect.width + 1, titleRect.height + 1);
    g2d.setFont(captionFont);
    fMetrix = g2d.getFontMetrics();
    len = fMetrix.stringWidth(caption);
    hei = (fMetrix.getDescent() + fMetrix.getAscent()) / 2;
    if (captionPosition == 1)
      xPosition = (titleRect.width - len) / 2;
    else if (captionPosition < 1)
      xPosition = 2;
    else
      xPosition = titleRect.width - len - 2;
    g2d.setColor(aFrame.frameForeColor);
    g2d.drawString(caption, xPosition, sca[0].leftBottom ? (fTop - 4) : (fTop - 4 - hei * 2));
    g2d.setTransform(transform);
    g2d.setFont(tmpFont);
    g2d.setClip(Cliprect);
  }
  private void backgroundPaint(java.awt.Graphics2D g2d, Rectangle Cliprect, Rectangle acopRect)
  {
    int i;
    if (nBackRegions == 0)
    {
      g2dima.setBackground(g2d.getBackground());
      if (Cliprect == null)
        g2dima.clearRect(0, 0, acopRect.width, acopRect.height);
      else
        g2dima.clearRect(Cliprect.x, Cliprect.y, Cliprect.width, Cliprect.height);
      return;
    }
    g2dima.setBackground(g2d.getBackground());
    if (false) // what to do for the display gap?????
    {
      if (Cliprect == null || Cliprect.intersects(titleRect) == true)
        g2dima.clearRect(titleRect.x, titleRect.y, titleRect.width, titleRect.height);
      if (Cliprect == null || Cliprect.intersects(xRect) == true)
        g2dima.clearRect(xRect.x, xRect.y, xRect.width, xRect.height);
      if (Cliprect == null || Cliprect.intersects(yRect) == true)
        g2dima.clearRect(yRect.x, yRect.y, yRect.width, yRect.height);
      if (Cliprect == null || Cliprect.intersects(yAxisRect) == true)
        g2dima.clearRect(yAxisRect.x, yAxisRect.y, yAxisRect.width, yAxisRect.height);
    }
    else
    {
      if (Cliprect == null)
        g2dima.clearRect(0, 0, acopRect.width, acopRect.height);
      else
        g2dima.clearRect(Cliprect.x, Cliprect.y, Cliprect.width, Cliprect.height);
    }
    g2dima.clipRect(histRoundRect.x, histRoundRect.y, histRoundRect.width, histRoundRect.height);
    Rectangle tmpCliprect = g2dima.getClipBounds();
    for (i = 0; i < nBackRegions; i++)
    {
      if (backkgroundRegionType[i] == 0) continue;
      if (tmpCliprect != null && tmpCliprect.intersects(backRegionRect[i]) == false) continue;
      if (backkgroundRegionType[i] == 1)
      {
        g2dima.setBackground(backRegionColor[i]);
        g2dima.clearRect(backRegionRect[i].x, backRegionRect[i].y, backRegionRect[i].width,
            backRegionRect[i].height);
      }
      else if (backkgroundRegionType[i] == 2)
        g2dima.drawImage(backRegionImage[i], backRegionRect[i].x, backRegionRect[i].y,
            backRegionRect[i].width, backRegionRect[i].height, this);
    }
    g2dima.setClip(Cliprect);
  }
  public void update(java.awt.Graphics a)
  {
    this.paint(a);
  }
  public void paint(java.awt.Graphics a)
  {
    java.awt.Graphics2D g2d = (Graphics2D) a;
    Rectangle r = getBounds();
    int i;
    if (ima == null || r.width != ima.getWidth() || r.height != ima.getHeight())
    {
      // ima = new java.awt.image.BufferedImage(r.width, r.height,
      // BufferedImage.TYPE_INT_RGB);
      ima = new java.awt.image.BufferedImage(r.width, r.height, BufferedImage.TYPE_INT_ARGB);
      g2dima = ima.createGraphics();
    }
    Rectangle Cliprect = g2d.getClipBounds(); // get original clip area
    backgroundPaint(g2d, Cliprect, r);
    g2dima.setColor(aFrame.frameForeColor); // draw border
    g2dima.drawRect(0, 0, r.width - 1, r.height - 1);
    captionPaint(g2dima); // paint caption
    if (changeScaleWidth == 0) // prepare random data only once
    {
      scaleframe();
      /*
       * if ( Beans.isDesignTime() && randomData == true ) { prepareDraw();
       * System.out.println("DesignTime and RandomData"); }
       */
      changeScaleWidth = 1;
    }
    if (Cliprect == null || Cliprect.intersects(histRoundRect) == true)
    {
      g2dima.setColor(aFrame.frameForeColor);
      g2dima.drawRect(histRoundRect.x, histRoundRect.y, histRoundRect.width, histRoundRect.height);
    }
    drawhist(g2dima);
    drawtext(g2dima);
    g2dima.setStroke(stroke);
    if (isZoomed && (Cliprect == null || Cliprect.intersects(aFrame.zoomIcon) == true))
    {
      g2dima.setColor(aFrame.frameForeColor);
      g2dima.setFont(aFrame.frameFont);
      g2dima.drawRect(aFrame.zoomIcon.x, aFrame.zoomIcon.y, aFrame.zoomIcon.width, aFrame.zoomIcon.height);
      g2dima.clipRect(aFrame.zoomIcon.x, aFrame.zoomIcon.y, aFrame.zoomIcon.width, aFrame.zoomIcon.height);
      if ((zooming & 0x4) != 0)
        g2dima.drawString(bufferedZoomRatio, aFrame.zoomIcon.x + 1, aFrame.zoomIcon.y
            + aFrame.zoomIcon.height - 1);
      else
      {
        g2dima.drawString(yZoomRatio, aFrame.zoomIcon.x + 1, aFrame.zoomIcon.y + aFrame.zoomIcon.width / 2);
        g2dima.drawString(xZoomRatio, aFrame.zoomIcon.x + 1, aFrame.zoomIcon.y + aFrame.zoomIcon.width - 1);
      }
      g2dima.setClip(Cliprect);
    }
    if ((textFlag == true || (aFrame.drawFlag == true && histo[m_histstart].dismode != AcopConst.mode_textbox))
        && (fLeft > 0 || fRight > 0 || fBottom > 0 || fTop > 0))
    {
      for (i = 0; i < 3; i++)
      {
        if (i == 2 && sca[i].OnFlag == false) continue;
        sca[i].drawTicks(g2dima, histo[m_histstart]);
      }
    }
    if (zoomFlag && (Cliprect == null || Cliprect.intersects(zoomRect) == true))
    {
      g2dima.setXORMode(Color.darkGray);
      BasicGraphicsUtils.drawDashedRect(g2dima, zoomRect.x, zoomRect.y, zoomRect.width, zoomRect.height);
      g2dima.setPaintMode();
    }
    super.paint(g2dima); // paint all children
    if (Cliprect == null)
      g2d.drawImage(ima, 0, 0, this);
    else
      g2d.drawImage(ima, Cliprect.x, Cliprect.y, Cliprect.x + Cliprect.width, Cliprect.y + Cliprect.height,
          Cliprect.x, Cliprect.y, Cliprect.x + Cliprect.width, Cliprect.y + Cliprect.height, this);
    // MotifGraphicsUtils.drawStringInRect(a,caption,
    // frameWidth+frameLeftOffset,
    // 0,
    // titleRect.width,
    // frameWidth,
    // MotifGraphicsUtils.CENTER);
    // todo. Add overriding code here.
  }
  public void paintAll(java.awt.Graphics a)
  {
    // todo. Add overriding code here.
  }
  public static void main(String argv[])
  {
    class DriverFrame extends java.awt.Frame
    {
      public DriverFrame()
      {
        addWindowListener(new java.awt.event.WindowAdapter()
        {
          public void windowClosing(java.awt.event.WindowEvent event)
          {
            dispose(); // free the system resources
            System.exit(0); // close the application
          }
          public void windowOpened(java.awt.event.WindowEvent event)
          {
            int test = 3;
          }
        });
        setLayout(null);
        setSize(400, 300);
        add(new Acop());
      }
    }
    new DriverFrame().show();
  }
  /*
   * public void addPropertyChangeListener(java.beans.PropertyChangeListener
   * pcl) { if (changes == null) changes = new
   * symantec.itools.beans.PropertyChangeSupport(this);
   * changes.addPropertyChangeListener("",pcl); } public void
   * removePropertyChangeListener(java.beans.PropertyChangeListener pcl) { if
   * (changes != null) changes.removePropertyChangeListener("",pcl); } public
   * void addVetoableChangeListener(java.beans.VetoableChangeListener vcl) { if
   * (veto == null) veto = new
   * symantec.itools.beans.VetoableChangeSupport(this);
   * veto.addVetoableChangeListener("",vcl); } public void
   * removeVetoableChangeListener(java.beans.VetoableChangeListener vcl) { if
   * (veto != null) veto.removeVetoableChangeListener("",vcl); }
   */
  public int addTransportProtocol(AcopTransportPlug transportPlug)
  {
    return transport.AcopTransportAddProtocol(transportPlug);
  }
  public synchronized void addAcopListener(AcopListener l)
  {
    if (!AcopListeners.contains(l)) AcopListeners.addElement(l);
  }
  public synchronized void removeAcopListener(AcopListener l)
  {
    if (AcopListeners.contains(l)) AcopListeners.removeElement(l);
  }
  // notify listening objects of Acop
  protected void notifyAcop(int id)
  {
    // create the event object
    if (id == AcopEvent.ACOP_MOUSE_CLICK_EVENT || id == AcopEvent.ACOP_MOUSE_MOVE_EVENT
        || id == AcopEvent.ACOP_MOUSE_ENTER_EVENT || id == AcopEvent.ACOP_MOUSE_EXIT_EVENT
        || id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT || id == AcopEvent.ACOP_RECEIVE_EVENT
        || id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT)
    {
      AcopEvent evt;
      if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
        evt = new AcopEvent(this, id, sca[0].min, sca[1].min, sca[0].max, sca[1].max);
      else if (id != AcopEvent.ACOP_RECEIVE_EVENT)
        evt = new AcopEvent(this, id, mouseIndex, mousepoint.x, mousepoint.y, mouseConvert[0],
            mouseConvert[1]);
      else
        evt = new AcopEvent(this, id, 1, 1); // link id ans error
      Vector v;
      synchronized (this)
      {
        v = (Vector) AcopListeners.clone();
      }
      // fire events
      int cnt = v.size();
      for (int i = 0; i < cnt; i++)
      {
        AcopListener client = (AcopListener) v.elementAt(i);
        if (id == AcopEvent.ACOP_MOUSE_CLICK_EVENT)
          client.AcopMouseClick(evt);
        else if (id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT)
          client.AcopMouseDoubleClick(evt);
        else if (id == AcopEvent.ACOP_MOUSE_MOVE_EVENT)
          client.AcopMouseMove(evt);
        else if (id == AcopEvent.ACOP_MOUSE_ENTER_EVENT)
          client.AcopMouseEnter(evt);
        else if (id == AcopEvent.ACOP_MOUSE_EXIT_EVENT)
          client.AcopMouseExit(evt);
        else if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
          client.AcopMouseZoom(evt);
        else if (id == AcopEvent.ACOP_RECEIVE_EVENT) client.AcopReceive(evt);
      }
    }
  }
  public void notifyAcop(int id, int link, int code)
  {
    // create the event object
    if (id == AcopEvent.ACOP_MOUSE_CLICK_EVENT || id == AcopEvent.ACOP_MOUSE_MOVE_EVENT
        || id == AcopEvent.ACOP_MOUSE_ENTER_EVENT || id == AcopEvent.ACOP_MOUSE_EXIT_EVENT
        || id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT || id == AcopEvent.ACOP_RECEIVE_EVENT
        || id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT)
    {
      AcopEvent evt;
      if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
        evt = new AcopEvent(this, id, sca[0].min, sca[1].min, sca[0].max, sca[1].max);
      else if (id != AcopEvent.ACOP_RECEIVE_EVENT)
        evt = new AcopEvent(this, id, mouseIndex, mousepoint.x, mousepoint.y, mouseConvert[0],
            mouseConvert[1]);
      else
        evt = new AcopEvent(this, id, link, code); // link id ans error
      Vector v;
      synchronized (this)
      {
        v = (Vector) AcopListeners.clone();
      }
      // fire events
      int cnt = v.size();
      for (int i = 0; i < cnt; i++)
      {
        AcopListener client = (AcopListener) v.elementAt(i);
        if (id == AcopEvent.ACOP_MOUSE_CLICK_EVENT)
          client.AcopMouseClick(evt);
        else if (id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT)
          client.AcopMouseDoubleClick(evt);
        else if (id == AcopEvent.ACOP_MOUSE_MOVE_EVENT)
          client.AcopMouseMove(evt);
        else if (id == AcopEvent.ACOP_MOUSE_ENTER_EVENT)
          client.AcopMouseEnter(evt);
        else if (id == AcopEvent.ACOP_MOUSE_EXIT_EVENT)
          client.AcopMouseExit(evt);
        else if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
          client.AcopMouseZoom(evt);
        else if (id == AcopEvent.ACOP_RECEIVE_EVENT) client.AcopReceive(evt);
      }
    }
  }
  /**
   * @brief Establishes and executes a synchronous data link using the Device
   *        Properties assigned to the control. Use Execute for synchronous data
   *        acquisition. Fill in the DeviceContext DeviceGroup, DeviceName, and
   *        DeviceProperty bean property parameters, along with the
   *        accessProtocol, accessMode, and accessRate bean property parameters.
   *        This method blocks until either the transfer is complete or a
   *        timeout has occured (given by the AccessRate setting). Asynchronous
   *        READ and WRITE calls can be effected by using the AttachLink()
   *        method and handling the results inside the corresonding receive
   *        event.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @param DataEx
   *          is the extended data object and refers to the data object to which
   *          holds the input data to be sent to a server. Pass 'null' if no
   *          return data is desired.
   * @param ArraySizeEx
   *          is the data array size associated with the DataEx object. This may
   *          be smaller than the actual size of the DataEx object, but NOT
   *          bigger.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data and DataEx objects above must refer to arrays of data types
   *       (which are passed by reference) and not single values (which are
   *       passed by value). So even if passing a single value, it must be
   *       declared as an array of 1 element!
   * @note The only allowed values of 'AccessMode' are "READ" and "WRITE" when
   *       using the Execute() method. \b Example: \include eg_acopExecute1.java
   */
  public int Execute(Object Data, int ArraySize, Object DataEx, int ArraySizeEx)
  {
    return transport.Execute(Data, ArraySize, DataEx, ArraySizeEx);
  }
  /**
   * @brief Establishes and executes a synchronous data link using the Device
   *        Properties assigned to the control. Use Execute for synchronous data
   *        acquisition. Fill in the DeviceContext DeviceGroup, DeviceName, and
   *        DeviceProperty bean property parameters, along with the
   *        accessProtocol, accessMode, and accessRate bean property parameters.
   *        This method blocks until either the transfer is complete or a
   *        timeout has occured (given by the AccessRate setting). Asynchronous
   *        READ and WRITE calls can be effected by using the AttachLink()
   *        method and handling the results inside the corresonding receive
   *        event.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param DataEx
   *          is the extended data object and refers to the data object to which
   *          holds the input data to be sent to a server. Pass 'null' if no
   *          return data is desired.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data and DataEx objects above must refer to arrays of data types
   *       (which are passed by reference) and not single values (which are
   *       passed by value). So even if passing a single value, it must be
   *       declared as an array of 1 element! The sizes of the arrays are in
   *       turn used in establishing the link when using this form of the
   *       Execute() method.
   * @note The only allowed values of 'AccessMode' are "READ" and "WRITE" when
   *       using the Execute() method. \b Example: \include
   *       eg_acopExecute1b.java
   */
  public int Execute(Object Data, Object DataEx)
  {
    return transport.Execute(Data, transport.getObjectSize(Data), DataEx, transport.getObjectSize(DataEx));
  }
  /**
   * @brief Establishes and executes a synchronous data link using the Device
   *        Properties assigned to the control. Use Execute for synchronous data
   *        acquisition. Fill in the DeviceContext DeviceGroup, DeviceName, and
   *        DeviceProperty bean property parameters, along with the
   *        accessProtocol, accessMode, and accessRate bean property parameters.
   *        This method blocks until either the transfer is complete or a
   *        timeout has occured (given by the AccessRate setting). Asynchronous
   *        READ and WRITE calls can be effected by using the AttachLink()
   *        method and handling the results inside the corresonding receive
   *        event.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data object above must refer to an array of data types (which is
   *       passed by reference) and not a single value (which is passed by
   *       value). So even if passing a single value, it must be declared as an
   *       array of 1 element! The size of the array is in turn used in
   *       establishing the link when using this form of the Execute() method.
   * @note The only allowed values of 'AccessMode' are "READ" and "WRITE" when
   *       using the Execute() method. \b Example: \include
   *       eg_acopExecute1c.java
   */
  public int Execute(Object Data)
  {
    return transport.Execute(Data, transport.getObjectSize(Data), null, 0);
  }
  /**
   * @brief Establishes and executes a synchronous data link using the Device
   *        Properties assigned to the control. Use Execute for synchronous data
   *        acquisition. Fill in the DeviceContext DeviceGroup, DeviceName, and
   *        DeviceProperty bean property parameters, along with the
   *        accessProtocol, accessMode, and accessRate bean property parameters.
   *        This method blocks until either the transfer is complete or a
   *        timeout has occured (given by the AccessRate setting). Asynchronous
   *        READ and WRITE calls can be effected by using the AttachLink()
   *        method and handling the results inside the corresonding receive
   *        event.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data object above must refer to an array of data types (which is
   *       passed by reference) and not a single value (which is passed by
   *       value). So even if passing a single value, it must be declared as an
   *       array of 1 element!
   * @note The only allowed values of 'AccessMode' are "READ" and "WRITE" when
   *       using the Execute() method. \b Example: \include
   *       eg_acopExecute1d.java
   */
  public int Execute(Object Data, int ArraySize)
  {
    return transport.Execute(Data, ArraySize, null, 0);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control and Attaches the data objects passed. Use
   *        AttachLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link and attach the returning data to
   *        the Data object passed. When new data arrive or the link status has
   *        changed, the de.desy.acop.chart receive event will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @param DataEx
   *          is the extended data object and refers to the data object to which
   *          holds the input data to be sent to a server. Pass 'null' if no
   *          return data is desired.
   * @param ArraySizeEx
   *          is the data array size associated with the DataEx object. This may
   *          be smaller than the actual size of the DataEx object, but NOT
   *          bigger.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data and DataEx objects above must refer to arrays of data types
   *       (which are passed by reference) and not single values (which are
   *       passed by value). So even if passing a single value, it must be
   *       declared as an array of 1 element! \b Example: \include
   *       eg_acopAttach1.java
   */
  public int AttachLink(Object Data, int ArraySize, Object DataEx, int ArraySizeEx)
  {
    return transport.AttachLink(Data, ArraySize, DataEx, ArraySizeEx, -1);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control and Attaches the data objects passed. Use
   *        AttachLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link and attach the returning data to
   *        the Data object passed. When new data arrive or the link status has
   *        changed, the de.desy.acop.chart receive event will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @param DataEx
   *          is the extended data object and refers to the data object to which
   *          holds the input data to be sent to a server. Pass 'null' if no
   *          return data is desired.
   * @param ArraySizeEx
   *          is the data array size associated with the DataEx object. This may
   *          be smaller than the actual size of the DataEx object, but NOT
   *          bigger.
   * @param identifier
   *          is a user-specified integer identifier which is used to identify
   *          the link to the calling application. Following a receive() event,
   *          the application can call getLinkId() to retrieve this number.
   *          Other forms of AttachLink() will use the returned link handle as
   *          and identifier.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data and DataEx objects above must refer to arrays of data types
   *       (which are passed by reference) and not single values (which are
   *       passed by value). So even if passing a single value, it must be
   *       declared as an array of 1 element! \b Example: \include
   *       eg_acopAttach1f.java
   */
  public int AttachLink(Object Data, int ArraySize, Object DataEx, int ArraySizeEx, int identifier)
  {
    return transport.AttachLink(Data, ArraySize, DataEx, ArraySizeEx, identifier);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control and Attaches the data objects passed. Use
   *        AttachLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link and attach the returning data to
   *        the Data object passed. When new data arrive or the link status has
   *        changed, the de.desy.acop.chart receive event will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param DataEx
   *          is the extended data object and refers to the data object to which
   *          holds the input data to be sent to a server. Pass 'null' if no
   *          return data is desired.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data and DataEx objects above must refer to arrays of data types
   *       (which are passed by reference) and not single values (which are
   *       passed by value). So even if passing a single value, it must be
   *       declared as an array of 1 element! The sizes of the arrays are in
   *       turn used in establishing the link when using this form of the
   *       AttachLink() method. \b Example: \include eg_acopAttach1b.java
   */
  public int AttachLink(Object Data, Object DataEx)
  {
    return transport.AttachLink(Data, transport.getObjectSize(Data), DataEx, transport.getObjectSize(DataEx),
        -1);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control and Attaches the data object passed. Use
   *        AttachLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link and attach the returning data to
   *        the Data object passed. When new data arrive or the link status has
   *        changed, the de.desy.acop.chart receive event will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data object above must refer to an array of data types (which is
   *       passed by reference) and not a single value (which is passed by
   *       value). So even if passing a single value, it must be declared as an
   *       array of 1 element! The size of the array is in turn used in
   *       establishing the link when using this form of the AttachLink()
   *       method. \b Example: \include eg_acopAttach1c.java
   */
  public int AttachLink(Object Data)
  {
    return transport.AttachLink(Data, transport.getObjectSize(Data), null, 0, -1);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control and Attaches the data object passed. Use
   *        AttachLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link and attach the returning data to
   *        the Data object passed. When new data arrive or the link status has
   *        changed, the de.desy.acop.chart receive event will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data object above must refer to an array of data types (which is
   *       passed by reference) and not a single value (which is passed by
   *       value). So even if passing a single value, it must be declared as an
   *       array of 1 element! \b Example: \include eg_acopAttach1d.java
   */
  public int AttachLink(Object Data, int ArraySize)
  {
    return transport.AttachLink(Data, ArraySize, null, 0, -1);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control and Attaches the data object passed. Use
   *        AttachLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link and attach the returning data to
   *        the Data object passed. When new data arrive or the link status has
   *        changed, the de.desy.acop.chart receive event will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @param identifier
   *          is a user-specified integer identifier which is used to identify
   *          the link to the calling application. Following a receive() event,
   *          the application can call getLinkId() to retrieve this number.
   *          Other forms of AttachLink() will use the returned link handle as
   *          and identifier.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data object above must refer to an array of data types (which is
   *       passed by reference) and not a single value (which is passed by
   *       value). So even if passing a single value, it must be declared as an
   *       array of 1 element! \b Example: \include eg_acopAttach1e.java
   */
  public int AttachLink(Object Data, int ArraySize, int identifier)
  {
    return transport.AttachLink(Data, ArraySize, null, 0, identifier);
  }
  /**
   * @brief Sets the link identifier to the value specified. Establishing a data
   *        link by using either AttachLink() or OpenLink() will assign a link
   *        identifier to the associated link when successful. This link
   *        identifier (or link 'handle') will be set prior to event
   *        notification via the Receive() event. One can set the link
   *        identifier to a desired value either in the original call to
   *        AttachLink() or OpenLink() or at a later time by calling this
   *        method.
   * @param currentLinkIdentifier
   *          is the current link identifier of the data link to which the new
   *          link identifier is to be assigned. If not originally set by the
   *          initial call, it is the value returned by the initial call to
   *          AttachLink() or OpenLink().
   * @param linkIdentifier
   *          is the desired link identifier to be associated with the data link
   *          defined by linkHandle.
   * @return The link identifier associated with the data link. If de.desy.acop.chart is
   *         unable to set the link identifier to the new value, it remains
   *         unchanged. If successful, the new link handle will be set to the
   *         assigned link identifier. \b Example: \include
   *         eg_acopSetLinkIdentifier.java
   */
  public int setLinkIdentifier(int currentLinkIdentifier, int linkIdentifier)
  {
    AcopTransportRequest a;
    int identifier = currentLinkIdentifier;
    Vector lnkTbl = transport.getAcopLinkTable();
    for (int i = 0; i < lnkTbl.size(); i++)
    {
      if ((a = (AcopTransportRequest) lnkTbl.elementAt(i)) == null) continue;
      if (a.getLinkIdentifier() != currentLinkIdentifier) continue;
      a.setLinkIdentifier(linkIdentifier);
      identifier = linkIdentifier;
    }
    return identifier;
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control, but does not Attach the data objects
   *        passed. Use OpenLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link. The data returned from a server
   *        is not bound to the Data object passed in the call and must be
   *        obtained by an independent call to the GetData() method. When new
   *        data arrive or the link status has changed, the de.desy.acop.chart receive event
   *        will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @param DataEx
   *          is the extended data object and refers to the data object to which
   *          holds the input data to be sent to a server. Pass 'null' if no
   *          return data is desired.
   * @param ArraySizeEx
   *          is the data array size associated with the DataEx object. This may
   *          be smaller than the actual size of the DataEx object, but NOT
   *          bigger.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data and DataEx objects above must refer to arrays of data types
   *       (which are passed by reference) and not single values (which are
   *       passed by value). So even if passing a single value, it must be
   *       declared as an array of 1 element!
   */
  public int OpenLink(Object Data, int ArraySize, Object DataEx, int ArraySizeEx)
  {
    return transport.OpenLink(Data, ArraySize, DataEx, ArraySizeEx, -1);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control, but does not Attach the data objects
   *        passed. Use OpenLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link. The data returned from a server
   *        is not bound to the Data object passed in the call and must be
   *        obtained by an independent call to the GetData() method. When new
   *        data arrive or the link status has changed, the de.desy.acop.chart receive event
   *        will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @param DataEx
   *          is the extended data object and refers to the data object to which
   *          holds the input data to be sent to a server. Pass 'null' if no
   *          return data is desired.
   * @param ArraySizeEx
   *          is the data array size associated with the DataEx object. This may
   *          be smaller than the actual size of the DataEx object, but NOT
   *          bigger.
   * @param identifier
   *          is a user-specified integer identifier which is used to identify
   *          the link to the calling application. Following a receive() event,
   *          the application can call getLinkId() to retrieve this number.
   *          Other forms of AttachLink() will use the returned link handle as
   *          and identifier.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data and DataEx objects above must refer to arrays of data types
   *       (which are passed by reference) and not single values (which are
   *       passed by value). So even if passing a single value, it must be
   *       declared as an array of 1 element!
   */
  public int OpenLink(Object Data, int ArraySize, Object DataEx, int ArraySizeEx, int identifier)
  {
    return transport.OpenLink(Data, ArraySize, DataEx, ArraySizeEx, identifier);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control, but does not Attach the data objects
   *        passed. Use OpenLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link. The data returned from a server
   *        is not bound to the Data object passed in the call and must be
   *        obtained by an independent call to the GetData() method. When new
   *        data arrive or the link status has changed, the de.desy.acop.chart receive event
   *        will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param DataEx
   *          is the extended data object and refers to the data object to which
   *          holds the input data to be sent to a server. Pass 'null' if no
   *          return data is desired.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data and DataEx objects above must refer to arrays of data types
   *       (which are passed by reference) and not single values (which are
   *       passed by value). So even if passing a single value, it must be
   *       declared as an array of 1 element! The size of the array is in turn
   *       used in establishing the link when using this form of the OpenLink()
   *       method.
   */
  public int OpenLink(Object Data, Object DataEx)
  {
    return transport.OpenLink(Data, transport.getObjectSize(Data), DataEx, transport.getObjectSize(DataEx),
        -1);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control, but does not Attach the data object passed.
   *        Use OpenLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link. The data returned from a server
   *        is not bound to the Data object passed in the call and must be
   *        obtained by an independent call to the GetData() method. When new
   *        data arrive or the link status has changed, the de.desy.acop.chart receive event
   *        will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data object above must refer to an array of data types (which is
   *       passed by reference) and not a single value (which is passed by
   *       value). So even if passing a single value, it must be declared as an
   *       array of 1 element! The size of the array is in turn used in
   *       establishing the link when using this form of the OpenLink() method.
   */
  public int OpenLink(Object Data)
  {
    return transport.OpenLink(Data, transport.getObjectSize(Data), null, 0, -1);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control, but does not Attach the data object passed.
   *        Use OpenLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link. The data returned from a server
   *        is not bound to the Data object passed in the call and must be
   *        obtained by an independent call to the GetData() method. When new
   *        data arrive or the link status has changed, the de.desy.acop.chart receive event
   *        will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data object above must refer to an array of data types (which is
   *       passed by reference) and not a single value (which is passed by
   *       value). So even if passing a single value, it must be declared as an
   *       array of 1 element!
   */
  public int OpenLink(Object Data, int ArraySize)
  {
    return transport.OpenLink(Data, ArraySize, null, 0, -1);
  }
  /**
   * @brief Establishes an asynchronous data link using the Device Properties
   *        assigned to the control, but does not Attach the data object passed.
   *        Use OpenLink for asynchronous data acquisition. Fill in the
   *        DeviceContext DeviceGroup, DeviceName, and DeviceProperty bean
   *        property parameters, along with the accessProtocol, accessMode, and
   *        accessRate bean property parameters. Call this method to establish
   *        the asynchronous data tranfer link. The data returned from a server
   *        is not bound to the Data object passed in the call and must be
   *        obtained by an independent call to the GetData() method. When new
   *        data arrive or the link status has changed, the de.desy.acop.chart receive event
   *        will be fired.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. Pass 'null' if no return
   *          data is desired.
   * @param ArraySize
   *          is the data array size associated with the Data object. This may
   *          be smaller than the actual size of the Data object, but NOT
   *          bigger.
   * @param identifier
   *          is a user-specified integer identifier which is used to identify
   *          the link to the calling application. Following a receive() event,
   *          the application can call getLinkId() to retrieve this number.
   *          Other forms of AttachLink() will use the returned link handle as
   *          and identifier.
   * @return A positive link handle if successful otherwise -1, in which case
   *         the getStatus() method can be queried to determine the cause of
   *         failure.
   * @note The Data object above must refer to an array of data types (which is
   *       passed by reference) and not a single value (which is passed by
   *       value). So even if passing a single value, it must be declared as an
   *       array of 1 element!
   */
  public int OpenLink(Object Data, int ArraySize, int identifier)
  {
    return transport.OpenLink(Data, ArraySize, null, 0, identifier);
  }
  /**
   * @brief Closes an existing de.desy.acop.chart data link. Using CloseLink() with a '-1'
   *        input parameter will close all data links associated with the de.desy.acop.chart
   *        bean.
   * @param identifier
   *          is the link handle of the de.desy.acop.chart data link which is to be
   *          terminated. If identifier == -1 then all associated links will be
   *          terminated.
   * @return 0 if successful otherwise -1, in which case the getStatus() method
   *         can be queried to determine the cause of failure. \b Example:
   *         \include eg_acopCloseLink1.java
   */
  public int CloseLink(int identifier)
  {
    return transport.CloseLink(identifier);
  }
  /**
   * @brief Retrieves the data associated with the given link handle into the
   *        data objects passed. This method is frequently used in conjunction
   *        with the OpenLink() method of establishing a data link, in which
   *        case the incoming data is not bound to a data object.
   * @param Data
   *          is the primary data object and refers to the data object to hold
   *          the output data returned from a server. This must be a reference
   *          to the same type of object passed in the original call to
   *          AttachLink() or OpenLink().
   * @param DataEx
   *          is the extended data object and refers to the data object to which
   *          holds the input data to be sent to a server. This must be a
   *          reference to the same type of object passed in the original call
   *          to AttachLink() or OpenLink().
   * @param identifier
   *          is the link handle of the de.desy.acop.chart data link which is to be
   *          terminated. If identifier == -1 then all associated links will be
   *          terminated.
   * @return 0 if successful otherwise -1, in which case the getStatus() method
   *         can be queried to determine the cause of failure.
   */
  public int GetData(Object Data, Object DataEx, int identifier)
  {
    return transport.GetData(Data, DataEx, identifier);
  }
  /**
   * @brief Gives the current data size of the data objects associated with the
   *        given link handle. This method provides an analogy with the
   *        equivalent method in the ACOP ActiveX control, where the arguments
   *        are explicitly passed by reference. In the ACOP java bean, the
   *        overloaded methods GetDataSize(int identifier) and GetDataSizeEx(int
   *        identifier) are preferred.
   * @param DataSize
   *          is a reference to the current data size of primary Data object
   *          attached to the data link. As this is passed by reference, this
   *          must be an array of 1 integer. A 'null' can be passed if you are
   *          not interested in this value.
   * @param DataSizeEx
   *          is a reference to the current data size of extended Data object
   *          attached to the data link. As this is passed by reference, this
   *          must be an array of 1 integer. A 'null' can be passed if you are
   *          not interested in this value.
   * @param identifier
   *          is the link handle of the de.desy.acop.chart data link for which the current
   *          data sizes are desired.
   * @return 0 if successful otherwise -1, in which case the getStatus() method
   *         can be queried to determine the cause of failure. \b Example:
   *         \include eg_acopGetDataSize1.java
   */
  public int GetDataSize(int[] DataSize, int[] DataSizeEx, int identifier)
  {
    int[] dsize = new int[1], dsizeEx = new int[1];
    int rc = transport.GetDataSize(dsize, dsizeEx, identifier);
    if (DataSize != null) DataSize[0] = dsize[0];
    if (DataSizeEx != null) DataSizeEx[0] = dsizeEx[0];
    return rc;
  }
  /**
   * @brief Returns the current data size of the primary data object associated
   *        with the given link handle.
   * @param identifier
   *          is the link handle of the de.desy.acop.chart data link for which the current
   *          data sizes are desired.
   * @return The data size of the returned data if successful otherwise -1, in
   *         which case the getStatus() method can be queried to determine the
   *         cause of failure. \b Example: \include eg_acopGetDataSize2.java
   */
  public int GetDataSize(int identifier)
  {
    int[] dsize = new int[1];
    int rc = transport.GetDataSize(dsize, null, identifier);
    if (rc < 0) return rc;
    return dsize[0];
  }
  /**
   * @brief Returns the current data size of the primary data object.
   * @return The data size of the returned data if successful otherwise -1, in
   *         which case the getStatus() method can be queried to determine the
   *         cause of failure. \b Example: \include eg_acopGetDataSize3.java
   */
  public int GetDataSize()
  {
    int[] dsize = new int[1];
    int rc = transport.GetDataSize(dsize, null, -1);
    if (rc < 0) return rc;
    return dsize[0];
  }
  /**
   * @brief Returns the current data size of the extended data object associated
   *        with the given link handle.
   * @param identifier
   *          is the link handle of the de.desy.acop.chart data link for which the current
   *          data sizes are desired.
   * @return The data size of the sent data if successful otherwise -1, in which
   *         case the getStatus() method can be queried to determine the cause
   *         of failure.
   */
  public int GetDataSizeEx(int identifier)
  {
    int[] dsize = new int[1];
    int rc = transport.GetDataSize(null, dsize, identifier);
    if (rc < 0) return rc;
    return dsize[0];
  }
  /**
   * @brief Returns the current data size of the extended data object.
   * @return The data size of the sent data if successful otherwise -1, in which
   *         case the getStatus() method can be queried to determine the cause
   *         of failure.
   */
  public int GetDataSizeEx()
  {
    int[] dsize = new int[1];
    int rc = transport.GetDataSize(null, dsize, -1);
    if (rc < 0) return rc;
    return dsize[0];
  }
  public java.lang.String CTime(int TimeStamp)
  {
    return transport.CTime(TimeStamp);
  }
  public java.lang.String CTime(double TimeStamp)
  {
    return transport.CTime(TimeStamp);
  }
  public java.lang.String CTime(Date TimeStamp)
  {
    return transport.CTime(TimeStamp);
  }
  public void setReceiveQueueDepth(int ReceiveQueueDepth)
  {
    transport.setReceiveQueueDepth(ReceiveQueueDepth);
  }
  public int getReceiveQueueDepth()
  {
    return transport.getReceiveQueueDepth();
  }
  public void setTimeStamp(Date TimeStamp)
  {
    transport.setTimeStamp(TimeStamp);
  }
  /**
   * @brief The current data time stamp as a Date object
   * @return The current data time stamp as a Date object
   */
  public Date getTimeStamp()
  {
    return transport.getDateStamp();
  }
  public Date getTimeStamp(int identifier)
  {
    return transport.getDateStamp(identifier);
  }
  /**
   * @brief The current data status string
   * @return The current data status string
   */
  public java.lang.String getStatus()
  {
    return transport.getStatus();
  }
  public int getGroupIndex()
  {
    return transport.getGroupIndex();
  }
  /**
   * @brief Sets the grouped flag
   * @param isGrouped
   *          determines whether all data links associated with this de.desy.acop.chart are to
   *          fire one single event (isGrouped = true) when all link states have
   *          changed or not (isGrouped = false)
   */
  public void setGrouped(boolean Grouped)
  {
    transport.setGrouped(Grouped);
  }
  /**
   * @brief The grouped flag
   * @return the isGrouped state of this de.desy.acop.chart
   */
  public boolean getGrouped()
  {
    return transport.isGrouped;
  }
  /**
   * @brief Queries for the available device contexts according to current
   *        setting of the AccessProtocol
   * @return A string array containing the device contexts
   */
  public String[] getDeviceContexts()
  {
    return transport.getDeviceContexts();
  }
  /**
   * @brief Queries for the available device groups according to current setting
   *        of the AccessProtocol
   * @param deviceContext
   *          is the device context for which the device groups are desired
   * @param deviceGroup
   *          is the device group (sub-string + wildcards) for which the device
   *          groups are desired. 'null' is equivalent to "*".
   * @param deviceName
   *          is the device name for which the device groups are desired. This
   *          parameter should typically passed as 'null'.
   * @param deviceProperty
   *          is the device property for which the device groups are desired.
   *          This parameter should typically passed as 'null'.
   * @return A string array containing the device groups
   */
  public String[] getDeviceGroups(String deviceContext, String deviceGroup, String deviceName,
      String deviceProperty)
  {
    return transport.getDeviceGroups(deviceContext, deviceGroup, deviceName, deviceProperty);
  }
  /**
   * @brief Queries for the available device groups according to current setting
   *        of the AccessProtocol and Device parameters
   * @return A string array containing the device groups
   */
  public String[] getDeviceGroups()
  {
    return transport.getDeviceGroups(getDeviceContext(), getDeviceGroup(), getDeviceName(),
        getDeviceProperty());
  }
  /**
   * @brief Queries for the available device names according to current setting
   *        of the AccessProtocol
   * @param deviceContext
   *          is the device context for which the device names are desired
   * @param deviceGroup
   *          is the device group for which the device names are desired.
   * @param deviceName
   *          is the device name (sub-string + wildcards) for which the device
   *          names are desired. 'null' is equivalent to "*".
   * @param deviceProperty
   *          is the device property for which the device names are desired.
   * @return A string array containing the device names
   */
  public String[] getDeviceNames(String deviceContext, String deviceGroup, String deviceName,
      String deviceProperty)
  {
    return transport.getDeviceNames(deviceContext, deviceGroup, deviceName, deviceProperty);
  }
  /**
   * @brief Queries for the available device names according to current setting
   *        of the AccessProtocol and Device parameters
   * @return A string array containing the device names
   */
  public String[] getDeviceNames()
  {
    return transport.getDeviceNames(getDeviceContext(), getDeviceGroup(), getDeviceName(),
        getDeviceProperty());
  }
  /**
   * @brief Queries for the available device properties according to current
   *        setting of the AccessProtocol
   * @param deviceContext
   *          is the device context for which the device properties are desired
   * @param deviceGroup
   *          is the device group for which the device properties are desired.
   * @param deviceName
   *          is the device name for which the device properties are desired.
   * @param deviceProperty
   *          is the device property (sub-string + wildcards) for which the
   *          device properties are desired. 'null' is equivalent to "*".
   * @return A string array containing the device properties
   */
  public String[] getDeviceProperties(String deviceContext, String deviceGroup, String deviceName,
      String deviceProperty)
  {
    return transport.getDeviceProperties(deviceContext, deviceGroup, deviceName, deviceProperty);
  }
  /**
   * @brief Queries for the available device properties according to current
   *        setting of the AccessProtocol and Device parameters
   * @return A string array containing the device properties
   */
  public String[] getDeviceProperties()
  {
    return transport.getDeviceProperties(getDeviceContext(), getDeviceGroup(), getDeviceName(),
        getDeviceProperty());
  }
  /**
   * @brief Queries for the available display setting according to current
   *        setting of the AccessProtocol This method uses the query mechanisms
   *        of the underlying transport to ascertain the maximum and minimum
   *        display settings and axis labels. The resulting 'Y' axis label will
   *        be the units associated with the queried property. The maximum and
   *        minimum settings for the 'Y' axis will be the range associated with
   *        the queried property. The resulting 'X' axis label will be the
   *        description associated with the queried property. The maximum and
   *        minimum settings for the 'X' axis will be 0 to the array size of the
   *        property queried, if the property corresponds to a multi-channel
   *        display.
   * @param deviceContext
   *          is the device context for which the device properties are desired
   * @param deviceGroup
   *          is the device group for which the device properties are desired.
   * @param deviceName
   *          is the device name for which the device properties are desired.
   * @param deviceProperty
   *          is the device property (sub-string + wildcards) for which the
   *          device properties are desired. 'null' is equivalent to "*".
   * @return 0 if successful otherwise -1.
   */
  public int acquireDisplayProperties(String deviceContext, String deviceGroup, String deviceName,
      String deviceProperty)
  {
    return transport.acquireDisplayProperties(this, deviceContext, deviceGroup, deviceName, deviceProperty);
  }
  /**
   * @brief Queries for the available display setting according to current
   *        setting of the AccessProtocol and display parameters. This method
   *        uses the query mechanisms of the underlying transport to ascertain
   *        the maximum and minimum display settings and axis labels. The
   *        resulting 'Y' axis label will be the units associated with the
   *        queried property. The maximum and minimum settings for the 'Y' axis
   *        will be the range associated with the queried property. The
   *        resulting 'X' axis label will be the description associated with the
   *        queried property. The maximum and minimum settings for the 'X' axis
   *        will be 0 to the array size of the property queried, if the property
   *        corresponds to a multi-channel display.
   * @return 0 if successful otherwise -1.
   */
  public int acquireDisplayProperties()
  {
    return transport.acquireDisplayProperties(this, getDeviceContext(), getDeviceGroup(), getDeviceName(),
        getDeviceProperty());
  }
  public void setDeviceContext(java.lang.String DeviceContext)
  {
    transport.setDeviceContext(DeviceContext);
  }
  public java.lang.String getDeviceContext()
  {
    return transport.getDeviceContext();
  }
  public void setDeviceGroup(java.lang.String DeviceGroup)
  {
    transport.setDeviceGroup(DeviceGroup);
  }
  public java.lang.String getDeviceGroup()
  {
    return transport.getDeviceGroup();
  }
  public void setDeviceName(java.lang.String DeviceName)
  {
    transport.setDeviceName(DeviceName);
  }
  public java.lang.String getDeviceName()
  {
    return transport.getDeviceName();
  }
  public void setDeviceProperty(java.lang.String DeviceProperty)
  {
    transport.setDeviceProperty(DeviceProperty);
  }
  public java.lang.String getDeviceProperty()
  {
    return transport.getDeviceProperty();
  }
  public void setAccessMode(java.lang.String AccessMode)
  {
    transport.setAccessMode(AccessMode);
  }
  public java.lang.String getAccessMode()
  {
    return transport.getAccessMode();
  }
  public void setAccessProtocol(java.lang.String AccessProtocol)
  {
    transport.setAccessProtocol(AccessProtocol);
  }
  public java.lang.String getAccessProtocol()
  {
    return transport.getAccessProtocol();
  }
  public void setAccessRate(java.lang.String AccessRate)
  {
    transport.setAccessRate(AccessRate);
  }
  public java.lang.String getAccessRate()
  {
    return transport.getAccessRate();
  }
  public void setAcopConfig(java.lang.String AcopConfig)
  {
    transport.setAcopConfig(AcopConfig);
  }
  public java.lang.String getAcopConfig()
  {
    return transport.getAcopConfig();
  }
  public void setCursorMarkerColor(java.awt.Color cursorMarkerColor)
  {
    // cursorColor = ~(TranslateColor(m_cursorMarkerColor) ^
    // TranslateColor(GetBackColor())) & 0xffffff;
    if (m_cursorMarkerColor == cursorMarkerColor) return;
    m_cursorMarkerColor = cursorMarkerColor;
    if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
  }
  public java.awt.Color getCursorMarkerColor()
  {
    return m_cursorMarkerColor;
  }
  public void setCursorMarkerMode(int cursorMarkerMode)
  {
    cursorMarkerMode = (cursorMarkerMode < 0 || cursorMarkerMode > 3) ? 0 : cursorMarkerMode;
    if (m_cursorMarkerMode == cursorMarkerMode) return;
    m_cursorMarkerMode = cursorMarkerMode;
    if (m_cursorMarkerMode != 0 && histRoundRect.contains(mMovePoint) == false)
    {
      mMovePoint.x = histRoundRect.x + histRoundRect.width / 2;
      mMovePoint.y = histRoundRect.y + histRoundRect.height / 2;
    }
    if (aFrame.drawFlag) repaintHisto();
  }
  public int getCursorMarkerMode()
  {
    return this.m_cursorMarkerMode;
  }
  public void setCursorMarkerStyle(int cursorMarkerStyle)
  {
    if (m_cursorMarkerStyle == cursorMarkerStyle) return;
    m_cursorMarkerStyle = cursorMarkerStyle;
    cursorMarkerStroke = AcopConst.createStroke(m_cursorMarkerWidth, m_cursorMarkerStyle);
    if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
  }
  public int getCursorMarkerStyle()
  {
    return m_cursorMarkerStyle;
  }
  public void setCursorMarkerWidth(int cursorMarkerWidth)
  {
    if (m_cursorMarkerWidth == cursorMarkerWidth) return;
    m_cursorMarkerWidth = cursorMarkerWidth;
    cursorMarkerStroke = AcopConst.createStroke(m_cursorMarkerWidth, m_cursorMarkerStyle);
    if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
  }
  public int getCursorMarkerWidth()
  {
    return m_cursorMarkerWidth;
  }
  public void setCursorMarkerXExtent(double cursorMarkerXExtent)
  {
    if (m_cursorMarkerXExtent == cursorMarkerXExtent) return;
    m_cursorMarkerXExtent = cursorMarkerXExtent;
    cursorXPercent = -1;
    if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
  }
  public double getCursorMarkerXExtent()
  {
    return m_cursorMarkerXExtent;
  }
  public void setCursorMarkerYExtent(double cursorMarkerYExtent)
  {
    if (m_cursorMarkerYExtent == cursorMarkerYExtent) return;
    m_cursorMarkerYExtent = cursorMarkerYExtent;
    cursorYPercent = -1;
    if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
  }
  public double getCursorMarkerYExtent()
  {
    return m_cursorMarkerYExtent;
  }
  public void setMarkerColor(java.awt.Color markerColor)
  {
    if (m_markerColor == markerColor) return;
    m_markerColor = markerColor;
    if (m_markerMode == 0 && aFrame.drawFlag) repaintHisto();
  }
  public java.awt.Color getMarkerColor()
  {
    return m_markerColor;
  }
  public void setMarkerMode(int markerMode)
  {
    markerMode = (markerMode < 0 || markerMode > 3) ? 0 : markerMode;
    if (this.m_markerMode == markerMode) return;
    m_markerMode = markerMode;
    if (aFrame.drawFlag) repaintHisto();
  }
  public int getMarkerMode()
  {
    return this.m_markerMode;
  }
  public void setMarkerStyle(int markerStyle)
  {
    if (this.m_markerStyle == markerStyle) return;
    m_markerStyle = markerStyle;
  }
  public int getMarkerStyle()
  {
    return this.m_markerStyle;
  }
  public void setMarkerWidth(int markerWidth)
  {
    if (this.m_markerWidth == markerWidth) return;
    m_markerWidth = markerWidth;
  }
  public int getMarkerWidth()
  {
    return this.m_markerWidth;
  }
  public void setMarkerXExtent(double markerXExtent)
  {
    if (this.m_markerXExtent == markerXExtent) return;
    m_markerXExtent = markerXExtent;
  }
  public double getMarkerXExtent()
  {
    return this.m_markerXExtent;
  }
  public void setMarkerYExtent(double markerYExtent)
  {
    if (this.m_markerYExtent == markerYExtent) return;
    m_markerYExtent = markerYExtent;
  }
  public double getMarkerYExtent()
  {
    return this.m_markerYExtent;
  }
  public int ErrorWindow(double XMax, double XMin, double YMax, double YMin)
  {
    return ErrorWindow(-1, XMax, XMin, YMax, YMin);
  }
  public int ErrorWindow(int hDisplay, double XMax, double XMin, double YMax, double YMin)
  {
    int i, start, stop, on;
    // out of range, -1 to set for default value
    if (hDisplay < -1 || hDisplay > n_display) return -1;
    on = 0;
    start = hDisplay;
    stop = hDisplay + 1;
    if (hDisplay == -1) // set all
    {
      start = 0;
      stop = n_display;
      e_xmax = XMax; // set default
      e_xmin = XMin;
      e_ymax = YMax;
      e_ymin = YMin;
    }
    for (i = start; i < stop; i++)
    {
      if (histo[i] == null) break;
      histo[i].err_xmax = XMax;
      histo[i].err_xmin = XMin;
      histo[i].err_ymax = YMax;
      histo[i].err_ymin = YMin;
      if (histo[i].errWindowEnable && histo[i].displayON != 0) on = 1;
    }
    if (aFrame.drawFlag && on != 0) repaintHisto();
    return 0;
  }
  public void setErrorColor(java.awt.Color errorColor)
  {
    if (m_errorColor == errorColor) return;
    m_errorColor = errorColor;
    if (histo[lastDisp] != null) histo[lastDisp].errorColor = m_errorColor;
  }
  public java.awt.Color getErrorColor()
  {
    return m_errorColor;
  }
  public void setTagColor(java.awt.Color tagColor)
  {
    if (m_tagColor == tagColor) return;
    m_tagColor = tagColor;
    for (int i = 0; i < n_display; i++)
    {
      if (histo[i] == null) break;
      histo[i].tagColor = m_tagColor;
    }
  }
  public java.awt.Color getTagColor()
  {
    return m_tagColor;
  }
  public void setTagging(boolean tagging)
  {
    if (this.m_tagging == tagging) return;
    this.m_tagging = tagging;
    if (aFrame.drawFlag) repaintHisto();
  }
  public boolean isTagging()
  {
    return this.m_tagging;
  }
  public void ClearTags(int hDisplay)
  {
    int i, j, ok, start, stop;
    if (pTagColorArray == null) return; // no hoistogram at all!
    if (hDisplay >= 0 && hDisplay < n_display) // tag one histogram only!
    {
      start = n_display;
      stop = start + 1;
    }
    else
    {
      start = 0;
      stop = n_display;
    }
    ok = 0;
    for (j = start; j < stop; j++) // clear all histogram tagging array!!
    {
      if (histo[j] == null) break;
      if (histo[j].dismode == AcopConst.mode_histogram
          || histo[j].dismode == AcopConst.mode_histogram_rastoring
          || histo[j].dismode == AcopConst.mode_dots || histo[j].dismode == AcopConst.mode_rectangle
          || histo[j].dismode == AcopConst.mode_circle)
      {
        ok = 1;
        for (i = 0; i < histo[j].npoints; i++)
          histo[j].m_tagColorArray[i] = histo[j].vorColor;
      }
    }
    if (ok != 0 && m_tagging && aFrame.drawFlag) repaintHisto();
  }
  private void repaintHisto()
  {
    this.repaint(histRoundRect.x, histRoundRect.y, histRoundRect.width, histRoundRect.height);
  }
  // read global marker flag
  public boolean Marker()
  {
    return m_marker != 0 ? true : false;
  }
  // read marker flag for hDisplay
  public boolean Marker(int hDisplay)
  {
    if (hDisplay < 0 || hDisplay >= n_display)
      return Marker();
    else if (histo[hDisplay] == null)
      return false;
    else
      return histo[hDisplay].markerFlag != 0 ? true : false;
  }
  // set marker flag for all displays shown
  public boolean Marker(boolean MarkerOn)
  {
    return Marker(MarkerOn, -1);
  }
  // set marker flag for hDisplay only
  public boolean Marker(boolean MarkerOn, int hDisplay)
  {
    int num, ende;
    m_marker = MarkerOn ? 2 : 0; // mark what you see!
    num = hDisplay;
    if (num < 0 || num >= n_display)
    {
      num = 0;
      ende = n_display - 1;
    }
    else
      ende = num;
    for (; num <= ende; num++)
    {
      if (histo[num] == null) continue;
      if (m_marker == 0)
        histo[num].markerFlag = 0;
      else if (histo[num].displayON != 0) histo[num].markerFlag = 1;
    }
    if (m_marker == 2) setmarkerflag(1); // copy once only
    // prepareDraw(FALSE, -1, FALSE, 0);
    if (aFrame.drawFlag)
      prepareDraw(); // dont scale keep old limit
    else
      changeScaleWidth = 0;
    return m_marker != 0 ? true : false;
  }
  protected void setmarkerflag(int flag)
  {
    for (int n = 0; n < n_display; n++)
    {
      if (histo[n] == null) break;
      if (flag == 2 || histo[n].displayON != 0) histo[n].marker_ary_cpy = flag;
    }
  }
  public boolean IsTagged(int index, int hDisplay)
  {
    return IsTagged(index, -1, hDisplay);
  }
  public boolean IsTagged(int index, int value, int hDisplay)
  {
    boolean tagon;
    int j, found, lasfDisp, lastTagON, start, stop;
    if (pTagColorArray == null) return false; // no hoistogram at all!
    if (index < -1) return false; // out of range, -1 to set colors for all
    found = 0;
    lastTagON = -1;
    if (hDisplay >= 0 && hDisplay < n_display) // tag one histogram only!
    {
      start = hDisplay;
      stop = start + 1;
    }
    else
    {
      start = 0;
      stop = n_display;
    }
    tagon = value == 1 ? true : false; // setting
    for (j = start; j < stop; j++) // loop all histograms to mark tagging color
    {
      if (histo[j] == null) break;
      if (histo[j].dismode == AcopConst.mode_histogram
          || histo[j].dismode == AcopConst.mode_histogram_rastoring
          || histo[j].dismode == AcopConst.mode_dots || histo[j].dismode == AcopConst.mode_rectangle
          || histo[j].dismode == AcopConst.mode_circle)
      {
        if (index >= histo[j].npoints) continue; // out of range
        if (found == 0) // first found
        {
          if (value < 0 || value > 1)
            // reading
            return index == -1 ? m_tagging : (histo[j].m_tagColorArray[index] == histo[j].vorColor ? false
                : true);
          found = 1;
          lasfDisp = j;
        }
        if (index != -1) // set color for this index only
          histo[j].m_tagColorArray[index] = tagon ? histo[j].tagColor : histo[j].vorColor;
        else
          // set color for all indexes
          for (int i = 0; i < histo[j].npoints; i++)
            histo[j].m_tagColorArray[i] = tagon ? histo[j].tagColor : histo[j].vorColor;
        if (histo[j].tagHist != 0) lasfDisp = j;
        if (j == lastTagHisto && histo[j].displayON != 0) lastTagON = j;
      }
    }
    if (found == 0) return false;
    // last recalled, refreshed or drawed, and still be seen on screen
    if (lastTagON >= 0) lastDisp = lastTagON;
    if (m_tagging && aFrame.drawFlag)
    {
      if (index == -1)
        repaintHisto();
      else
      {
        int xpos, left, right, low = 0, high = 0;
        // loop all histograms to mark tagging color
        for (lasfDisp = start; lasfDisp < stop; lasfDisp++)
        {
          if (histo[lasfDisp] == null) break;
          xpos = histo[lasfDisp].ix[index];
          if (histo[lasfDisp].dismode == AcopConst.mode_histogram
              || histo[lasfDisp].dismode == AcopConst.mode_histogram_rastoring)
          {
            left = xpos - histo[lasfDisp].penWidth;
            right = xpos + histo[lasfDisp].penWidth;
          }
          else
          {
            left = xpos - histo[lasfDisp].xextent;
            right = xpos + histo[lasfDisp].xextent;
          }
          if (lasfDisp == start)
          {
            low = left;
            high = right;
            continue;
          }
          if (low > left) low = left;
          if (high < right) high = right;
        }
        tagRect.x = low + aFrame.histRect.x;
        tagRect.width = high - low;
        repaintTagging();
      }
    }
    return tagon;
  }
  protected void repaintTagging()
  {
    this.repaint(tagRect.x, tagRect.y, tagRect.width, tagRect.height);
  }
  public int GetTaggedColor(Color[] ColorArray, int Npoints, int StartIndex, int hDisplay)
  {
    int format, num, start, ndata;
    int aryType, refType, NoInputY, DataSize, i, j, k;
    if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null
        || histo[hDisplay].m_tagColorArray == null) return -1;
    num = Npoints; // number of points, at least 1 point
    if (num < 1) num = histo[hDisplay].npoints;
    start = StartIndex; // start point: 0 to (npoints-1)
    if (start < 0 || start >= histo[hDisplay].npoints) return -8;
    if (num + start > histo[hDisplay].npoints) num = histo[hDisplay].npoints - start;
    num += start;
    if (ColorArray == null) return -2;
    ndata = ColorArray.length;
    if (ndata < num - start) num = start + ndata;
    for (k = start; k < num; k++)
    {
      i = k - start;
      j = k < histo[hDisplay].npoints ? k : (k - histo[hDisplay].npoints);
      ColorArray[i] = histo[hDisplay].m_tagColorArray[j];
    }
    return num - start; // return number of valid data
  }
  public void setForeground(Color c)
  {
    // super.setForeground(c);
    if (foreColor == c) return;
    foreColor = c;
    if (randomData == true)
    {
      rescaleFlag = 2;
      prepareDraw(); // rescale and reset limit
    }
  }
  public java.awt.Color getForeground()
  {
    return foreColor;
  }
  // PropertyDescriptor ReceiveQueueDepth = new
  // PropertyDescriptor("ReceiveQueueDepth",beanClass,
  // "getReceiveQueueDepth","setReceiveQueueDepth");
  protected java.awt.List listTextBox;
  protected java.lang.String caption = "";
  protected int captionPosition;
  protected int frameWidth;
  // protected java.awt.Color frameForeColor;
  protected int frameLeftOffset;
  protected int frameRightOffset;
  protected int frameTopOffset;
  protected int frameBottomOffset;
  protected int displayMode;
  // protected double xMin;
  // protected double xMax;
  // protected double yMin;
  // protected double yMax;
  protected int drawWidth;
  // protected java.awt.Font frameFont;
  // protected int XTicks;
  protected double XScale;
  protected double XShift;
  protected int graphStyle;
  // protected int YTicks;
  protected double YScale;
  protected boolean wrapAround;
  protected double YShift;
  protected double YExtent;
  protected int screenDepth;
  protected int keepStyle;
  // protected boolean YGrid;
  // protected boolean XGrid;
  protected int zooming;
  // protected java.lang.String YAxisLabel = "";
  protected int keepWidth;
  protected boolean randomData;
  protected boolean randomText;
  // protected int XFineTicks;
  protected boolean invert;
  protected int drawStyle;
  // protected boolean XTickText;
  protected boolean reuseText;
  protected java.awt.Color keepColor;
  // protected boolean xBestScale;
  protected int averagingMode, averagingDepth;
  protected int FFT;
  protected double XExtent;
  // protected boolean YTickText;
  // protected int histogramPosition;
  // protected int YFineTicks;
  protected boolean reuseScreen;
  protected int textDepth;
  // protected java.lang.String XAxisLabel = "";
  // protected boolean yBestScale;
  protected int colorFilled;
  // protected boolean leftTimeLabel;
  protected int xlabelRotation;
  protected int printTextStickyAttribute;
  protected int printTextLocation;
  protected int printTextRotation;
  protected java.awt.Color m_tagColor;
  protected boolean m_tagging;
  protected java.awt.Color m_errorColor;
  protected java.awt.Color LeadingEdgeColor;
  protected int LeadingEdgeGapSize;
  protected int LeadingEdgeMotion;
  protected int LeadingEdgeMode;
  protected int LeadingEdgeWidth;
  protected int LeadingEdgeStyle;
  protected double LeadingEdgeXExtent;
  protected double LeadingEdgeYExtent;
  protected java.awt.Color m_markerColor;
  protected int m_markerMode;
  protected int m_markerStyle;
  protected int m_markerWidth;
  protected double m_markerXExtent;
  protected double m_markerYExtent;
  protected java.awt.Color m_cursorMarkerColor;
  protected int m_cursorMarkerMode;
  protected int m_cursorMarkerStyle;
  protected int m_cursorMarkerWidth;
  protected double m_cursorMarkerXExtent;
  protected double m_cursorMarkerYExtent;
  // private symantec.itools.beans.PropertyChangeSupport changes = null;
  // private symantec.itools.beans.VetoableChangeSupport veto = null;
}